local cColor = {
	["DEATHKNIGHT"] = { 196/255, 30/255, 60/255 },
	["DRUID"] = { 255/255, 125/255, 10/255 },
	["HUNTER"] = { 171/255, 214/255, 116/255 },
	["MAGE"] = { 104/255, 205/255, 255/255 },
	["PALADIN"] = { 245/255, 140/255, 186/255 },
	["PRIEST"] = { 212/255, 212/255, 212/255 },
	["ROGUE"] = { 255/255, 243/255, 82/255 },
	["SHAMAN"] = { 41/255, 79/255, 155/255 },
	["WARLOCK"] = { 148/255, 130/255, 201/255 },
	["WARRIOR"] = { 199/255, 156/255, 110/255 },
}
local class = SVRoot.myclass
local colorz = cColor[class]
local c_r,c_g,c_b = (colorz[1]*0.5),(colorz[2]*0.5),(colorz[3]*0.5)
-- This will filter everythin NON user config data out of SuperSet
local ALLOWED_GROUPS = {
	["load"]=1,
	["ttops"]=1,
	["chatops"]=1,
	["unitops"]=1,
	["panelops"]=1,
	["scaleops"]=1,
	["font_sizes"]=1
}

local function Local(o)
	-- load
	if o == "DiabolicalPLANload" then o = SVUICONFIG.option_load end
	--
	if o == "DiabolicalPLANloadoverridelocal" then o = "English" end
	if o == "DiabolicalPLANloadsct_enabled" then o = "SuperVillain "..COMBAT_TEXT_LABEL end
	if o == "DiabolicalPLANloadxct_style" then o = "xCT "..COMBAT_TEXT_LABEL end
	if o == "DiabolicalPLANloadcomics_enabled" then o = SVUICONFIG.option_load_comics end
	if o == "DiabolicalPLANloadloot" then o = SVUICONFIG.option_loot_enableloot end
	if o == "DiabolicalPLANloadlootroll" then o = SVUICONFIG.option_loot_enableroll end
	if o == "DiabolicalPLANloadnameplates" then o = SVUICONFIG.option_nameplates_enable end
	if o == "DiabolicalPLANloadreplacefont" then o = SVUICONFIG.option_load_rfont end
	if o == "DiabolicalPLANloadbags" then o = SVUICONFIG.option_bags_enable end
	if o == "DiabolicalPLANloadbigmap" then o = SVUICONFIG.option_map_enable end
	if o == "DiabolicalPLANloadlocaltime" then o = SVUICONFIG.option_datatext_localtime end
	if o == "DiabolicalPLANloadtime24" then o = SVUICONFIG.option_datatext_24h end
	if o == "DiabolicalPLANloadmark_bar" then o = SVUICONFIG.option_load_mark end
	if o == "DiabolicalPLANloaddeclfg" then o = SVUICONFIG.option_load_dlfg end
	if o == "DiabolicalPLANloadcoolbar" then o = SVUICONFIG.option_load_coolbar end
	----------------------------------------------------------------------------------

	-- font_sizes
	if o == "DiabolicalPLANfont_sizes" then o = SVUICONFIG.option_datatext_font_sizes end
	--
	if o == "DiabolicalPLANfont_sizesunitname" then o = FONT_SIZE..": "..UNIT_NAMES end
	if o == "DiabolicalPLANfont_sizesunitnumber" then o = FONT_SIZE..": Numbers" end
	if o == "DiabolicalPLANfont_sizesraidname" then o = FONT_SIZE..": "..RAID_MEMBERS.." "..UNIT_NAMES end
	if o == "DiabolicalPLANfont_sizespartyname" then o = FONT_SIZE..": "..PARTY.." "..UNIT_NAMES end
	if o == "DiabolicalPLANfont_sizesp_fs" then o = FONT_SIZE..": "..PLAYER.." "..COMBAT_MESSAGES end
	if o == "DiabolicalPLANfont_sizest_fs" then o = FONT_SIZE..": "..TARGET.." "..COMBAT_MESSAGES end
	if o == "DiabolicalPLANfont_sizesa_fs" then o = FONT_SIZE..": "..COMBAT_MESSAGES end
	----------------------------------------------------------------------------------
	
	-- unit frames
	if o == "DiabolicalPLANunitops" then o = SVUICONFIG.option_unitops_unitops end
	--
	if o == "DiabolicalPLANunitopsgrid" then o = SVUICONFIG.option_actionbar_grid end
	if o == "DiabolicalPLANunitopsold_style_party" then o = SVUICONFIG.option_unitops_old_party end
	if o == "DiabolicalPLANunitopsbuffs" then o = SVUICONFIG.option_unitops_targetaura end
	if o == "DiabolicalPLANunitopsdebuffs" then o = OPTION_TOOLTIP_SHOW_CASTABLE_DEBUFFS end
	if o == "DiabolicalPLANunitopsswingbar" then o = SVUICONFIG.option_unitops_swing end
	if o == "DiabolicalPLANunitopsthreatbar" then o = SVUICONFIG.option_unitops_threatbar end
	if o == "DiabolicalPLANunitopssniper" then o = SVUICONFIG.option_unitops_ezfocus end
	if o == "DiabolicalPLANunitopsfocustarget" then o = SVUICONFIG.option_unitops_focus end
	if o == "DiabolicalPLANunitopsplayerparty" then o = SVUICONFIG.option_unitops_playerparty end
	if o == "DiabolicalPLANunitopsparty_space" then o = SVUICONFIG.option_unitops_party_spacing end
	if o == "DiabolicalPLANunitopsallparty" then o = SVUICONFIG.option_unitops_enable end
	if o == "DiabolicalPLANunitopstotalhpmp" then o = SVUICONFIG.option_unitops_totalhpmp end
	if o == "DiabolicalPLANunitopsmaintank" then o = SVUICONFIG.option_unitops_maintank end
	if o == "DiabolicalPLANunitopsmainassist" then o = SVUICONFIG.option_unitops_mainassist end
	if o == "DiabolicalPLANunitopsarenaframes" then o = SVUICONFIG.option_arena_uf end
	if o == "DiabolicalPLANunitopsraidwatch" then o = SVUICONFIG.option_unitops_aurawatch end
	if o == "DiabolicalPLANunitopsfancycp" then o = SVUICONFIG.option_nameplates_showcombo end
	----------------------------------------------------------------------------------
	
	-- ttops
	if o == "DiabolicalPLANttops" then o = SVUICONFIG.option_ttops end
	--
	if o == "DiabolicalPLANttopstooltip" then o = SVUICONFIG.option_ttops_enable end
	if o == "DiabolicalPLANttopsmousetip" then o = SVUICONFIG.option_ttops_cursor end
	if o == "DiabolicalPLANttopshidecombat" then o = SVUICONFIG.option_ttops_hidecombat end
	if o == "DiabolicalPLANttopshidebuttons" then o = SVUICONFIG.option_ttops_hidebutton end
	----------------------------------------------------------------------------------
	
	-- chatops
	if o == "DiabolicalPLANchatops" then o = SVUICONFIG.option_chatops end
	--
	if o == "DiabolicalPLANchatopschat_width" then o = SVUICONFIG.option_chatops_width end
	if o == "DiabolicalPLANchatopschat_height" then o = SVUICONFIG.option_chatops_height end
	if o == "DiabolicalPLANchatopschat" then o = SVUICONFIG.option_chatops_enable end
	if o == "DiabolicalPLANchatopschattabs" then o = SVUICONFIG.option_chatops_tabs end
	if o == "DiabolicalPLANchatopshide_chat_junk" then o = OPTION_TOOLTIP_SPAM_FILTER end
	if o == "DiabolicalPLANchatopstimestamps" then o = SVUICONFIG.option_chatops_chatopstime end
	----------------------------------------------------------------------------------

	-- panelops
	if o == "DiabolicalPLANpanelops" then o = SVUICONFIG.option_panelops end
	--
	if o == "DiabolicalPLANpanelopstop" then o = SVUICONFIG.option_panelops_top end
	if o == "DiabolicalPLANpanelopsbottom" then o = SVUICONFIG.option_panelops_bottom end
	if o == "DiabolicalPLANpanelopsminimap" then o = BINDING_NAME_TOGGLEMINIMAP end
	----------------------------------------------------------------------------------

	-- scaleops
	if o == "DiabolicalPLANscaleops" then o = SVUICONFIG.option_scaleops end
	--
	if o == "DiabolicalPLANscaleopsuiscale" then o = UI_SCALE end
	if o == "DiabolicalPLANscaleopsgridscale" then o = SVUICONFIG.option_unitops_gridscale end
	if o == "DiabolicalPLANscaleopschatscale" then o = SVUICONFIG.option_scaleops end
	if o == "DiabolicalPLANscaleopsabscale" then o = SVUICONFIG.option_scaleops_abutton end
	if o == "DiabolicalPLANscaleopsmmscale" then o = SVUICONFIG.option_scaleops_menu end
	if o == "DiabolicalPLANscaleopsufscale" then o = SVUICONFIG.option_scaleops_uframe end
	if o == "DiabolicalPLANscaleopsminimapscale" then o = SVUICONFIG.option_scaleops_minimap end
	----------------------------------------------------------------------------------
	
	SuperSet.option = o
end
local comicBG1 = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\MungMaps\CONFIG-RIGHT]]
local comicBG2 = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\MungMaps\CONFIG-LEFT]]
local mr_mung = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\MungMaps\MUNGLUNCH]]

local NewButton = function(text,parent)
	local result = CreateFrame("Button", nil, parent)
	local label = result:CreateFontString(nil,"OVERLAY",nil)
	label:SetFont(SVFonts.super,17,"OUTLINE")
	label:SetText(text)
	result:SetWidth(label:GetWidth())
	result:SetHeight(label:GetHeight())
	result:SetFontString(label)
	result:SetScript("OnEnter", function() label:SetTextColor(1,1,0) end)
	result:SetScript("OnLeave", function() label:SetTextColor(1,1,1) end)
	return result
end

-- We wanna make sure we have all needed tables when we try add values
local function SetValue(group,option,value)
	SVUISet[group][option] = value
end

local VISIBLE_GROUP = nil
local function ShowGroup(group)
	if(VISIBLE_GROUP) then
		_G["DiabolicalPLAN"..VISIBLE_GROUP]:Hide()
	end
	if _G["DiabolicalPLAN"..group] then
		local o = "DiabolicalPLAN"..group
		Local(o)
		_G["DiabolicalPLANTitle"]:SetText(SuperSet.option)
		local height = _G["DiabolicalPLAN"..group]:GetHeight()
		_G["DiabolicalPLAN"..group]:Show()
		local max = height > 250 and height-240 or 1
		if max == 1 then
			_G["DiabolicalPLANGroupSlider"]:SetValue(1)
			_G["DiabolicalPLANGroupSlider"]:Hide()
		else
			_G["DiabolicalPLANGroupSlider"]:SetMinMaxValues(0, max)
			_G["DiabolicalPLANGroupSlider"]:Show()
			_G["DiabolicalPLANGroupSlider"]:SetValue(1)
		end
		_G["DiabolicalPLANGroup"]:SetScrollChild(_G["DiabolicalPLAN"..group])
		VISIBLE_GROUP = group
	end
end

function CreateDiabolicalPLAN()
	if DiabolicalPLAN then
		ShowGroup("load")
		DiabolicalPLAN:Show()
		return
	end
	
	-- MAIN FRAME
	local DiabolicalPLAN = CreateFrame("Frame","DiabolicalPLAN",UIParent)
	DiabolicalPLAN:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 250, -150)
	DiabolicalPLAN:SetWidth(500)
	DiabolicalPLAN:SetHeight(300)
	DiabolicalPLAN:SetFrameStrata("DIALOG")
	DiabolicalPLAN:SetFrameLevel(20)
	DiabolicalPLAN:SetBackdrop({bgFile = comicBG1, tile=true, tileSize=300})
	DiabolicalPLAN:SetBackdropColor(c_r,c_g,c_b)
	SVMod.SimpleSkin(DiabolicalPLAN)
	
	-- TITLE 2
	local DiabolicalPLANTitleBox = CreateFrame("Frame","DiabolicalPLAN",DiabolicalPLAN)
	DiabolicalPLANTitleBox:SetWidth(500)
	DiabolicalPLANTitleBox:SetHeight(24)
	DiabolicalPLANTitleBox:SetPoint("TOP", 0, 42)
	SVMod.BasicSkin(DiabolicalPLANTitleBox)
	
	local title = DiabolicalPLANTitleBox:CreateFontString("DiabolicalPLANTitle", "OVERLAY")
	title:SetFont(SVFonts.super, 42, "THICKOUTLINE")
	title:SetPoint("CENTER")
	
	-- ANIMATION
	conani = CreateFrame("Frame", "SVUIConfigSprite", DiabolicalPLAN)
	conani:SetHeight(256)
	conani:SetWidth(256)
	conani:SetPoint("LEFT", DiabolicalPLAN, "RIGHT", 10, 50)
	anitex = conani:CreateTexture(nil, "ARTWORK")
	anitex:SetTexture(mr_mung)
	anitex:SetAllPoints(conani)
	anitex:SetParent(conani)
	SVAnimate.SetTrans(SVUIConfigSprite)

	-- GROUP SELECTION ( LEFT SIDE )
	local groups = CreateFrame("ScrollFrame", nil, DiabolicalPLAN)
	groups:SetPoint("TOPLEFT",-210,0)
	groups:SetWidth(200)
	groups:SetHeight(300)
	groups:SetBackdrop({bgFile = comicBG2, tile=false})
	groups:SetBackdropColor(c_r,c_g,c_b)
	SVMod.SimpleSkin(groups)
		
	local slider = CreateFrame("Slider", nil, groups)
	slider:SetPoint("TOPRIGHT",-3,-3)
	slider:SetWidth(20)
	slider:SetHeight(294)
	slider:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
	slider:SetOrientation("VERTICAL")
	slider:SetValueStep(20)
	SVMod.setbackdrop(slider)
	slider:SetBackdropColor(0.5,0.3,0,0.8)
	slider:SetBackdropBorderColor(0.8,0.8,0.3,0.9)
	slider:SetScript("OnValueChanged", function(self,value) groups:SetVerticalScroll(value) end)
	local child = CreateFrame("Frame",nil,groups)
	child:SetPoint("TOPRIGHT",-26,-12)
	child:SetWidth(174)
	child:SetHeight(288)
	local offset=12
	for group in pairs(ALLOWED_GROUPS) do
		local o = "DiabolicalPLAN"..group
		Local(o)
		local button = NewButton(SuperSet.option, child)
		button:SetHeight(16)
		button:SetWidth(130)
		button:SetPoint("TOPRIGHT",-13,-(offset))
		button:SetScript("OnClick", function(self) ShowGroup(group) end)		
		offset=offset+20
	end
	slider:SetMinMaxValues(0,100)
	slider:SetValue(1)
	groups:SetScrollChild(child)
	
	-- GROUP SCROLLFRAME ( RIGHT SIDE)
	local group = CreateFrame("ScrollFrame", "DiabolicalPLANGroup", DiabolicalPLAN)
	group:SetPoint("TOPLEFT",3,-3)
	group:SetWidth(494)
	group:SetHeight(294)
	local slider = CreateFrame("Slider", "DiabolicalPLANGroupSlider", group)
	slider:SetPoint("TOPRIGHT")
	slider:SetWidth(20)
	slider:SetHeight(294)
	slider:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
	slider:SetOrientation("VERTICAL")
	slider:SetValueStep(20)
	SVMod.setbackdrop(slider)
	slider:SetBackdropColor(0.5,0.3,0,0.8)
	slider:SetBackdropBorderColor(0.8,0.8,0.3,0.9)
	slider:SetScript("OnValueChanged", function(self,value) group:SetVerticalScroll(value) end)
	
	for group in pairs(ALLOWED_GROUPS) do
		local frame = CreateFrame("Frame","DiabolicalPLAN"..group,DiabolicalPLANGroup)
		frame:SetPoint("TOPLEFT")
		frame:SetWidth(225)
	
		local offset=5
		for option,value in pairs(SuperSet[group]) do
			
			if type(value) == "boolean" then
				local button = CreateFrame("CheckButton", "DiabolicalPLAN"..group..option, frame, "InterfaceOptionsCheckButtonTemplate")
				local o = "DiabolicalPLAN"..group..option
				Local(o)
				_G["DiabolicalPLAN"..group..option.."Text"]:SetText(SuperSet.option)
				_G["DiabolicalPLAN"..group..option.."Text"]:SetFont(SVFonts.font, 16, "OUTLINE")
				button:SetChecked(value)
				button:SetScript("OnClick", function(self) SetValue(group,option,(self:GetChecked() and true or false)) end)
				button:SetPoint("TOPLEFT", 5, -(offset))
				offset = offset+25
			elseif type(value) == "number" or type(value) == "string" then
				local label = frame:CreateFontString(nil,"OVERLAY",nil)
				label:SetFont(SVFonts.font,16,"OUTLINE")
				local o = "DiabolicalPLAN"..group..option
				Local(o)
				label:SetText(SuperSet.option)
				label:SetWidth(320)
				label:SetHeight(20)
				label:SetJustifyH("LEFT")
				label:SetPoint("TOPLEFT", 5, -(offset))
				
				local editbox = CreateFrame("EditBox", nil, frame)
				editbox:SetAutoFocus(false)
				editbox:SetMultiLine(false)
				editbox:SetWidth(220)
				editbox:SetHeight(20)
				editbox:SetMaxLetters(255)
				editbox:SetTextInsets(3,0,0,0)
				editbox:SetBackdrop({
					bgFile = [=[Interface\A_Battle_Begins\Supervillain_Media\textures\Default\blankTex]=], 
					tiled = false,
				})
				editbox:SetBackdropColor(0,0,0,0.5)
				editbox:SetBackdropBorderColor(0,0,0,1)
				editbox:SetFontObject(GameFontHighlight)
				editbox:SetPoint("TOPLEFT", 5, -(offset+20))
				editbox:SetText(value)
				
				SVMod.BasicSkin(editbox)
				
				local okbutton = CreateFrame("Button", nil, frame)
				okbutton:SetHeight(editbox:GetHeight())
				okbutton:SetWidth(editbox:GetWidth())
				SVMod.BasicSkin(okbutton)
				okbutton:SetPoint("LEFT", editbox, "RIGHT", 2, 0)
				
				local oktext = okbutton:CreateFontString(nil,"OVERLAY",nil)
				oktext:SetFont(SVFonts.cooldown,16,"OUTLINE")
				oktext:SetText(ACTIVATE.." ?")
				oktext:SetPoint("CENTER", SVMod.Scale(1), 0)
				oktext:SetJustifyH("CENTER")
				okbutton:Hide()
 
				if type(value) == "number" then
					editbox:SetScript("OnEscapePressed", function(self) okbutton:Hide() self:ClearFocus() self:SetText(value) end)
					editbox:SetScript("OnChar", function(self) okbutton:Show() end)
					editbox:SetScript("OnEnterPressed", function(self) okbutton:Hide() self:ClearFocus() SetValue(group,option,tonumber(self:GetText())) end)
					okbutton:SetScript("OnMouseDown", function(self) editbox:ClearFocus() self:Hide() SetValue(group,option,tonumber(editbox:GetText())) end)
				else
					editbox:SetScript("OnEscapePressed", function(self) okbutton:Hide() self:ClearFocus() self:SetText(value) end)
					editbox:SetScript("OnChar", function(self) okbutton:Show() end)
					editbox:SetScript("OnEnterPressed", function(self) okbutton:Hide() self:ClearFocus() SetValue(group,option,tostring(self:GetText())) end)
					okbutton:SetScript("OnMouseDown", function(self) editbox:ClearFocus() self:Hide() SetValue(group,option,tostring(editbox:GetText())) end)
				end
				offset = offset+45
			end
		end
				
		frame:SetHeight(offset)
		frame:Hide()
	end

	local reset = NewButton(SVUICONFIG.option_button_reset, DiabolicalPLAN)
	reset:SetWidth(100)
	reset:SetHeight(30)
	reset:SetPoint("BOTTOMLEFT",0, -38)
	reset:SetScript("OnClick", function(self) SVUISet = {} ReloadUI() end)
	SVMod.ButtonSkin(reset)
	
	local close = NewButton(SVUICONFIG.option_button_close, DiabolicalPLAN)
	close:SetWidth(100)
	close:SetHeight(30)
	close:SetPoint("BOTTOMRIGHT", 0, -38)
	close:SetScript("OnClick", function(self) DiabolicalPLAN:Hide() end)
	SVMod.ButtonSkin(close)
	
	local load = NewButton(SVUICONFIG.option_button_load, DiabolicalPLAN)
	load:SetHeight(30)
	load:SetPoint("LEFT", reset, "RIGHT", 15, 0)
	load:SetPoint("RIGHT", close, "LEFT", -15, 0)
	load:SetScript("OnClick", function(self) ReloadUI() end)
	SVMod.ButtonSkin(load)
	
	ShowGroup("load")
end

do
	SLASH_CONFIG1 = '/setupsvui'
	SLASH_CONFIG2 = '/munglunch'
	function SlashCmdList.CONFIG(msg, editbox)
		if not DiabolicalPLAN or not DiabolicalPLAN:IsShown() then
			CreateDiabolicalPLAN()
			SVUIConfigSprite.trans:Play()
		else
			DiabolicalPLAN:Hide()
		end
	end
end

local ipanel = CreateFrame("Frame")
ipanel.name = "SuperVillain UI"
ipanel:SetScript("OnShow", function(this)
	local t1 = this:CreateFontString(nil, "ARTWORK")
	t1:SetJustifyH("LEFT")
	t1:SetJustifyV("TOP")
	t1:SetFontObject(GameFontNormalLarge)
	t1:SetPoint("TOPLEFT", 16, -16)
	t1:SetText(this.name)
	
	local t2 = this:CreateFontString(nil, "ARTWORK")
	t2:SetJustifyH("LEFT")
	t2:SetJustifyV("TOP")
	t2:SetFontObject(GameFontHighlightSmall)
	t2:SetHeight(43)
	t2:SetPoint("TOPLEFT", t1, "BOTTOMLEFT", 0, -8)
	t2:SetPoint("RIGHT", this, "RIGHT", -32, 0)
	t2:SetNonSpaceWrap(true)
	t2:SetFormattedText("Notes: %s\nAuthor: %s\nVersion: %s\n"..
						"Hint: |cffffff00/callminion|r to ..well ..call your Minion for assistance.", 
						 "SuperVillain UI: 2",
						 GetAddOnMetadata("A_Supervillain_Emerges", "Author") or "N/A",
						 GetAddOnMetadata("A_Supervillain_Emerges", "Version") or "N/A")

	local b = CreateFrame("Button", nil, this, "UIPanelButtonTemplate")
	b:SetWidth(120)
	b:SetHeight(20)
	b:SetText(OPTIONS_MENU)
	b:SetScript("OnClick", function()
		if not DiabolicalPLAN or not DiabolicalPLAN:IsShown() then
			CreateDiabolicalPLAN()
			SVUIConfigSprite.trans:Play()
		else
			DiabolicalPLAN:Hide()
		end
	end)
	b:SetPoint("TOPLEFT", t2, "BOTTOMLEFT", -2, -8)
	this:SetScript("OnShow", nil)
end)
InterfaceOptions_AddCategory(ipanel)