local aniToggle = function (toon)
	if toon:IsShown() then
		toon:Hide()
	else
		toon:Show()
	end
end
SVAnimate.Tog = aniToggle

-----------////FLASH ANIMATION////------------------------------------------------------------------------
function SVAnimate.SetFlash(f)
	f.anim = f:CreateAnimationGroup("Flash")
	f.anim.fadein = f.anim:CreateAnimation("ALPHA", "FadeIn")
	f.anim.fadein:SetChange(1)
	f.anim.fadein:SetOrder(2)

	f.anim.fadeout = f.anim:CreateAnimation("ALPHA", "FadeOut")
	f.anim.fadeout:SetChange(-1)
	f.anim.fadeout:SetOrder(1)
end

-----------///Pulsing Animation//-------------------------------------------------------------------------
function SVAnimate.SetPulse(f, l, s, d1, d2)   ----(frame, loopingstate, scale, duration1, duration2)--------
	f.fade = f:CreateAnimationGroup()
	f.fadeAlpha = f.fade:CreateAnimation()
	f.fadeAlpha.parent = f
	f.fadeAlpha:SetScript("OnPlay", function(f)
	f.startAlpha = f.parent:GetAlpha()
	if f.startAlpha ~= 1 then
		f.endAlpha = 1
	else
		f.endAlpha = 0.1
	end
	end)
	f.fadeAlpha:SetScript("OnUpdate", function(f)		
		local new = f.startAlpha + ((f.endAlpha - f.startAlpha) * f:GetProgress())
		f.parent:SetAlpha(new)
	end)

	local pulseScale = s
	local d1 = d1 or 0.2
	local d2 = d2 or 0.6
	f.pulse = f:CreateAnimationGroup()
	if l == 1 then
		f.pulse:SetLooping("BOUNCE")
	end
	f.pulse[1] = f.pulse:CreateAnimation()
	f.pulse[1]:SetDuration(d1)
	f.pulse[1]:SetEndDelay(0.1)
	f.pulse[1]:SetOrder(1)
	f.pulse[1]:SetScript("OnUpdate", function(self)
		local p = self:GetRegionParent()
		p:SetFrameLevel(128)
		self:GetRegionParent():SetScale(1 + (pulseScale * self:GetProgress()))
		if not f.fade:IsPlaying() and l ~= 0 then
			f.fadeAlpha:SetDuration(d1)
			f.fade:Play()
		end
	end)

	f.pulse[2] = f.pulse:CreateAnimation()
	f.pulse[2]:SetDuration(d2)
	f.pulse[2]:SetOrder(2)
	f.pulse[2]:SetScript("OnUpdate", function(self)
		local p = self:GetRegionParent()
		p:SetFrameLevel(128)
		p:SetScale(1 + (pulseScale * (1 - self:GetProgress())))
		if not f.fade:IsPlaying() and l ~= 0 then
			f.fadeAlpha:SetDuration(d2)
			f.fade:Play()
		end
	end)

	f.pulse:SetScript("OnPlay", function()
		f.FrameLevel = f.FrameLevel or f:GetFrameLevel()
		f:SetFrameLevel(128)
	end)
	f.pulse:SetScript("OnStop", function()
		f:SetScale(1)
		if l ~= 0 then
			f.fade:Stop()
		end
		f:SetAlpha(1)
		if f.FrameLevel then
			f:SetFrameLevel(f.FrameLevel)
			f.FrameLevel = nil
		end
	end)
	f.pulse:SetScript("OnFinished", f.pulse:GetScript("OnStop"))
end
-------------------------------------
----SLIDER ANIMATIONS-----------------
function SVAnimate.SetTrans(f)
	local layer = layer or 1
	f.trans = f:CreateAnimationGroup()
	f.trans[1] = f.trans:CreateAnimation("Translation")
	f.trans[1]:SetOrder(1)
	f.trans[1]:SetOffset(10,10)
	f.trans[1]:SetDuration(3)
	f.trans[1]:SetScript("OnUpdate", function(self)
		local p = self:GetRegionParent()
		if layer == 1 then
			p:SetFrameLevel(128)
		else
			p:SetFrameLevel(108)
		end
	end)
	
	f.trans[2] = f.trans:CreateAnimation("Translation")
	f.trans[2]:SetOrder(2)
	f.trans[2]:SetOffset(-10,10)
	f.trans[2]:SetDuration(4)
	f.trans[2]:SetScript("OnUpdate", function(self)
		local p = self:GetRegionParent()
		if layer == 1 then
			p:SetFrameLevel(128)
		else
			p:SetFrameLevel(108)
		end
	end)
	
	f.trans[3] = f.trans:CreateAnimation("Translation")
	f.trans[3]:SetOrder(3)
	f.trans[3]:SetOffset(-10,-10)
	f.trans[3]:SetDuration(3)
	f.trans[3]:SetScript("OnUpdate", function(self)
		local p = self:GetRegionParent()
		if layer == 1 then
			p:SetFrameLevel(128)
		else
			p:SetFrameLevel(108)
		end
	end)
	
	f.trans[4] = f.trans:CreateAnimation("Translation")
	f.trans[4]:SetOrder(4)
	f.trans[4]:SetOffset(10,-10)
	f.trans[4]:SetDuration(4)
	f.trans[4]:SetScript("OnUpdate", function(self)
		local p = self:GetRegionParent()
		if layer == 1 then
			p:SetFrameLevel(128)
		else
			p:SetFrameLevel(108)
		end
	end)
	
	f.trans:SetScript("OnPlay", function()
		f.FrameLevel = f.FrameLevel or f:GetFrameLevel()
		f:SetFrameLevel(128)
	end)
end

local slider = function (self,k,x,y)
	self.slide = self:CreateAnimationGroup("Move_In")
	self.slide.in_a = self.slide:CreateAnimation("Translation")
	self.slide.in_a:SetDuration(0)
	self.slide.in_a:SetOrder(1)
	self.slide.in_b = self.slide:CreateAnimation("Translation")
	self.slide.in_b:SetDuration(.3)
	self.slide.in_b:SetOrder(2)
	self.slide.in_b:SetSmoothing("OUT")
	self.slide_out = self:CreateAnimationGroup("Move_Out")
	self.slide_out.b = self.slide_out:CreateAnimation("Translation")
	self.slide_out.b:SetDuration(.3)
	self.slide_out.b:SetOrder(1)
	self.slide_out.b:SetSmoothing("IN")
	self.slide.in_a:SetOffset(x,y)
	self.slide.in_b:SetOffset(-x,-y)
	self.slide_out.b:SetOffset(x,y)	
	if k then self.slide_out:SetScript("OnFinished",function() self:Hide() end) end
end
SVAnimate.Slide = slider
--[[
UIFrameFadeOut(frame, timeToFade, startAlpha, endAlpha)
UIFrameFadeIn(frame, timeToFade, startAlpha, endAlpha)
]]--