-----------------------------------------------------------------------------
-------SET AUTO SCALING------------------------------------------------------
-----------------------------------------------------------------------------
function SVRoot.UIScale()
	-- the tukui high reso whitelist
	if not (SVRoot.getscreenresolution == "1680x945"
		or SVRoot.getscreenresolution == "2560x1440" 
		or SVRoot.getscreenresolution == "1680x1050" 
		or SVRoot.getscreenresolution == "1920x1080" 
		or SVRoot.getscreenresolution == "1920x1200" 
		or SVRoot.getscreenresolution == "1600x900" 
		or SVRoot.getscreenresolution == "2048x1152" 
		or SVRoot.getscreenresolution == "1776x1000" 
		or SVRoot.getscreenresolution == "2560x1600" 
		or SVRoot.getscreenresolution == "1600x1200") then
			SVRoot.lowversion = true		
	end

	if SuperSet.autoscale == true then
		SuperSet["scaleops"].uiscale = min(2, max(.64, 768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)")))
	end

	if SVRoot.lowversion then
		SuperSet["scaleops"].gridscale = 0.8
	else
		SuperSet["scaleops"].gridscale = 1
	end
end
SVRoot.UIScale()

local mult = 768/string.match(GetCVar("gxResolution"), "%d+x(%d+)")/SuperSet["scaleops"].uiscale
local function scale(x)
    return mult*math.floor(x/mult+.5)
end

function SVMod.Scale(x) return scale(x) end
SVMod.mult = mult

SVMod.uiscale = SuperSet["scaleops"].uiscale
-----------------------------------------------------------------------------
-------KILL THE MM CLOCK-----------------------------------------------------
-----------------------------------------------------------------------------
local f = CreateFrame("Frame", nil, UIParent)
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(self, event, name)
    if name == "Blizzard_TimeManager" then
        TimeManagerClockButton:Hide()
        TimeManagerClockButton:SetScript("OnShow", function(self)
            TimeManagerClockButton:Hide()
        end)
    end
end)
-----------------------------------------------------------------------------
-------KILL OTHER STUFF------------------------------------------------------
-----------------------------------------------------------------------------
function SVMod.Kill(object)
	if not object then return end
	if object.UnregisterAllEvents then
		object:UnregisterAllEvents()
	end
	object.Show = SVRoot.dummy
	object:Hide()
end
-----------------------------------------------------------------------------
-------STATUSBAR TEXTURE SMOOTHING-------------------------------------------
-----------------------------------------------------------------------------
local function fixStatBar(bar)
	bar:GetStatusBarTexture():SetHorizTile(false)
end
SVMod.fixStatBar = fixStatBar
-----------------------------------------------------------------------------
-------( COLOR ) MATH FUNCTIONS----------------------------------------------
-----------------------------------------------------------------------------
SVMod.Round = function(number, decimals)	
	if not decimals then decimals = 0 end
	return (("%%.%df"):format(decimals)):format(number)
end
	
SVMod.RGBPercToHex = function(r, g, b)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("|cff%02x%02x%02x", r*255, g*255, b*255)
end
-----------------------------------------------------------------------------
-------MUNGMAP HANDLERS------------------------------------------------------
-----------------------------------------------------------------------------
---USAGE---     
---art: Texture Frame Name
---tex: Texture file to pull from
---pos: The image extracted from the map
-----------------------------------------------------------------------------
local MapDraw = function (art,tex,pos) 
	local map = SVConfig["MungMap"]
	local a = map[tex]
	local b = a[1]
	local c = a[2]
	local map2 = SVConfig[c]
	local d = map2[pos]

	art:SetTexture(b)
	art:SetTexCoord(d[1],d[2],d[3],d[4])
	return art
end
SVMod.MapDraw = MapDraw

local rotateTex = function (self, degrees)
	local angle = math.rad(degrees)
	local cos, sin = math.cos(angle), math.sin(angle)
	self:SetTexCoord((sin - cos), -(cos + sin), -cos, -sin, sin, -cos, 0, 0)
end
SVMod.RotateTexture = rotateTex