local gradient = {.2,.2,.2,.25,.25,.25,.25,.6}
local gradient2 = {.35,.35,.35,.7,.5,.5,.5,.25}
local _G = _G
function RunSlashCmd(cmd)
  local slash, rest = cmd:match("^(%S+)%s*(.-)$")
  for name, func in pairs(SlashCmdList) do
     local i, slashCmd = 1
     repeat
        slashCmd, i = _G["SLASH_"..name..i], i + 1
        if slashCmd == slash then
           return true, func(rest)
        end
     until not slashCmd
  end
  -- Okay, so it's not a slash command. It may also be an emote.
  local i = 1
  while _G["EMOTE" .. i .. "_TOKEN"] do
     local j, cn = 2, _G["EMOTE" .. i .. "_CMD1"]
     while cn do
        if cn == slash then
           return true, DoEmote(_G["EMOTE" .. i .. "_TOKEN"], rest);
        end
        j, cn = j+1, _G["EMOTE" .. i .. "_CMD" .. j]
     end
     i = i + 1
  end
end 
SVMod.RunSlash = RunSlashCmd

local bg11 = {
	bgFile = SVMedia.blank, 
	edgeFile = SVMedia.glow, 
	edgeSize = 4, insets = {left = 3, right = 3, top = 3, bottom = 3}}
	
local style = function (myframe,nobg,f1,blend,invis,flip)
	if not myframe then return end
	local off = f1 or 3
	local culla, grady, bgtex, alf
	if invis == true then
		culla = {0,0,0,0}
		grady = {0,0,0,0,0,0,0,0}
		bgtex = {0,0,0,0}
		alf = 0
	elseif flip == true then
		culla = SVMedia.bordercolor
		grady = gradient2
		bgtex = {1,1,1,1}
		alf = 1
	else
		culla = SVMedia.bordercolor
		grady = gradient
		bgtex = {1,1,1,1}
		alf = 1
	end
	if nobg ~= true then
		local bg = myframe:CreateTexture(nil,"BORDER")
		bg:SetPoint("TOPLEFT",off+1,-off-1)
		bg:SetPoint("BOTTOMRIGHT",-off-1,off+1)
		bg:SetTexture(unpack(bgtex))
		bg:SetGradientAlpha("VERTICAL",unpack(grady))
		bg:SetBlendMode(blend or "ADD")
		myframe.bg = bg
	end
	
	local left = myframe:CreateTexture(nil,"OVERLAY")
	left:SetTexture(unpack(culla))
	left:SetPoint("TOPLEFT",off,-off)
	left:SetPoint("BOTTOMLEFT",off,off)
	left:SetWidth(1)
	left:SetAlpha(alf)
	myframe.left = left
	
	local right = myframe:CreateTexture(nil,"OVERLAY")
	right:SetTexture(unpack(culla))
	right:SetPoint("TOPRIGHT",-off,-off)
	right:SetPoint("BOTTOMRIGHT",-off,off)
	right:SetWidth(1)
	right:SetAlpha(alf)
	myframe.right = right
	
	local bottom = myframe:CreateTexture(nil,"OVERLAY")
	bottom:SetTexture(unpack(culla))
	bottom:SetPoint("BOTTOMLEFT",off,off)
	bottom:SetPoint("BOTTOMRIGHT",-off,off)
	bottom:SetHeight(1)
	bottom:SetAlpha(alf)
	myframe.bottom = bottom
	
	local top = myframe:CreateTexture(nil,"OVERLAY")
	top:SetTexture(unpack(culla))
	top:SetPoint("TOPLEFT",off,-off)
	top:SetPoint("TOPRIGHT",-off,off)
	top:SetHeight(1)
	top:SetAlpha(alf)
	myframe.top = top
end
SVMod.style = style

local setbackdrop = function (self)
	if not self then return end
	self:SetBackdrop(bg11)
	self:SetBackdropBorderColor(unpack(SVMedia.bordershadow))
	self:SetBackdropColor(unpack(SVMedia.backdropcolor))
end
SVMod.setbackdrop = setbackdrop

local setmentalobg = function (self)
	if not self then return end
	self:SetBackdrop(bg11)
	self:SetBackdropBorderColor(0.5,0.8,1,0.15)
	self:SetBackdropColor(0.5,0.8,1,0.5)
end
SVMod.MentaloBG = setmentalobg

SVMod.frame = function (parent,level,strata,nobg,nols,off,tag,blend,invis)
	local myframe = CreateFrame ("Frame",tag,parent)
	
	if nols ~= true then
		myframe:SetFrameLevel(level or 2)
		myframe:SetFrameStrata(strata or "LOW")
	end
	if invis ~= true then
		setbackdrop(myframe)
	end
	style(myframe,nobg,off,blend,invis)
	return myframe
end

SVMod.flipframe = function (parent,level,strata,nobg,nols,off,tag,blend,invis)
	local myframe = CreateFrame ("Frame",tag,parent)
	
	if nols ~= true then
		myframe:SetFrameLevel(level or 2)
		myframe:SetFrameStrata(strata or "LOW")
	end
	if invis ~= true then
		setbackdrop(myframe)
	end
	style(myframe,nobg,off,blend,invis,true)
	return myframe
end

SVMod.SetFont = function(parent,size,isoffset,layer,fy,fz,outline)
	local a = parent:CreateFontString(nil,layer or "OVERLAY")
	a:SetFont(SVFonts.font,size or 13,outline or nil)
	if not(isoffset) then
		a:SetShadowOffset(1,-1)
	end
	a:SetJustifyH(fy or "LEFT")
	a:SetJustifyV(fz or "MIDDLE")
	a:SetHeight(size or 13)
	return a
end

SVRoot.Null = function() end
SVRoot.PostApply = {}

local abc = CreateFrame("Frame")
abc:Hide()
abc:RegisterEvent("PLAYER_ENTERING_WORLD")
abc:SetScript("OnEvent",function(self) self:Show() end)

local function GetSpellID(spell)
    local name
    for i = 1, 100000 do
        name = GetSpellInfo(i)
        if name == spell then
            return i
        end
    end
end

local n = 2
local abcload = function()
	for _,f in pairs(SVRoot.PostApply) do f() end
	SVRoot.PostApply = nil
	abc:SetScript("OnEvent",SVRoot.Null)
	abc:UnregisterAllEvents()
	abc:Hide()
	collectgarbage()
end

abc:SetScript("OnUpdate",function(self,t)
	n = n - t
	if n > 0 then return end
	self:SetScript("OnUpdate",SVRoot.Null)
		if not InCombatLockdown() then
			abcload()
		else
			self:RegisterEvent("PLAYER_REGEN_ENBALED")
		end
end)

local setbutton = function (target,ison,parent)
	local button = CreateFrame ("Frame",nil,parent)
	button:SetFrameLevel(7)
	button:SetFrameStrata("HIGH")
	button:SetBackdrop(bg11)
	button.txt = SVMod.SetFont(button,12)
	button.txt:SetTextColor(1,1,0.2)
	button.txt:SetText("")
	button.txt:SetAllPoints(button)
	button.txt:SetJustifyH("CENTER")
	button.txt:SetJustifyV("CENTER")
	if target == true and ison == true then
		button:SetBackdropColor(0,.8,.8,.9)
		button:SetBackdropBorderColor(0,.8,.8,.9)
		button.txt:SetText("ON")
	elseif not target and not ison then
		button:SetBackdropColor(1,.1,.1,.9)
		button:SetBackdropBorderColor(1,.1,.1,.9)
		button.txt:SetText("OFF")
	else
		button:SetBackdropColor(.3,.3,.3,.9)
		button:SetBackdropBorderColor(.3,.3,.3,.9)
		button.txt:SetText("")
	end
	button:SetWidth(35)
	button:SetHeight(18)
	return button
end

local swch = function (self,ison,alternative)
	local target
	if ison == true then
		self:SetBackdropColor(0,.8,.8,.9)
		self:SetBackdropBorderColor(0,.8,.8,.9)
		self.txt:SetText("ON")
		target = true
	else
		self:SetBackdropColor(1,.1,.1,.9)
		self:SetBackdropBorderColor(1,.1,.1,.9)
		self.txt:SetText("OFF")
		target = false
	end
	alternative:SetBackdropColor(.3,.3,.3,.9)
	alternative:SetBackdropBorderColor(.3,.3,.3,.9)
	alternative.txt:SetText("")
	return target
end

local makebuttons = function(parent,r,s)
	local a = setbutton(r[s],true,parent)
	local b = setbutton(r[s],false,parent)
	a:SetScript("OnMouseDown",function() r[s] = swch(a,true,b) end)
	b:SetScript("OnMouseDown",function() r[s] = swch(b,false,a)end)
	
	b:SetPoint("RIGHT",a,"LEFT",-4,0)
	return a
end
local mkerase = function(parent,ptxt,entry,pos)
	local a = CreateFrame("Button",nil,parent)
	a:SetSize(64,17)
	a:SetPoint("RIGHT",parent,"LEFT",-10,0)
	
	local t = SVMod.SetFont(a,15,nil,nil,"RIGHT")
	t:SetText("X")
	t:SetAllPoints()
	
	a:SetScript("OnEnter",function() t:SetTextColor(1,.3,.3) end)
	a:SetScript("OnLeave",function() t:SetTextColor(1,1,1) end)
	a:SetScript("OnClick",function() SVUIAuraBars[entry][pos] = nil; parent:SetAlpha(0.4); ptxt:SetAlpha(0.4); end)
end
local seteditbox = function (val,parent)
	local editbox = CreateFrame("EditBox", nil, parent)
	local val = val or 0
	editbox:SetAutoFocus(false)
	editbox:SetMultiLine(false)
	editbox:SetWidth(95)
	editbox:SetHeight(20)
	editbox:SetMaxLetters(30)
	editbox:SetTextInsets(12,0,0,0)
	editbox:SetBackdrop(bg11)
	editbox:SetBackdropColor(0,0,0,0.8)
	editbox:SetBackdropBorderColor(0,.8,.8,.9)
	editbox:SetFontObject(GameFontHighlight)
	editbox:SetText(val)
	return editbox
end

local maketext = function(parent,r,s)
	local a = seteditbox(r[s],parent)
	a:SetScript("OnEscapePressed", function(self) self:ClearFocus() self:SetText(value) end)
	a:SetScript("OnChar", function(self) r[s] = tonumber(self:GetText()) end)
	a:SetScript("OnEnterPressed", function(self) self:ClearFocus() r[s] = tonumber(self:GetText()) end)
	return a
end

local setslides_scale = function (val,parent)
	local slide = CreateFrame ("Slider",nil,parent)
	slide:SetFrameLevel(7)
	slide:SetFrameStrata("HIGH")
	slide:SetBackdrop(bg11)
	slide:SetOrientation("HORIZONTAL")
	local slidetex = slide:CreateTexture (nil,"OVERLAY")
	slidetex:SetTexture (1,1,1,1)
	slidetex:SetGradient("HORIZONTAL",0,0.8,0.8,0,0.4,0.4)
	slide:SetThumbTexture(slidetex)
	slide:SetBackdropColor(0.3,0.8,0.8,0.2)
	slide:SetBackdropBorderColor(0,.8,.8,.9)
	slide:SetWidth(200)
	slide:SetHeight(18)
	slide.txt = SVMod.SetFont(slide,15)
	slide.txt:SetText(floor(val*100).." %")
	slide.txt:SetPoint("RIGHT",slide,"LEFT",-6,0)
	slide:SetValueStep(0.01)
	slide:SetMinMaxValues(0.64,1.28)
	slide:SetValue(val)
	return slide
end

local makeslides_scale = function(parent,r,s)
	local a = setslides_scale(r[s],parent)
	a:SetScript("OnValueChanged", function(self,value) a.txt:SetText(floor(value*100).." %"); r[s] = (floor(value*100)*0.01) end)
	return a
end

local setslides_font = function (val,parent)
	local slide = CreateFrame ("Slider",nil,parent)
	slide:SetFrameLevel(7)
	slide:SetFrameStrata("HIGH")
	slide:SetBackdrop(bg11)
	slide:SetOrientation("HORIZONTAL")
	local slidetex = slide:CreateTexture (nil,"OVERLAY")
	slidetex:SetTexture (1,1,1,1)
	slidetex:SetGradient("HORIZONTAL",0,0.8,0.8,0,0.4,0.4)
	slide:SetThumbTexture(slidetex)
	slide:SetBackdropColor(0.3,0.8,0.8,0.2)
	slide:SetBackdropBorderColor(0,.8,.8,.9)
	slide:SetWidth(200)
	slide:SetHeight(18)
	slide.txt = SVMod.SetFont(slide,15)
	slide.txt:SetText(val)
	slide.txt:SetPoint("RIGHT",slide,"LEFT",-6,0)
	slide:SetValueStep(1)
	slide:SetMinMaxValues(8,22)
	slide:SetValue(val)
	return slide
end

local makeslides_font = function(parent,r,s)
	local a = setslides_font(r[s],parent)
	a:SetScript("OnValueChanged", function(self,value) a.txt:SetText(value); r[s] = (value) end)
	return a
end

local setmenutext = function(t,frame)
	local text = SVMod.SetFont(frame)
	text:SetText(t)
	return text
end

local setspelltext = function(id,frame)
	local text = SVMod.SetFont(frame)
	local name,_,_,_,_,_,_,_,_ = GetSpellInfo(id)
	text:SetText(name)
	return text
end

local close_ui_button = function(parent)
	local a = CreateFrame("Button",nil,parent)
	a:SetSize(64,17)
	a:SetPoint("BOTTOMLEFT",parent,10,7)
	
	local t = SVMod.SetFont(a,15)
	t:SetText("RELOAD")
	t:SetAllPoints()
	
	a:SetScript("OnEnter",function() t:SetTextColor(1,.3,.3) end)
	a:SetScript("OnLeave",function() t:SetTextColor(1,1,1) end)
	a:SetScript("OnClick",ReloadUI)
end

local mkclose = function(parent)
	local a = CreateFrame("Button",nil,parent)
	a:SetSize(64,17)
	a:SetPoint("BOTTOMRIGHT",parent,-10,7)
	
	local t = SVMod.SetFont(a,15,nil,nil,"RIGHT")
	t:SetText("CLOSE")
	t:SetAllPoints()
	
	a:SetScript("OnEnter",function() t:SetTextColor(1,.3,.3) end)
	a:SetScript("OnLeave",function() t:SetTextColor(1,1,1) end)
	a:SetScript("OnClick",function() UIFrameFadeOut(parent,.7,1,0) parent.fd:Show() end)
end
local mkaclose = function(parent,fdfrm)
	local a = CreateFrame("Button",nil,parent)
	local fdfrm = fdfrm or parent
	a:SetSize(64,17)
	a:SetPoint("BOTTOMRIGHT",parent,-10,7)
	
	local t = SVMod.SetFont(a,15,nil,nil,"RIGHT")
	t:SetText("CLOSE")
	t:SetAllPoints()
	
	a:SetScript("OnEnter",function() t:SetTextColor(1,.3,.3) end)
	a:SetScript("OnLeave",function() t:SetTextColor(1,1,1) end)
	a:SetScript("OnClick",function() UIFrameFadeOut(fdfrm,.7,1,0) fdfrm.fd:Show() end)
end
local load_aura_info = function(id,tab)
	local aset,cid,sid
	local fail = "FAIL"
	sid = tonumber(id)
	cid = GetSpellInfo(sid)
	if (cid) then
		aset = SVMod.CreateSpellEntry( sid )
		tinsert(tab,aset)
		return aset
	else
		return fail
	end
end

local new_aura_button = function(anchor,tab,pos,new,newtxt,parent)
	local editboxy = CreateFrame("EditBox", nil, anchor)
	editboxy:SetAutoFocus(false)
	editboxy:SetMultiLine(false)
	editboxy:SetWidth(225)
	editboxy:SetHeight(20)
	editboxy:SetMaxLetters(50)
	editboxy:SetTextInsets(12,0,0,0)
	editboxy:SetBackdrop(bg11)
	editboxy:SetBackdropColor(0,0,0,0.8)
	editboxy:SetBackdropBorderColor(0,.8,.8,.9)
	editboxy:SetFontObject(GameFontHighlight)
	editboxy:SetText("Enter Spell-ID")
	editboxy:SetPoint("BOTTOMLEFT",anchor,7,7)
	local adb = SVUIAuraBars[tab]
	local loadit = function()
		local entered = tostring(editboxy:GetText())
		if strlen(entered) >= 2 then
			local cid = load_aura_info(tostring(editboxy:GetText()),adb)
			if cid ~= "FAIL" then
				local newer = maketext(parent,cid,"id")
				newer:SetPoint("TOPRIGHT",new,"BOTTOMRIGHT",0,-3)
				local newertxt = setspelltext(cid["id"],parent)
				newertxt:SetPoint("TOPLEFT",newtxt,"BOTTOMLEFT",0,-10.2)
			else
				print("Spell not found...")
			end
		end
		editboxy:ClearFocus()
		editboxy:SetText("")
	end
	editboxy:SetScript("OnEscapePressed", function(self) self:ClearFocus() end)
	editboxy:SetScript("OnEnterPressed", function() loadit() end)
	
	local a = CreateFrame("Button",nil,anchor)
	a:SetSize(64,17)
	a:SetPoint("LEFT",editboxy,"RIGHT",5,0)
	
	local t = SVMod.SetFont(a,15)
	t:SetText("ADD")
	t:SetAllPoints()
	a:SetScript("OnEnter",function() t:SetTextColor(1,.3,.3) end)
	a:SetScript("OnLeave",function() t:SetTextColor(1,1,1) end)
	a:SetScript("OnClick",function()
		loadit()
	end)
end

local mkfade = function(p)
	p.fd = CreateFrame("Frame",nil,p)
	p.fd:Hide()
	p.fd:SetScript("OnUpdate",function(self) 
		if p:GetAlpha() == 0 then 
			p:Hide()
			self:Hide()
		end
	end)
	p:SetScript("OnShow",function(self) 
		self.fd:Hide()
		UIFrameFadeIn(self,.7,0,1)
	end)
end

local makeframe = function(nametable,swtable,offset,width,sname,showreload,desc,kind)
	local aboffset
	if desc then
		aboffset = (offset or 0) + 60
	else
		aboffset = (offset or 0) + 30
	end
	local frame = SVMod.frame(UIParent)
	frame:Hide()
	frame:SetWidth(width or 70)
	frame:SetPoint("TOPRIGHT",UIParent,"TOPRIGHT",-280,-200)
	local b1,b2 = {}
	local i = 1
	local lasttext
	local switchtype
	if kind == "SCALE" then
		switchtype = makeslides_scale
	elseif kind == "FONT" then
		switchtype = makeslides_font
	else
		switchtype = makebuttons
	end
	if swtable then
		for y,name in pairs(swtable) do
			if (kind ~= "SCALE" and kind ~= "FONT") and (type(name) == "number") then
				b1[i] = maketext (frame,swtable,y)
			else
				b1[i] = switchtype (frame,swtable,y)
			end
			local a = setmenutext(nametable[y],frame)
			if i == 1 then
				b1[i]:SetPoint("TOPRIGHT",frame,-18,-aboffset+1.5)
				a:SetPoint("TOPLEFT",frame,18,-aboffset)
			else
				b1[i]:SetPoint("TOPRIGHT",b1[i-1],"BOTTOMRIGHT",0,-3)
				a:SetPoint("TOPLEFT",lasttext,"BOTTOMLEFT",0,-8)
			end
			lasttext = a
			i = i + 1
		end
	end
	frame:SetHeight((i-1)*23+aboffset+28)
	mkclose(frame)
	mkfade(frame)
	if showreload then
		close_ui_button(frame)
	end
	local stname = SVMod.SetFont(frame,15,nil,nil,"CENTER")
	stname:SetPoint("TOPLEFT",8,-6)
	stname:SetPoint("TOPRIGHT",-8,-6)
	stname:SetText(sname)
	local stdesc = SVMod.SetFont(frame,12,nil,nil,"CENTER")
	stdesc:SetPoint("TOPLEFT",stname,"BOTTOMLEFT",0,-6)
	stdesc:SetPoint("TOPRIGHT",stname,"BOTTOMRIGHT",0,-6)
	stdesc:SetText(desc)
	
	return frame
end
SVMod.make_settings = makeframe
-----------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------
local makeselector = function(nutabz,nametable,tabz,saved,offset,width,sname,showreload,desc)
	local aboffset
	if desc then
		aboffset = (offset or 0) + 50
	else
		aboffset = (offset or 0) + 20
	end
	
	local frame = SVMod.frame(UIParent)
	frame:SetWidth(1020)
	frame:SetHeight(450)
	frame:SetPoint("TOPLEFT",UIParent,"TOPLEFT",35,-185)
	frame:SetBackdropColor(0.1,0.1,0.1,0.8)
	frame.bg:SetGradientAlpha("VERTICAL",0,0,0,0.4,0,0,0,0.8)
	
	local b1,tseg,b2 = {},{}
	local k = 1
	local lasttext
	local ltxt
	local newitem
	local lastgrp = frame
	
	for i=1, nutabz do
		local group = CreateFrame("ScrollFrame", nil, frame)
		if i == 1 then
			group:SetPoint("BOTTOMLEFT",lastgrp,"BOTTOMLEFT",28,36)
		else
			group:SetPoint("BOTTOMLEFT",lastgrp,"BOTTOMRIGHT",20,0)
		end
		group:SetWidth(320)
		group:SetHeight(350)
		lastgrp = group
		local slider = CreateFrame("Slider", nil, group)
		slider:SetPoint("TOPLEFT",-22,-2)
		slider:SetWidth(20)
		slider:SetHeight(350)
		slider:SetBackdrop(bg11)
		slider:SetBackdropColor(0.3,0.8,0.6,0.4)
		slider:SetBackdropBorderColor(0,.8,.8,.9)
		local slidetex = slider:CreateTexture (nil,"OVERLAY")
		slidetex:SetTexture (1,1,1,1)
		slidetex:SetGradient("VERTICAL",0.8,0.9,0.2,0.9,0.5,0.1)
		slidetex:SetHeight(20)
		slidetex:SetWidth(20)
		slider:SetThumbTexture(slidetex)
		slider:SetOrientation("VERTICAL")
		slider:SetValueStep(15)
		slider:SetMinMaxValues(1,600)
		slider:SetValue(1)
		local framed = SVMod.frame(group)
		framed:SetPoint("TOPLEFT",group)
		framed:SetWidth(300)
		framed:SetHeight(600)
		group:SetScrollChild(framed)
		slider:SetScript("OnValueChanged", function(self,value) group:SetVerticalScroll(value) end)
		local edit = SVMod.frame(group)
		edit:SetPoint("TOPLEFT",group,"BOTTOMLEFT")
		edit:SetWidth(300)
		edit:SetHeight(34)
		local detab = tabz[i]
		local usedis = saved[detab]
		for y,name in pairs(usedis) do
			if name["id"] then
				txtf = CreateFrame("Frame",nil,framed)
				txtf:SetWidth(framed:GetWidth()-36)
				txtf:SetHeight(16)
				tseg[k] = txtf
				if k == 1 then
					tseg[k]:SetPoint("TOPRIGHT",framed,-18,-aboffset+1.5)
				else
					tseg[k]:SetPoint("TOP",tseg[k-1],"BOTTOM",0,-3)
				end
				b1[k] = maketext(tseg[k],name,"id")
				local a = setspelltext(name["id"],tseg[k])
				b1[k]:SetPoint("RIGHT",tseg[k])
				a:SetPoint("LEFT",tseg[k])
				mkerase(b1[k],a,detab,k)
				lasttext = a
				ltxt = lasttext
				newitem = b1[k]
				k = k + 1
			end
		end
		
		new_aura_button(edit,detab,k,newitem,ltxt,framed)
		local stname = SVMod.SetFont(framed,15,nil,nil,"CENTER")
		stname:SetPoint("TOPLEFT",8,-6)
		stname:SetPoint("TOPRIGHT",-8,-6)
		stname:SetText(nametable[i])
		
		k = 1
	end
	
	local frame4 = SVMod.frame(frame)
	frame4:SetPoint("TOP",frame,"BOTTOM")
	frame4:SetWidth(320)
	frame4:SetHeight(34)
	
	frame:Hide()

	mkfade(frame)
	mkaclose(frame4,frame)

	if showreload then
		close_ui_button(frame4)
	end
	
	local mstname = SVMod.SetFont(frame,20,nil,nil,"CENTER")
	mstname:SetPoint("TOPLEFT",8,-6)
	mstname:SetPoint("TOPRIGHT",-8,-6)
	mstname:SetText(sname)
	local stdesc = SVMod.SetFont(frame,18,nil,nil,"CENTER")
	stdesc:SetPoint("TOPLEFT",mstname,"BOTTOMLEFT",0,-6)
	stdesc:SetPoint("TOPRIGHT",mstname,"BOTTOMRIGHT",0,-6)
	stdesc:SetText(desc)
	
	return frame
end
SVMod.make_selector = makeselector
-----------------------------------------------------------------------------------------------------------------
local re_color = function(self,r_col,g_col,b_col,bd)
	self.top:SetTexture(r_col,g_col,b_col)
	self.bottom:SetTexture(r_col,g_col,b_col)
	self.right:SetGradientAlpha("VERTICAL",r_col,g_col,b_col,0.86,0,0,0,0)
	self.left:SetGradientAlpha("VERTICAL",r_col,g_col,b_col,0.86,0,0,0,0)
	if bd == true then
		self:SetBackdropBorderColor(r_col,g_col,b_col)
	end
	if self.Portrait then
		if self.Portrait.bg then
			self.Portrait.bg:SetBackdropBorderColor(r,g,b,1)
		end
	end
end	
SVMod.re_Color = re_color
local re_color2 = function(self,r,g,b,ag)
	if self.Portrait then
		if self.Portrait.bg then
			self.Portrait.bg:SetBackdropBorderColor(r,g,b,1)
		end
	end
	if ag then 
		self:SetBackdropColor(r,g,b)
		self:SetBackdropBorderColor(r,g,b)
	end
	if self.glow then
		self.glow.top:SetTexture(r,g,b)
		self.glow.bottom:SetTexture(r,g,b)
		self.glow.left:SetTexture(r,g,b)
		self.glow.right:SetTexture(r,g,b)
	end
end
SVMod.re_Color_too = re_color2
-----------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------
local speed = .027789124
local font = SVFonts.damage
local fontsize = 18

local GetNextChar = function(word,num)
	local c = word:byte(num)
	local shift
	if not c then return "",num end
		if (c > 0 and c <= 127) then
			shift = 1
		elseif (c >= 192 and c <= 223) then
			shift = 2
		elseif (c >= 224 and c <= 239) then
			shift = 3
		elseif (c >= 240 and c <= 247) then
			shift = 4
		end
	return word:sub(num,num+shift-1),(num+shift)
end

local updaterun = CreateFrame("Frame")

local flowingframe = CreateFrame("Frame",nil,UIParent)
	flowingframe:SetFrameStrata("HIGH")
	flowingframe:SetPoint("CENTER",UIParent,0,136)
	flowingframe:SetHeight(64)
	
local flowingtext = flowingframe:CreateFontString(nil,"OVERLAY")
	flowingtext:SetFont(font,fontsize)
	flowingtext:SetShadowOffset(1,-1)
	
local rightchar = flowingframe:CreateFontString(nil,"OVERLAY")
	rightchar:SetFont(font,60)
	rightchar:SetShadowOffset(1,-1)
	rightchar:SetJustifyH("LEFT")
	
local count,len,step,word,stringE,a,backstep

local nextstep = function()
	a,step = GetNextChar (word,step)
	flowingtext:SetText(stringE)
	stringE = stringE..a
	a = string.upper(a)
	rightchar:SetText(a)
end

local backrun = CreateFrame("Frame")
backrun:Hide()

local updatestring = function(self,t)
	count = count - t
		if count < 0 then
			count = speed
			if step > len then 
				self:Hide()
				flowingtext:SetText(stringE)
				rightchar:SetText()
				flowingtext:ClearAllPoints()
				flowingtext:SetPoint("RIGHT")
				flowingtext:SetJustifyH("RIGHT")
				rightchar:ClearAllPoints()
				rightchar:SetPoint("RIGHT",flowingtext,"LEFT")
				rightchar:SetJustifyH("RIGHT")
				self:Hide()
				count = 1.456789
				backrun:Show()
			else 
				nextstep()
			end
		end
end

updaterun:SetScript("OnUpdate",updatestring)
updaterun:Hide()

local backstepf = function()
	local a = backstep
	local firstchar
		local texttemp = ""
		local flagon = true
		while a <= len do
			local u
			u,a = GetNextChar(word,a)
			if flagon == true then
				backstep = a
				flagon = false
				firstchar = u
			else
				texttemp = texttemp..u
			end
		end
	flowingtext:SetText(texttemp)
	firstchar = string.upper(firstchar)
	rightchar:SetText(firstchar)
end

local rollback = function(self,t)
	count = count - t
		if count < 0 then
			count = speed
			if backstep > len then
				self:Hide()
				flowingtext:SetText()
				rightchar:SetText()
			else
				backstepf()
			end
		end
end

backrun:SetScript("OnUpdate",rollback)

local allertrun = function(f,r,g,b,pos)
	flowingframe:Hide()
	updaterun:Hide()
	backrun:Hide()
	
	flowingtext:SetText(f)
	local l = flowingtext:GetWidth()
		
	local color1 = r or 1
	local color2 = g or 1
	local color3 = b or 1
	
	flowingtext:SetTextColor(color1*.95,color2*.95,color3*.95)
	rightchar:SetTextColor(color1,color2,color3)
	
	word = f
	len = f:len()
	step,backstep = 1,1
	count = speed
	stringE = ""
	a = ""
	
	flowingtext:SetText("")
	flowingframe:SetWidth(l)
	flowingtext:ClearAllPoints()
	flowingtext:SetPoint("LEFT")
	flowingtext:SetJustifyH("LEFT")
	rightchar:ClearAllPoints()
	rightchar:SetPoint("LEFT",flowingtext,"RIGHT")
	rightchar:SetJustifyH("LEFT")
	if pos == "TOP" then
		flowingframe:ClearAllPoints()
		flowingframe:SetPoint("CENTER",UIParent,0,116)
	else
		flowingframe:ClearAllPoints()
		flowingframe:SetPoint("CENTER",UIParent,0,136)
	end
	rightchar:SetText("")
	updaterun:Show()
	flowingframe:Show()
end
	
SlashCmdList.ALLEYRUN = function(lol) allertrun(lol) end
SLASH_ALLEYRUN1 = "/arn"
SVMedia.allertrun = allertrun

SlashCmdList.GETFRAMENAME = function() print(GetMouseFocus():GetName()) end
SLASH_GETFRAMENAME1 = "/frame"