local normTex = SVMedia.blank
local glowTex = SVMedia.glow
local cColor = SVColors["classy"]
local class = SVRoot.myclass
local colorz = cColor[class]
local ir,ig,ib = (1-(colorz[1]*0.8)),(1-(colorz[2]*0.8)),(1-(colorz[3]*0.8))

-------------frame builder functions-------------------

local BasicSkin = function (f)
	f:SetBackdrop( {
		bgFile = normTex,
		edgeFile = glowTex,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	f:SetBackdropColor(0.3, 0.3, 0.3, 0.7)
	f:SetBackdropBorderColor(0, 0, 0)
	return f
end
SVMod.BasicSkin = BasicSkin

local TabSkin = function (f)
	f:SetBackdrop( {
		bgFile = normTex,
		edgeFile = glowTex,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	f:SetBackdropColor(0.1, 0.1, 0.1, 0.7)
	f:SetBackdropBorderColor(0, 0, 0)
	return f
end
SVMod.TabSkin = TabSkin

SVMod.altframe = function (parent,level,tag,strata)
	local myframe = CreateFrame ("Frame",tag,parent)
	myframe:SetBackdrop( {
		bgFile = normTex,
		edgeFile = glowTex,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	myframe:SetBackdropColor(0.05, 0.05, 0.05, 0.8)
	myframe:SetBackdropBorderColor(0, 0, 0)
	myframe:SetFrameLevel(level or 2)
	myframe:SetFrameStrata(strata or "BACKGROUND")
	SVMod.style(myframe,true)
	return myframe
end

SVMod.chatskin = function (myframe,off,nobg,nobdr)
	if myframe.left or myframe.bg then return end
	local off = off or 1
	if nobg ~= true then
		myframe.bg = myframe:CreateTexture(nil,"BORDER")
		myframe.bg:SetPoint("TOPLEFT",-4,16)
		myframe.bg:SetPoint("BOTTOMRIGHT",4,-14)
		myframe.bg:SetTexture(1,1,1,1)
		myframe.bg:SetGradientAlpha("VERTICAL",0.12,0.12,0.12,0.9,0,0,0,0)
	end
	if nobdr ~= true then
		myframe.left = myframe:CreateTexture(nil,"OVERLAY")
		myframe.left:SetTexture(1,1,1,1)
		myframe.left:SetPoint("TOPLEFT",off,-off)
		myframe.left:SetPoint("BOTTOMLEFT",-off,off)
		myframe.left:SetWidth(4)
		myframe.left:SetGradientAlpha("VERTICAL",0,0,0,0.86,0,0,0,0)
		
		myframe.right = myframe:CreateTexture(nil,"OVERLAY")
		myframe.right:SetTexture(1,1,1,1)
		myframe.right:SetPoint("TOPRIGHT",-off,-off)
		myframe.right:SetPoint("BOTTOMRIGHT",-off,off)
		myframe.right:SetWidth(4)
		myframe.right:SetGradientAlpha("VERTICAL",0,0,0,0.86,0,0,0,0)
		
		myframe.bottom = myframe:CreateTexture(nil,"OVERLAY")
		myframe.bottom:SetTexture(0,0,0,1)
		myframe.bottom:SetPoint("BOTTOMLEFT",off,off)
		myframe.bottom:SetPoint("BOTTOMRIGHT",-off,off)
		myframe.bottom:SetHeight(4)
		
		myframe.top = myframe:CreateTexture(nil,"OVERLAY")
		myframe.top:SetTexture(0,0,0,0)
		myframe.top:SetPoint("TOPLEFT",off,-off)
		myframe.top:SetPoint("TOPRIGHT",-off,off)
		myframe.top:SetAlpha(0)
		myframe.top:SetHeight(1)
	end
	return myframe
end

SVMod.chatframe = function (myframe,level,off,nobg,nobdr)
	myframe:SetBackdrop( {
		bgFile = SVMedia.blank,
		} )
	myframe:SetBackdropColor(0, 0, 0, 0)
	myframe:SetFrameLevel(level or 2)
	myframe:SetFrameStrata("BACKGROUND")
	SVMod.chatskin(myframe,off,nobg,nobdr)
	return myframe
end

local ButtonSkin = function (f)
	if f.bg then return end
	local r = colorz[1]
	local g = colorz[2]
	local b = colorz[3]
	f:SetBackdrop( {
		bgFile = normTex,
		edgeFile = glowTex,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	f:SetBackdropColor(0.05, 0.05, 0.05, 0.8)
	f:SetBackdropBorderColor(0, 0, 0)
	local offset = offset or 2
	f.bg = f:CreateTexture(nil,"BORDER")
	f.bg:SetPoint("TOPLEFT", offset, offset*-1)
	f.bg:SetPoint("BOTTOMRIGHT", offset*-1, offset)
	f.bg:SetTexture(r,g,b)
	f.bg:SetGradientAlpha("VERTICAL",0.1,0.1,0.1,1,1,1,1,0.5)
	return f
end
SVMod.ButtonSkin = ButtonSkin

local ButtonMaker = function (f, w, h, a1, p, a2, x, y, color)
	local flvl = f:GetFrameLevel()
	f:SetFrameLevel(1)
	f:SetHeight(h)
	f:SetWidth(w)
	f:SetFrameStrata("BACKGROUND")
	f:SetPoint(a1, p, a2, x, y)
	if f.bg then return end
	local color = color or {0.8,0.4,0.2}
	f:SetBackdrop( {
		bgFile = normTex,
		edgeFile = glowTex,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	f:SetBackdropColor(unpack(color))
	f:SetBackdropBorderColor(0, 0, 0)
	local offset = offset or 2
	f.bg = f:CreateTexture(nil,"BORDER")
	f.bg:SetPoint("TOPLEFT", offset, offset*-1)
	f.bg:SetPoint("BOTTOMRIGHT", offset*-1, offset)
	f.bg:SetTexture(unpack(color))
	f.bg:SetGradientAlpha("VERTICAL",0.1,0.1,0.1,1,1,1,1,0.5)
	return f
end
SVMod.ButtonMaker = ButtonMaker

local BasicPanel = function (f, w, h, a1, p, a2, x, y)
	local flvl = f:GetFrameLevel()
	f:SetFrameLevel(1)
	f:SetHeight(h)
	f:SetWidth(w)
	f:SetFrameStrata("BACKGROUND")
	f:SetPoint(a1, p, a2, x, y)
	SVMod.BasicSkin(f)
end
SVMod.BasicPanel = BasicPanel

local DeluxePanel = function (f, w, h, a1, p, a2, x, y, alf)
	if f.bg then return end
	local alf = alf or 1
	f:SetHeight(h)
	f:SetWidth(w)
	f:SetPoint(a1, p, a2, x, y)
	f:SetBackdrop( {
		bgFile = SVMedia.bar})
	f:SetBackdropColor(0.4,0.4,0.4,alf)
	f.bg = f:CreateTexture(nil,"BORDER")
	f.bg:SetTexture(0.4,0.4,0.4,alf)
	f.bg:SetGradientAlpha("VERTICAL",0,0,0,0,0,0,0,0.4)
	f.bg:SetPoint("TOPLEFT",2,-2)
	f.bg:SetPoint("BOTTOMRIGHT",-2,2)
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(0,0,0)
	f.left:SetPoint("TOPLEFT")
	f.left:SetPoint("BOTTOMLEFT")
	f.left:SetWidth(2)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(0,0,0)
	f.right:SetPoint("TOPRIGHT")
	f.right:SetPoint("BOTTOMRIGHT")
	f.right:SetWidth(2)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(0,0,0)
	f.top:SetPoint("TOPLEFT")
	f.top:SetPoint("TOPRIGHT")
	f.top:SetHeight(2)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(0,0,0)
	f.bottom:SetPoint("BOTTOMLEFT")
	f.bottom:SetPoint("BOTTOMRIGHT")
	f.bottom:SetHeight(2)
end
SVMod.DeluxePanel = DeluxePanel

local AddonSkin = function (f,v,v2,off,r,g,b)
	if f.bg then return end
	local color = {0,0,0}
	local v = v or 1
	local v2 = v2 or 0.3
	local off = off or 4
	local r = r or colorz[1]
	local g = g or colorz[2]
	local b = b or colorz[3]
	f:SetBackdrop( {
		bgFile = normTex,
		edgeFile = glowTex,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	f:SetBackdropColor(0,0,0,0)
	f:SetBackdropBorderColor(0, 0, 0, 0)
	f.bg = f:CreateTexture(nil,"BACKGROUND")
	f.bg:SetTexture(SVMedia.blank)
	f.bg:SetGradient("VERTICAL",r*v, g*v, b*v,r*v2, g*v2, b*v2)
	f.bg:SetPoint("TOPLEFT",-off,off)
	f.bg:SetPoint("BOTTOMRIGHT",off,-off)
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(unpack(color))
	f.left:SetPoint("TOPLEFT",-off,off)
	f.left:SetPoint("BOTTOMLEFT",off,-off)
	f.left:SetWidth(2)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(unpack(color))
	f.right:SetPoint("TOPRIGHT",off,off)
	f.right:SetPoint("BOTTOMRIGHT",-off,-off)
	f.right:SetWidth(2)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(unpack(color))
	f.top:SetPoint("TOPLEFT",-off,off)
	f.top:SetPoint("TOPRIGHT",off,off)
	f.top:SetHeight(2)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(unpack(color))
	f.bottom:SetPoint("BOTTOMLEFT",-off,-off)
	f.bottom:SetPoint("BOTTOMRIGHT",off,-off)
	f.bottom:SetHeight(2)
	return f
end
SVMod.AddonSkin = AddonSkin

local super_skin = function (f,thick,r,g,b,alf)
	if f.left then return end
	local thick = thick or 4
	local off = thick + 2
	local r = r or colorz[1]
	local g = g or colorz[2]
	local b = b or colorz[3]
	local r2,g2,b2 = (r*0.3),(g*0.3),(b*0.3)
	f:SetBackdrop( {
		bgFile = SVMedia.bar,
		edgeFile = SVMedia.glow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	f:SetBackdropColor(0,0,0,alf or 0.6)
	f:SetBackdropBorderColor(0, 0, 0, 1)
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(SVMedia.blank)
	f.left:SetGradient("VERTICAL", r, g, b, r2, g2, b2)
	f.left:SetPoint("TOPLEFT",off,-off)
	f.left:SetPoint("BOTTOMLEFT",off,off)
	f.left:SetWidth(thick)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(SVMedia.blank)
	f.right:SetGradient("VERTICAL", r, g, b, r2, g2, b2)
	f.right:SetPoint("TOPRIGHT",-off,-off)
	f.right:SetPoint("BOTTOMRIGHT",-off,off)
	f.right:SetWidth(thick)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(SVMedia.blank)
	f.top:SetVertexColor(r2, g2, b2)
	f.top:SetPoint("TOPLEFT",off,-off)
	f.top:SetPoint("TOPRIGHT",-off,-off)
	f.top:SetHeight(thick)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(SVMedia.blank)
	f.bottom:SetVertexColor(r, g, b)
	f.bottom:SetPoint("BOTTOMLEFT",off,off)
	f.bottom:SetPoint("BOTTOMRIGHT",-off,off)
	f.bottom:SetHeight(thick)
	return f
end
SVMod.SuperSkin = super_skin

local SimpleSkin = function (f,s)
	if f.left then return end
	local s = s or 2
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(0,0,0)
	f.left:SetPoint("TOPLEFT")
	f.left:SetPoint("BOTTOMLEFT")
	f.left:SetWidth(s)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(0,0,0)
	f.right:SetPoint("TOPRIGHT")
	f.right:SetPoint("BOTTOMRIGHT")
	f.right:SetWidth(s)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(0,0,0)
	f.top:SetPoint("TOPLEFT")
	f.top:SetPoint("TOPRIGHT")
	f.top:SetHeight(s)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(0,0,0)
	f.bottom:SetPoint("BOTTOMLEFT")
	f.bottom:SetPoint("BOTTOMRIGHT")
	f.bottom:SetHeight(s)
	return f
end
SVMod.SimpleSkin = SimpleSkin

local SuperPanel = function (parent,thick,strata,r,g,b,alf)
	local myframe = CreateFrame ("Frame",nil,parent)
	local thick = thick or 3
	local r = r or 0.2
	local g = g or 0.2
	local b = b or 0.2
	local alf = alf or 0.8
	parent:SetFrameLevel(4)
	myframe:SetFrameLevel(parent:GetFrameLevel()-2)
	myframe:SetFrameStrata(strata or "MEDIUM")
	myframe:SetPoint("TOPLEFT",parent,-thick,thick)
	myframe:SetPoint("BOTTOMRIGHT",parent,thick,-thick)
	myframe:SetBackdrop({
		bgFile = SVMedia.bar,
		edgeFile = SVMedia.glow,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	myframe:SetBackdropColor(r,g,b,alf)
	myframe:SetBackdropBorderColor(0,0,0,0)
	myframe.left = myframe:CreateTexture(nil,"OVERLAY")
	myframe.left:SetTexture(0,0,0)
	myframe.left:SetPoint("TOPLEFT")
	myframe.left:SetPoint("BOTTOMLEFT")
	myframe.left:SetWidth(thick)
	myframe.right = myframe:CreateTexture(nil,"OVERLAY")
	myframe.right:SetTexture(0,0,0)
	myframe.right:SetPoint("TOPRIGHT")
	myframe.right:SetPoint("BOTTOMRIGHT")
	myframe.right:SetWidth(thick)
	myframe.top = myframe:CreateTexture(nil,"OVERLAY")
	myframe.top:SetTexture(0,0,0)
	myframe.top:SetPoint("TOPLEFT")
	myframe.top:SetPoint("TOPRIGHT")
	myframe.top:SetHeight(thick)
	myframe.bottom = myframe:CreateTexture(nil,"OVERLAY")
	myframe.bottom:SetTexture(0,0,0)
	myframe.bottom:SetPoint("BOTTOMLEFT")
	myframe.bottom:SetPoint("BOTTOMRIGHT")
	myframe.bottom:SetHeight(thick)
	return myframe
end
SVMod.SuperPanel = SuperPanel

local SuperAnchor = function(parent,txtname,skin,p1,p2,xx,yy)
	local anchorbg = CreateFrame("Frame",name1.."Back",parent)
	parent:SetFrameLevel(2)
	anchorbg:SetFrameLevel(0)
	anchorbg:SetFrameStrata("BACKGROUND")
	anchorbg:SetPoint("TOPLEFT",parent,-15,15)
	anchorbg:SetPoint("BOTTOMRIGHT",parent,15,-15)
	anchorbg:SetBackdrop({bgFile=SVMedia.menuglow,tile=false})
	anchorbg:SetBackdropColor(0.5,0.8,1,0.5)
	local mentaloframe = CreateFrame("Frame",nil,parent)
	mentaloframe:SetSize(200,200)
	mentaloframe:SetPoint(p1,anchorbg,p2,xx,yy)
    mentaloframe:SetAlpha(0)
    mentaloframe:Hide()
	local mentalo = mentaloframe:CreateTexture(nil,"OVERLAY")
	mentalo:SetAllPoints(mentaloframe)
	mentalo:SetTexture(skin)
	local anchortxt = anchorbg:CreateFontString(nil,"OVERLAY")
	anchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	anchortxt:SetText(txtname)
	anchortxt:SetPoint("TOP",anchorbg,0,-22)
	anchorbg:SetAlpha(0)
	anchorbg:SetScript("OnEnter",function()
			if mentaloframe:IsShown() then
				UIFrameFadeIn(mentaloframe, 0.3, 0, 1)
			end
		end)
	anchorbg:SetScript("OnLeave",function()
			if mentaloframe:IsShown() then
				UIFrameFadeOut(mentaloframe, 0.3, 1, 0)
			end
		end)
end
SVMod.SuperAnchor = SuperAnchor

local ShadeMe = function (f)
	if f.shadow then return end
	local shadow = CreateFrame("Frame", nil, f)
	shadow:SetFrameLevel(1)
	shadow:SetFrameStrata(f:GetFrameStrata())
	shadow:SetPoint("TOPLEFT")
	shadow:SetPoint("BOTTOMLEFT")
	shadow:SetPoint("TOPRIGHT")
	shadow:SetPoint("BOTTOMRIGHT")
	shadow:SetBackdrop( { 
		edgeFile = SVMedia.glow, edgeSize = SVMod.Scale(3),
		insets = {left = SVMod.Scale(2), right = SVMod.Scale(2), top = SVMod.Scale(2), bottom = SVMod.Scale(2)},
	})
	shadow:SetBackdropColor(0, 0, 0, 0)
	shadow:SetBackdropBorderColor(0, 0, 0, 0.5)
	f.shadow = shadow
end
SVMod.ShadeMe = ShadeMe
----------------------------------------------------------------------------------------------
----NAMEPLATE FUNCTIONS--------------------------------------------------------------
----------------------------------------------------------------------------------------------

local RoleUpdater = CreateFrame("Frame")
local function CheckRole(self, event, unit)
	local resilience
	if GetCombatRating(COMBAT_RATING_RESILIENCE_PLAYER_DAMAGE_TAKEN)*0.02828 > GetDodgeChance() then
		resilience = true
	else
		resilience = false
	end
	--print(dodge, resil)
	if ((SVRoot.myclass == "PALADIN" and GetPrimaryTalentTree() == 2) or
	(SVRoot.myclass == "WARRIOR" and GetPrimaryTalentTree() == 3) or
	(SVRoot.myclass == "DEATHKNIGHT" and GetPrimaryTalentTree() == 1)) and
	resilience == false or
	--Check for 'Thick Hide' tanking talent
	(SVRoot.myclass == "DRUID" and GetPrimaryTalentTree() == 2 and GetBonusBarOffset() == 3) then
		SVMod.Role = "Tank"
	else
		local playerint = select(2, UnitStat("player", 4))
		local playeragi	= select(2, UnitStat("player", 2))
		local base, posBuff, negBuff = UnitAttackPower("player");
		local playerap = base + posBuff + negBuff;
 
		if ((playerap > playerint) or (playeragi > playerint)) and not (UnitBuff("player", GetSpellInfo(24858)) or UnitBuff("player", GetSpellInfo(65139))) then
			SVMod.Role = "Melee"
		else
			SVMod.Role = "Caster"
		end
	end
end
RoleUpdater:RegisterEvent("PLAYER_ENTERING_WORLD")
RoleUpdater:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
RoleUpdater:RegisterEvent("PLAYER_TALENT_UPDATE")
RoleUpdater:RegisterEvent("CHARACTER_POINTS_CHANGED")
RoleUpdater:RegisterEvent("UNIT_INVENTORY_CHANGED")
RoleUpdater:RegisterEvent("UPDATE_BONUS_ACTIONBAR")
RoleUpdater:SetScript("OnEvent", CheckRole)
CheckRole()
------------------------------------------------------------------------
--	Copy URL, by Tukz.
------------------------------------------------------------------------
local SetItemRef_orig = SetItemRef
function ReURL_SetItemRef(link, text, button, chatFrame)
	if (strsub(link, 1, 3) == "url") then
		local ChatFrameEditBox = ChatEdit_ChooseBoxForSend()
		local url = strsub(link, 5);
		if (not ChatFrameEditBox:IsShown()) then
			ChatEdit_ActivateChat(ChatFrameEditBox)
		end
		ChatFrameEditBox:Insert(url)
		ChatFrameEditBox:HighlightText()

	else
		SetItemRef_orig(link, text, button, chatFrame)
	end
end
SetItemRef = ReURL_SetItemRef

function ReURL_AddLinkSyntax(chatstring)
	if (type(chatstring) == "string") then
		local extraspace;
		if (not strfind(chatstring, "^ ")) then
			extraspace = true;
			chatstring = " "..chatstring;
		end
		chatstring = gsub (chatstring, " www%.([_A-Za-z0-9-]+)%.(%S+)%s?", ReURL_Link("www.%1.%2"))
		chatstring = gsub (chatstring, " (%a+)://(%S+)%s?", ReURL_Link("%1://%2"))
		chatstring = gsub (chatstring, " ([_A-Za-z0-9-%.]+)@([_A-Za-z0-9-]+)(%.+)([_A-Za-z0-9-%.]+)%s?", ReURL_Link("%1@%2%3%4"))
		chatstring = gsub (chatstring, " (%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?):(%d%d?%d?%d?%d?)%s?", ReURL_Link("%1.%2.%3.%4:%5"))
		chatstring = gsub (chatstring, " (%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%s?", ReURL_Link("%1.%2.%3.%4"))
		if (extraspace) then
			chatstring = strsub(chatstring, 2);
		end
	end
	return chatstring
end

REURL_COLOR = "16FF5D"
ReURL_Brackets = false
ReUR_CustomColor = true

function ReURL_Link(url)
	if (ReUR_CustomColor) then
		if (ReURL_Brackets) then
			url = " |cff"..REURL_COLOR.."|Hurl:"..url.."|h["..url.."]|h|r "
		else
			url = " |cff"..REURL_COLOR.."|Hurl:"..url.."|h"..url.."|h|r "
		end
	else
		if (ReURL_Brackets) then
			url = " |Hurl:"..url.."|h["..url.."]|h "
		else
			url = " |Hurl:"..url.."|h"..url.."|h "
		end
	end
	return url
end

--Hook all the AddMessage funcs
for i=1, NUM_CHAT_WINDOWS do
	local frame = getglobal("ChatFrame"..i)
	local addmessage = frame.AddMessage
	frame.AddMessage = function(self, text, ...) addmessage(self, ReURL_AddLinkSyntax(text), ...) end
end