local function style(self)
	local name = self:GetName()
	if name:match("MultiCastActionButton") then return end 
	
	local Button = self
	local Border  = _G[name.."Border"]
	local Flash	 = _G[name.."Flash"]
	local hilight  = self:GetHighlightTexture()
	local pushed = self:GetPushedTexture()
	local check = self:GetCheckedTexture()
	
	hilight:SetTexture(1,1,1,.2)
	pushed:SetTexture(0,0,0,.4)
	check:SetTexture(1,1,1,.2)
	
	Flash:SetTexture("")
	Button:SetNormalTexture("")
 
	Border:Hide()
	Border = SVRoot.Null
	
	if not self.setd then
		local Btname = _G[name.."Name"]
		local Icon = _G[name.."Icon"]
		local Count = _G[name.."Count"]
		local HotKey = _G[name.."HotKey"]
		
		self:SetWidth(SVMod.Scale(32)*SuperSet.scaleops.abscale)
		self:SetHeight(SVMod.Scale(32)*SuperSet.scaleops.abscale)
		Icon:SetTexCoord(.1, .9, .1, .9)
		Icon:SetPoint("TOPLEFT", Button)
		Icon:SetPoint("BOTTOMRIGHT", Button)
		Icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
		self.setd = true
		
		HotKey:ClearAllPoints()
		HotKey:SetPoint("TOPRIGHT", 1, -1)
		HotKey:SetFont(SVFonts.font, 13, "OUTLINE")
		HotKey:SetShadowOffset(1, -1)
		
		if SuperBar.menu.shownames ~= true then
			HotKey:Hide()
		elseif SuperBar.menu.hovernames == true then
			HotKey:SetDrawLayer("HIGHLIGHT")
		end	
		
		HotKey.ClearAllPoints = SVRoot.Null
		HotKey.SetPoint = SVRoot.Null
		
		if HotKey:GetText() then
			HotKey:SetFormattedText("|cffFFFFFF%s",HotKey:GetText())
		end

		Btname:ClearAllPoints()
		Btname:SetPoint("LEFT",.5,-1)
		Btname:SetPoint("RIGHT",-.5,-1)
		Btname:SetJustifyH("CENTER")

		if SuperBar.menu.showmacro ~= true then
			Btname:SetText("")
			Btname:Hide()
			Btname.Show = SVRoot.Null
		elseif SuperBar.menu.hovermacro == true then
			Btname:SetDrawLayer("HIGHLIGHT")
		end
		
		Count:ClearAllPoints()
		Count:SetPoint("BOTTOMRIGHT", 1, 1)
		Count:SetShadowOffset(1, -1)
		Count:SetFont(SVFonts.font, 13, "OUTLINE")
	end
end
SVMod.StyleThis = style

local function stylesmallbutton( button, icon, name, pet, hilight, pushed, check, size)
	local Flash	 = _G[name.."Flash"]
	button:SetNormalTexture("")
	hilight:SetTexture(1,1,1,.2)
	pushed:SetTexture(0,0,0,.4)
	check:SetTexture(1,1,1,.2)
	button.SetNormalTexture = SVRoot.Null
	Flash:SetTexture("")
	
	if not button.setd then
		button:SetWidth(28*SuperSet.scaleops.abscale)
		button:SetHeight(28*SuperSet.scaleops.abscale)
		
		icon:SetTexCoord(.1, .9, .1, .9)
		icon:ClearAllPoints()
		icon:SetPoint("TOPLEFT", button)
		icon:SetPoint("BOTTOMRIGHT", button)
		icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
		
		button.setd = true
		
		if pet then
			local autocast = _G[name.."AutoCastable"]
			autocast:SetWidth(36)
			autocast:SetHeight(36)
			autocast:ClearAllPoints()
			autocast:SetPoint("CENTER", button,0,0)
		else
			local buttonbg = CreateFrame("Frame",nil,button)
			buttonbg:SetWidth(size+4)
			buttonbg:SetHeight(size+4)
			buttonbg:SetPoint("CENTER",button)
			SVMod.SimpleSkin(buttonbg)
		end
	end
end
SVMod.StyleThisSmall = stylesmallbutton

function SVMod.StyleButton(b, checked) 
    local name = b:GetName()
 
    local button          = _G[name]
    local icon            = _G[name.."Icon"]
    local count           = _G[name.."Count"]
    local border          = _G[name.."Border"]
    local hotkey          = _G[name.."HotKey"]
    local cooldown        = _G[name.."Cooldown"]
    local nametext        = _G[name.."Name"]
    local flash           = _G[name.."Flash"]
    local normaltexture   = _G[name.."NormalTexture"]
	local icontexture     = _G[name.."IconTexture"]

	local hover = b:CreateTexture("frame", nil, self) -- hover
	hover:SetTexture(1,1,1,0.3)
	hover:SetHeight(button:GetHeight())
	hover:SetWidth(button:GetWidth())
	hover:SetPoint("TOPLEFT",button,2,-2)
	hover:SetPoint("BOTTOMRIGHT",button,-2,2)
	button:SetHighlightTexture(hover)

	local pushed = b:CreateTexture("frame", nil, self) -- pushed
	pushed:SetTexture(0.9,0.8,0.1,0.3)
	pushed:SetHeight(button:GetHeight())
	pushed:SetWidth(button:GetWidth())
	pushed:SetPoint("TOPLEFT",button,2,-2)
	pushed:SetPoint("BOTTOMRIGHT",button,-2,2)
	button:SetPushedTexture(pushed)
 
	if checked then
		local checked = b:CreateTexture("frame", nil, self) -- checked
		checked:SetTexture(0,1,0,0.3)
		checked:SetHeight(button:GetHeight())
		checked:SetWidth(button:GetWidth())
		checked:SetPoint("TOPLEFT",button,2,-2)
		checked:SetPoint("BOTTOMRIGHT",button,-2,2)
		button:SetCheckedTexture(checked)
	end
end