ConsolidatedBuffs:ClearAllPoints()
ConsolidatedBuffs:SetPoint("LEFT", Minimap, 4, 0)
ConsolidatedBuffs:SetSize(16, 16)
ConsolidatedBuffsIcon:SetTexture("")
ConsolidatedBuffs.SetPoint = SVRoot.Null

-- BUFF_FLASH_TIME_ON = 0.4
-- BUFF_FLASH_TIME_OFF = 0.4
-- BUFF_MIN_ALPHA = 0.7

local rowbuffs = 5
local maxbuff = 20

WorldStateAlwaysUpFrame:SetFrameStrata("BACKGROUND")
WorldStateAlwaysUpFrame:SetFrameLevel(0)

local function StyleBuffs(buttonName, index, debuff)
	local buff		= _G[buttonName..index]
	local icon		= _G[buttonName..index.."Icon"]
	local border	= _G[buttonName..index.."Border"]
	local duration	= _G[buttonName..index.."Duration"]
	local count 	= _G[buttonName..index.."Count"]
	if icon and not _G[buttonName..index.."Panel"] then
		icon:SetTexCoord(.1,.9,.1,.9)
		icon:SetPoint("TOPLEFT")
		icon:SetPoint("BOTTOMRIGHT")
		icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
		
		buff:SetSize(30,30)
		
		count:ClearAllPoints()
		count:SetPoint("TOPRIGHT",1,0)
		count:SetFont(SVFonts.super_c, 12, "OUTLINE")
		count:SetShadowOffset(1,-1)
		
		local panel = SVMod.frame(buff,buff:GetFrameLevel() + 2,buff:GetFrameStrata(),true,nil,nil)
		panel:SetPoint("TOPLEFT",-4,4)
		panel:SetPoint("BOTTOMRIGHT",4,-4)
		panel:SetBackdrop({
			edgeFile = SVMedia.glow, 
			edgeSize = 4, insets = {left = 3, right = 3, top = 3, bottom = 3}})
		panel:SetBackdropBorderColor(unpack(SVMedia.bordershadow))
		
		local top_level = CreateFrame("Frame",nil,panel)
		top_level:SetAllPoints(panel)
		top_level:SetFrameLevel(panel:GetFrameLevel() + 2)
		duration:ClearAllPoints()
		duration:SetParent(top_level)
		duration:SetFont(SVFonts.numbers,11,"THINOUTLINE")
		duration:SetShadowOffset(-2,-2)
		duration:SetShadowColor(0,0,0)
		duration:SetPoint("BOTTOMLEFT",-2,0)
		duration:SetJustifyH("LEFT")
		
		_G[buttonName..index.."Panel"] = panel
	end
	if border then border:Hide() end
end

local function UpdateBuffAnchors()
	buttonName = "BuffButton"
	local buff, previousBuff, aboveBuff;
	local numBuffs = 0;
	for index=1, BUFF_ACTUAL_DISPLAY do
		local buff = _G[buttonName..index]
		StyleBuffs(buttonName, index, false)
		
		if ( buff.consolidated ) then
			if ( buff.parent == BuffFrame ) then
				buff:SetParent(ConsolidatedBuffsContainer)
				buff.parent = ConsolidatedBuffsContainer
			end
		else
			numBuffs = numBuffs + 1
			index = numBuffs
			if index > maxbuff then buff:Hide() end
			buff:ClearAllPoints()
			if ( (index > 1) and (mod(index, rowbuffs) == 1) ) then
				if ( index == rowbuffs+1 ) then
					buff:SetPoint("TOPRIGHT", MapBorder, "TOPLEFT", -46, -42)
				else
					buff:SetPoint("TOPRIGHT", MapBorder, "TOPLEFT", -46, -80)
				end
				aboveBuff = buff;
			elseif ( index == 1 ) then
				buff:SetPoint("TOPRIGHT", MapBorder, "TOPLEFT", -46, -4)
			else
				buff:SetPoint("RIGHT", previousBuff, "LEFT", -8, 0)
			end
			previousBuff = buff
		end		
	end
end

local takecolor = function(target,r,g,b)
	target.top:SetTexture(r,g,b)
	target.bottom:SetTexture(r,g,b)
	target.left:SetTexture(r,g,b)
	target.right:SetTexture(r,g,b)
	target:SetBackdropBorderColor(r,g,b,.5)
end

local UpdateDebuffAnchors = SVRoot.Null
if SuperSet["unitops"].debuffs then
	UpdateDebuffAnchors = function(buttonName, index)
		local debuff = _G[buttonName..index];
		StyleBuffs(buttonName, index, true)
		local dtype = select(5, UnitDebuff("player",index))      
		local color
		if (dtype ~= nil) then
			color = DebuffTypeColor[dtype]
		else
			color = DebuffTypeColor["none"]
		end
		takecolor(_G[buttonName..index.."Panel"],color.r,color.g,color.b)
		debuff:ClearAllPoints()
		if index == 1 then
			debuff:SetPoint("BOTTOMRIGHT", MapBorder, "BOTTOMLEFT", -46, 4)
		else
			debuff:SetPoint("RIGHT", _G[buttonName..(index-1)], "LEFT", -8, 0)
		end
	end
	SVMedia.debuff = true
else
	UpdateDebuffAnchors = function(buttonName, index)
		_G[buttonName..index]:Hide()
	end
end

hooksecurefunc("DebuffButton_UpdateAnchors", UpdateDebuffAnchors)
hooksecurefunc("BuffFrame_UpdateAllBuffAnchors", UpdateBuffAnchors)

SecondsToTimeAbbrev = function(time)
    local hr, m, text
    if time <= 0 then text = ""
    elseif(time < 3600 and time > 60) then
		hr = floor(time / 3600)
		m = floor(mod(time, 3600) / 60 + 1)
		text = format("|cffffffff%dm|r", m)
    elseif time < 60 then
		m = floor(time / 60)
		text = (m == 0 and format("|cffff1111%.1f|r",time))
    else
		hr = floor(time / 3600 + 1)
		text = format("|cffffffff%dh|r", hr)
    end
    return text
end