﻿
if SuperSet["chatops"].hide_chat_junk then
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_JOIN", function(msg) return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_LEAVE", function(msg) return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE", function(msg) return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_AFK", function(msg) return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_DND", function(msg) return true end)
	DUEL_WINNER_KNOCKOUT, DUEL_WINNER_RETREAT = "", ""
	DRUNK_MESSAGE_ITEM_OTHER1 = "", ""
	DRUNK_MESSAGE_ITEM_OTHER2 = "", ""
	DRUNK_MESSAGE_ITEM_OTHER3 = "", ""
	DRUNK_MESSAGE_ITEM_OTHER4 = "", ""
	DRUNK_MESSAGE_OTHER1 = "", ""
	DRUNK_MESSAGE_OTHER2 = "", ""
	DRUNK_MESSAGE_OTHER3 = "", ""
	DRUNK_MESSAGE_OTHER4 = "", ""
	DRUNK_MESSAGE_ITEM_SELF1 = "", ""
	DRUNK_MESSAGE_ITEM_SELF2 = "", ""
	DRUNK_MESSAGE_ITEM_SELF3 = "", ""
	DRUNK_MESSAGE_ITEM_SELF4 = "", ""
	DRUNK_MESSAGE_SELF1 = "", ""
	DRUNK_MESSAGE_SELF2 = "", ""
	DRUNK_MESSAGE_SELF3 = "", ""
	DRUNK_MESSAGE_SELF4 = "", ""
	RAID_MULTI_LEAVE = "", ""
	RAID_MULTI_JOIN = "", ""
	ERR_PET_LEARN_ABILITY_S = "", ""
	ERR_PET_LEARN_SPELL_S = "", ""
	ERR_PET_SPELL_UNLEARNED_S = "", ""
end

if SuperSet["chatops"].chat ~= true then return end
-----------------------------------------------------------------------
-- SETUP CHATS (COURTESY OF TUKZ)
-----------------------------------------------------------------------

local SuperChat = CreateFrame("Frame")
local tabalpha = 1
local tabnoalpha = 0
local _G = _G
local origs = {}
local type = type
local a_low = SuperSet.chatops.chat_height*0.6
local a_high = SVMod.Scale(SuperSet.chatops.chat_height)*SuperSet.scaleops.chatscale
local a_slim = SVMod.Scale(SuperSet.chatops.chat_width)*SuperSet.scaleops.chatscale
		
-- function to rename channel and other stuff w/timestamps
local AddMessage = function(self, text, ...)
	if(type(text) == "string") then
		text = text:gsub('|h%[(%d+)%. .-%]|h', '|h[%1]|h')
	end
	if SuperSet.chatops.timestamp == true then
		local hour = date("%H");
		local minute = date("%M");
		local second = date("%S");
		local newmsg = format("|cff9B9797[%02d:%02d:%02d]|r %s", hour, minute, second, text);
		return origs[self](self, newmsg, ...)
	else
		return origs[self](self, text, ...)
	end
end

-- localize this later k tukz? DON'T FORGET!
_G.CHAT_BATTLEGROUND_GET = "|Hchannel:Battleground|h"..SVLocal.chat_BATTLEGROUND_GET.."|h %s:\32"
_G.CHAT_BATTLEGROUND_LEADER_GET = "|Hchannel:Battleground|h"..SVLocal.chat_BATTLEGROUND_LEADER_GET.."|h %s:\32"
_G.CHAT_BN_WHISPER_GET = SVLocal.chat_BN_WHISPER_GET.." %s:\32"
_G.CHAT_GUILD_GET = "|Hchannel:Guild|h"..SVLocal.chat_GUILD_GET.."|h %s:\32"
_G.CHAT_OFFICER_GET = "|Hchannel:o|h"..SVLocal.chat_OFFICER_GET.."|h %s:\32"
_G.CHAT_PARTY_GET = "|Hchannel:Party|h"..SVLocal.chat_PARTY_GET.."|h %s:\32"
_G.CHAT_PARTY_GUIDE_GET = "|Hchannel:party|h"..SVLocal.chat_PARTY_GUIDE_GET.."|h %s:\32"
_G.CHAT_PARTY_LEADER_GET = "|Hchannel:party|h"..SVLocal.chat_PARTY_LEADER_GET.."|h %s:\32"
_G.CHAT_RAID_GET = "|Hchannel:raid|h"..SVLocal.chat_RAID_GET.."|h %s:\32"
_G.CHAT_RAID_LEADER_GET = "|Hchannel:raid|h"..SVLocal.chat_RAID_LEADER_GET.."|h %s:\32"
_G.CHAT_RAID_WARNING_GET = SVLocal.chat_RAID_WARNING_GET.." %s:\32"
_G.CHAT_SAY_GET = "%s:\32"
_G.CHAT_WHISPER_GET = SVLocal.chat_WHISPER_GET.." %s:\32"
_G.CHAT_YELL_GET = "%s:\32"
 
_G.CHAT_FLAG_AFK = "|cffFF0000"..SVLocal.chat_FLAG_AFK.."|r "
_G.CHAT_FLAG_DND = "|cffE7E716"..SVLocal.chat_FLAG_DND.."|r "
_G.CHAT_FLAG_GM = "|cff4154F5"..SVLocal.chat_FLAG_GM.."|r "
 
_G.ERR_FRIEND_ONLINE_SS = "|Hplayer:%s|h[%s]|h "..SVLocal.chat_ERR_FRIEND_ONLINE_SS.."!"
_G.ERR_FRIEND_OFFLINE_S = "%s "..SVLocal.chat_ERR_FRIEND_OFFLINE_S.."!"

-- Hide friends micro button (added in 3.3.5)
SVMod.Kill(FriendsMicroButton)

-- hide chat bubble menu button
SVMod.Kill(ChatFrameMenuButton)

-- set the chat style
local function SetChatStyle(frame)
	local id = frame:GetID()
	local chat = frame:GetName()
	local tab = _G[chat.."Tab"]
	
	-- always set alpha to 1, don't fade it anymore
	tab:SetAlpha(1)
	tab.SetAlpha = UIFrameFadeRemoveFrame
	
	-- hide text when setting chat
	_G[chat.."TabText"]:SetAlpha(0.4)
	
	-- now show text if mouse is found over tab.
	tab:HookScript("OnEnter", function() _G[chat.."TabText"]:SetAlpha(1) end)
	tab:HookScript("OnLeave", function() _G[chat.."TabText"]:SetAlpha(0.4) end)
	
	-- yeah baby
	_G[chat]:SetClampRectInsets(0,0,0,0)
	
	-- Removes crap from the bottom of the chatbox so it can go to the bottom of the screen.
	_G[chat]:SetClampedToScreen(false)
			
	-- Stop the chat chat from fading out
	_G[chat]:SetFading(false)
	
	-- Hide textures
	for j = 1, #CHAT_FRAME_TEXTURES do
		_G[chat..CHAT_FRAME_TEXTURES[j]]:SetTexture(nil)
	end

	-- Removes Default ChatFrame Tabs texture				
	SVMod.Kill(_G[format("ChatFrame%sTabLeft", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabMiddle", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabRight", id)])

	SVMod.Kill(_G[format("ChatFrame%sTabSelectedLeft", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabSelectedMiddle", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabSelectedRight", id)])
	
	SVMod.Kill(_G[format("ChatFrame%sTabHighlightLeft", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabHighlightMiddle", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabHighlightRight", id)])

	-- Killing off the new chat tab selected feature
	SVMod.Kill(_G[format("ChatFrame%sTabSelectedLeft", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabSelectedMiddle", id)])
	SVMod.Kill(_G[format("ChatFrame%sTabSelectedRight", id)])

	-- Kills off the new method of handling the Chat Frame scroll buttons as well as the resize button
	-- Note: This also needs to include the actual frame textures for the ButtonFrame onHover
	SVMod.Kill(_G[format("ChatFrame%sButtonFrameUpButton", id)])
	SVMod.Kill(_G[format("ChatFrame%sButtonFrameDownButton", id)])
	SVMod.Kill(_G[format("ChatFrame%sButtonFrameBottomButton", id)])
	SVMod.Kill(_G[format("ChatFrame%sButtonFrameMinimizeButton", id)])
	SVMod.Kill(_G[format("ChatFrame%sButtonFrame", id)])

	-- Kills off the retarded new circle around the editbox
	SVMod.Kill(_G[format("ChatFrame%sEditBoxFocusLeft", id)])
	SVMod.Kill(_G[format("ChatFrame%sEditBoxFocusMid", id)])
	SVMod.Kill(_G[format("ChatFrame%sEditBoxFocusRight", id)])

	-- Kill off editbox artwork
	local a, b, c = select(6, _G[chat.."EditBox"]:GetRegions()); SVMod.Kill (a); SVMod.Kill (b); SVMod.Kill (c)
	
	--GeneralDockManager:ClearAllPoints()
	--GeneralDockManager:SetPoint("BOTTOMLEFT",SuperLeftChat,"TOPLEFT")
	--GeneralDockManager:SetPoint("BOTTOMRIGHT",SuperLeftChat,"TOPRIGHT")
	
	-- move the chat edit box
	_G[chat.."EditBox"]:ClearAllPoints();
	_G[chat.."EditBox"]:SetPoint("TOPLEFT", GeneralDockManager, SVMod.Scale(2), SVMod.Scale(-2))
	_G[chat.."EditBox"]:SetPoint("BOTTOMRIGHT", GeneralDockManager, SVMod.Scale(-2), SVMod.Scale(2))
	
	-- Disable alt key usage
	_G[chat.."EditBox"]:SetAltArrowKeyMode(false)
	
	-- hide editbox on login
	_G[chat.."EditBox"]:Hide()

	-- script to hide editbox instead of fading editbox to 0.35 alpha via IM Style
	_G[chat.."EditBox"]:HookScript("OnEditFocusLost", function(self) self:Hide() end)
	
	-- hide edit box every time we click on a tab
	_G[chat.."Tab"]:HookScript("OnClick", function() _G[chat.."EditBox"]:Hide() end)
			
	-- rename combag log to log
	if _G[chat] == _G["ChatFrame2"] then
		FCF_SetWindowName(_G[chat], "Log")
	end
			
	-- create our own texture for edit box
	local EditBoxBackground = CreateFrame("frame", "SuperChatEditBoxBackground", _G[chat.."EditBox"])
	SVMod.BasicPanel(EditBoxBackground, 1, 1, "LEFT", _G[chat.."EditBox"], "LEFT", 0, 0)
	EditBoxBackground:ClearAllPoints()
	EditBoxBackground:SetAllPoints(GeneralDockManager)
	EditBoxBackground:SetFrameStrata("LOW")
	EditBoxBackground:SetFrameLevel(1)
	
	local function colorize(r,g,b)
		EditBoxBackground:SetBackdropBorderColor(r, g, b)
	end
	
	-- update border color according where we talk
	hooksecurefunc("ChatEdit_UpdateHeader", function()
		local type = _G[chat.."EditBox"]:GetAttribute("chatType")
		if ( type == "CHANNEL" ) then
		local id = GetChannelName(_G[chat.."EditBox"]:GetAttribute("channelTarget"))
			if id == 0 then
				colorize(unpack(SVMedia.bordercolor))
			else
				colorize(ChatTypeInfo[type..id].r,ChatTypeInfo[type..id].g,ChatTypeInfo[type..id].b)
			end
		else
			colorize(ChatTypeInfo[type].r,ChatTypeInfo[type].g,ChatTypeInfo[type].b)
		end
	end)
	
	if _G[chat] ~= _G["ChatFrame2"] then
		origs[_G[chat]] = _G[chat].AddMessage
		_G[chat].AddMessage = AddMessage
	end
end

-- Setup chatframes 1 to 10 on login.
local function SetupChat(self)	
	for i = 1, NUM_CHAT_WINDOWS do
		local frame = _G[format("ChatFrame%s", i)]
		SetChatStyle(frame)
		FCFTab_UpdateAlpha(frame)
	end
				
	-- Remember last channel
	if SuperSet.stickies.w_sticky == true then
		ChatTypeInfo.WHISPER.sticky = 1
	end
	if SuperSet.stickies.bn_sticky == true then
		ChatTypeInfo.BN_WHISPER.sticky = 1
	end
	if SuperSet.stickies.o_sticky == true then
		ChatTypeInfo.OFFICER.sticky = 1
	end
	if SuperSet.stickies.rw_sticky == true then
		ChatTypeInfo.RAID_WARNING.sticky = 1
	end
	if SuperSet.stickies.ch_sticky == true then
		ChatTypeInfo.CHANNEL.sticky = 1
	end
end

local function SetupChatPosAndFont(self)	
	for i = 1, NUM_CHAT_WINDOWS do
		local chat = _G[format("ChatFrame%s", i)]
		local tab = _G[format("ChatFrame%sTab", i)]
		local id = chat:GetID()
		local name = FCF_GetChatWindowInfo(id)
		local point = GetChatWindowSavedPosition(id)
		local _, fontSize = FCF_GetChatWindowInfo(id)
		
		-- well... tukui font under fontsize 12 is unreadable.
		if fontSize < 12 then		
			FCF_SetChatWindowFontSize(nil, chat, 12)
		else
			FCF_SetChatWindowFontSize(nil, chat, fontSize)
		end
		SVMod.chatskin(chat,-6,false,true)
		-- force chat position on #1 and #4, needed if we change ui scale or resolution
		-- also set original width and height of chatframes 1 and 4 if first time we run tukui.
		-- doing resize of chat also here for users that hit "cancel" when default installation is show.
		if i == 1 then
			chat:ClearAllPoints()
			chat:SetPoint("TOPLEFT", SuperLeftChat, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(-8))
			chat:SetPoint("BOTTOMRIGHT", SuperLeftChat, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(18))
			FCF_SavePositionAndDimensions(chat)
		elseif (i == 4) and (name == "Loot") and (Quokkas_Options.lootchat == true) then
			if not chat.isDocked then
				chat:ClearAllPoints()
				chat:SetPoint("TOPLEFT", SuperDock1, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(-8))
				chat:SetPoint("BOTTOMRIGHT", SuperDock1, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(18))
				FCF_SavePositionAndDimensions(chat)
			end 
		end
		if not chat.isDocked then
			SVMod.chatskin(chat,-6,false,true)
			FCF_SavePositionAndDimensions(chat)
		end
	end
			
	-- reposition battle.net popup over chat #1
	BNToastFrame:HookScript("OnShow", function(self)
		self:ClearAllPoints()
		self:SetPoint("BOTTOM",SuperLeftChat,"TOP",0,20)
	end)
	
	SVMod.setbackdrop(BNToastFrame)
	SVMod.style(BNToastFrame,true)
	BNToastFrame:SetBackdropColor(.08,.08,.08,.9)
end

SuperChat:RegisterEvent("ADDON_LOADED")
SuperChat:RegisterEvent("PLAYER_ENTERING_WORLD")
SuperChat:SetScript("OnEvent", function(self, event, ...)
	local addon = ...
	if event == "ADDON_LOADED" then
		if addon == "Blizzard_CombatLog" then
			self:UnregisterEvent("ADDON_LOADED")
			SetupChat(self)
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		SetupChatPosAndFont(self)
	end
end)

-- Setup temp chat (BN, WHISPER) when needed.
local function SetupTempChat()
	local frame = FCF_GetCurrentChatFrame()
	SetChatStyle(frame)
end
hooksecurefunc("FCF_OpenTemporaryWindow", SetupTempChat)

-- /tt - tell your current target.
for i = 1, NUM_CHAT_WINDOWS do
	local editBox = _G["ChatFrame"..i.."EditBox"]
	editBox:HookScript("OnTextChanged", function(self)
	   local text = self:GetText()
	   if text:len() < 5 then
		  if text:sub(1, 4) == "/tt " then
			 local unitname, realm
			 unitname, realm = UnitName("target")
			 if unitname then unitname = gsub(unitname, " ", "") end
			 if unitname and not UnitIsSameServer("player", "target") then
				unitname = unitname .. "-" .. gsub(realm, " ", "")
			 end
			 ChatFrame_SendTell((unitname or SVLocal.chat_invalidtarget), ChatFrame1)
		  end
	   end
	end)
end

-----------------------------------------------------------------------------
-- Copy on chatframes feature
-----------------------------------------------------------------------------

local lines = {}
local frame = nil
local editBox = nil
local isf = nil

local function CreatCopyFrame()
	frame = CreateFrame("Frame", "CopyFrame", UIParent)
	frame:SetBackdrop({
			bgFile = SVMedia.blank, 
			edgeFile = SVMedia.blank, 
			tile = 0, tileSize = 0, edgeSize = SVMod.mult, 
			insets = { left = -SVMod.mult, right = -SVMod.mult, top = -SVMod.mult, bottom = -SVMod.mult }
	})
	frame:SetBackdropColor(unpack(SVMedia.backdropcolor))
	frame:SetBackdropBorderColor(unpack(SVMedia.bordercolor))
	frame:SetWidth(SVMod.Scale(410))
	frame:SetHeight(SVMod.Scale(200))
	frame:SetScale(1)
	frame:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, SVMod.Scale(10))
	frame:Hide()
	frame:SetFrameStrata("DIALOG")

	local scrollArea = CreateFrame("ScrollFrame", "CopyScroll", frame, "UIPanelScrollFrameTemplate")
	scrollArea:SetPoint("TOPLEFT", frame, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(-30))
	scrollArea:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", SVMod.Scale(-30), SVMod.Scale(8))

	editBox = CreateFrame("EditBox", "CopyBox", frame)
	editBox:SetMultiLine(true)
	editBox:SetMaxLetters(99999)
	editBox:EnableMouse(true)
	editBox:SetAutoFocus(false)
	editBox:SetFontObject(ChatFontNormal)
	editBox:SetWidth(SVMod.Scale(410))
	editBox:SetHeight(SVMod.Scale(200))
	editBox:SetScript("OnEscapePressed", function() frame:Hide() end)

	scrollArea:SetScrollChild(editBox)

	local close = CreateFrame("Button", "CopyCloseButton", frame, "UIPanelCloseButton")
	close:SetPoint("TOPRIGHT", frame, "TOPRIGHT")

	isf = true
end

local function GetLines(...)
	--[[		Grab all those lines		]]--
	local ct = 1
	for i = select("#", ...), 1, -1 do
		local region = select(i, ...)
		if region:GetObjectType() == "FontString" then
			lines[ct] = tostring(region:GetText())
			ct = ct + 1
		end
	end
	return ct - 1
end

local function Copy(cf)
	local _, size = cf:GetFont()
	FCF_SetChatWindowFontSize(cf, cf, 0.01)
	local lineCt = GetLines(cf:GetRegions())
	local text = table.concat(lines, "\n", 1, lineCt)
	FCF_SetChatWindowFontSize(cf, cf, size)
	if not isf then CreatCopyFrame() end
	if frame:IsShown() then frame:Hide() return end
	frame:Show()
	editBox:SetText(text)
end

function SVMod.ChatCopyButtons()
	for i = 1, NUM_CHAT_WINDOWS do
		local cf = _G[format("ChatFrame%d",  i)]
		local button = CreateFrame("Button", format("ButtonCF%d", i), cf)
		button:SetPoint("BOTTOMRIGHT", -2, 2)
		button:SetHeight(SVMod.Scale(20))
		button:SetWidth(SVMod.Scale(20))
		button:SetAlpha(0)
		SVMod.BasicSkin(button)
		
		local buttontext = button:CreateFontString(nil,"OVERLAY",nil)
		buttontext:SetFont(SVFonts.font,12,"OUTLINE")
		buttontext:SetText("C")
		buttontext:SetPoint("CENTER", SVMod.Scale(1), 0)
		buttontext:SetJustifyH("CENTER")
		buttontext:SetJustifyV("CENTER")
				
		button:SetScript("OnMouseUp", function(self)
			Copy(cf)
		end)
		button:SetScript("OnEnter", function() 
			button:SetAlpha(1) 
		end)
		button:SetScript("OnLeave", function() button:SetAlpha(0) end)
	end
end
SVMod.ChatCopyButtons()


------------------------------------------------------------------------
--	Enhance/rewrite a Blizzard feature, chatframe mousewheel.
------------------------------------------------------------------------

local ScrollLines = 3 -- set the jump when a scroll is done !
function FloatingChatFrame_OnMouseScroll(self, delta)
	if delta < 0 then
		if IsShiftKeyDown() then
			self:ScrollToBottom()
		else
			for i = 1, ScrollLines do
				self:ScrollDown()
			end
		end
	elseif delta > 0 then
		if IsShiftKeyDown() then
			self:ScrollToTop()
		else
			for i = 1, ScrollLines do
				self:ScrollUp()
			end
		end
	end
end

------------------------------------------------------------------------
--	Alt-click Invite. by Quokka.
------------------------------------------------------------------------
local origSetItemRef = SetItemRef
SetItemRef = function(link, text, button)
	local linkType = string.sub(link, 1, 6)
	if IsAltKeyDown() and linkType == "player" then
		local aname = string.match(link, "player:([^:]+)")
		InviteUnit(aname)
		return nil
	end
	return origSetItemRef(link,text,button)
end



------------------------------------------------------------------------
--	Play sound files system
------------------------------------------------------------------------

if SVConfig.chat.whispersound then
	local SoundSys = CreateFrame("Frame")
	SoundSys:RegisterEvent("CHAT_MSG_WHISPER")
	SoundSys:RegisterEvent("CHAT_MSG_BN_WHISPER")
	SoundSys:HookScript("OnEvent", function(self, event, ...)
		if event == "CHAT_MSG_WHISPER" or "CHAT_MSG_BN_WHISPER" then
			PlaySoundFile(SVMedia.whisper)
		end
	end)
end
------------------------------------------------------------------------
--	Chat Animations and Miscellaneous features by AlleyKat
------------------------------------------------------------------------
-- rep
function SVCHATSTRETCH()
	ChatFrame1:ClearAllPoints()
	ChatFrame1:SetPoint("TOPLEFT", SuperLeftChat, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(-8))
	ChatFrame1:SetPoint("BOTTOMRIGHT", SuperLeftChat, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(18))
	SuperLeftChat:SetAlpha(1)
	if (Quokkas_Options.lootchat == true) then
		ChatFrame4:ClearAllPoints()
		ChatFrame4:SetPoint("TOPLEFT", SuperDock1, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(-8))
		ChatFrame4:SetPoint("BOTTOMRIGHT", SuperDock1, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(18))
		SuperDock1:SetAlpha(1)
	end
end

local chatcur = {a_low,a_high,a_low,a_high}

-- Frame swiches
local n = {
	[1] = chatcur[1],
	[2] = chatcur[2],
	[3] = chatcur[3],
	[4] = chatcur[4],}

local speed = 240

local move_UP = function (self,t,target,N)
	n[N] = n[N] + t * speed
	if n[N] < a_high then
		target:SetHeight(n[N])
	else
		self:Hide()
		n[N] = a_high
		target:SetHeight(a_high)
	end
end

local move_DOWN = function (self,t,target,N)
	n[N] = n[N] - t * speed
	if n[N] > a_low then
		target:SetHeight(n[N])
	else
		self:Hide()
		n[N] = a_low
		target:SetHeight(a_low)
	end

end

local c1,c2,c3,ca = unpack(SVMedia.bordershadow)

local left_up = CreateFrame("Frame") 
local left_down = CreateFrame("Frame")
local right_up = CreateFrame("Frame") 
local right_down = CreateFrame("Frame")

---LEFTCHAT BUTTON SETUP
left_up:Hide()
left_down:Hide()
left_up:SetScript("OnUpdate",function(self,t) move_UP(self,t,SuperLeftChat,1,2) end)
left_down:SetScript("OnUpdate",function(self,t) move_DOWN(self,t,SuperLeftChat,1,2) end)
FirstframeSwitch:SetScript("OnMouseDown",function() 
	if chatcur[1] == a_low then
		chatcur[1] = a_high
		left_up:Show()
		left_down:Hide()
		if (Quokkas_Options.lootchat == true) then
			if right_up:IsShown() then
				right_up:Hide()
			end
		end
	else 
		chatcur[1] = a_low
		left_up:Hide()
		left_down:Show()
	end
	SVCHATSTRETCH()
end)

---RIGHTCHAT BUTTON SETUP
if (Quokkas_Options.lootchat == true) then
	right_up:Hide()
	right_down:Hide()
	right_up:SetScript("OnUpdate",function(self,t) move_UP(self,t,SuperDock1,3,4) end)
	right_down:SetScript("OnUpdate",function(self,t) move_DOWN(self,t,SuperDock1,3,4) end)
	SuperDockToggle1:SetScript("OnMouseDown",function() 
		if chatcur[3] == a_low then
			chatcur[3] = a_high
			right_up:Show()
			right_down:Hide()
			if left_up:IsShown() then
				left_up:Hide()
			end
		else 
			chatcur[3] = a_low
			right_up:Hide()
			right_down:Show()
		end
		SVCHATSTRETCH()
	end)
end

tinsert(SVRoot.PostApply,SVCHATSTRETCH)

-- scroll
local ScrollLines = 3
function FloatingChatFrame_OnMouseScroll(self, delta)
	if delta < 0 then
		if IsShiftKeyDown() then
			self:ScrollToBottom()
		else
			for i = 1, ScrollLines do
				self:ScrollDown()
			end
		end
	elseif delta > 0 then
		if IsShiftKeyDown() then
			self:ScrollToTop()
		else
			for i = 1, ScrollLines do
				self:ScrollUp()
			end
		end
	end
end