﻿if SuperSet["panelops"].minimap ~= true then return end

local cColor = oUF.colors.class
local myclass = SVRoot.myclass
local colorz = cColor[myclass]
local r, g, b = colorz[1], colorz[2], colorz[3]
	
Minimap:ClearAllPoints()
Minimap:SetClampedToScreen(false) 
Minimap:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -10, -2)
Minimap:SetSize(186*SuperSet.scaleops.minimapscale, 186*SuperSet.scaleops.minimapscale)
Minimap:SetHitRectInsets(0, 0, 28*SuperSet.scaleops.minimapscale, 28*SuperSet.scaleops.minimapscale)
Minimap:SetFrameLevel(10)
local blips = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\MungMaps\OBJECTICONS]]
--local svarrow = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\MungMaps\SVUI-MINIMAPARROW]]
--local svcorpse = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\MungMaps\SVUI-MINIMAPCORPSEARROW]]
--local svguide = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\MungMaps\SVUI-MINIMAPGUIDEARROW]]
--Minimap:SetStaticPOIArrowTexture(svarrow)
--Minimap:SetCorpsePOIArrowTexture(svcorpse)
--Minimap:SetPOIArrowTexture(svguide)
Minimap:SetBlipTexture(blips)
Minimap:SetMaskTexture('Interface\\AddOns\\A_Battle_Begins\\Supervillain_Media\\textures\\Default\\RectangleMask')
MinimapBorder:Hide()
MinimapBorderTop:Hide()
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
MiniMapVoiceChatFrame:Hide()
GameTimeFrame:Hide()
MinimapNorthTag:SetTexture(nil)
MinimapZoneTextButton:Hide()
MiniMapTracking:Hide()
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPRIGHT", MapBorder, -5, -5)
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture([[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Icons\MAIL]])
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("RIGHT", MapBorder, "LEFT", -4, 0)
MiniMapWorldMapButton:Hide()
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetParent(Minimap)
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", MapBorder, "TOPLEFT", -4, -2)
GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetParent(Minimap)
GuildInstanceDifficulty:SetPoint("TOPRIGHT", MapBorder, "TOPLEFT", -4, -2)

Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function(self, d)
	if d > 0 then
		_G.MinimapZoomIn:Click()
	elseif d < 0 then
		_G.MinimapZoomOut:Click()
	end
end)

local menuFrame = CreateFrame("Frame", "MinimapRightClickMenu", UIParent, "UIDropDownMenuTemplate")
local menuList = {
	{text = "CALL MINION!!",
	func = function() RunSlashCmd("/callminion") end},
	{text = "General SVUI Options",
	func = function() RunSlashCmd("/setupsvui") end},
	{text = "Show/Hide Watchframe",
	func = function() RunSlashCmd("/wf") end},
	{text = "Lock/Unlock Shapeshift Bar",
	func = function() RunSlashCmd("/mss") end},
	{text = "Reset Shapeshift Bar",
	func = function() RunSlashCmd("/rss") end},
	{text = "Lock/Unlock Pet Bar",
	func = function() RunSlashCmd("/mpb") end},
	{text = "Reset Pet Bar",
	func = function() RunSlashCmd("/rpb") end},
	{text = "Set Keybindings",
	func = function() RunSlashCmd("/hb") end},
	{text = "Unlock Combat Text",
	func = function() RunSlashCmd("/svctext unlock") end},
	{text = "Lock Combat Text",
	func = function() RunSlashCmd("/svctext lock") end},
	{text = "Tip/Loot Anchors",
	func = function() RunSlashCmd("/svanchor") end},
	{text = "Tooltip Options",
	func = function() RunSlashCmd("/svtips") end},
	{text = "All Praise Due",
	func = function() SendChatMessage("Munglunch is the greatest addon developer in the world.") end},
	{text = "",
	func = function() SendChatMessage("Sorry I am busy clicking on blank spaces in my minimap! Don't worry though I would have failed anyway.") end},
	{text = L_CALENDAR,
	func = function()
	if(not CalendarFrame) then LoadAddOn("Blizzard_Calendar") end
		Calendar_Toggle()
	end},
}

Minimap:SetScript("OnMouseUp", function(self, btn)
	if btn == "RightButton" then
		ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self)
	elseif btn == "MiddleButton" then
		EasyMenu(menuList, menuFrame, "cursor", 0, 0, "MENU", 2)
	else
		Minimap_OnClick(self)
	end
end)

function GetMinimapShape() return 'SQUARE' end

function UpdateLFG()
	MiniMapLFGFrame:ClearAllPoints()
	MiniMapLFGFrame:SetPoint("BOTTOMRIGHT", MapBorder, "BOTTOMLEFT", -4, 2)
end
hooksecurefunc("MiniMapLFG_UpdateIsShown", UpdateLFG)

local set_slide = SVAnimate.Slide

local m_coord = CreateFrame("Frame","MapCoordSlider",UIParent)
	m_coord:SetWidth(67*SuperSet.scaleops.minimapscale)
	m_coord:SetHeight(20*SuperSet.scaleops.minimapscale)
	m_coord:SetPoint("TOPRIGHT", MapBorder, "TOPRIGHT",-2,-2)
	set_slide(m_coord,true,0,100)
	m_coord:Hide()		
local m_coord_text = SVUnit.SuperText(m_coord, SVFonts.super, 16, "OUTLINE", "CENTER")
	m_coord_text:SetPoint("TOPLEFT",6,0)
	m_coord_text:SetPoint("BOTTOMRIGHT",-1,0)
	m_coord_text:SetTextColor(r, g, b)
Minimap:SetScript("OnEnter",function()
	m_coord.slide_out:Stop()
	m_coord:Show()
	m_coord.slide:Play()
end)
Minimap:SetScript("OnLeave",function()
	m_coord.slide:Stop()
	m_coord.slide_out:Play()
end)

local m_ptog = CreateFrame("Frame","MapBottomToggle",UIParent)
	m_ptog:SetWidth(200*SuperSet.scaleops.minimapscale)
	m_ptog:SetHeight(18*SuperSet.scaleops.minimapscale)
	SVMod.setbackdrop(m_ptog)
	m_ptog:SetBackdropColor(1,1,0,0.5)
	m_ptog:SetPoint("TOP", MapBorder, "BOTTOM",0,6)
local mpt_t = SVUnit.SuperText(m_ptog, SVFonts.super, 14, "OUTLINE", "CENTER")
	mpt_t:SetAllPoints(m_ptog)
	mpt_t:SetTextColor(1, 1, 1, 0.6)
	mpt_t:SetJustifyH("CENTER")
	mpt_t:SetText("Supervillain Options")
	m_ptog:SetAlpha(0)
local m_panel = CreateFrame("Frame","MapBottomSlider",UIParent)
	m_panel:SetWidth(186*SuperSet.scaleops.minimapscale)
	m_panel:SetHeight(60*SuperSet.scaleops.minimapscale)
	m_panel:SetFrameStrata("BACKGROUND")
	m_panel:SetFrameLevel(0)
	m_panel:SetPoint("TOP", MapBorder, "BOTTOM",0,2)
	set_slide(m_panel,true,200,0)
	m_panel:Hide()	
MapBottomToggle:SetScript("OnEnter",function()
	MapBottomToggle:SetAlpha(1)
end)
MapBottomToggle:SetScript("OnLeave",function()
	MapBottomToggle:SetAlpha(0)
end)
MapBottomToggle:SetScript("OnMouseDown",function()
	if m_panel:IsShown() then
		m_panel.slide:Stop()
		m_panel.slide_out:Play()
	else
		m_panel.slide_out:Stop()
		m_panel:Show()
		m_panel.slide:Play()
	end
end)
m_coord_text:SetText("00,00")

local ela,go = 0,false

m_coord.slide:SetScript("OnFinished",function() go = true end)
m_coord.slide_out:SetScript("OnPlay",function() go = false end)

local coord_Update = function(self,t)
	ela = ela - t
	if ela > 0 or not(go) then return end
	local x,y = GetPlayerMapPosition("player")
	local xt,yt
	x = math.floor(100 * x)
	y = math.floor(100 * y)
	if x == 0 and y == 0 then
		m_coord_text:SetText("X _ X")
	else
		if x < 10 then 
			xt = "0"..x
		else 
			xt = x 
		end
		if y < 10 then 
			yt = "0"..y 
		else 
			yt = y 
		end
		m_coord_text:SetText(xt..","..yt)
	end
	ela = .2
end

m_coord:SetScript("OnUpdate",coord_Update)

local hide_cl = function()
	TimeManagerClockButton:Hide()
end

tinsert(SVRoot.PostApply,hide_cl)