local fstring = GameTooltip:CreateFontString("SVUITooltipID","ARTWORK")
fstring:SetFont(SVFonts.super_c, 15, "OUTLINE")
fstring:SetTextColor(1,1,0.2)
fstring:SetShadowOffset(-2,-2)
fstring:SetShadowColor(0,0,0,0.8)
fstring:SetPoint("TOP",GameTooltip,"BOTTOM")

GameTooltip:HookScript("OnTooltipCleared", function(self) self.SVUIItemTooltip=nil; SVUITooltipID:SetText("") end)
GameTooltip:HookScript("OnTooltipSetItem", function(self)
	if (IsShiftKeyDown() or IsAltKeyDown()) and (SVUIItemTooltip and not self.SVUIItemTooltip and (SVUIItemTooltip.id or SVUIItemTooltip.count)) then
		local item, link = self:GetItem()
		local num = GetItemCount(link)
		local left = ""
		local right = ""
		
		if SVUIItemTooltip.id and link ~= nil then
			left = "|cFFCA3C3CID|r "..link:match(":(%w+)")
		end
		
		if SVUIItemTooltip.count and num > 1 then
			right = "|cFFCA3C3C Count |r "..num
		end
				
		self:AddLine(" ")
		self:AddDoubleLine(left, right)
		self.SVUIItemTooltip = 1
	end
end)

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(_, _, name)
	if name ~= "A_Supervillain_Emerges" then return end
	f:UnregisterEvent("ADDON_LOADED")
	f:SetScript("OnEvent", nil)
	SVUIItemTooltip = SVUIItemTooltip or {count=true,id=true}
end)

local select, UnitBuff, UnitDebuff, UnitAura, tonumber, strfind, hooksecurefunc =
	select, UnitBuff, UnitDebuff, UnitAura, tonumber, strfind, hooksecurefunc

local function addLine(self,id,isItem)
	if isItem then
		SVUITooltipID:SetText("ItemID:       ".."|cff00ffff"..id)
	else
		SVUITooltipID:SetText("SpellID:       ".."|cff00ffff"..id)
	end
end

-- Spell Hooks ----------------------------------------------------------------
hooksecurefunc(GameTooltip, "SetUnitBuff", function(self,...)
	local id = select(11,UnitBuff(...))
	if (id) and (IsShiftKeyDown() or IsAltKeyDown()) then addLine(self,id) end
end)

hooksecurefunc(GameTooltip, "SetUnitDebuff", function(self,...)
	local id = select(11,UnitDebuff(...))
	if (id) and (IsShiftKeyDown() or IsAltKeyDown()) then addLine(self,id) end
end)

hooksecurefunc(GameTooltip, "SetUnitAura", function(self,...)
	local id = select(11,UnitAura(...))
	if (id) and (IsShiftKeyDown() or IsAltKeyDown()) then addLine(self,id) end
end)

GameTooltip:HookScript("OnTooltipSetSpell", function(self)
	local id = select(3,self:GetSpell())
	if (id) and (IsShiftKeyDown() or IsAltKeyDown()) then addLine(self,id) end
end)

-- Item Hooks -----------------------------------------------------------------
hooksecurefunc("SetItemRef", function(link, ...)
	local id = tonumber(link:match("spell:(%d+)"))
	if (id) and (IsShiftKeyDown() or IsAltKeyDown()) then addLine(ItemRefTooltip,id) end
end)

local function attachItemTooltip(self)
	local link = select(2,self:GetItem())
	if not link then return end
	local id = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"))
	if (id) and (IsShiftKeyDown() or IsAltKeyDown()) then addLine(self,id,true) end
end

GameTooltip:HookScript("OnTooltipSetItem", attachItemTooltip)
ItemRefTooltip:HookScript("OnTooltipSetItem", attachItemTooltip)
ItemRefShoppingTooltip1:HookScript("OnTooltipSetItem", attachItemTooltip)
ItemRefShoppingTooltip2:HookScript("OnTooltipSetItem", attachItemTooltip)
ItemRefShoppingTooltip3:HookScript("OnTooltipSetItem", attachItemTooltip)
ShoppingTooltip1:HookScript("OnTooltipSetItem", attachItemTooltip)
ShoppingTooltip2:HookScript("OnTooltipSetItem", attachItemTooltip)
ShoppingTooltip3:HookScript("OnTooltipSetItem", attachItemTooltip)