local Main = CreateFrame("StatusBar",nil,Minimap)
local Off = CreateFrame("StatusBar",nil,Minimap)
Main.curr = 0
Off.curr = 0

Main:SetPoint("BOTTOMRIGHT",MapBorder,"TOPRIGHT",-3,5)

if TempEnchant2:IsShown() then
	Main:SetWidth(102)
else
	Main:SetWidth(210)
end

local stages = {
	[1] = 3600,
	[2] = 1800,
	[3] = 900}
local color = {
	[1] = {.2,.5,1},
	[2] = {1,.8,.1},
	[3] = {1,.2,.2}}

local mtexture = Main:CreateTexture(nil,"Overlay")
mtexture:SetTexture(1,1,1,0.6)
Main.texx = mtexture

local atexture = Off:CreateTexture(nil,"Overlay")
atexture:SetTexture(1,1,1,0.6)
Off.texx = atexture
	
local color_it = function(self,c,mark)
	if self.curr == mark then return end
	self.curr = mark
	local r,g,b = unpack(color[c])
	self.texx:SetGradient("VERTICAL",r,g,b,r*.6,g*.6,b*.6)
end

local check_minmax = function(self,t)
	if not t then return end
	t = math.floor(t/1000)
	if t <= stages[3] then
		t = stages[3]
		color_it(self,3,t)
	elseif t<= stages[2] then
		t = stages[2]
		color_it(self,2,t)
	else
		t = stages[1]
		color_it(self,1,t)
	end
	self:SetMinMaxValues(0,t)
end

local check_current = function (self,t)
	if not t then return end
	local a = math.floor(t/1000)
	if a <= stages[3] then
		if self.curr == stages[3] then return end
		check_minmax(self,t)
	elseif a<= stages[2] then
		if self.curr == stages[2] then return end
		check_minmax(self,t)
	else
		if self.curr == stages[1] then return end
		check_minmax(self,t)
	end
end

Main:SetHeight(11)
Main:SetStatusBarTexture(Main.texx)
Main:SetMinMaxValues(0,3600)
Main:SetFrameLevel(6)
Main:SetFrameStrata("LOW")

Main.char = SVMod.SetFont(Main,13,nil,nil,"RIGHT")
Main.char:SetPoint("RIGHT",-1.7,1)
Main.char:SetText("X")

Off:SetPoint("TOPRIGHT",Main,"TOPLEFT",-10,0)
Off:SetWidth(102)
Off:SetHeight(11)
Off:SetStatusBarTexture(Off.texx)
Off:SetMinMaxValues(0,3600)
Off:SetFrameLevel(6)
Off:SetFrameStrata("LOW")

Off.char = SVMod.SetFont(Off,13,nil,nil,"RIGHT")
Off.char:SetPoint("RIGHT",-1.7,1)
Off.char:SetText("X")

local Mainbackdrop = SVMod.frame(UIParent,0)
	Mainbackdrop:SetPoint("TOPLEFT",Main,-4,4)
	Mainbackdrop:SetPoint("BOTTOMRIGHT",Main,4,-4)

local Offbackdrop = SVMod.frame(UIParent,0)
	Offbackdrop:SetPoint("TOPLEFT",Off,-4,4)
	Offbackdrop:SetPoint("BOTTOMRIGHT",Off,4,-4)
	
local make_anim_in = function(self)
	self.show_in = self:CreateAnimationGroup("IN")
	self.show_in.b = self.show_in:CreateAnimation("Translation")
	self.show_in.b:SetOffset(0,40)
	self.show_in.b:SetDuration(2)
	self.show_in.b:SetOrder(1)
	self.show_in.b:SetSmoothing("OUT")
end	

local show_out = function(self)
	self.show_out = self:CreateAnimationGroup("OUT")
	self.show_out.a = self.show_out:CreateAnimation("Translation")
	self.show_out.a:SetOffset(0,-40)
	self.show_out.a:SetDuration(2)
	self.show_out.a:SetOrder(1)
	self.show_out.a:SetSmoothing("IN")
end

make_anim_in(Mainbackdrop)
make_anim_in(Offbackdrop)
show_out(Mainbackdrop)

local Main_show_end = function()
	Main:SetPoint("BOTTOMRIGHT",MapBorder,"TOPRIGHT",-3,1)
	local _,t2,t3 = GetWeaponEnchantInfo()
		Main:Show()
		check_minmax(Main,t2)
end

local Off_show_end = function()
	Off:SetPoint("TOPRIGHT",Main,"TOPLEFT",-6,0)
	local _,_,_,_,t2,t3 = GetWeaponEnchantInfo()
		Off:Show()
		check_minmax(Off,t2)
end

Mainbackdrop.show_in:SetScript("OnFinished",Main_show_end)
Mainbackdrop.show_out:SetScript("OnFinished",function() Mainbackdrop:Hide() end)
Offbackdrop.show_in:SetScript("OnFinished",Off_show_end)

local offset = 0

TempEnchant1:HookScript("OnShow",function(self)
	Main:Hide()
	Mainbackdrop.show_out:Stop()
	Main:SetPoint("BOTTOMRIGHT",MapBorder,"TOPRIGHT",-3,offset+1)
	Mainbackdrop:Show()
	Mainbackdrop.show_in:Play()
end)

TempEnchant1:HookScript("OnHide",function(self) 
	Main:Hide()
	Mainbackdrop.show_in:Stop()
	Mainbackdrop.show_out:Play()
end)

TempEnchant2:HookScript("OnShow",function(self)
	Main:SetWidth(37)
	Offbackdrop:Show()
	Off:SetPoint("TOPRIGHT",Main,"TOPLEFT",-6,offset)
	Offbackdrop.show_in:Play()
end)

TempEnchant2:HookScript("OnHide",function(self) 
	Main:SetWidth(80)
	Off:Hide()
	Offbackdrop.show_in:Stop()
	Offbackdrop:Hide()
end)

local Update_it = function(self,t1,t2,t3)
	if not t1 then return end
		if t2 then 
			self:SetValue(t2/1000)
			check_current(self,t2)
			end
		if t3 == 0 or not(t3) then t3 = "" end
		self.char:SetText(t3)
end

local N = 0

local Update = function(self,t)
	N = N - t
		if N > 0 then return end
		N = 1
		local a,b,c,d,e,t = GetWeaponEnchantInfo()
			Update_it(Main,a,b,c)
			Update_it(Off,d,e,t)
end

local update_frame = CreateFrame("Frame")
update_frame:SetScript("OnUpdate",Update)

	TempEnchant1:ClearAllPoints()
	TempEnchant2:ClearAllPoints()

	TemporaryEnchantFrame.SetPoint = function() end
	TemporaryEnchantFrame:SetAlpha(0)
	TemporaryEnchantFrame:ClearAllPoints()
	TemporaryEnchantFrame:SetAllPoints(Minimap)
	
	TempEnchant1:SetPoint("TOPLEFT",Main,-1,1)
	TempEnchant1:SetPoint("BOTTOMRIGHT",Main,1,-1)	
	TempEnchant2:SetPoint("TOPLEFT",Off,-1,1)
	TempEnchant2:SetPoint("BOTTOMRIGHT",Off,1,-1)	
	
	Off:Hide()
	Offbackdrop:Hide()
	Main:Hide()
	Mainbackdrop:Hide()
	
local correct_minmax = CreateFrame("Frame")
local ad,second_chek = 5
correct_minmax:Hide()
correct_minmax:RegisterEvent("PLAYER_ENTERING_WORLD")

correct_minmax:SetScript("OnEvent",function(self) 
	self:UnregisterAllEvents() 
	self:Show() 
	offset = 40/GetCVar("UIScale") 
end)

correct_minmax:SetScript("OnUpdate",function(self,t)
	ad = ad - t
		if ad > 0 then return end
			local a,b,_,d,e = GetWeaponEnchantInfo()
			if a then
				check_minmax(Main,b)
				Main:Show()
				Mainbackdrop:Show()
			end
			if d then
				check_minmax(Off,e)
				Off:Show()
				Offbackdrop:Show()
			end
end)