if (SuperSet.uf_layout ~= 1) then return end

--[[  LOCALS  ]]--
SVLock.threat_ok = false
local mk_anim = true
local colors = SVColors.oUF_colors
local playerdebuffs = true
local bartex
local assisttank_width  = 125
local assisttank_height  = 35
local t1,t2
if (SuperSet.colortheme == 3) then
	bartex = SVMedia.smoothbar
else
	bartex = SVMedia.colorbar
end
local show_fade = function(self)
	if not InCombatLockdown() then
		UIFrameFadeIn(self,.1,0,self:GetAlpha())
	end
end
SVLock.threat_ok = true
	
--[[  STYLE FUNCTION  ]]--
local villain_style = function(self,unit)
	self.menu = SVUnit.SpawnMenu
	self.disallowVehicleSwap = true
	self:SetScale(SVUnit.ufscale())
	self:RegisterForClicks("anyup")
	self:SetAttribute("*type2", "menu")
	self:SetFrameStrata("LOW")
	self:SetFrameLevel(0)
	SVMod.setbackdrop(self)
	local glowme = CreateFrame("Frame",nil,self)
	glowme:SetAllPoints(self)
	glowme:SetFrameLevel(10)
	SVMod.SimpleSkin(glowme,3)
	self.glow = glowme
	self:SetScript('OnEnter',UnitFrame_OnEnter)
	self:SetScript('OnLeave',UnitFrame_OnLeave)
	if unit == "vehicle" then unit = "player" end
	------------------------------------------------------------------------------
	-- MAKE PORTRAITS
	------------------------------------------------------------------------------
	if (unit=="player") then
		local portrait = CreateFrame("PlayerModel",nil,self)
		portrait:SetPoint("TOPLEFT",self,5,-5)
		portrait:SetPoint("BOTTOMRIGHT",self,-5,5)
		portrait:SetFrameLevel(2)
		portrait:SetAlpha(1)
		portrait.bg = CreateFrame("Frame",nil,portrait)
		portrait.bg:SetPoint("TOPLEFT",portrait,-2,2)
		portrait.bg:SetPoint("BOTTOMRIGHT",portrait,2,-2)
		portrait.bg:SetBackdrop({bgFile = SVMedia.unitbg, tile = false})
		portrait.bg:SetAlpha(1)
		portrait.bg:SetFrameLevel(1)
		portrait.fg = CreateFrame("Frame",nil,portrait)
		portrait.fg:SetAllPoints(portrait.bg)
		portrait.fg:SetBackdrop({bgFile = SVMedia.unitfg, tile = false})
		portrait.fg:SetBackdropColor(1, 1, 1)
		portrait.fg:SetAlpha(1)
		portrait.fg:SetFrameLevel(10)
		portrait.Player = true
		self.Portrait = portrait
	elseif (unit=="target") then
		local portrait = CreateFrame("PlayerModel",nil,self)
		portrait:SetPoint("TOPRIGHT",self,-5,-5)
		portrait:SetPoint("BOTTOMLEFT",self,5,5)
		portrait:SetFrameLevel(2)
		portrait:SetAlpha(1)
		portrait.bg = CreateFrame("Frame",nil,portrait)
		portrait.bg:SetPoint("TOPLEFT",portrait,-2,2)
		portrait.bg:SetPoint("BOTTOMRIGHT",portrait,2,-2)
		portrait.bg:SetBackdrop({bgFile = SVMedia.unitbg, tile = false})
		portrait.bg:SetAlpha(1)
		portrait.bg:SetFrameLevel(1)
		portrait.fg = CreateFrame("Frame",nil,portrait)
		portrait.fg:SetAllPoints(portrait.bg)
		portrait.fg:SetAlpha(1)
		portrait.fg:SetFrameLevel(10)
		portrait.fg.tex = portrait.fg:CreateTexture(nil,"ARTWORK")
		portrait.fg.tex:SetAllPoints(portrait.fg)
		portrait.fg.tex:SetTexture(SVMedia.unitfg)
		SVUnit.TexFlip(portrait.fg.tex)
		portrait.fg.tex:SetVertexColor(1, 1, 1)
		if (IsAddOnLoaded('oUF_SpellRange')) then 	
			self.SpellRange = {["insideAlpha"] = 1,["outsideAlpha"] = .777,}
		end
		portrait.Target = true
		self.Portrait = portrait
	else
		local portframe = CreateFrame("PlayerModel",nil,self)
		portframe:SetPoint("TOPLEFT",self,"TOPLEFT",3,-3)
		portframe:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",-3,3)
		portframe:SetFrameLevel(3)
		portframe:SetAlpha(1)
		SVMod.SimpleSkin(portframe)
		local portrait = CreateFrame("PlayerModel",nil,self)
		portrait:SetPoint("TOPLEFT",portframe,2,-2)
		portrait:SetPoint("BOTTOMRIGHT",portframe,-2,2)
		portrait:SetFrameLevel(2)
		portrait:SetAlpha(1)
		portrait.bg = CreateFrame("Frame",nil,self)
		portrait.bg:SetAllPoints(portrait)
		portrait.bg:SetPoint("TOPLEFT",portrait,-2,2)
		portrait.bg:SetPoint("BOTTOMRIGHT",portrait,2,-2)
		portrait.bg:SetBackdrop({bgFile = SVMedia.smallbg, tile = false})
		portrait.bg:SetAlpha(1)
		portrait.bg:SetFrameLevel(1)
		self.Portrait = portrait
		if (IsAddOnLoaded('oUF_SpellRange')) then 	
			self.SpellRange = {["insideAlpha"] = 1,["outsideAlpha"] = .777,}
		end
	end
	
	SVUnit.PortraitUnavailable(self.Portrait)
	self.Portrait.PostUpdate = SVUnit.PicturePages
	
	if unit == "player" or unit == "pet" then
		self.Portrait.bg.unit = unit
	end

	------------------------------------------------------------------------------
	-- MAKE HEALTH BARZ
	------------------------------------------------------------------------------
	local hp = CreateFrame("StatusBar", nil, self)
	if (unit == "player") then
		hp:SetStatusBarTexture(SVMedia.blank)
		hp:SetAllPoints(self.Portrait.bg)
		hp:SetFrameLevel(4)
		hp:SetStatusBarColor(0,0,0,0)
		hp.Smooth = true
		self.Health = hp
		hp.second = hp:CreateTexture(nil,"OVERLAY")
		hp.second:SetHeight(SVUnit.unitH-6)
		hp.second:SetPoint("BOTTOMLEFT",self,3,3)
		hp.second:SetTexture(bartex)
		hp.second:SetVertexColor(0,0,0,0)
		hp.third = hp:CreateTexture(nil,"BORDER")
		hp.third:SetAllPoints(self.Portrait.bg)
		hp.third:SetTexture(bartex)
		hp.third:SetVertexColor(0,0,0,0)
		SVUnit.Animated(hp.second,.3,2,1)
		self.Health.frequentUpdates = true
		self.Health.PostUpdate = SVUnit.SuperPlayerHealth
	elseif (unit == "target") then
		hp:SetStatusBarTexture(SVMedia.blank)
		hp:SetAllPoints(self.Portrait.bg)
		hp:SetFrameLevel(4)
		hp.Smooth = true
		self.Health = hp
		hp.second = hp:CreateTexture(nil,"OVERLAY")
		hp.second:SetHeight(SVUnit.unitH-6)
		hp.second:SetPoint("BOTTOMRIGHT",self,-3,3)
		hp.second:SetTexture(bartex)
		hp.second:SetVertexColor(0,0,0,0)
		hp.third = hp:CreateTexture(nil,"BORDER")
		hp.third:SetAllPoints(self.Portrait.bg)
		hp.third:SetTexture(bartex)
		hp.third:SetVertexColor(0,0,0,0)
		SVUnit.Animated(hp.second,.3,2,1)
		self.Health.frequentUpdates = true
		self.Health.PostUpdate = SVUnit.SuperTargetHealth
	else
		hp:SetStatusBarTexture(SVMedia.blank)
		hp:SetAllPoints(self.Portrait)
		self.Health = hp
		hp:SetFrameLevel(5)	
		hp.Smooth = true
		hp.second = CreateFrame("StatusBar",nil,self)
		hp.second:SetFrameLevel(5)
		hp.second:SetAllPoints(self.Portrait)
		hp.second:SetStatusBarTexture(SVMedia.blank)
		SVUnit.Animated(hp.second,.3,1,2)
		self.Health.PostUpdate = SVUnit.SuperHealth
	end
	------------------------------------------------------------------------------
	-- MAKE POWER BARZ
	------------------------------------------------------------------------------
	local pp = CreateFrame("StatusBar", nil, self)
	if (unit == "player") then
		pp:SetFrameLevel(6)
		pp:SetStatusBarTexture(bartex)
		pp:SetPoint("BOTTOMLEFT",self,"BOTTOMLEFT",6,3)
		pp:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",-4,3)
		pp:SetHeight(10)
		pp.frequentUpdates = true
		pp.Smooth = true
		pp.colorSmooth = true
		self.Power = pp
		pp.bg = self.Power:CreateTexture(nil, 'BORDER')
		pp.bg:SetAllPoints(self.Power)
		pp.bg:SetTexture(SVMedia.blank)
		pp.bg:SetVertexColor(1, 1, 1)
		pp.bg.multiplier = (0.15)
		self.Power.bg = pp.bg
	elseif (unit == "target") then
		pp:SetFrameLevel(6)
		pp:SetStatusBarTexture(bartex)
		pp:SetPoint("BOTTOMLEFT",self,"BOTTOMLEFT",4,3)
		pp:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",-6,3)
		pp:SetHeight(10)
		pp.frequentUpdates = true
		pp.Smooth = true
		pp.colorSmooth = true
		self.Power = pp
		pp.bg = self.Power:CreateTexture(nil, 'BORDER')
		pp.bg:SetAllPoints(self.Power)
		pp.bg:SetTexture(SVMedia.blank)
		pp.bg:SetVertexColor(1, 1, 1)
		pp.bg.multiplier = (0.15)
		self.Power.bg = pp.bg
	else
		pp:SetFrameLevel(6)
		pp:SetStatusBarTexture(bartex)
		pp:SetPoint("BOTTOMLEFT",self,"BOTTOMLEFT",3,3)
		pp:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",-3,3)
		pp:SetHeight(10)
		pp.frequentUpdates = true
		pp.Smooth = true
		pp.colorReaction = true
		SVMod.SimpleSkin(pp)
		self.Power = pp
		pp.bg = self.Power:CreateTexture(nil, 'BORDER')
		pp.bg:SetAllPoints(self.Power)
		pp.bg:SetTexture(SVMedia.blank)
		pp.bg:SetVertexColor(1, 1, 1)
		pp.bg.multiplier = (0.15)
		self.Power.bg = pp.bg
	end
	self.Power.PostUpdate = SVUnit.PowerUP
	------------------------------------------------------------------------------
	-- MAKE OTHER BARZ
	------------------------------------------------------------------------------
	local infoz = CreateFrame("Frame",nil,self)
	infoz:SetFrameStrata("LOW")
	infoz:SetFrameLevel(18)
	self.infoz = infoz 
	local dataz = CreateFrame("Frame",nil,self)
	dataz:SetFrameStrata("LOW")
	dataz:SetFrameLevel(11)
	if(unit == "targettarget") or (unit == "pet") or (unit == "focus") or (unit == "focustarget") then
		dataz:SetPoint("BOTTOMLEFT", self.Power, "TOPLEFT", 0, 0)
		dataz:SetPoint("BOTTOMRIGHT", self.Power, "TOPRIGHT", 0, 0)
	else
		dataz:SetPoint("BOTTOMLEFT", self.Power, "TOPLEFT", 0, -3)
		dataz:SetPoint("BOTTOMRIGHT", self.Power, "TOPRIGHT", 0, -3)
	end
	dataz:SetHeight(12)
	self.data = dataz
	
	local isf = CreateFrame("Frame",nil,self)
	isf:SetHeight(10*SuperSet.scaleops.ufscale)
	if (unit == "player") then
		if (SVRoot.myclass == 'DEATHKNIGHT') or (EclipseBarFrame:IsShown() and SVRoot.myclass == 'DRUID') or (SVRoot.myclass == "SHAMAN") or (SVRoot.myclass == "WARLOCK") or (SVRoot.myclass == "PALADIN") then
			isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT",2,20)
			isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT",-2,20)
		else	
			isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT",2,10)
			isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT",-2,10)
		end
	else
		isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT",2,10)
		isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT",-2,10)
	end
	self.isf = isf
	if (unit~="player") then
		if (unit == "target") then
			local info = self.infoz:CreateFontString(nil, "OVERLAY")
			info:SetFont(SVFonts.super, SVUnit.fsname, "THINOUTLINE")
			info:SetJustifyH("LEFT")
			self.info = info
			SVUnit.RaidIcons(self,"RIGHT")
			if SuperSet.unitops.threatbar == true then
				local thrbar = CreateFrame("Frame",nil,self.data)
				thrbar:SetFrameLevel(11)
				thrbar:SetPoint("BOTTOM", self, "BOTTOM",0,0)
				thrbar:SetWidth(SVUnit.unitW-4)
				thrbar:SetHeight(4)
				self.SuperThreatBar = thrbar
			end
		else
			local info = self.infoz:CreateFontString(nil, "OVERLAY")
			info:SetFont(SVFonts.font, 12, "THINOUTLINE")
			info:SetJustifyH("CENTER")
			if (unit == "focus") or (unit == "focustarget")  then
				info:SetPoint("TOPLEFT",self,"TOPLEFT",2,-2)
				self:Tag(info, "[raidcolor][nameraid]")
			elseif (unit == "targettarget") or (unit == "pet") then
				info:SetPoint("TOPLEFT",self,"TOPLEFT",2,-2)
				info:SetPoint("TOPRIGHT",self,"TOPRIGHT",-2,-2)
				self:Tag(info, "[raidcolor][name]")
			else
				info:SetPoint("TOPLEFT",self,"TOPLEFT",2,-2)
				info:SetPoint("TOPRIGHT",self,"TOPRIGHT",-2,-2)
				self:Tag(info, "[raidcolor][name] |r|cfffed100[smartlevel]")
			end
			self.info = info
			SVUnit.RaidIcons(self)
		end
	else
		local info = self.infoz:CreateFontString(nil, "OVERLAY")
		info:SetFont(SVFonts.super, SVUnit.fsname, "THINOUTLINE")
		info:SetJustifyH("CENTER")
		info:SetShadowOffset(1.3, -1.3)
		self.info = info
		SVUnit.RaidIcons(self,"LEFT")
		if SuperSet.unitops.swingbar == true then
			SVUnit.SwingSet(self)
			self.Swing:SetWidth(SVUnit.unitW-4)
			self.Swing:SetHeight(3)
			self.Swing:SetPoint("BOTTOM", self, "BOTTOM",0,0)
		end
		if SuperSet.unitops.threatbar == true then
			SVUnit.CreateThreatBar(self)
		end
	end
	----------Make CastBars--------------------------------------
	local castbg = CreateFrame("Frame",nil,self)
	if (unit == "player") then
		castbg:SetPoint("TOPLEFT", self, "BOTTOMLEFT",0,-8)
		castbg:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT",0,-8)
		castbg:SetHeight(19*SuperSet.scaleops.ufscale)
	elseif (unit == "target") then
		castbg:SetPoint("TOPLEFT", self, "BOTTOMLEFT",0,-8)
		castbg:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT",0,-8)
		castbg:SetHeight(19*SuperSet.scaleops.ufscale)
	else
		castbg:SetAllPoints(self.Power)
		castbg:SetFrameLevel(11)
	end
	self.cbb = castbg
	SVUnit.CreateCast(self,unit)

	if (unit == "player") then
		local H_value = self.data:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1.3, -1.3)
			H_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("BOTTOMRIGHT",self.data,"BOTTOMRIGHT",-2,1)
		self.Health.value = H_value
		local P_value = self.data:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1.3, -1.3)
			P_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			P_value:SetJustifyH("RIGHT")
			P_value:SetPoint("RIGHT",self.Health.value,"LEFT",-6,0)
		self.Power.value = P_value
		local leader = self.data:CreateFontString(nil, "OVERLAY")
		leader:SetFont(SVFonts.cooldown,SVUnit.fsname,"THINOUTLINE")
		leader:SetShadowOffset(1.3,-1.3)
		leader:SetPoint("BOTTOMLEFT",self,"BOTTOMLEFT",-4,-4)
		leader:SetText("L")
		leader:SetJustifyH("LEFT")
		self.Leader = leader
		self.info:SetPoint("RIGHT",self.isf,"RIGHT",-2,0)
		local aura = CreateFrame("Frame",nil,self)
		aura:SetPoint("BOTTOMLEFT", self.isf,"BOTTOMLEFT",0,4)
		aura:SetPoint("BOTTOMRIGHT", self.isf,"BOTTOMRIGHT",0,4)
		aura.initialAnchor = "BOTTOMRIGHT"
		aura["growth-x"] = "LEFT"
		aura["growth-y"] = "UP"
		aura.numBuffs = 0
		aura.numDebuffs = 8
		aura.spacing = 4
		aura.size = 23
		aura:SetHeight(aura.size+aura.spacing)
		aura.cbt = true
		self.Auras = aura
		self.Auras.PostCreateIcon = SVUnit.auraIcon
		self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
		self.Aggro = SVUnit.Aggro(self)
		table.insert(self.__elements, SVUnit.PlayerThreat)
		self:RegisterEvent('PLAYER_TARGET_CHANGED', SVUnit.PlayerThreat)
		self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', SVUnit.PlayerThreat)
		self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', SVUnit.PlayerThreat)
		if SVRoot.myclass == 'DEATHKNIGHT' then
			SVUnit.LOLFiftyFive(self)
		elseif SVRoot.myclass == 'DRUID' then
			SVUnit.OhGodCyclone(self)
			self.EclipseBar:SetScript("OnShow",function()
				self.isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT",2,14)
				self.isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT",-2,14)
			end)
			self.EclipseBar:SetScript("OnHide",function()
				self.isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT",2,4)
				self.isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT",-2,4)
			end)
		elseif SVRoot.myclass == 'PALADIN' then
			SVUnit.IJustSharded(self,"PALADIN")
		elseif SVRoot.myclass == 'SHAMAN' then
			SVUnit.MakeEmTotems(self)
		elseif SVRoot.myclass == 'WARLOCK' then
			SVUnit.IJustSharded(self,"WARLOCK") 
		end
		SVUnit.RUExperienced(self)
		SVUnit.CombatResting(self,"TOPRIGHT")
		SVUnit.PutYoHoodUp(self)
		SVUnit.ManaFlash(self)
		SVUnit.SparkPlug(self)
		SVUnit.SetCastFader(self)
		SVUnit.CombatFeed(self,SVUnit.fsnum)
		local AltPowerBar = CreateFrame("StatusBar", nil, self.Health)
		AltPowerBar:SetFrameLevel(12)
		AltPowerBar:SetStatusBarTexture(SVMedia.colorbar)
		AltPowerBar:GetStatusBarTexture():SetHorizTile(false)
		AltPowerBar:SetStatusBarColor(1, 0, 0)
		AltPowerBar:SetPoint("TOP", self, "BOTTOM",0,2)
		AltPowerBar:SetHeight(10*SuperSet.scaleops.ufscale)
		AltPowerBar:SetWidth(SVUnit.unitW)
		SVMod.SimpleSkin(AltPowerBar)
		self.AltPowerBar = AltPowerBar
		local ufIcon = CreateFrame("Frame",nil,self)
		ufIcon:SetHeight(SVUnit.unitH-6)
		ufIcon:SetWidth(SVUnit.unitH-6)
		ufIcon:SetFrameLevel(8)
		ufIcon:SetPoint("TOPLEFT",3,-3)
		self.SuperIcon = ufIcon
		local pvp = self.SuperIcon:CreateTexture(nil, "ARTWORK")
		pvp:SetAllPoints(self.SuperIcon)
		self.MyPvP = pvp
		self:RegisterEvent("UNIT_FACTION", SVUnit.MyOwnPVP)
		self:RegisterEvent("PLAYER_ENTERING_WORLD", SVUnit.MyOwnPVP)
		self:RegisterEvent("PLAYER_FLAGS_CHANGED", SVUnit.MyOwnPVP)
		table.insert(self.__elements, SVUnit.MyOwnPVP)
		local dbh = self.data:CreateTexture(nil,"OVERLAY")
		dbh:SetAllPoints(self)
		dbh:SetTexture(SVMedia.unitaf)
		dbh:SetBlendMode("ADD")
		dbh:SetVertexColor(0,0,0,0)
		self.DebuffHighlight = dbh
		self.DebuffHighlightFilter = true
		self.DebuffHighlightAlpha = 0.5
		local lfd = self.data:CreateTexture(nil, "OVERLAY")
		lfd:SetHeight(24*SuperSet.scaleops.ufscale)
		lfd:SetWidth(24*SuperSet.scaleops.ufscale)
		lfd:SetPoint("TOPRIGHT",self,"TOPLEFT")
		self.LFDRole = lfd
	end
	
	if (unit == "target") then
		local H_value = self.data:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1.3, -1.3)
			H_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			H_value:SetJustifyH("LEFT")
			H_value:SetPoint("BOTTOMLEFT",self.data,"BOTTOMLEFT",2,1)
		self.Health.value = H_value
		local P_value = self.data:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1.3, -1.3)
			P_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			P_value:SetJustifyH("LEFT")
			P_value:SetPoint("LEFT",self.Health.value,"RIGHT",6,0)
		self.Power.value = P_value
		local afk_tag = CreateFrame("Frame",nil,self)
		afk_tag:SetFrameLevel(12)
		local afktext = afk_tag:CreateFontString (nil,"OVERLAY")
		afktext:SetFont(SVFonts.super,22,"OUTLINE")
		afktext:SetShadowOffset(3,-3)
		afktext:SetPoint("RIGHT",self,"RIGHT",6,-16)
		afktext:SetTextColor(1,1,0.2)
		afktext:SetJustifyH("RIGHT")
		afktext:SetHeight(13)
		afk_tag:RegisterEvent("PLAYER_FLAGS_CHANGED")
		afk_tag:SetScript("OnEvent",function(self,event,...)
		local arg1 = ...;
		if arg1 ~= "target" then return end
			SVUnit.AfkCheck(self,arg1)
		end)
		self.afktag = afk_tag
		self.afktag.text = afktext
		local linfo = afk_tag:CreateFontString(nil, "OVERLAY")
		linfo:SetFont(SVFonts.cooldown,SVUnit.fsname,"THINOUTLINE")
		linfo:SetShadowOffset(1,-1.5)
		linfo:SetPoint("BOTTOMLEFT",self,"BOTTOMLEFT",-4,-4)
		linfo:SetText("L")
		linfo:SetJustifyH("RIGHT")
		self.Leader = linfo
		self.info:SetPoint("BOTTOMLEFT",self,"TOPLEFT",3,-10)
		self.info:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT",-3,-10)
		self:Tag(self.info, "|cfffed100[smartlevel]|r [raidcolor][name]")
		local buffs = CreateFrame("Frame", nil, self)
		buffs:SetPoint("TOPLEFT", self,"BOTTOMLEFT",2,-10)
		buffs:SetPoint("TOPRIGHT", self,"BOTTOMRIGHT",-2,-10)
		buffs.initialAnchor = "TOPLEFT"
		buffs["growth-x"] = "RIGHT"
		buffs["growth-y"] = "DOWN"
		if SuperSet.unitops.buffs == true then
			buffs.num = 8
			buffs.spacing = 4
		else
			buffs.num = 0
			buffs.spacing = 4
		end
		buffs.size = 23
		buffs:SetHeight(buffs.size+buffs.spacing)
		self.Buffs = buffs
		self.Buffs.PostCreateIcon = SVUnit.auraIcon
		self.Buffs.PostUpdateIcon = SVUnit.auraUpdateIcon
		local debuffs = CreateFrame("Frame", nil, self)
		debuffs:SetPoint("BOTTOMLEFT", self.isf,"BOTTOMLEFT",0,4)
		debuffs:SetPoint("BOTTOMRIGHT", self.isf,"BOTTOMRIGHT",0,4)
		debuffs.initialAnchor = "BOTTOMLEFT"
		debuffs["growth-x"] = "RIGHT"
		debuffs["growth-y"] = "UP"
		debuffs.num = 8
		debuffs.spacing = 4
		debuffs.size = 23
		debuffs:SetHeight(debuffs.size+debuffs.spacing)
		if SuperSet.unitops.debuffs == true then
			debuffs.onlyShowPlayer = true
		end
		self.Debuffs = debuffs
		self.Debuffs.PostCreateIcon = SVUnit.auraIcon
		self.Debuffs.PostUpdateIcon = SVUnit.auraUpdateIcon
		self.tapped = SVUnit.CreateTapped(self)
		self.tapped:Hide()
		self:RegisterEvent("UNIT_COMBAT", SVUnit.UpdateTapped)
		table.insert(self.__elements, SVUnit.UpdateTapped)
		local ufIcon = CreateFrame("Frame",nil,self)
		ufIcon:SetHeight(SVUnit.unitH-6)
		ufIcon:SetWidth(SVUnit.unitH-6)
		ufIcon:SetFrameLevel(8)
		ufIcon:SetPoint("TOPRIGHT",-3,-3)
		self.SuperIcon = ufIcon
		local pvp = self.SuperIcon:CreateTexture(nil, "ARTWORK")
		pvp:SetAllPoints(self.SuperIcon)
		self.MyPvP = pvp
		self:RegisterEvent("UNIT_FACTION", SVUnit.TargetPVP)
		table.insert(self.__elements, SVUnit.TargetPVP)
		local AltPowerBar = CreateFrame("StatusBar", nil, self.Health)
		AltPowerBar:SetFrameLevel(12)
		AltPowerBar:SetStatusBarTexture(SVMedia.colorbar)
		AltPowerBar:GetStatusBarTexture():SetHorizTile(false)
		AltPowerBar:SetStatusBarColor(1, 0, 0)
		AltPowerBar:SetPoint("TOP", self, "BOTTOM",0,2)
		AltPowerBar:SetHeight(10*SuperSet.scaleops.ufscale)
		AltPowerBar:SetWidth(SVUnit.unitW)
		SVMod.SimpleSkin(AltPowerBar)
		self.AltPowerBar = AltPowerBar
		if (SVRoot.myclass == 'DRUID') or (SVRoot.myclass == 'ROGUE') then
			SVUnit.ComboBreaker(self,unit)
		end
		SVUnit.CombatFeed(self,SVUnit.fsnum,"RIGHT")
		if SuperSet.unitops.sniper == true then
			self.sniper = SVUnit.SniperOn(self)
			self.sniper:SetPoint("TOPRIGHT",12,12)
		end
	end
	
	if (unit == "pet") then
		local H_value = self.data:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1.3, -1.3)
			H_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("BOTTOMRIGHT",self.data,"BOTTOMRIGHT",-1,1)
		self.Health.value = H_value
		local P_value = self.data:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1.3, -1.3)
			P_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			P_value:SetJustifyH("RIGHT")
			P_value:SetPoint("RIGHT",self.Health.value,"LEFT",-6,0)
		self.Power.value = P_value
		self.Power.value:Hide()
		local aura = CreateFrame("Frame", nil, self)
		aura:SetPoint("TOPLEFT", self,"BOTTOMLEFT", 2, -2)
		aura:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT", -2, -2)
		aura.initialAnchor = "TOPLEFT"
		aura["growth-x"] = "RIGHT"
		aura["growth-y"] = "DOWN"
		aura.numBuffs = 0
		aura.numDebuffs = 4
		aura.spacing = 4
		aura.size = 34
		aura:SetHeight((aura.size+aura.spacing)*2)
		aura.cc_font_size = SVUnit.supersize
		aura.cbt = true
		self.Auras = aura
		self.Auras.PostCreateIcon = SVUnit.auraIcon
		self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
		SVUnit.CombatFeed(self,16)
		SVUnit.CheckPetModel(self)
		table.insert(self.__elements, SVUnit.UpdateThreat)
		self:RegisterEvent('PLAYER_TARGET_CHANGED', SVUnit.UpdateThreat)
		self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', SVUnit.UpdateThreat)
		self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', SVUnit.UpdateThreat)
	end
	
	if (unit == "focus") then
		local H_value = self.data:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1.3, -1.3)
			H_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("BOTTOMRIGHT",self.data,"BOTTOMRIGHT",-1,1)
		self.Health.value = H_value
		local P_value = self.data:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1.3, -1.3)
			P_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			P_value:SetJustifyH("RIGHT")
			P_value:SetPoint("RIGHT",self.Health.value,"LEFT",-6,0)
		self.Power.value = P_value
		self.Power.value:Hide()
		local aura = CreateFrame("Frame", nil, self)
		aura:SetPoint("BOTTOMLEFT", self,"TOPLEFT", 4, 4)
		aura:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", -4, 4)
		aura.initialAnchor = "BOTTOMLEFT"
		aura["growth-x"] = "RIGHT"
		aura["growth-y"] = "UP"
		aura.numBuffs = 0
		aura.numDebuffs = 4
		aura.spacing = 4
		aura.size = 34
		aura:SetHeight((aura.size+aura.spacing)*2)
		aura.cc_font_size = SVUnit.supersize
		aura.cbt = true
		self.Auras = aura
		self.Auras.PostCreateIcon = SVUnit.auraIcon
		self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
		if SuperSet.unitops.sniper == true then
			self.sniper = SVUnit.SniperOff(self)
			self.sniper:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",20,-10)
		end
	end
	
	if (unit == "focustarget") then
		local H_value = self.data:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1.3, -1.3)
			H_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("BOTTOMRIGHT",self.data,"BOTTOMRIGHT",-1,1)
		self.Health.value = H_value
		local P_value = self.data:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1.3, -1.3)
			P_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			P_value:SetJustifyH("RIGHT")
			P_value:SetPoint("RIGHT",self.Health.value,"LEFT",-6,0)
		self.Power.value = P_value
		self.Power.value:Hide()
	end
	
	if (unit == "targettarget") then
		local H_value = self.data:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1.3, -1.3)
			H_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("BOTTOMRIGHT",self.data,"BOTTOMRIGHT",-1,1)
		self.Health.value = H_value
		local P_value = self.data:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1.3, -1.3)
			P_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			P_value:SetJustifyH("RIGHT")
			P_value:SetPoint("RIGHT",self.Health.value,"LEFT",-6,0)
		self.Power.value = P_value
	end
	
	if (unit and unit:find("boss%d")) or (unit and unit:find("arena%d")) or ((self:GetParent():GetName():match"oUF_Villain_MainTank") or (self:GetParent():GetName():match"oUF_Villain_MainAssist")) then
		local H_value = self.data:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1.3, -1.3)
			H_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("BOTTOMRIGHT",self.data,"BOTTOMRIGHT",-1,1)
		self.Health.value = H_value
		local P_value = self.data:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1.3, -1.3)
			P_value:SetFont(SVFonts.numbers,SVUnit.fsnum,"THINOUTLINE")
			P_value:SetJustifyH("RIGHT")
			P_value:SetPoint("RIGHT",self.Health.value,"LEFT",-6,0)
		self.Power.value = P_value
		if((unit and unit:find("arena%d")) and (SuperSet.unitops.arenaframes == true)) then
			local aura = CreateFrame("Frame", nil, self)
			aura:SetPoint("TOPLEFT", self,"TOPRIGHT", 4, 0)
			aura:SetPoint("BOTTOMLEFT", self, "BOTTOMRIGHT", 4, 0)
			aura.initialAnchor = "TOPLEFT"
			aura["growth-x"] = "RIGHT"
			aura["growth-y"] = "DOWN"
			aura.numBuffs = 2
			aura.numDebuffs = 4
			aura.spacing = 4
			aura.size = 20
			aura:SetHeight((aura.size*2)+(aura.spacing*2))
			aura.cc_font_size = SVUnit.supersize
			aura.cbt = true
			self.Auras = aura
			self.Auras.PostCreateIcon = SVUnit.auraIcon
			self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
		elseif(unit and unit:find("boss%d")) then
			local aura = CreateFrame("Frame", nil, self)
			aura:SetPoint("BOTTOMLEFT", self,"TOPLEFT", 4, 4)
			aura:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", -4, 4)
			aura.initialAnchor = "BOTTOMLEFT"
			aura["growth-x"] = "RIGHT"
			aura["growth-y"] = "UP"
			aura.numBuffs = 2
			aura.numDebuffs = 4
			aura.spacing = 4
			aura.size = 20
			aura:SetHeight(aura.size+aura.spacing)
			aura.cc_font_size = SVUnit.supersize
			aura.cbt = true
			self.Auras = aura
			self.Auras.PostCreateIcon = SVUnit.auraIcon
			self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
		else
			local aura = CreateFrame("Frame", nil, self)
			aura:SetPoint("BOTTOMLEFT", self,"TOPLEFT", 4, 4)
			aura:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", -4, 4)
			aura.initialAnchor = "BOTTOMLEFT"
			aura["growth-x"] = "RIGHT"
			aura["growth-y"] = "UP"
			aura.numBuffs = 0
			aura.numDebuffs = 6
			aura.spacing = 4
			aura.size = 20
			aura:SetHeight(aura.size+aura.spacing)
			aura.cc_font_size = SVUnit.supersize
			aura.cbt = true
			self.Auras = aura
			self.Auras.PostCreateIcon = SVUnit.auraIcon
			self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
		end
		if(unit and unit:find("boss%d")) then
			local AltPowerBar = CreateFrame("StatusBar", nil, self.Health)
			AltPowerBar:SetFrameLevel(12)
			AltPowerBar:SetStatusBarTexture(SVMedia.colorbar)
			AltPowerBar:GetStatusBarTexture():SetHorizTile(false)
			AltPowerBar:SetStatusBarColor(1, 0, 0)
			AltPowerBar:SetPoint("TOP", self, "BOTTOM",0,2)
			AltPowerBar:SetHeight(10*SuperSet.scaleops.ufscale)
			AltPowerBar:SetWidth(SVUnit.unitW)
			SVMod.SimpleSkin(AltPowerBar)
			self.AltPowerBar = AltPowerBar
		end
		if (unit and unit:find("arena%d") and (SuperSet.unitops.arenaframes == true)) or (unit and unit:find("boss%d")) then
			-- Right-click focus on arena or boss units
			self:SetAttribute("type2", "focus")
		end
		-- trinket feature via trinket plugin
		if (SuperSet.unitops.arenaframes == true) and (unit and unit:find('arena%d')) then
			local Trinketbg = CreateFrame("Frame", nil, self)
			Trinketbg:SetHeight(26)
			Trinketbg:SetWidth(26)
			Trinketbg:SetPoint("RIGHT", self, "LEFT", -6, 0)				
			SVMod.SimpleSkin(Trinketbg)
			Trinketbg:SetFrameLevel(0)
			self.Trinketbg = Trinketbg
			
			local Trinket = CreateFrame("Frame", nil, Trinketbg)
			Trinket:SetAllPoints(Trinketbg)
			Trinket:SetPoint("TOPLEFT", Trinketbg, SVMod.Scale(2), SVMod.Scale(-2))
			Trinket:SetPoint("BOTTOMRIGHT", Trinketbg, SVMod.Scale(-2), SVMod.Scale(2))
			Trinket:SetFrameLevel(1)
			Trinket.trinketUseAnnounce = true
			self.Trinket = Trinket
		end
	end
	---------Misc Additions---------------------------------------
	SVUnit.IncomingHeals(self,unit)
	self.MoveableFrames = true
	if (unit == "target" or unit == "player") then
		SVMod.PVPAuraWatch(self,unit)
    end
end

oUF:RegisterStyle("Villain",villain_style)

-- PLAYER
local player = oUF:Spawn('player', "oUF_Villain_player")
player:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOM", -3, SVMedia.oufspawn)
player:SetSize(SVUnit.unitW, SVUnit.unitH)
if SuperSet.aurabars.enabled == true then
	PlayerBarAnchor:ClearAllPoints()
	PlayerBarAnchor:SetPoint ("BOTTOMLEFT",player.Auras,"TOPLEFT",0,10)
	PlayerBarAnchor:SetPoint ("BOTTOMRIGHT",player.Auras,"TOPRIGHT",0,10)
end
-- TARGET
local target = oUF:Spawn('target', "oUF_Villain_target")
target:SetPoint("BOTTOMLEFT", UIParent, "BOTTOM", 3, SVMedia.oufspawn)
target:SetSize(SVUnit.unitW, SVUnit.unitH)
target:HookScript("OnShow",show_fade)
if SuperSet.aurabars.enabled == true then
	TargetBarAnchor:ClearAllPoints()
	TargetBarAnchor:SetPoint ("BOTTOMLEFT",target.Debuffs,"TOPLEFT",0,8)
	TargetBarAnchor:SetPoint ("BOTTOMRIGHT",target.Debuffs,"TOPRIGHT",0,8)
end
if SuperSet.unitops.threatbar == true then
	t1 = player.ThreatBar
	if SVLock.threat_ok then
		player.ThreatBar:SetParent(target.SuperThreatBar)
		player.ThreatBar:SetAllPoints(target.SuperThreatBar)
	end
end
t2 = target.afktag
-- TARGET of TARGET
local tot = oUF:Spawn('targettarget', "oUF_Villain_targettarget")
tot:SetPoint("BOTTOMLEFT",target, "BOTTOMRIGHT", 4, 0)
tot:SetSize(SVUnit.smallW, SVUnit.unitH)
tot:HookScript("OnShow",show_fade)
-- PET
local pet = oUF:Spawn('pet', "oUF_Villain_pet")
pet:SetPoint("BOTTOMRIGHT",player, "BOTTOMLEFT", -4, 0)
pet:SetSize(SVUnit.smallW, SVUnit.unitH)
pet:HookScript("OnShow",show_fade)
-- FOCUS
local focus = oUF:Spawn('focus', "oUF_Villain_focus")
focus:SetPoint("BOTTOMRIGHT",player, "TOPLEFT", -4, 16)
focus:SetSize(SVUnit.smallW, SVUnit.unitH)
focus:HookScript("OnShow",show_fade)
if SuperSet.unitops.focustarget == true then
	-- FOCUS TARGET
	local focustarget = oUF:Spawn('focustarget', "oUF_Villain_focustarget")
	focustarget:SetPoint("RIGHT",focus,"LEFT", -4, 0)
	focustarget:SetSize(SVUnit.smallW, SVUnit.smallH)
end
	
local t = CreateFrame("Frame")
local change = function()
		SVUnit.AfkCheck(t2,"target")
	if SuperSet.unitops.threatbar == true then
		if not UnitIsPlayer("target") and SVLock.threat_ok then
			t1:SetAlpha(1)
		elseif SVLock.threat_ok then
			t1:SetAlpha(0)
		end
	end
end
t:SetScript("OnEvent",change)
t:RegisterEvent("PLAYER_TARGET_CHANGED")

if (SuperSet.unitops.arenaframes == true) then
	local arena = {}
	for i = 1, 5 do
		arena[i] = oUF:Spawn("arena"..i, "oUF_Villain_Arena"..i)
		if i == 1 then
			arena[i]:SetPoint("BOTTOM", UIParent, "BOTTOM", 252, 260)
		else
			arena[i]:SetPoint("BOTTOM", arena[i-1], "TOP", 0, 16)
		end
		arena[i]:SetSize(SVUnit.otherW, SVUnit.otherH)
	end
end

for i = 1,MAX_BOSS_FRAMES do
   local t_boss = _G["Boss"..i.."TargetFrame"]
   t_boss:UnregisterAllEvents()
   t_boss.Show = dummy
   t_boss:Hide()
   _G["Boss"..i.."TargetFrame".."HealthBar"]:UnregisterAllEvents()
   _G["Boss"..i.."TargetFrame".."ManaBar"]:UnregisterAllEvents()
end
local boss = {}
for i = 1, MAX_BOSS_FRAMES do
   boss[i] = oUF:Spawn("boss"..i, "oUF_Villain_Boss"..i)
   if i == 1 then
	  boss[i]:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -100, 250)
   else
	  boss[i]:SetPoint('BOTTOM', boss[i-1], 'TOP', 0, 50)             
   end
   boss[i]:SetSize(SVUnit.otherW, SVUnit.otherH)
end

if SuperSet.unitops.maintank == true then
	local tank = oUF:SpawnHeader('oUF_Villain_MainTank', nil, 'raid',
		'oUF-initialConfigFunction', ([[
			self:SetWidth(%d)
			self:SetHeight(%d)
		]]):format(assisttank_width, assisttank_height),
		'showRaid', true,
		'groupFilter', 'MAINTANK',
		'yOffset', 7,
		'point' , 'BOTTOM',
		'template', 'oUF_VillainMtt'
	)
	tank:SetPoint("CENTER", UIParent, "CENTER", -200, 0)
end
if SuperSet.unitops.mainassist == true then
	local assist = oUF:SpawnHeader("oUF_Villain_MainAssist", nil, 'raid',
		'oUF-initialConfigFunction', ([[
			self:SetWidth(%d)
			self:SetHeight(%d)
		]]):format(assisttank_width, assisttank_height),
		'showRaid', true,
		'groupFilter', 'MAINASSIST',
		'yOffset', 7,
		'point' , 'BOTTOM',
		'template', 'oUF_VillainMtt'
	)
	if SuperSet.unitops.maintank == true then
		assist:SetPoint("TOPLEFT", oUF_Villain_MainTank, "BOTTOMLEFT", 2, -50)
	else
		assist:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	end
end

do
	UnitPopupMenus["SELF"] = { "PVP_FLAG", "LOOT_METHOD", "LOOT_THRESHOLD", "OPT_OUT_LOOT_TITLE", "LOOT_PROMOTE", "DUNGEON_DIFFICULTY", "RAID_DIFFICULTY", "RESET_INSTANCES", "RAID_TARGET_ICON", "SELECT_ROLE", "LEAVE", "CANCEL" };
	UnitPopupMenus["PET"] = { "PET_PAPERDOLL", "PET_RENAME", "PET_ABANDON", "PET_DISMISS", "CANCEL" };
	UnitPopupMenus["PARTY"] = { "MUTE", "UNMUTE", "PARTY_SILENCE", "PARTY_UNSILENCE", "RAID_SILENCE", "RAID_UNSILENCE", "BATTLEGROUND_SILENCE", "BATTLEGROUND_UNSILENCE", "WHISPER", "PROMOTE", "PROMOTE_GUIDE", "LOOT_PROMOTE", "VOTE_TO_KICK", "UNINVITE", "INSPECT", "ACHIEVEMENTS", "TRADE", "FOLLOW", "DUEL", "RAID_TARGET_ICON", "SELECT_ROLE", "PVP_REPORT_AFK", "RAF_SUMMON", "RAF_GRANT_LEVEL", "CANCEL" }
	UnitPopupMenus["PLAYER"] = { "WHISPER", "INSPECT", "INVITE", "ACHIEVEMENTS", "TRADE", "FOLLOW", "DUEL", "RAID_TARGET_ICON", "RAF_SUMMON", "RAF_GRANT_LEVEL", "CANCEL" }
	UnitPopupMenus["RAID_PLAYER"] = { "MUTE", "UNMUTE", "RAID_SILENCE", "RAID_UNSILENCE", "BATTLEGROUND_SILENCE", "BATTLEGROUND_UNSILENCE", "WHISPER", "INSPECT", "ACHIEVEMENTS", "TRADE", "FOLLOW", "DUEL", "RAID_TARGET_ICON", "SELECT_ROLE", "RAID_LEADER", "RAID_PROMOTE", "RAID_DEMOTE", "LOOT_PROMOTE", "RAID_REMOVE", "PVP_REPORT_AFK", "RAF_SUMMON", "RAF_GRANT_LEVEL", "CANCEL" };
	UnitPopupMenus["RAID"] = { "MUTE", "UNMUTE", "RAID_SILENCE", "RAID_UNSILENCE", "BATTLEGROUND_SILENCE", "BATTLEGROUND_UNSILENCE", "RAID_LEADER", "RAID_PROMOTE", "RAID_MAINTANK", "RAID_MAINASSIST", "RAID_TARGET_ICON", "LOOT_PROMOTE", "RAID_DEMOTE", "RAID_REMOVE", "PVP_REPORT_AFK", "CANCEL" };
	UnitPopupMenus["VEHICLE"] = { "RAID_TARGET_ICON", "VEHICLE_LEAVE", "CANCEL" }
	UnitPopupMenus["TARGET"] = { "RAID_TARGET_ICON", "CANCEL" }
	UnitPopupMenus["ARENAENEMY"] = { "CANCEL" }
	UnitPopupMenus["FOCUS"] = { "RAID_TARGET_ICON", "CANCEL" }
	UnitPopupMenus["BOSS"] = { "RAID_TARGET_ICON", "CANCEL" }
end
