SVUnit.supersize = 12
SVUnit.fsname = SuperSet.font_sizes.unitname
SVUnit.fsnum = SuperSet.font_sizes.unitnumber
if (SuperSet.uf_layout == 1) then
	SVUnit.unitW = 220*SuperSet.scaleops.ufscale
	SVUnit.unitH = 55*SuperSet.scaleops.ufscale
	SVUnit.smallW = 80*SuperSet.scaleops.ufscale
	SVUnit.smallH = 46*SuperSet.scaleops.ufscale
	SVUnit.otherW = 150*SuperSet.scaleops.ufscale
	SVUnit.otherH = 55*SuperSet.scaleops.ufscale
elseif (SuperSet.uf_layout == 2) then
	SVUnit.unitW = 250*SuperSet.scaleops.ufscale
	SVUnit.unitH = 50*SuperSet.scaleops.ufscale
	SVUnit.smallW = 90*SuperSet.scaleops.ufscale
	SVUnit.smallH = 42*SuperSet.scaleops.ufscale
	SVUnit.otherW = 175*SuperSet.scaleops.ufscale
	SVUnit.otherH = 50*SuperSet.scaleops.ufscale
else
	SVUnit.unitW = 210*SuperSet.scaleops.ufscale
	SVUnit.unitH = 35*SuperSet.scaleops.ufscale
	SVUnit.smallW = 90*SuperSet.scaleops.ufscale
	SVUnit.smallH = 28*SuperSet.scaleops.ufscale
	SVUnit.otherW = 150*SuperSet.scaleops.ufscale
	SVUnit.otherH = 38*SuperSet.scaleops.ufscale
end

----------------------------------------------------------------------------------------------------
-------------[[//||\\-----------------STANDARD TEXT FUNCTIONS-----------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local set_text = function(self,size,fy,uf,ol)
	local uf = uf or SVFonts.font
	local ol = ol or nil
	self:SetFont(uf,size,ol)
	self:SetShadowOffset(1,-1)
	self:SetJustifyH(fy or "LEFT")
	self:SetHeight(size)
	self:SetJustifyV("MIDDLE")
end
SVUnit.SetText = set_text
------------------------------------------
local SuperText = function(parent, fontName, fontHeight, fontStyle, fontJust)  --for fontJust use numbers blank(nil)=left, 2=center, 3=right..-----
	local fs = parent:CreateFontString(nil, "OVERLAY")
	fs:SetFont(fontName, fontHeight, fontStyle)
	if fontJust == 2 then
		fs:SetJustifyH("CENTER")
	elseif fontJust == 3 then
		fs:SetJustifyH("RIGHT")
	else
		fs:SetJustifyH("LEFT")
	end
	fs:SetShadowColor(0, 0, 0)
	fs:SetShadowOffset(1.25, -1.25)
	return fs
end
SVUnit.SuperText = SuperText
------------------------------------------
local short_value = function(value)
	if value >= 1e6 then
		return ("%.1fm"):format(value / 1e6):gsub("%.?0+([km])$", "%1")
	elseif value >= 1e3 or value <= -1e3 then
		return ("%.1fk"):format(value / 1e3):gsub("%.?0+([km])$", "%1")
	else
		return value
	end
end
SVUnit.ShortValue = short_value

local short_value_negative = function(v)
	if v <= 999 then return v end
	if v >= 1000000 then
		local value = string.format("%.1fm", v/1000000)
		return value
	elseif v >= 1000 then
		local value = string.format("%.1fk", v/1000)
		return value
	end
end
SVUnit.ShortValueNegative = short_value_negative
----------------------------------------------------------------------------------------------------
-------------[[//||\\-----------------COMMON UNIT FUNCTIONS-------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
SVUnit.ufscale = function()
	if GetCVar("UseUIScale") == "1" then
		return (768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)"))/GetCVar("UIScale")
	else
		return 1
	end
end

SVUnit.mkButton = function (myframe,offset,nobg,blend,invis)
	SVMod.style(myframe,nobg,offset,blend,invis)
end

SVUnit.frame = function(parent,strata,level,invis)
	return SVMod.frame(parent,level,strata,nil,nil,nil,nil,nil,invis)
end

SVUnit.TexFlip = function(tex)
	tex:SetTexCoord(1,0,1,1,0,0,0,1)
	return tex
end

local pp = {128,166,204,166,204,128,166}
SVMedia.oufspawn = pp[SuperBar.barset]

SVUnit.PortraitUnavailable = function(parent)
	local problem = CreateFrame("Frame", nil, parent)
	problem:SetAllPoints(parent)
	problem:SetFrameLevel(parent:GetFrameLevel()+2)
	local problem_tex = problem:CreateTexture(nil,"OVERLAY")
	problem_tex:SetAllPoints(problem)
	SVMod.MapDraw(problem_tex,"PROBLEM",1)
	problem_tex:SetVertexColor(1,1,1,0.5)
	parent.DEAD = problem
end