SVColors.oUF_colors = SVColors.oUF_colors

local FormatTime = function(time)
    local hr, m, text
    if time <= 0 then text = ""
    elseif(time < 3600 and time > 60) then
		hr = floor(time / 3600)
		m = floor(mod(time, 3600) / 60 + 1)
		text = format("|cffffffff%dm|r", m)
    elseif time > 10 and time < 60 then
		m = floor(time / 60)
		text = (m == 0 and format("|cffffff11%d|r",time))
	elseif time < 10 then
		m = floor(time / 60)
		text = (m == 0 and format("|cffffaa11%.1f|r",time))
    else
		hr = floor(time / 3600 + 1)
		text = format("|cffffffff%dh|r", hr)
    end
    return text
end

local CreateAuraTimer = function(self, elapsed)
	if self.timeLeft then
		self.elapsed = (self.elapsed or 0) + elapsed
		if self.elapsed >= 0.1 then
			if not self.first then
				self.timeLeft = self.timeLeft - self.elapsed
			else
				self.timeLeft = self.timeLeft - GetTime()
				self.first = false
			end
			if self.timeLeft > 0 then
				local time = FormatTime(self.timeLeft)
				self.remaining:SetText(time)
			else
				self.remaining:Hide()
				self:SetScript("OnUpdate", nil)
			end
			self.elapsed = 0
		end
	end
end

local setcdfont = function(parent,size)
	local font_used
		if size >= 9 then
			font_used = SVFonts.numbers
		else
			font_used = SVFonts.pixel
		end
	local a = parent:CreateFontString(nil,"OVERLAY")
	a:SetFont(font_used,size,"THINOUTLINE")
	a:SetShadowOffset(1,-1.4)
	return a
end

SVUnit.auraIcon = function(icons, button)
	icons.showDebuffType = true
	icons.disableCooldown = true
	
	button.icon:SetTexCoord(.1, .9, .1, .9)
	button.icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
	button.icon:SetPoint("TOPLEFT", button,1,-1)
	button.icon:SetPoint("BOTTOMRIGHT", button,-1,1)
	
	button.cd.noOCC = true
	button.cd.noCooldownCount = true
	
	button.glow = CreateFrame ("Frame",nil,button)
	button.glow:SetPoint("TOPLEFT",-3,3)
	button.glow:SetFrameLevel(0)
	button.glow:SetPoint("BOTTOMRIGHT",3,-3)
	button.glow:SetBackdrop ( {
		bgfile = SVMedia.blank,
	  edgeFile = SVMedia.glow, 
	  edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	SVUnit.mkButton (button.glow,nil,true)
	
	button.cd:SetAlpha(0)

	button.count:ClearAllPoints()
	button.count:SetPoint("TOPRIGHT", button, "TOPRIGHT",1,1)
	button.count:SetJustifyH("LEFT")
	button.count:SetFont(SVFonts.numbers, 9, "OUTLINE")
	button.count:SetShadowOffset(2,-2)
	button.count:SetShadowColor(0,0,0)
	button.count:SetTextColor(1,1,0.2)
	
	local a = floor(button:GetWidth())
	if a > 20 then
		button.remaining = setcdfont(button,9)
	else
		button.remaining = setcdfont(button,8)
	end
	button.remaining:SetPoint("BOTTOMLEFT", button, "BOTTOMLEFT",-2,-3)
	button.remaining:SetJustifyH("LEFT")
	button.overlay:SetTexture(nil)
end

local r,g,b,sh = unpack(SVMedia.bordershadow)
SVUnit.auraUpdateIcon = function(icons, unit, icon, index)
	local _, _, _, _, _, duration, expirationTime = UnitAura(unit, index, icon.filter)
	if duration and duration > 0 then
		icon.remaining:Show()
		icon.timeLeft = expirationTime
		icon:SetScript("OnUpdate", CreateAuraTimer)
	else
		icon.remaining:Hide()
		icon.timeLeft = math.huge		
		icon:SetScript("OnUpdate", nil)
	end
	icon.first = true
	if (icon.debuff) then
		local r,g,b = icon.overlay:GetVertexColor()
		icon.glow:SetBackdropBorderColor(r,g,b,.6)
		icon.glow.top:SetTexture(r,g,b)
		icon.glow.bottom:SetTexture(r,g,b)
		icon.glow.left:SetTexture(r,g,b)
		icon.glow.right:SetTexture(r,g,b)
	else 
		icon.glow:SetBackdropBorderColor(r,g,b,sh)
		icon.glow.right:SetTexture(0,0,0)
		icon.glow.top:SetTexture(0,0,0)
		icon.glow.left:SetTexture(0,0,0)
		icon.glow.bottom:SetTexture(0,0,0)
	end
end