-----------------------------------------------------------------------------------------------------------------------------
-- TARGET FOCUSING
-----------------------------------------------------------------------------------------------------------------------------
local BSZE = SVUnit.unitH
local SniperOn = function (self)
	local sniper = CreateFrame("BUTTON", "SniperScope", self, "SecureActionButtonTemplate")
	sniper:EnableMouse(true)
	sniper:RegisterForClicks("AnyUp")
	sniper:SetAttribute("type", "macro")
	sniper:SetAttribute("macrotext", "/focus")
	sniper:SetHeight(BSZE*SuperSet.scaleops.ufscale)
	sniper:SetWidth(BSZE*SuperSet.scaleops.ufscale)
	sniper:SetFrameStrata("DIALOG")
	
	sniper.headshot = sniper:CreateTexture(nil, "ARTWORK")
	SVMod.MapDraw(sniper.headshot,"ACTIONS",17)
	sniper.headshot:SetAllPoints(sniper)
	sniper.headshot:SetAlpha(0)

	sniper:SetScript("OnLeave", function() GameTooltip:Hide(); sniper.headshot:SetAlpha(0) end)
	sniper:SetScript("OnEnter", function(self)
		sniper.headshot:SetAlpha(1)
		local sx, sy, x, y = GetScreenHeight(), GetScreenWidth(), self:GetCenter()
		local x1, y1, y2 = "RIGHT", "TOP", "BOTTOM"
		if x < (sx/2) then x1 = "LEFT" end
		if y < (sy/2) then y1, y2 = y2, y1 end
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint(y1..x1, self, y2..x1)
		GameTooltip:SetText(FOCUSTARGET.."\n")
	end)
	return sniper
end
SVUnit.SniperOn = SniperOn

local SniperOff = function (self)
	local sniper2 = CreateFrame("BUTTON", "SniperCancel", self, "SecureActionButtonTemplate")
	sniper2:EnableMouse(true)
	sniper2:RegisterForClicks("AnyUp")
	sniper2:SetAttribute("type", "macro")
	sniper2:SetAttribute("macrotext", "/clearfocus")
	sniper2:SetWidth(BSZE*SuperSet.scaleops.ufscale)
	sniper2:SetHeight(BSZE*SuperSet.scaleops.ufscale)
	sniper2:SetFrameStrata("DIALOG")
	sniper2.headshot2 = sniper2:CreateTexture(nil, "ARTWORK")
	SVMod.MapDraw(sniper2.headshot2,"ACTIONS",7)
	sniper2.headshot2:SetAllPoints(sniper2)
	sniper2.headshot2:SetVertexColor(1,0.2,0.1)

	sniper2:SetScript("OnLeave", function() GameTooltip:Hide() sniper2.headshot2:SetVertexColor(1,0.2,0.1)end)
	sniper2:SetScript("OnEnter", function(self)
		sniper2.headshot2:SetVertexColor(1,1,0.2)
		local sx, sy, x, y = GetScreenHeight(), GetScreenWidth(), self:GetCenter()
		local x1, y1, y2 = "RIGHT", "TOP", "BOTTOM"
		if x < (sx/2) then x1 = "LEFT" end
		if y < (sy/2) then y1, y2 = y2, y1 end
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint(y1..x1, self, y2..x1)
		GameTooltip:SetText(CLEAR_FOCUS.."\n")
	end)
	return sniper2
end
SVUnit.SniperOff = SniperOff

-----------------------------------------------------------------------------------------------------------------------------
-- TAPPED TEXTURE
-----------------------------------------------------------------------------------------------------------------------------
--TAPPED
local create_tapped = function(self)
	local tap = CreateFrame("Frame",nil,self.Health)
	tap:SetAllPoints(self.Health)
	tap:SetFrameLevel(16)
	local taptex = tap:CreateTexture(nil,"ARTWORK")
	taptex:SetAllPoints(self)
	taptex:SetTexture(SVMedia.tapped)
	taptex:SetAlpha(0.6)
	return tap
end
SVUnit.CreateTapped = create_tapped

local update_tapped = function(self,event,unit)
	if unit ~= self.unit then return end
	if UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) then
		self.tapped:Show()
	else
		self.tapped:Hide()
	end
end
SVUnit.UpdateTapped = update_tapped