----------------------------------------------------------------------------------------------------
-------------[[//||\\-----------------STANDARD HEALTH UPDATE------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local PostUpdateHealth = function(health, unit, min, max)
	if not UnitIsConnected(unit) or UnitIsDead(unit) or UnitIsGhost(unit) then
		if not UnitIsConnected(unit) then
			health.value:SetText("|cffD7BEA5"..SVLocal.unitframes_ouf_offline.."|r")
		elseif UnitIsDead(unit) then
			health.value:SetText("|cffD7BEA5"..SVLocal.unitframes_ouf_dead.."|r")
		elseif UnitIsGhost(unit) then
			health.value:SetText("|cffD7BEA5"..SVLocal.unitframes_ouf_ghost.."|r")
		end
	else
		local r1,g1,b1 = 1,0.2,0.1
		local r2,g2,b2 = 1,1,0.2
		local r3,g3,b3 = 0.1,1,0.2
		local r, g, b = oUF.ColorGradient(min/max, r1, g1, b1, r2, g2, b2, r3, g3, b3)
		if min ~= max then
			if unit == "player" and health:GetAttribute("normalUnit") ~= "pet" then
				health.value:SetFormattedText("|cffAF5050%d|r |cffD7BEA5-|r |cff%02x%02x%02x%d%%|r", min, r * 255, g * 255, b * 255, floor(min / max * 100))
			elseif (unit == "target") or (unit and unit:find("boss%d")) or (unit and unit:find("arena%d")) then
				health.value:SetFormattedText("|cffAF5050%s|r |cffD7BEA5 - |r |cff%02x%02x%02x%d%%|r", SVUnit.ShortValue(min), r * 255, g * 255, b * 255, floor(min / max * 100))
			elseif (unit == "focus") or (unit == "focustarget") then
				health.value:SetText("|cff75FF75-"..SVUnit.ShortValueNegative(max-min).."|r")
			else
				health.value:SetFormattedText("|cff%02x%02x%02x%d%%|r", r * 255, g * 255, b * 255, floor(min / max * 100))
			end
		else
			if unit == "player" and health:GetAttribute("normalUnit") ~= "pet" then
				health.value:SetFormattedText("|cff359635%s|r",SVUnit.ShortValue(max))
			elseif (unit == "target") or (unit and unit:find("boss%d")) or (unit and unit:find("arena%d")) then
				health.value:SetFormattedText("|cffAF5050%s|r |cffD7BEA5 - |r |cff%02x%02x%02x%d%%|r", SVUnit.ShortValue(max), r * 255, g * 255, b * 255, floor(min / max * 100))
			else
				health.value:SetText(" ")
			end
		end
	end
end
SVUnit.PostHealth = PostUpdateHealth

----------------------------------------------------------------------------------------------------
-------------[[//||\\------------------RAID HEALTH FUNCTIONS------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local PostUpdateHealthRaid = function(self, unit, min, max)
	if not UnitIsConnected(unit) or UnitIsDead(unit) or UnitIsGhost(unit) then
		if not UnitIsConnected(unit) then
			self.value:SetText("|cffD7BEA5"..SVLocal.unitframes_ouf_offline.."|r")
		elseif UnitIsDead(unit) then
			self.value:SetText("|cffD7BEA5"..SVLocal.unitframes_ouf_dead.."|r")
		elseif UnitIsGhost(unit) then
			self.value:SetText("|cffD7BEA5"..SVLocal.unitframes_ouf_ghost.."|r")
		end
	else
		self:SetValue(min)
		self.value:SetText("")
		if not UnitIsPlayer(unit) and UnitIsFriend(unit, "player") then
			self:SetStatusBarColor(0.1,1,0.2)
			self.bg:SetTexture(.1, .1, .1)
		end
	end
end
SVUnit.PostHealthRaid = PostUpdateHealthRaid

----------------------------------------------------------------------------------------------------
-------------[[//||\\------------CUSTOM FLIPPED HEALTH FUNCTIONS--------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local update_O_Health = function(self, unit, min, max)  
	if (UnitIsDead(unit)) or (UnitIsGhost(unit)) or not(UnitIsConnected(unit)) then
		self:SetStatusBarColor(0,0,0,0)
		self.second:SetStatusBarColor(0.2, 0.2, 0.2, 0.68)
		self.second:SetMinMaxValues(0,max)
		self.second:SetValue(max)
		self.second:SetAlpha(1)
		if self.second.anim:IsPlaying() then
			self.second.anim:Stop()
			self:SetFrameLevel(6)
			self.second:SetFrameLevel(3)
		end
	else
		self:SetMinMaxValues(0,max)
		self:SetValue(max-min)
		self.second:SetMinMaxValues(0,max)
		self.second:SetValue(max-min)
		if min == max then
			self:SetStatusBarColor(0.9, 0.1, 0, 0.5)
			self.second:SetStatusBarColor(0.9, 0.4, 0, 0.7)
			self.second:SetAlpha(1)
				if anim then
					self.second.anim:Stop()
					self:SetFrameLevel(6)
					self.second:SetFrameLevel(5) 
				end
		else
			if (min/max) <= .35 then
				if not self.second.anim:IsPlaying() then
					self.second.anim:Play()
					self:SetFrameLevel(6)
					self.second:SetFrameLevel(5)	
				end
					self.second:SetStatusBarColor(1, 0, 0, 0.5)
					self:SetStatusBarColor(1, 0.2, 0, 0.5)
			elseif (min/max) <= .75 then
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()
					self:SetFrameLevel(6)
					self.second:SetFrameLevel(5)	
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(1, 0.5, 0, 0.5)
					self.second:SetStatusBarColor(1, 0.7, 0, 0.5)
			else 
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()
					self:SetFrameLevel(6)
					self.second:SetFrameLevel(5)	
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(1, 1, 0, 0.5)
					self.second:SetStatusBarColor(0.8, 1, 0, 0.5)
			end
		end	
	end
end
----------------------------------------------------------------------------------------------------
-------------[[//||\\------------CUSTOM PLAYER HEALTH FUNCTIONS---------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
-- Player Health Update
local update_P_Health = function(self, unit, min, max)
	local reversed = max-min
	local coorD
	if unit == "player" then
		coorD = (math.abs(reversed / max))
	else
		coorD = 1
	end
	if (UnitIsDead(unit)) or (UnitIsGhost(unit)) or not(UnitIsConnected(unit)) then
		self:SetStatusBarColor(0.2, 0.2, 0.2, 0)
		self:SetMinMaxValues(0,max)
		self:SetValue(max)
		self:SetAlpha(1)
		self.second:SetWidth((reversed / max) * self:GetWidth())
	    self.second:SetTexCoord(0,coorD,0,1)
	    self.second:SetVertexColor(0.2,0.2,0.2,0.68)
		self.third:SetVertexColor(0.2,0.2,0.2,0.2)
		if self.second.anim:IsPlaying() then
			self.second.anim:Stop()
		end
	else
		self:SetMinMaxValues(0,max)
		self:SetValue(max-min)
		self.second:SetWidth((reversed / max) * self:GetWidth())
	    self.second:SetTexCoord(0,coorD,0,1)
	    self.second:SetVertexColor(0,0,0,0)
		self.third:SetVertexColor(0,0,0,0)
		if min == max then
			self:SetStatusBarColor(0,0,0,0)
			self.second:SetAlpha(1)
			self.second:SetWidth((reversed / max) * self:GetWidth())
			self.second:SetTexCoord(0,coorD,0,1)
			self.second:SetVertexColor(0,0,0,0)
			self.third:SetVertexColor(0,0,0,0)
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()
				end
		else
			if (min/max) <= .25 then
				if not self.second.anim:IsPlaying() then
					self.second.anim:Play()
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(0,0,0,0)
					self.second:SetWidth((reversed / max) * self:GetWidth())
					self.second:SetTexCoord(0,coorD,0,1)
					self.second:SetVertexColor(1,0.1,0.1,1)
					self.third:SetVertexColor(0.3,0,0,0.9)
			elseif (min/max) <= .55 then
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()	
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(0,0,0,0)
					self.second:SetWidth((reversed / max) * self:GetWidth())
					self.second:SetTexCoord(0,coorD,0,1)
					self.second:SetVertexColor(1,0.5,0.1,1)
					self.third:SetVertexColor(0.3,0.3,0.1,0.8)
			else 
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(0,0,0,0)
					self.second:SetWidth((reversed / max) * self:GetWidth())
					self.second:SetTexCoord(0,coorD,0,1)
					self.second:SetVertexColor(1,1,0,1)
					self.third:SetVertexColor(0.2,0.2,0.2,0.6)
			end
		end
	end
end
----------------------------------------------------------------------------------------------------
-------------[[//||\\------------CUSTOM TARGET HEALTH FUNCTIONS---------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
-- Target Health Update
local update_T_Health = function(self, unit, min, max)
	local current,maxhp = min,max
	local reversed = maxhp-current
	local perc = floor(current/maxhp*100)
	if (UnitIsDead(unit)) or (UnitIsGhost(unit)) or not(UnitIsConnected(unit)) then
		self:SetStatusBarColor(0.2, 0.2, 0.2, 0)
		self:SetMinMaxValues(0,maxhp)
		self:SetValue(maxhp)
		self:SetAlpha(1)
		self.second:SetWidth((reversed / maxhp) * self:GetWidth())
		self.second:SetTexCoord(1,1,0,1)
		self.second:SetVertexColor(0.2,0.2,0.2,0.68)
		self.third:SetVertexColor(0.2,0.2,0.2,0.2)
		if self.second.anim:IsPlaying() then
			self.second.anim:Stop()
		end
	else
		self:SetMinMaxValues(0,maxhp)
		self:SetValue(maxhp-current)
		self.second:SetWidth((reversed / maxhp) * self:GetWidth())
		self.second:SetTexCoord(math.abs(reversed / maxhp - 1),1,0,1)
		self.second:SetVertexColor(0,0,0,0)
		self.third:SetVertexColor(0,0,0,0)
		if min == maxhp then
			self:SetStatusBarColor(0,0,0,0)
			self.second:SetAlpha(1)
			self.second:SetWidth((reversed / maxhp) * self:GetWidth())
			self.second:SetTexCoord(math.abs(reversed / maxhp - 1),1,0,1)
			self.second:SetVertexColor(0,0,0,0)
			self.third:SetVertexColor(0,0,0,0)
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()
				end
		else
			if (current/maxhp) <= .25 then
				if not self.second.anim:IsPlaying() then
					self.second.anim:Play()
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(0,0,0,0)
					self.second:SetWidth((reversed / maxhp) * self:GetWidth())
					self.second:SetTexCoord(math.abs(reversed / maxhp - 1),1,0,1)
					self.second:SetVertexColor(1,0.1,0.1,1)
					self.third:SetVertexColor(0.3,0,0,0.9)
			elseif (current/maxhp) <= .55 then
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()	
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(0,0,0,0)
					self.second:SetWidth((reversed / maxhp) * self:GetWidth())
					self.second:SetTexCoord(math.abs(reversed / maxhp - 1),1,0,1)
					self.second:SetVertexColor(1,0.5,0.1,1)
					self.third:SetVertexColor(0.3,0.3,0.1,0.8)
			else 
				if self.second.anim:IsPlaying() then
					self.second.anim:Stop()
				end
					self.second:SetAlpha(1)
					self:SetStatusBarColor(0,0,0,0)
					self.second:SetWidth((reversed / maxhp) * self:GetWidth())
					self.second:SetTexCoord(math.abs(reversed / maxhp - 1),1,0,1)
					self.second:SetVertexColor(1,1,0,1)
					self.third:SetVertexColor(0.2,0.2,0.2,0.6)
			end
		end
	end
end
----------------------------------------------------------------------------------------------------
-------------[[//||\\------------CUSTOM PLAYER HEALTH POSTUPDATE--------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local pl_h_upd = function(self, unit, min, max)
	update_P_Health(self, unit, min, max)
	SVUnit.PostHealth(self, unit, min, max)
end
SVUnit.SuperPlayerHealth = pl_h_upd
----------------------------------------------------------------------------------------------------
-------------[[//||\\------------CUSTOM TARGET HEALTH POSTUPDATE--------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local tar_h_upd = function(self, unit, min, max)
	update_T_Health(self, unit, min, max)
	SVUnit.PostHealth(self, unit, min, max)
end
SVUnit.SuperTargetHealth = tar_h_upd
----------------------------------------------------------------------------------------------------
-------------[[//||\\-----------ALL OTHER UNITS HEALTH POSTUPDATE-------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local oth_h_upd = function(self, unit, min, max)
	update_O_Health(self, unit, min, max)
	SVUnit.PostHealth(self, unit, min, max)
end
SVUnit.SuperHealth = oth_h_upd