------------------------------------------------------------------------
--	AltPowerBar Creator Function
------------------------------------------------------------------------
function SVUnit.AltPowBar(self)
	-- alt power self
	local AltPowerBar = CreateFrame("StatusBar", nil, self.Health)
	AltPowerBar:SetFrameLevel(12)
	AltPowerBar:SetStatusBarTexture(SVMedia.colorbar)
	AltPowerBar:GetStatusBarTexture():SetHorizTile(false)
	AltPowerBar:SetStatusBarColor(1,0.2,0.1)

	AltPowerBar:SetPoint("TOP", self, "BOTTOM",0,0)
	AltPowerBar:SetHeight(8*SuperSet.scaleops.ufscale)
	AltPowerBar:SetWidth(SVUnit.unitW)
	
	AltPowerBar:SetBackdrop({
	bgFile = SVMedia.blank,
	edgeFile = SVMedia.blank,
	tile = false, tileSize = 0, edgeSize = 1,
	insets = { left = 0, right = 0, top = 0, bottom = SVMod.Scale(-1)}
	})
	AltPowerBar:SetBackdropColor(0, 0, 0)
	self.AltPowerBar = AltPowerBar
end

------------------------------------------------------------------------
--	Unitframe Text-Feed Functions
------------------------------------------------------------------------
-- oUF_CombatFeedback
local mk_feedback = function(self,size,side)
	local feed
	if (self.data) then
		feed = self.data:CreateFontString(nil, "OVERLAY")
	else
		feed = self.Health:CreateFontString(nil, "OVERLAY")
	end
	local side = side or "LEFT"
	feed:SetFont(SVFonts.font, size, "OUTLINE")
	feed:SetShadowOffset(2,-2)
	if self.data then
		feed:SetPoint(side, self.data, side)	
	else
		feed:SetPoint("TOP", self, "TOP",0, -8)
	end
	self.CombatFeedbackText = feed
end
SVUnit.CombatFeed = mk_feedback

------------------------------------------------------------------------
--	HealComm Constructor
------------------------------------------------------------------------
local mk_heal_comm = function(self,unit)
	if not(IsAddOnLoaded("oUF_HealComm4")) then return end
		local text = self.data:CreateFontString(nil, 'OVERLAY')
		text:SetFont(SVFonts.font_s,19,"OUTLINE")
		text:SetTextColor(0.1,1,0.2)
		if not(unit=="player") then 
			text:SetPoint('TOP', self.Health,"BOTTOM", 0, 7)
		else 
			text:SetPoint('BOTTOM', self.Health,"TOP", 0, -7) 
		end
		self.allowHealCommOverflow = true
	self.HealCommText = text
end
SVUnit.IncomingHeals = mk_heal_comm

------------------------------------------------------------------------
--	Raid Icons
------------------------------------------------------------------------
local mk_ricon = function(self,side)
	local r = self.data:CreateTexture(nil, "OVERLAY")
	local side = side or "TOP"
		if side == "RIGHT" then
			r:SetHeight(30)
			r:SetWidth(30)
			r:SetPoint("TOPRIGHT",self,"TOPRIGHT",-4,-4)
		elseif side == "LEFT" then
			r:SetHeight(30)
			r:SetWidth(30)
			r:SetPoint("TOPLEFT",self,"TOPLEFT",4,-4)
		else
			r:SetHeight(24)
			r:SetWidth(24)
			r:SetPoint("CENTER", self)
		end
		r:SetVertexColor(1,1,1,.9)
		r:SetTexture(SVMedia.raidicons)
		r:SetAlpha(0.5)
	self.RaidIcon = r
end
SVUnit.RaidIcons = mk_ricon

------------------------------------------------------------------------
--	Experience / reputation
------------------------------------------------------------------------	
-- Player XP
local mk_experience = function(self)
	if UnitLevel("player") ~= MAX_PLAYER_LEVEL then
		local XP = CreateFrame('StatusBar', nil, self)
		XP:SetAllPoints(self.Power)
		XP:SetStatusBarTexture(SVMedia.bar)
		XP:SetStatusBarColor(0.1,0.3,1)
		XP:SetBackdrop({bgFile = SVMedia.blank})
		XP:SetBackdropColor(0,0,0,0.8)
		XP:SetFrameStrata("MEDIUM")
		XP.Tooltip = true
		local Rested = CreateFrame('StatusBar', nil, XP)
		Rested:SetAllPoints(XP)
		Rested:SetStatusBarTexture(SVMedia.bar)
		Rested:SetStatusBarColor(1,0,1,0.6)
		XP.Rested = Rested
		XP.Text = XP:CreateFontString(nil, 'OVERLAY')
		XP.Text:SetFont(SVFonts.pixel,7,"THINOUTLINE")
		XP.Text:SetShadowOffset(-1,-1)
		XP.Text:SetAllPoints(XP)
		SVMod.SimpleSkin(XP)
		XP.Rested:SetBackdrop({bgFile = SVMedia.blank})
		XP.Rested:SetBackdropColor(unpack(SVMedia.backdropcolor))
		local dataz = self.data
		XP:SetScript('OnEnter', function(self) UIFrameFadeIn(self,.1,0,1); dataz:SetAlpha(0) end)
		XP:SetScript('OnLeave', function(self) UIFrameFadeOut(self,.2,1,0); dataz:SetAlpha(1) end)
		XP:SetAlpha(0)
		self.Experience = XP
	end
end
SVUnit.RUExperienced = mk_experience

-- Player Rep
-------------------------------------------------------------------------------------------------------
local UpdateReputationColor = function(self, event, unit, bar)
	local name, id = GetWatchedFactionInfo()
	bar:SetStatusBarColor(FACTION_BAR_COLORS[id].r, FACTION_BAR_COLORS[id].g, FACTION_BAR_COLORS[id].b)
end
SVUnit.RepColor = UpdateReputationColor
----------------------------------------
local mk_reputation = function(self)
	if UnitLevel("player") ~= MAX_PLAYER_LEVEL then return end
	local REP = CreateFrame('StatusBar', nil, self)
	REP:SetAllPoints(self.Power)
	REP:SetStatusBarTexture(SVMedia.bar)
	REP:SetStatusBarColor(0.1,1,0.2)
	REP:SetBackdrop({bgFile = SVMedia.blank})
	REP:SetBackdropColor(0,0,0,0.8)
	SVMod.SimpleSkin(REP)
	REP:SetFrameStrata("HIGH")
	REP.Tooltip = true
	REP.Text = REP:CreateFontString(nil, 'OVERLAY')
	REP.Text:SetFont(SVFonts.pixel,7,"THINOUTLINE")
	REP.Text:SetAllPoints(REP)
	REP.Text:SetShadowOffset(-1,-1)
	local dataz = self.data
	REP:SetScript('OnEnter', function(self) UIFrameFadeIn(self,.1,0,1); dataz:SetAlpha(0) end)
	REP:SetScript('OnLeave', function(self) UIFrameFadeOut(self,.2,1,0); dataz:SetAlpha(1) end)
	REP:SetAlpha(0)
	self.Reputation = REP
end
SVUnit.PutYoHoodUp = mk_reputation

--- Swing Bar
local mk_swing = function(self)
		if not SuperSet.unitops.swingbar == true then return end
		local swing = CreateFrame("Frame",nil,self.data)
		swing:SetFrameLevel(16)
		swing.texture = SVMedia.smoothbar
		swing.color = {0.8,0.8,0.8,1}
		swing.textureBG = SVMedia.smoothbar
	 	swing.colorBG = {0, 0, 0, 0.8}
		self.Swing = swing
end
SVUnit.SwingSet = mk_swing

--- Power Sparks
local mk_spark = function(self)
		local spark = self.Power:CreateTexture(nil, "OVERLAY")
		spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		spark:SetVertexColor(.75, .75, 1, .8)
		spark:SetBlendMode("ADD")
		spark:SetHeight(self.Power:GetHeight()*3.4)
		spark:SetWidth(self.Power:GetHeight()+4)
		self.Spark = spark
end
SVUnit.SparkPlug = mk_spark