------------------------------------------------------------------------
--	LOCALS
------------------------------------------------------------------------
local mk_anim
local colors = SVColors.oUF_colors

if SVRoot.myclass == "DEATHKNIGHT" or SVRoot.myclass == "WARRIOR" or SVRoot.myclass == "ROGUE" then 
	mk_anim = false
else
	mk_anim = true
end

local colorPower = {
		["MANA"] = {0.31, 0.45, 0.63},
		["RAGE"] = {0.69, 0.31, 0.31},
		["FOCUS"] = {0.71, 0.43, 0.27},
		["ENERGY"] = {0.65, 0.63, 0.35},
		["RUNES"] = {0.55, 0.57, 0.61},
		["RUNIC_POWER"] = {0, 0.82, 1},
		["AMMOSLOT"] = {0.8, 0.6, 0},
		["FUEL"] = {0, 0.55, 0.5},
		["POWER_TYPE_STEAM"] = {0.55, 0.57, 0.61},
		["POWER_TYPE_PYRITE"] = {0.60, 0.09, 0.17},
	}
----------------------------------------------------------------------------------------------------
-------------[[//||\\------------------STANDARD POWER UPDATE------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
SVUnit.UpdateManaLevel = function(self, elapsed)
	delay = delay + elapsed
	if self.parent.unit ~= "player" or delay < 0.2 or UnitIsDeadOrGhost("player") or UnitPowerType("player") ~= 0 then return end
	delay = 0

	local percMana = UnitMana("player") / UnitManaMax("player") * 100

	if percMana <= SVUnit.unitframes.lowThreshold then
		self.ManaLevel:SetText("|cffaf5050"..SVLocal.unitframes_ouf_lowmana.."|r")
		Flash(self, 0.3)
	else
		self.ManaLevel:SetText()
		StopFlash(self)
	end
end
----------------------------------------------------------------------------------------------------
-------------[[//||\\-----------------POWER PRE UPDATE------------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
SVUnit.PreUpdatePower = function(power, unit)
	local _, pType = UnitPowerType(unit)
	
	local color = SVColors.oUF_colors.power[pType]
	if color then
		power:SetStatusBarColor(color[1], color[2], color[3])
	end
end
----------------------------------------------------------------------------------------------------
-------------[[//||\\-----------------POWER POST UPDATE-----------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
SVUnit.PostUpdatePower = function(power, unit, min, max)
	local self = power:GetParent()
	local pType, pToken = UnitPowerType(unit)
	local color = colorPower[pToken]

	if color then
		power.value:SetTextColor(color[1], color[2], color[3])
	end

	if not UnitIsPlayer(unit) and not UnitPlayerControlled(unit) or not UnitIsConnected(unit) then
		power.value:SetText()
		if unit == "player" and mk_anim and self.flashlow then
			if self.flashlow.anim:IsPlaying() then
				self.flashlow.anim:Finish()
				self.flashlow:SetAlpha(0) 				
			end
		end
	elseif UnitIsDead(unit) or UnitIsGhost(unit) then
		power.value:SetText()
		if unit == "player" and mk_anim and self.flashlow then
			if self.flashlow.anim:IsPlaying() then
				self.flashlow.anim:Finish()
				self.flashlow:SetAlpha(0) 				
			end
		end
	else
		if min ~= max then
			if pType == 0 then
				if unit == "target" then
					if SuperSet.unitops.totalhpmp == true then
						power.value:SetFormattedText("%s |cffD7BEA5|||r %s", SVUnit.ShortValue(max - (max - min)), SVUnit.ShortValue(max))
					else
						power.value:SetFormattedText("%d%% |cffD7BEA5-|r %s", floor(min / max * 100), SVUnit.ShortValue(max - (max - min)))
					end
				elseif unit == "player" and self:GetAttribute("normalUnit") == "pet" or unit == "pet" then
					if SuperSet.unitops.totalhpmp == true then
						power.value:SetFormattedText("%s |cffD7BEA5|||r %s", SVUnit.ShortValue(max - (max - min)), SVUnit.ShortValue(max))
					else
						power.value:SetFormattedText("%d%%", floor(min / max * 100))
					end
					if mk_anim and self.flashlow then
						if min/max <= .33 then
							if not self.flashlow.anim:IsPlaying()  then
								self.flashlow.anim:Play() 
							end
						else
							if self.flashlow.anim:IsPlaying() then
								self.flashlow.anim:Finish()
								self.flashlow:SetAlpha(0) 
							end
						end			
					end
				elseif (unit and unit:find("arena%d")) then
					power.value:SetText(SVUnit.ShortValue(min))
				else
					if SuperSet.unitops.totalhpmp == true then
						power.value:SetFormattedText("%s |cffD7BEA5|||r %s", SVUnit.ShortValue(max - (max - min)), SVUnit.ShortValue(max))
					else
						power.value:SetFormattedText("%d%% |cffD7BEA5-|r %d", floor(min / max * 100), max - (max - min))
					end
				end
			else
				power.value:SetText(max - (max - min))
			end
		else
			if unit == "pet" or unit == "target" or (unit and unit:find("arena%d")) then
				power.value:SetText(SVUnit.ShortValue(min))
			else
				power.value:SetText(min)
			end
		end
	end
end
------------------------------------------------------------------------
--	Power Update Function by: AlleyKat
------------------------------------------------------------------------		
local updatePower = function(self, unit, min, max)
	if UnitIsDead(unit) or UnitIsGhost(unit) or not(UnitIsConnected(unit)) then
		self:SetValue(0)
		if self.value then
			self.value:SetText(" ")
		end
		if unit == "player" and mk_anim and self.flashlow then
			if self.flashlow.anim:IsPlaying() then
				self.flashlow.anim:Finish()
				self.flashlow:SetAlpha(0) 				
			end
		end	
	else
		self:SetValue(min)
		if unit == "player" and self.value then
			self.value:SetText(min)
			if mk_anim and self.flashlow then
				if min/max <= .33 then
					if not self.flashlow.anim:IsPlaying()  then
						self.flashlow.anim:Play() 
					end
				else
					if self.flashlow.anim:IsPlaying() then
						self.flashlow.anim:Finish()
						self.flashlow:SetAlpha(0) 
					end
				end			
			end
		elseif unit =="target" then
			local tclass = select(2, UnitClass(unit))
			if (not(UnitIsPlayer(unit)) and (tclass == "PALADIN")) or UnitIsPlayer(unit) then
				self.value:SetText(min.." ")
			else
				self.value:SetText(" ")
			end
		end
		local ptype = select(2, UnitPowerType(unit))
		if(colors.power[ptype]) then
			local r, g, b = unpack(colorPower[ptype])
			if self.value then
				self.value:SetTextColor(r,g,b)
			end
		end
	end
end
SVUnit.PowerUP = updatePower