------------------------------------------------------------------------
--	AFK
------------------------------------------------------------------------

-- afk check
local afkcheck = function(self,unit)
	if (UnitIsAFK(unit)) then
		self.text:SetText("AFK ")
	else 
		self.text:SetText("")
	end
end
SVUnit.AfkCheck = afkcheck

------------------------------------------------------------------------
--	LOCALS
------------------------------------------------------------------------
local mk_anim
local colors = SVColors.oUF_colors

------------------------------------------------------------------------
--	PVP
------------------------------------------------------------------------
local t_villain_pvp = function(self, event, unit)
	if(unit ~= self.unit) then return end

	local pvp = self.MyPvP
	if(pvp) then
		local factionGroup = UnitFactionGroup(unit)
		if(UnitIsPVPFreeForAll(unit)) then
			pvp:SetTexture(SVMedia.tpvpd)
			if not UnitIsPlayer(unit) then 
				local t = SVColors.oUF_colors.reaction[UnitReaction(unit, "player")]
				local r, g, b = t[1],t[2],t[3]
				pvp:SetVertexColor(r, g, b)
			else
				local englass = select(2, UnitClass(unit)) 
				local r, g, b = unpack(colors.class[englass])
				pvp:SetVertexColor(r, g, b)
			end
			pvp:Show()
		elseif(UnitIsPVP(unit) and factionGroup) then
			if(factionGroup == 'Horde') then
				pvp:SetTexture(SVMedia.tpvph)
			else
				pvp:SetTexture(SVMedia.tpvpa)
			end
			pvp:SetVertexColor(1, 1, 1)
			pvp:Show()
		else
			pvp:SetTexture(SVMedia.tpvpd)
			if not UnitIsPlayer(unit) then 
				local t = SVColors.oUF_colors.reaction[UnitReaction(unit, "player")]
				local r, g, b = t[1],t[2],t[3]
				pvp:SetVertexColor(r, g, b)
			else
				local englass = select(2, UnitClass(unit)) 
				local r, g, b = unpack(colors.class[englass])
				pvp:SetVertexColor(r, g, b)
			end
			pvp:Show()
		end
	end
end
SVUnit.TargetPVP = t_villain_pvp
-------------
local p_villain_pvp = function(self, event, unit)
	if(unit ~= self.unit) then return end

	local pvp = self.MyPvP
	if(pvp) then
		local factionGroup = UnitFactionGroup(unit)
		if(UnitIsPVPFreeForAll(unit)) then
			pvp:SetTexture(SVMedia.ppvpd)
			if not UnitIsPlayer(unit) then 
				local t = SVColors.oUF_colors.reaction[UnitReaction(unit, "player")]
				local r, g, b = t[1],t[2],t[3]
				pvp:SetVertexColor(r, g, b)
			else
				local englass = select(2, UnitClass(unit)) 
				local r, g, b = unpack(colors.class[englass])
				pvp:SetVertexColor(r, g, b)
			end
			pvp:Show()
		elseif(UnitIsPVP(unit) and factionGroup) then
			if(factionGroup == 'Horde') then
				pvp:SetTexture(SVMedia.ppvph)
			else
				pvp:SetTexture(SVMedia.ppvpa)
			end
			pvp:SetVertexColor(1, 1, 1)
			pvp:Show()
		else
			pvp:SetTexture(SVMedia.ppvpd)
			if not UnitIsPlayer(unit) then 
				local t = SVColors.oUF_colors.reaction[UnitReaction(unit, "player")]
				local r, g, b = t[1],t[2],t[3]
				pvp:SetVertexColor(r, g, b)
			else
				local englass = select(2, UnitClass(unit)) 
				local r, g, b = unpack(colors.class[englass])
				pvp:SetVertexColor(r, g, b)
			end
			pvp:Show()
		end
	end
end
SVUnit.MyOwnPVP = p_villain_pvp

local simple_pvp = function(self, event, unit)
	if(unit ~= self.unit) then return end

	local pvp = self.MyPvP
	if(pvp) then
		local factionGroup = UnitFactionGroup(unit)
		if((UnitIsPVP(unit) or UnitIsPVPFreeForAll(unit)) and factionGroup) then
			if(factionGroup == 'Horde') then
				pvp:SetTexture(SVMedia.spvph)
			else
				pvp:SetTexture(SVMedia.spvpa)
			end
			pvp:SetVertexColor(1, 1, 1)
			pvp:Show()
		else
			pvp:Hide()
		end
	end
end
SVUnit.SimplePVP = simple_pvp

-- Pet Pvp flag check
local pvp_update = function(self,event,unit)
	if unit ~= "pet" and event ~= "PLAYER_ENTERING_WORLD" then return end
	if not unit then
		unit = self.unit
	end
	if UnitIsPVPFreeForAll(unit) then
		self:SetBackdropColor(1,1,0.2)
	elseif UnitIsPVP(unit) then
		self:SetBackdropColor(0.1,1,0.2)
	else
		self:SetBackdropColor(0.1,0.3,1)
	end
end
SVUnit.PetPVPupdate = pvp_update

local mk_pvpflag = function(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_FLAGS_CHANGED")
	self:SetScript("OnEvent",SVUnit.PetPVPupdate)
end
SVUnit.PetPVP = mk_pvpflag

-- Player PvP flag check
local update_pvp = function(self,event,unit)
	if unit ~= "player" then return end
	if UnitIsPVPFreeForAll("player") then
		self:SetBackdropColor(1,1,0.2)
	elseif UnitIsPVP("player") then
		self:SetBackdropColor(0.1,1,0.2)
	else
		self:SetBackdropColor(0.1,0.3,1)
	end
end
SVUnit.PlayerPVP = update_pvp