﻿if SuperSet["load"].bags ~= true then return end
--Stuffing--
--All credits of this bags script is by Stuffing and his author Hungtar.--

local BAGS_BACKPACK = {0, 1, 2, 3, 4}
local BAGS_BANK = {-1, 5, 6, 7, 8, 9, 10, 11}
local BAGSFONT = SVFonts.font
local ST_NORMAL = 1
local ST_FISHBAG = 2
local ST_SPECIAL = 3
local bag_bars = 1
local hide_soulbags = 1
local quest_glow = 1
local custom_skin = 1
local s_frame = SVMod.flipframe

Stuffing = CreateFrame ("Frame", nil, UIParent)
local SimpleSkin = function (f)
	if f.left then return end
	local color = {0.2,0.2,0.2}
	
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(unpack(color))
	f.left:SetPoint("TOPLEFT")
	f.left:SetPoint("BOTTOMLEFT")
	f.left:SetWidth(2)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(unpack(color))
	f.right:SetPoint("TOPRIGHT")
	f.right:SetPoint("BOTTOMRIGHT")
	f.right:SetWidth(2)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(unpack(color))
	f.top:SetPoint("TOPLEFT")
	f.top:SetPoint("TOPRIGHT")
	f.top:SetHeight(2)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(unpack(color))
	f.bottom:SetPoint("BOTTOMLEFT")
	f.bottom:SetPoint("BOTTOMRIGHT")
	f.bottom:SetHeight(2)
	return f
end
local names
if SVRoot.L == "ruRU" then
	names = {
	["stuffload"] = "используйте команду /bags для дополнительной информации.",
	["srch"] = "Поиск",
	["rclick"] = "Щелкните правой кнопкой для начала поиска.",
	["com"] = "Доступные команды:",
	["sort"] = "сортировка вещей в сумках и в банке, если тот открыт.",
	["staks"] = "заполнение неполных стаков в сумках и в банке, если тот открыт.",
	["buyslot"] = "покупка ячейки в банке.",
	["stuff_re"] = "Один момент...",
	["openbank"] = "Сначала нужно открыть банк.",
	["purch_yes"] = "Для покупки используйте команду /bags purchase yes",
	["cost_st"] = "Стоимость:",
	["cant_buy"] = "Нимагу больше купить.",
	["rest_st"] = "Сборка завершена.",
	["na_st"] = "Нипасортировать!!!!",
	["sr_compl"] = "Сортировка завершена.",
	["st_using"] = "Используются сумки: "}
else
	names = {
	["stuffload"] = "use /bags for more information.",
	["srch"] = "Search",
	["rclick"] = "Right-click to search.",
	["com"] = "Comands:",
	["sort"] = "sort your bags or your bank, if open.",
	["staks"] = "fill up partial stacks in your bags or bank, if open.",
	["buyslot"] = "buy new slot in bank.",
	["stuff_re"] = "Restacking, please be patient...",
	["openbank"] = "You need to open your bank first.",
	["purch_yes"] = "Buy new slot with /bags purchase yes",
	["cost_st"] = "Cost:",
	["cant_buy"] = "can't buy anymore slots",
	["rest_st"] = "Restacking finished.",
	["na_st"] = "Nothing to sort.",
	["sr_compl"] = "Sorting finished.",
	["st_using"] = "Using bags: "}
end

print("|cffdd7799Stuffing: |r",names.stuffload)

-- stub for localization.
local L = setmetatable({}, {
	__index = function (t, v)
		t[v] = v
		return v
	end
})


local function Print (x)
	print("|cffdd7799Stuffing: |r" .. x)
end

local function Stuffing_Sort(args)
	if not args then
		args = ""
	end

	Stuffing.itmax = 0
	Stuffing:SetBagsForSorting(args)
	Stuffing:SortBags()
end


local function Stuffing_OnShow()
	Stuffing:PLAYERBANKSLOTS_CHANGED(29)	-- XXX: hack to force bag frame update

	Stuffing:Layout()
	Stuffing:SearchReset()
end


local function StuffingBank_OnHide()
	CloseBankFrame()
	if Stuffing.frame:IsShown() then
		Stuffing.frame:Hide()
	end
end


local function Stuffing_OnHide()
	if Stuffing.bankFrame and Stuffing.bankFrame:IsShown() then
		Stuffing.bankFrame:Hide()
	end
end


local function Stuffing_Open()
	Stuffing.frame:Show()
end


local function Stuffing_Close()
	Stuffing.frame:Hide()
end


local function Stuffing_Toggle()
	if Stuffing.frame:IsShown() then
		Stuffing.frame:Hide()
	else
		Stuffing.frame:Show()
	end
end


local function Stuffing_ToggleBag(id)
	if id == -2 then
		ToggleKeyRing()
		return
	end
	Stuffing_Toggle()
end

local function StartMoving(self)
	self:StartMoving()
	local n = self:GetName()
end


local function StopMoving(self)
	self:StopMovingOrSizing()
	self:SetUserPlaced(false)
	local n = self:GetName()
end

local re_color = function(self,r,g,b)
	self.top:SetTexture(r,g,b)
	self.bottom:SetTexture(r,g,b)
	self.left:SetTexture(r,g,b)
	self.right:SetTexture(r,g,b)
end

--
-- bag slot stuff
--
local trashParent = CreateFrame("Frame", nil, UIParent)
local trashButton = {}
local trashBag = {}

-- for the tooltip frame used to scan item tooltips
local StuffingTT = nil

-- mostly from cargBags_Aurora
local QUEST_ITEM_STRING = nil

function Stuffing:SlotUpdate(b)
	local texture, count, locked = GetContainerItemInfo (b.bag, b.slot)
	local clink = GetContainerItemLink(b.bag, b.slot)

	if b.Cooldown then
		local cd_start, cd_finish, cd_enable = GetContainerItemCooldown(b.bag, b.slot)
		CooldownFrame_SetTimer(b.Cooldown, cd_start, cd_finish, cd_enable)
	end

	if(clink) then
		local iType
		b.name, _, b.rarity, _, _, iType = GetItemInfo(clink)


			if not StuffingTT then
				StuffingTT = CreateFrame("GameTooltip", "StuffingTT", nil, "GameTooltipTemplate")
				StuffingTT:Hide()
			end

			if QUEST_ITEM_STRING == nil then
				-- GetItemInfo returns a localized item type.
				-- this is to figure out what that string is.
				local t = {GetAuctionItemClasses()}
				QUEST_ITEM_STRING = t[#t]	-- #t == 12
			end

			-- load tooltip, check if ITEM_BIND_QUEST ("Quest Item") is in it.
			-- If the tooltip says its a quest item, we assume it is a quest item
			-- and ignore the item type from GetItemInfo.
			StuffingTT:SetOwner(WorldFrame, "ANCHOR_NONE")
			StuffingTT:ClearLines()
			StuffingTT:SetBagItem(b.bag, b.slot)
			for i = 1, StuffingTT:NumLines() do
				local txt = getglobal("StuffingTTTextLeft" .. i)
				if txt then
					local text = txt:GetText()
					if string.find (txt:GetText(), ITEM_BIND_QUEST) then
						iType = QUEST_ITEM_STRING
					end
				end
			end

			if iType and iType == QUEST_ITEM_STRING then
				--print (iType .. " " .. b.name)
				b.qitem = true
			else
				b.qitem = nil
			end

	else
		b.name, b.rarity, b.qitem = nil, nil, nil
	end
	
	SetItemButtonTexture(b.frame, texture)
	SetItemButtonCount(b.frame, count)
	SetItemButtonDesaturated(b.frame, locked, 0.5, 0.5, 0.5)

	if b.Glow then
		b.Glow:Show()
		if b.rarity then
			if b.rarity > 1 then
				local r,g,y = GetItemQualityColor(b.rarity)
				re_color(b.Glow,r,g,y)
			elseif b.qitem and quest_glow == 1 then
				re_color(b.Glow,1.0, 0.3, 0.3)
			else
				re_color(b.Glow,0.2,0.2,0.2)
			end
		else
			re_color(b.Glow,0.2,0.2,0.2)
		end
	end
	
	if b.iconTex then
		b.iconTex:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
	end
	
	b.frame:Show()
end


function Stuffing:BagSlotUpdate(bag)
	if not self.buttons then
		return
	end

	for _, v in ipairs (self.buttons) do
		if v.bag == bag then
			self:SlotUpdate(v)
		end
	end
end

local setbagicons = function(self)
	local name = self:GetName()
	local Icon = 		_G[name.."IconTexture"]
	local Count = 		_G[name.."Count"]
	local Border =		_G[name.."NormalTexture"]
	local Push =		self:GetPushedTexture()
	local HI =			self:GetHighlightTexture()
	
		Icon:SetTexCoord(.1,.9,.1,.9)
		Border:SetTexture(nil)
		Count:SetFont(SVFonts.numbers,10,"THINOUTLINE")
		Count:SetShadowOffset(1,-1)
		Count:ClearAllPoints()
		Count:SetPoint("TOPRIGHT",.3,.3)
		Push:SetTexture(.3,.3,.3,.5)
		HI:SetTexture(1,1,1,.4)
		
	if not self.m_bg then
		local bg = s_frame(self,10,"HIGH")
		bg:SetPoint("TOPLEFT",-4,4)
		bg:SetPoint("BOTTOMRIGHT",4,-4)
		self.m_bg = bg
	end
	
		self:SetSize(30,30)
		
end

function Stuffing:BagFrameSlotNew (slot, p)
	for _, v in ipairs(self.bagframe_buttons) do
		if v.slot == slot then
			--print ("found " .. slot)
			return v, false
		end
	end

	--print ("new " .. slot)
	local ret = {}
	local tpl

	if slot > 3 then
		ret.slot = slot
		slot = slot - 4
		tpl = "BankItemButtonBagTemplate"
		ret.frame = CreateFrame("CheckButton", "StuffingBBag" .. slot, p, tpl)
		setbagicons(ret.frame)
		ret.frame:SetID(slot + 4)
		table.insert(self.bagframe_buttons, ret)

		BankFrameItemButton_Update(ret.frame)
		BankFrameItemButton_UpdateLocked(ret.frame)

		if not ret.frame.tooltipText then
			ret.frame.tooltipText = ""
		end
	else
		tpl = "BagSlotButtonTemplate"
		ret.frame = CreateFrame("CheckButton", "StuffingFBag" .. slot .. "Slot", p, tpl)
		setbagicons(ret.frame)
		ret.slot = slot
		table.insert(self.bagframe_buttons, ret)
	end

	return ret
end


function Stuffing:SlotNew (bag, slot)
	for _, v in ipairs(self.buttons) do
		if v.bag == bag and v.slot == slot then
			return v, false
		end
	end

	local tpl = "ContainerFrameItemButtonTemplate"

	if bag == -1 then
		tpl = "BankItemButtonGenericTemplate"
	end

	local ret = {}

	if #trashButton > 0 then
		local f = -1
		for i, v in ipairs(trashButton) do
			local b, s = v:GetName():match("(%d+)_(%d+)")

			b = tonumber(b)
			s = tonumber(s)

			--print (b .. " " .. s)
			if b == bag and s == slot then
				f = i
				break
			end
		end

		if f ~= -1 then
			--print("found it")
			ret.frame = trashButton[f]
			table.remove(trashButton, f)
		end
	end

	if not ret.frame then
		ret.frame = CreateFrame("Button", "StuffingBag" .. bag .. "_" .. slot, self.bags[bag], tpl)
	end

	ret.bag = bag
	ret.slot = slot
	ret.frame:SetID(slot)

	if not ret.Glow then
		-- from cargBags_Aurora
		local glow = CreateFrame("Frame",nil,ret.frame)
		glow:SetPoint("TOPLEFT",-2,2)
		glow:SetPoint("BOTTOMRIGHT",2,-2)
		glow:SetFrameStrata("HIGH")
		glow:SetFrameLevel(20)
		SimpleSkin(glow)
		local glowbg = SVMod.altframe(glow,0,nil,"HIGH")
		glowbg:SetAllPoints(glow)
		ret.Glow = glow
	end

	ret.Cooldown = _G[ret.frame:GetName() .. "Cooldown"]
	ret.Cooldown:Show()

	self:SlotUpdate (ret)

	return ret, true
end


-- from OneBag
local BAGTYPE_PROFESSION = 0x0008 + 0x0010 + 0x0020 + 0x0040 + 0x0080 + 0x0200 + 0x0400
local BAGTYPE_FISHING = 32768

function Stuffing:BagType(bag)
	local bagType = select(2, GetContainerNumFreeSlots(bag))
	if bit.band(bagType, BAGTYPE_FISHING) > 0 then
	    return ST_FISHBAG
	elseif bit.band(bagType, BAGTYPE_PROFESSION) > 0 then 
		return ST_SPECIAL
	end

	return ST_NORMAL
end


function Stuffing:BagNew (bag, f)
	for i, v in pairs(self.bags) do
		if v:GetID() == bag then
			v.bagType = self:BagType(bag)
			return v
		end
	end

	local ret

	if #trashBag > 0 then
		local f = -1
		for i, v in pairs(trashBag) do
			if v:GetID() == bag then
				f = i
				break
			end
		end

		if f ~= -1 then
			--print("found bag " .. bag)
			ret = trashBag[f]
			table.remove(trashBag, f)
			ret:Show()
			ret.bagType = self:BagType(bag)
			return ret
		end
	end

	--print("new bag " .. bag)
	ret = CreateFrame("Frame", "StuffingBag" .. bag, f)
	ret.bagType = self:BagType(bag)
	ret:SetID(bag)
	return ret
end


function Stuffing:SearchUpdate(str)
	str = string.lower(str)

	for _, b in ipairs(self.buttons) do
		if b.name then
			if b.iconTex then
				b.iconTex:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
			end
			if not string.find (string.lower(b.name), str) then
				SetItemButtonDesaturated(b.frame, 1, 1, 1, 1)
				if b.iconTex then
					b.iconTex:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
				end
				if b.Glow then
					b.Glow:Show()
					re_color(b.Glow,0.2,0.2,0.2)
				end
			else
				SetItemButtonDesaturated(b.frame, 0, 1, 1, 1)
				if b.iconTex then
					b.iconTex:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
				end
				if b.Glow then
					b.Glow:Show()
					re_color(b.Glow,1,.7,.1)
				end
			end
		end
	end
end


function Stuffing:SearchReset()
	for _, b in ipairs(self.buttons) do
		SetItemButtonDesaturated(b.frame, 0, 1, 1, 1)
		if b.iconTex then
			b.iconTex:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
		end
		if b.Glow then
			b.Glow:Show()
			if b.rarity then
				if b.rarity > 1 then
					local r,g,y = GetItemQualityColor(b.rarity)
					re_color(b.Glow,r,g,y)
				elseif b.qitem and quest_glow == 1 then
					re_color(b.Glow,1.0, 0.3, 0.3)
				else
					re_color(b.Glow,0.2,0.2,0.2)
				end
			else
				re_color(b.Glow,0.2,0.2,0.2)
			end
		end
	end
end

-- drop down menu stuff from Postal
local Stuffing_DDMenu = CreateFrame("Frame", "Stuffing_DropDownMenu")
Stuffing_DDMenu.displayMode = "MENU"
Stuffing_DDMenu.info = {}
Stuffing_DDMenu.HideMenu = function()
	if UIDROPDOWNMENU_OPEN_MENU == Stuffing_DDMenu then
		CloseDropDownMenus()
	end
end

function Stuffing:CreateBagFrame(w)
	local n = "StuffingFrame"  .. w
	local f = CreateFrame ("Frame", n, UIParent)
	f:EnableMouse(1)
	f:SetMovable(1)
	f:SetToplevel(1)
	f:SetFrameStrata("HIGH")
	f:SetFrameLevel(18)
	local bagback = SVMod.altframe(f,0,nil,"HIGH")
	bagback:SetAllPoints(f)
	
	local up_frame = s_frame(f,10,"HIGH")
	up_frame:SetPoint("TOPLEFT",2,0)
	up_frame:SetPoint("TOPRIGHT",-2,0)
	up_frame:SetFrameStrata("HIGH")
	up_frame:SetHeight(32)
	
	--[[
	if w == "Bank" then
		f:SetScript("OnMouseDown", StartMoving)
		f:SetScript("OnMouseUp", StopMoving)
	else
		f:SetScript("OnMouseDown", StartMoving)
		f:SetScript("OnMouseUp", StopMoving)
	end
	]]--
	
	local x = 50
	
	if w == "Bank" then
		f:SetPoint ("LEFT",x,0)
	else
		f:SetPoint ("RIGHT",-x,0)
	end
	-- close button
	f.b_close = CreateFrame("Button", "Stuffing_CloseButton" .. w, f, "UIPanelCloseButton")
	f.b_close:SetWidth(32)
	f.b_close:SetHeight(32)
	f.b_close:SetFrameStrata("HIGH")
	f.b_close:SetPoint("RIGHT",up_frame)
	f.b_close:SetScript("OnClick", function(self, btn)
		if self:GetParent():GetName() == "StuffingFrameBags" and btn == "RightButton" then
			if Stuffing_DDMenu.initialize ~= Stuffing.Menu then
				CloseDropDownMenus()
				Stuffing_DDMenu.initialize = Stuffing.Menu
			end
			ToggleDropDownMenu(1, nil, Stuffing_DDMenu, self:GetName(), 0, 0)
			return
		end
		self:GetParent():Hide()
	end)
	f.b_close:RegisterForClicks("AnyUp")
	f.b_close:GetNormalTexture():SetDesaturated(1)
	f.up_frame = up_frame
	-- create the bags frame
	local fb = CreateFrame ("Frame", n .. "BagsFrame", f)
		if w == "Bank" then
			fb:SetPoint("TOPLEFT", up_frame, "BOTTOMRIGHT", 1, 0)
		else
			fb:SetPoint("TOPRIGHT", up_frame, "BOTTOMLEFT", -1, 0)
		end
	f.bags_frame = fb

	return f
end


function Stuffing:InitBank()
	if self.bankFrame then
		return
	end

	local f = self:CreateBagFrame("Bank")
	f:SetScript("OnHide", StuffingBank_OnHide)
	self.bankFrame = f
end


local parent_startmoving = function(self)
	StartMoving(self:GetParent())
end


local parent_stopmovingorsizing = function (self)
	StopMoving(self:GetParent())
end

function Stuffing:LockUnlock()
	local f = self.frame

		f:SetScript("OnMouseDown", StartMoving)
		f:SetScript("OnMouseUp", StopMovingOrSizing)
		f.button:SetScript("OnMouseDown", parent_startmoving)
		f.button:SetScript("OnMouseUp", parent_stopmovingorsizing)
end

function Stuffing:InitBags()
	if self.frame then
		return
	end

	self.buttons = {}
	self.bags = {}
	self.bagframe_buttons = {}

	local f = self:CreateBagFrame("Bags")
	f:SetScript("OnShow", Stuffing_OnShow)
	f:SetScript("OnHide", Stuffing_OnHide)

	-- search editbox (tekKonfigAboutPanel.lua)
	local editbox = CreateFrame("EditBox", nil, f)
	editbox:Hide()
	editbox:SetAutoFocus(true)
	editbox:SetHeight(32)

	local resetAndClear = function (self)
		self:GetParent().detail:Show()
		self:GetParent().gold:Show()
		self:ClearFocus()
		Stuffing:SearchReset()
	end

	local updateSearch = function(self, t)
		if t == true then
			Stuffing:SearchUpdate(self:GetText())
		end
	end

	editbox:SetScript("OnEscapePressed", resetAndClear)
	editbox:SetScript("OnEnterPressed", resetAndClear)
	editbox:SetScript("OnEditFocusLost", editbox.Hide)
	editbox:SetScript("OnEditFocusGained", editbox.HighlightText)
	editbox:SetScript("OnTextChanged", updateSearch)
	editbox:SetText(names.srch)

	local detail = f:CreateFontString(nil, "ARTWORK", "GameFontHighlightLarge")
	detail:SetPoint("LEFT", f.up_frame, 8, 1)
	detail:SetPoint("RIGHT",f.up_frame, -44,1)
	detail:SetHeight(13)
	detail:SetJustifyH("LEFT")
	detail:SetText("|cffffff33" .. names.srch)
	editbox:SetAllPoints(detail)

	local gold = f:CreateFontString(nil, "ARTWORK", "GameFontHighlightLarge")
	gold:SetJustifyH("RIGHT")
	gold:SetPoint("RIGHT", f.b_close, "LEFT", -14, 1)

	f:SetScript("OnEvent", function (self, e)
		self.gold:SetText (GetCoinTextureString(GetMoney(), 12))
	end)

	f:RegisterEvent("PLAYER_MONEY")
	f:RegisterEvent("PLAYER_LOGIN")
	f:RegisterEvent("PLAYER_TRADE_MONEY")
	f:RegisterEvent("TRADE_MONEY_CHANGED")

	local OpenEditbox = function(self)
		self:GetParent().detail:Hide()
		self:GetParent().gold:Hide()
		self:GetParent().editbox:Show()
		self:GetParent().editbox:HighlightText()
	end
	
	local button = CreateFrame("Button", nil, f)
	button:EnableMouse(1)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetAllPoints(detail)
	button:SetScript("OnClick", function(self, btn)
		if btn == "RightButton" then
			OpenEditbox(self)
		else
			if self:GetParent().editbox:IsShown() then
				self:GetParent().editbox:Hide()
				self:GetParent().editbox:ClearFocus()
				self:GetParent().detail:Show()
				self:GetParent().gold:Show()
				Stuffing:SearchReset()
			end
		end
	end)

	local tooltip_hide = function()
		GameTooltip:Hide()
	end

	local tooltip_show = function (self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		GameTooltip:SetText(names.rclick)
	end

	button:SetScript("OnEnter", tooltip_show)
	button:SetScript("OnLeave", tooltip_hide)
	
	button:SetScript("OnMouseDown", parent_startmoving)
	button:SetScript("OnMouseUp", parent_stopmovingorsizing)

	f.editbox = editbox
	f.detail = detail
	f.button = button
	f.gold = gold	
	self.frame = f
	f:Hide()
end


function Stuffing:Layout(lb)
	local slots = 0
	local rows = 0
	local off = 33
	local cols
	local f
	local bs

	if lb then
		bs = BAGS_BANK
		cols = 10
		f = self.bankFrame
	else
		bs = BAGS_BACKPACK
		cols = 10
		f = self.frame

		f.gold:SetText (GetCoinTextureString(GetMoney(), 12))
		f.editbox:SetFont(BAGSFONT, 14)
		f.editbox:SetShadowOffset(1,-1)
		f.detail:SetFont(BAGSFONT, 14)
		f.detail:SetShadowOffset(1,-1)
		f.gold:SetFont(SVFonts.super_c, 14, "OUTLINE")
		f.gold:SetShadowOffset(1,-1)

		f.detail:ClearAllPoints()
		f.detail:SetPoint("LEFT", f.up_frame, 8, 1)
		f.detail:SetPoint("RIGHT",f.up_frame, -44,1)
	end

	f:SetClampedToScreen(1)

	-- bag frame stuff
	local fb = f.bags_frame
	if bag_bars == 1 then
		fb:SetClampedToScreen(1)
		local bsize = 34
		if lb then
			fb:SetHeight(7*bsize+38)
		else
			fb:SetHeight(4*bsize+20)
		end
		fb:SetWidth(bsize)
		fb:Show()
	else
		fb:Hide()
	end

	local idx = 0
	for _, v in ipairs(bs) do
		if (not lb and v <= 3 ) or (lb and v ~= -1) then
			local bsize = 36

			local b = self:BagFrameSlotNew(v, fb)

			local off = 6

			off = off + (idx * bsize) + (idx * 4)
			
			b.frame:ClearAllPoints()
			b.frame:SetPoint("TOP", fb, 0, -off)
			b.frame:Show()

			idx = idx + 1
		end
	end


	for _, i in ipairs(bs) do
		local x = GetContainerNumSlots(i)
		if x > 0 then
			if not self.bags[i] then
				self.bags[i] = self:BagNew(i, f)
			end
		
			slots = slots + GetContainerNumSlots(i)	
		end
	end


	rows = floor (slots / cols)
	if (slots % cols) ~= 0 then
		rows = rows + 1
	end

	f:SetWidth(cols * 34
			+ (cols - 1) * 6 + 8)

	f:SetHeight(rows * 32
			+ (rows - 1) * 6
			+ off + 17 * 2)


	local idx = 0
	for _, i in ipairs(bs) do
		local bag_cnt = GetContainerNumSlots(i)

		if bag_cnt > 0 then
			self.bags[i] = self:BagNew(i, f)
			local bagType = self.bags[i].bagType

			self.bags[i]:Show()
				--print (i .. ": " .. GetContainerNumSlots(i) .. " slots.")
				for j = 1, bag_cnt do
					local b, isnew = self:SlotNew (i, j)
					local xoff
					local yoff
					local x = (idx % cols)
					local y = floor(idx / cols)

					if isnew then
						table.insert(self.buttons, idx + 1, b)
					end

					xoff = 10 + (x * 33)
							+ (x * 6)

					yoff = off + 18 + (y * 33)
							+ ((y - 1) * 6)
							
					yoff = yoff * -1

					b.frame:ClearAllPoints()
					b.frame:SetPoint("TOPLEFT", f, "TOPLEFT", xoff, yoff)
					b.frame:SetHeight(29)
					b.frame:SetWidth(29)
					b.frame:Show()

					local normalTex = _G[b.frame:GetName() .. "NormalTexture"]
					normalTex:SetTexture(nil)
					b.normalTex = normalTex
					
					local Push = b.frame:GetPushedTexture()
					local HI = b.frame:GetHighlightTexture()
	
						Push:SetTexture(.3,.3,.3,.5)
						HI:SetTexture(1,1,1,.4)
					
					local iconTex = _G[b.frame:GetName() .. "IconTexture"]
						iconTex:SetTexCoord(0.1, 0.9, 0.1, 0.9)
						iconTex:ClearAllPoints()
						iconTex:SetPoint("TOPLEFT", b.frame)
						iconTex:SetPoint("BOTTOMRIGHT", b.frame)
					iconTex:Show()
					b.iconTex = iconTex		
					
					local scount = _G[b.frame:GetName() .. "Count"]
						scount:SetFont (SVFonts.numbers, 10, "THINOUTLINE")
						scount:SetTextColor(1,1,0.3)
						scount:SetShadowOffset(-2,-1)
						scount:ClearAllPoints()
						scount:SetPoint("BOTTOMRIGHT",b.frame,6,-1)
						b.scount = scount

					if b.Glow then
						b.Glow:SetPoint("TOPLEFT", b.frame,-4,4)
						b.Glow:SetPoint("BOTTOMRIGHT", b.frame,4,-4)
							if bagType == ST_FISHBAG then
								b.Glow:SetBackdropBorderColor(1,0,0.3)
							elseif bagType == ST_SPECIAL then
								b.Glow:SetBackdropBorderColor(0,0,1)
							elseif bagType == ST_NORMAL then
								b.Glow:SetBackdropBorderColor(unpack(SVMedia.bordershadow))
							end
					end

					idx = idx + 1
				end
				
		end
	end
end


function Stuffing:SetBagsForSorting(c)
	Stuffing_Open()

	self.sortBags = {}

	local cmd = ((c == nil or c == "") and {"d"} or {strsplit("/", c)})

	for _, s in ipairs(cmd) do
		if s == "c" then
			self.sortBags = {}
		elseif s == "d" then
			if not self.bankFrame or not self.bankFrame:IsShown() then
				for _, i in ipairs(BAGS_BACKPACK) do
					if self.bags[i] and self.bags[i].bagType == ST_NORMAL then
						table.insert(self.sortBags, i)
					end
				end
			else
				for _, i in ipairs(BAGS_BANK) do
					if self.bags[i] and self.bags[i].bagType == ST_NORMAL then
						table.insert(self.sortBags, i)
					end
				end
			end
		elseif s == "p" then
			if not self.bankFrame or not self.bankFrame:IsShown() then
				for _, i in ipairs(BAGS_BACKPACK) do
					if self.bags[i] and (self.bags[i].bagType == ST_SPECIAL or self.bags[i].bagType == ST_FISHBAG) then
						table.insert(self.sortBags, i)
					end
				end
			else
				for _, i in ipairs(BAGS_BANK) do
					if self.bags[i] and (self.bags[i].bagType == ST_SPECIAL or self.bags[i].bagType == ST_FISHBAG) then
						table.insert(self.sortBags, i)
					end
				end
			end
		else
			if tonumber(s) == nil then
				Print(string.format("Error: don't know what \"%s\" means.", s))
			end

			table.insert(self.sortBags, tonumber(s))
		end
	end

	local bids = names.st_using
	for _, i in ipairs(self.sortBags) do
		bids = bids .. i .. " "
	end

	Print(bids)
end


-- slash command handler
local function StuffingSlashCmd(Cmd)
	local cmd, args = strsplit(" ", Cmd:lower(), 2)

	if cmd == "sort" then
		Stuffing_Sort(args)
	elseif cmd == "psort" then
		Stuffing_Sort("c/p")
	elseif cmd == "stack" then
		Print(names.stuff_re)
		Stuffing:SetBagsForSorting(args)
		Stuffing:Restack()
	elseif cmd == "test" then
		Stuffing:SetBagsForSorting(args)
	elseif cmd == "purchase" then
		-- XXX
		if Stuffing.bankFrame and Stuffing.bankFrame:IsShown() then
			local cnt, full = GetNumBankSlots()
			if full then
				Print(names.cant_buy)
				return
			end

			if args == "yes" then
				PurchaseSlot()
				return
			end

			Print(string.format(names.cost_st.." %.2fg", GetBankSlotCost() / 10000))
			Print(names.purch_yes)
		else
			Print(names.openbank)
		end
	else
		Print(names.com)
		Print("sort - " .. names.sort)
		Print("stack - " .. names.staks)
		Print("purchase - " .. names.buyslot)
	end
end


function Stuffing:PLAYERBANKSLOTS_CHANGED(id)
	if id > 28 then
		for _, v in ipairs(self.bagframe_buttons) do
			if v.frame and v.frame.GetInventorySlot then

				BankFrameItemButton_Update(v.frame)
				BankFrameItemButton_UpdateLocked(v.frame)

				if not v.frame.tooltipText then
					v.frame.tooltipText = ""
				end
			end
		end
	end

	if self.bankFrame and self.bankFrame:IsShown() then
		self:BagSlotUpdate(-1)
	end
end


function Stuffing:BAG_UPDATE(id)
	self:BagSlotUpdate(id)
end


function Stuffing:ITEM_LOCK_CHANGED(bag, slot)
	if slot == nil then
		return
	end

	for _, v in ipairs(self.buttons) do
		if v.bag == bag and v.slot == slot then
			self:SlotUpdate(v)
			break
		end
	end
end


function Stuffing:BANKFRAME_OPENED()
	if not self.bankFrame then
		self:InitBank()
	end

	self:Layout(true)
	for _, x in ipairs(BAGS_BANK) do
		self:BagSlotUpdate(x)
	end
	self.bankFrame:Show()
	Stuffing_Open()
end


function Stuffing:BANKFRAME_CLOSED()
	if not self.bankFrame then
		return
	end

	self.bankFrame:Hide()
end


function Stuffing:BAG_CLOSED(id)
	local b = self.bags[id]
	if b then
		table.remove(self.bags, id)
		b:Hide()
		table.insert (trashBag, #trashBag + 1, b)
	end

	while true do
		local changed = false

		for i, v in ipairs(self.buttons) do
			if v.bag == id then
				v.frame:Hide()
				v.normalTex:Hide()
				v.iconTex:Hide()

				if v.Glow then
					v.Glow:Hide()
				end

				table.insert (trashButton, #trashButton + 1, v.frame)
				table.remove(self.buttons, i)

				v = nil
				changed = true
			end
		end

		if not changed then
			break
		end
	end
end


function Stuffing:SortOnUpdate(e)
	if not self.elapsed then
		self.elapsed = 0
	end

	if not self.itmax then
		self.itmax = 0
	end

	self.elapsed = self.elapsed + e

	if self.elapsed < 0.1 then
		return
	end

	self.elapsed = 0
	self.itmax = self.itmax + 1

	local changed, blocked  = false, false

	if self.sortList == nil or next(self.sortList, nil) == nil then
		-- wait for all item locks to be released.
		local locks = false

		for i, v in pairs(self.buttons) do
			local _, _, l = GetContainerItemInfo(v.bag, v.slot)
			if l then
				locks = true
			else
				v.block = false
			end
		end

		if locks then
			-- something still locked. wait some more.
			return
		else
			-- all unlocked. get a new table.
			self:SetScript("OnUpdate", nil)
			self:SortBags()

			if self.sortList == nil then
				return
			end
		end
	end

	-- go through the list and move stuff if we can.
	for i, v in ipairs (self.sortList) do
		repeat
			if v.ignore then
				blocked = true
				break
			end

			if v.srcSlot.block then
				changed = true
				break
			end

			if v.dstSlot.block then
				changed = true
				break
			end

			local _, _, l1 = GetContainerItemInfo(v.dstSlot.bag, v.dstSlot.slot)
			local _, _, l2 = GetContainerItemInfo(v.srcSlot.bag, v.srcSlot.slot)

			if l1 then
				v.dstSlot.block = true
			end

			if l2 then
				v.srcSlot.block = true
			end

			if l1 or l2 then
				break
			end

			if v.sbag ~= v.dbag or v.sslot ~= v.dslot then
				if v.srcSlot.name ~= v.dstSlot.name then
					v.srcSlot.block = true
					v.dstSlot.block = true
					PickupContainerItem (v.sbag, v.sslot)
					PickupContainerItem (v.dbag, v.dslot)
					changed = true
					break
				end
			end
		until true
	end

	self.sortList = nil

	if (not changed and not blocked) or self.itmax > 250 then
		self:SetScript("OnUpdate", nil)
		self.sortList = nil
		Print (names.sr_compl)
	end
end


local function InBags(x)
	if not Stuffing.bags[x] then
		return false
	end

	for _, v in ipairs(Stuffing.sortBags) do
		if x == v then
			return true
		end
	end
	return false
end


function Stuffing:SortBags()
	local bs = self.sortBags
	if #bs < 1 then
		Print (names.na_st)
		return
	end

	local st = {}
	local bank = false

	Stuffing_Open()

	for i, v in pairs(self.buttons) do
		if InBags(v.bag) then
			self:SlotUpdate(v)

			if v.name then
				local tex, cnt, _, _, _, _, clink = GetContainerItemInfo(v.bag, v.slot)
				local n, _, q, iL, rL, c1, c2, _, Sl = GetItemInfo(clink)
				table.insert(st, {
					srcSlot = v,
					sslot = v.slot,
					sbag = v.bag,
					--sort = q .. iL .. c1 .. c2 .. rL .. Sl .. n .. i,
					--sort = q .. iL .. c1 .. c2 .. rL .. Sl .. n .. (#self.buttons - i),
					sort = q .. c1 .. c2 .. rL .. n .. iL .. Sl .. (#self.buttons - i),
					--sort = q .. (#self.buttons - i) .. n,
				})
			end
		end
	end

	-- sort them
	table.sort (st, function(a, b)
		return a.sort > b.sort
	end)

	-- for each button we want to sort, get a destination button
	local st_idx = 1
	local dbag = bs[st_idx]
	local dslot = 1
	local max_dslot = GetContainerNumSlots(dbag)

	for i, v in ipairs (st) do
		v.dbag = dbag
		v.dslot = dslot
		v.dstSlot = self:SlotNew(dbag, dslot)

		dslot = dslot + 1

		if dslot > max_dslot then
			dslot = 1

			while true do
				st_idx = st_idx + 1

				if st_idx > #bs then
					break
				end

				dbag = bs[st_idx]

				if Stuffing:BagType(dbag) == ST_NORMAL or dbag > 4 then
					break
				end
			end

			max_dslot = GetContainerNumSlots(dbag)
		end
	end

	-- throw various stuff out of the search list
	local changed = true
	while changed do
		changed = false
		-- XXX why doesn't this remove all x->x moves in one pass?

		for i, v in ipairs (st) do

			-- source is same as destination
			if (v.sslot == v.dslot) and (v.sbag == v.dbag) then
				table.remove (st, i)
				changed = true
			end
		end
	end

	-- kick off moving of stuff, if needed.
	if st == nil or next(st, nil) == nil then
		Print(L["Sorting finished."])
		self:SetScript("OnUpdate", nil)
	else
		self.sortList = st
		self:SetScript("OnUpdate", Stuffing.SortOnUpdate)
	end
end


function Stuffing:RestackOnUpdate(e)
	if not self.elapsed then
		self.elapsed = 0
	end

	self.elapsed = self.elapsed + e

	if self.elapsed < 0.1 then
		return
	end

	self.elapsed = 0
	self:Restack()
end


function Stuffing:Restack()
	local st = {}

	Stuffing_Open()

	for i, v in pairs(self.buttons) do
		if InBags(v.bag) then
			local tex, cnt, _, _, _, _, clink = GetContainerItemInfo(v.bag, v.slot)
			if clink then
				local n, _, _, _, _, _, _, s = GetItemInfo(clink)

				if cnt ~= s then
					if not st[n] then
						st[n] = {{
							item = v,
							size = cnt,
							max = s
						}}
					else
						table.insert(st[n], {
							item = v,
							size = cnt,
							max = s
						})
					end
				end
			end
		end
	end

	local did_restack = false

	for i, v in pairs(st) do
		if #v > 1 then
			for j = 2, #v, 2 do
				local a, b = v[j - 1], v[j]
				local _, _, l1 = GetContainerItemInfo(a.item.bag, a.item.slot)
				local _, _, l2 = GetContainerItemInfo(b.item.bag, b.item.slot)

				if l1 or l2 then
					did_restack = true
				else
					PickupContainerItem (a.item.bag, a.item.slot)
					PickupContainerItem (b.item.bag, b.item.slot)
					did_restack = true
				end
			end
		end
	end

	if did_restack then
		self:SetScript("OnUpdate", Stuffing.RestackOnUpdate)
	else
		self:SetScript("OnUpdate", nil)
		Print (names.rest_st)
	end
end

function Stuffing.Menu(self, level)
	if not level then
		return
	end

	local info = self.info

	wipe(info)

	if level ~= 1 then
		return
	end

	wipe(info)
	info.text = "Sort"
	info.notCheckable = 1
	info.func = function()
		Stuffing_Sort("d")
	end
	UIDropDownMenu_AddButton(info, level)

	wipe(info)
	info.text = "Stack"
	info.notCheckable = 1
	info.func = function()
		Stuffing:SetBagsForSorting("d")
		Stuffing:Restack()
	end
	UIDropDownMenu_AddButton(info, level)

	wipe(info)
	info.text = "Show Bags"
	info.checked = function()
		return bag_bars == 1
	end

	info.func = function()
		if bag_bars == 1 then
			bag_bars = 0
		else
			bag_bars = 1
		end
		Stuffing:Layout()
		if Stuffing.bankFrame and Stuffing.bankFrame:IsShown() then
			Stuffing:Layout(true)
		end

	end
	UIDropDownMenu_AddButton(info, level)
	
	wipe(info)
	info.text = "Show Keyring"
	info.notCheckable = 1
	info.func = ToggleKeyRing
	UIDropDownMenu_AddButton(info, level)

	wipe(info)
	info.disabled = nil
	info.notCheckable = 1
	info.text = CLOSE
	info.func = self.HideMenu
	info.tooltipTitle = CLOSE
	UIDropDownMenu_AddButton(info, level)
end


	Stuffing:SetScript("OnEvent", function(this, event, ...)
		Stuffing[event](this, ...)
	end)

	Stuffing:RegisterEvent("BAG_UPDATE")
	Stuffing:RegisterEvent("ITEM_LOCK_CHANGED")

	Stuffing:RegisterEvent("BANKFRAME_OPENED")
	Stuffing:RegisterEvent("BANKFRAME_CLOSED")
	Stuffing:RegisterEvent("PLAYERBANKSLOTS_CHANGED")

	Stuffing:RegisterEvent("BAG_CLOSED")

	SlashCmdList["STUFFING"] = StuffingSlashCmd
	SLASH_STUFFING1 = "/bags"

	Stuffing:InitBags()

	tinsert(UISpecialFrames,"StuffingFrameBags")

	--
	-- hook functions
	--
	ToggleBackpack = Stuffing_Toggle
	ToggleBag = Stuffing_ToggleBag
	OpenAllBags = Stuffing_Open --Stuffing_Open
	ToggleAllBags = Stuffing_Toggle
	OpenBackpack = Stuffing_Open
	CloseAllBags = Stuffing_Close
	CloseBackpack = Stuffing_Close

	BankFrame:UnregisterAllEvents()