if SuperSet.load.sct_enabled ~= true then return end
if SuperSet.load.xct_style == true then return end
local _, Internals = ...; 

-- **** imports ****
local CombatTextFrame = Internals.CombatTextFrame;
local MiniCombatTextFrame = Internals.MiniCombatTextFrame;

-- color printer
local pr = function(msg)
    print("|cffFF0000SVUI|r Supervillain:", tostring(msg))
end
KCoreText = {}
-- the frames
SVLock.kcore=true
local sizewide = SuperSet.SizeMe
KCoreText.frames = {}
for i=1,3 do
	local f=CreateFrame("Frame","SVText"..i,UIParent)
	f:SetPoint("CENTER",0,0)
	f:SetMovable(true)
	f:SetResizable(true)
	f:SetUserPlaced(true)
	f:SetMinResize(100,100)
	f:SetMaxResize(600,600)
	f:SetClampedToScreen(true)
	f:SetClampRectInsets(0,16,16,0)
	if(i==1)then
		f:SetWidth(SuperText.positions.one.width)
		f:SetHeight(SuperText.positions.one.height)
		f:SetPoint("CENTER",-192,-32)
	elseif(i==2)then
		f:SetWidth(SuperText.positions.two.width)
		f:SetHeight(SuperText.positions.two.height)
		f:SetPoint("CENTER",192,-32)
	else
		f:SetWidth(SuperText.positions.three.width)
		f:SetHeight(SuperText.positions.three.height)
		f:SetPoint("CENTER",320,0)
	end
	KCoreText.frames[i] = f
end

-- **** main ****

local highlightFrame = CombatTextFrame( "player" );
highlightFrame:SetAllPoints(SVText3);
highlightFrame:SetSpeed( 95 );
highlightFrame:SetMaxSize( 32 );
highlightFrame:DisableDamage();
highlightFrame:DisableHealing();
highlightFrame:EnableCombat();
highlightFrame:EnableDispels();

-- player
local playerFrame = CombatTextFrame( "player" );
playerFrame:SetParent( UIParent );
playerFrame:SetSpeed( 95 );
playerFrame:SetAllPoints(SVText1);

-- target
local targetFrame = CombatTextFrame( "target" );
targetFrame:SetParent( UIParent );
targetFrame:SetSpeed( 95 );
targetFrame:SetAllPoints(SVText2);
targetFrame:SetDamageSourceUnit( "player" );

-- awesome configmode and testmode
local StartConfigmode=function()
	if not InCombatLockdown()then
		for i=1,#KCoreText.frames do
			local f = KCoreText.frames[i]
			f:SetBackdrop({
				bgFile="Interface/Tooltips/UI-Tooltip-Background",
				edgeFile="Interface/Tooltips/UI-Tooltip-Border",
				tile=false,tileSize=0,edgeSize=2,
				insets={left=0,right=0,top=0,bottom=0}})
			f:SetBackdropColor(.1,.1,.1,.8)
			f:SetBackdropBorderColor(.1,.1,.1,.5)

			f.fs=f:CreateFontString(nil,"OVERLAY")
			f.fs:SetFont(SVFonts.font,14,"OUTLINE")
			f.fs:SetPoint("BOTTOM",f,"BOTTOM",0,-4)
			if(i==1)then
				f.fs:SetText("Player Text")
				f.fs:SetTextColor(.1,1,.1,.9)
			elseif(i==2)then
				f.fs:SetText("Target Text")
				f.fs:SetTextColor(1,.1,.1,.9)
			else
				f.fs:SetText("Announcements")
				f.fs:SetTextColor(1,1,0,.9)
			end

			f.t=f:CreateTexture"ARTWORK"
			f.t:SetPoint("BOTTOMLEFT",f,"BOTTOMLEFT",0,0)
			f.t:SetPoint("BOTTOMRIGHT",f,"BOTTOMRIGHT",-11,0)
			f.t:SetHeight(10)
			f.t:SetTexture(.5,.5,.5)
			f.t:SetAlpha(.3)
			
			f.at=f:CreateTexture"ARTWORK"
			f.at:SetPoint("TOPLEFT",f,"TOPLEFT",0,0)
			f.at:SetPoint("BOTTOMRIGHT",f,"BOTTOMRIGHT",-11,11)
			f.at:SetHeight(10)
			f.at:SetTexture(.8,.8,.2)
			f.at:SetAlpha(.8)
			
			f.d=f:CreateTexture"ARTWORK"
			f.d:SetPoint("TOPRIGHT",f,"TOPRIGHT",0,0)
			f.d:SetPoint("BOTTOMRIGHT",f,"BOTTOMRIGHT",0,0)
			f.d:SetWidth(10)
			f.d:SetTexture(.5,.5,.5)
			f.d:SetAlpha(.3)
			
			f.tr=f:CreateTitleRegion()
			f.tr:SetPoint("BOTTOMLEFT",f,"BOTTOMLEFT",0,0)
			f.tr:SetPoint("BOTTOMRIGHT",f,"BOTTOMRIGHT",-11,0)
			f.tr:SetHeight(10)
			
			f:EnableMouse(true)
			f:RegisterForDrag"LeftButton"
			f:SetScript("OnDragStart",f.StartSizing)
			f:SetScript("OnDragStop",f.StopMovingOrSizing)
			SVLock.kcore=false
		end
		pr("unlocked.")
	else
		pr("can't be configured in combat.")
	end
end
SVConfig.StartSCT = StartConfigmode

local function EndConfigmode()
	for i=1,#KCoreText.frames do
		f=KCoreText.frames[i]
		f:SetBackdrop(nil)
		f.fs:Hide()
		f.fs=nil
		f.t:Hide()
		f.t=nil
		f.at:Hide()
		f.at=nil
		f.d:Hide()
		f.d=nil
		f.tr=nil
		f:EnableMouse(false)
		f:SetScript("OnDragStart",nil)
		f:SetScript("OnDragStop",nil)
	end
	SVLock.kcore=true
	pr("Window positions unsaved, don't forget to reload UI.")
end


local function SaveNGo()
	SuperText.positions.one.height = SVText1:GetHeight()
	SuperText.positions.one.width = SVText1:GetWidth()
	SuperText.positions.two.height = SVText2:GetHeight()
	SuperText.positions.two.width = SVText2:GetWidth()
	SuperText.positions.three.height = SVText3:GetHeight()
	SuperText.positions.three.width = SVText3:GetWidth()
	ReloadUI()
end

-- /svctext lock popup dialog
StaticPopupDialogs["SVCTXT_LOCK"]={
	text="To save |cffFF0000SVUI|rKcore window positions you need to reload your UI.\n Click "..ACCEPT.." to reload UI.\nClick "..CANCEL.." to do it later.",
	button1=ACCEPT,
	button2=CANCEL,
	OnAccept=function() if not InCombatLockdown() then SaveNGo() else EndConfigmode() end end,
	OnCancel=EndConfigmode,
	timeout=0,
	whileDead=1,
	hideOnEscape=true,
	showAlert=true,
}
-- slash commands
SLASH_SVCTXT1="/svctext"
SlashCmdList["SVCTXT"]=function(input)
	input=string.lower(input)
	if(input=="unlock")then
		if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
		if (SVLock.kcore)then
			StartConfigmode()
		else
			pr("combat text already unlocked.")
		end
	elseif(input=="lock")then
		if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
		if (SVLock.kcore) then
			pr("combat text already locked.")
		else
			StaticPopup_Show("SVCTXT_LOCK")
		end
	elseif(input=="reset")then
		if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
		SVText1:ClearAllPoints()
		SVText1:SetPoint("CENTER",UIParent, "CENTER", -200, -8)
		SVText1:SetHeight(225)
		SVText1:SetWidth(225)
		SVText2:ClearAllPoints()
		SVText2:SetPoint("CENTER",UIParent, "CENTER", 200, -8)
		SVText2:SetHeight(225)
		SVText2:SetWidth(225)
		SVText3:ClearAllPoints()
		SVText3:SetPoint("TOP",UIParent, "TOP", -2, -34)
		SVText3:SetHeight(225)
		SVText3:SetWidth(225)
		SaveNGo()
	else
		pr("use |cffFF0000/svctext unlock|r to move and resize frames.")
		pr("use |cffFF0000/svctext lock|r to lock frames.")
	end
end