if SuperBar.menu.autobar == false then return end

------------------------------
--      Util Functions      --
------------------------------
local ids, bests, allitems, stuff, dirty = LibStub("evilBuffet"), {}, {}, {}
local TOTAL_AUTO_SLOTS = 11
local Items = {}
local EquipedItems = {
	49278, -- Goblin Rocket Pack (ICC)
--	50356, -- Corroded Skeleton Key (Test)
	39213, -- Massive Seaforium Charge
}

------------------------------
--     Buffet Functions     --
------------------------------
for i,v in pairs(SVConfig["buffet"]) do stuff[i] = v end

local function TableStuffer(...)
	local t = {}
	for i=1,select("#", ...) do
		local id, v = string.split(":", (select(i, ...)))
		if id and id ~= "" then
			t[tonumber(id)] = tonumber(v) or 0
			allitems[tonumber(id)] = tonumber(v) or 0
		end
	end
	return t
end
for i,v in pairs(stuff) do bests[i], stuff[i] = {}, TableStuffer(string.split("\n", v)) end

------------------------------
--      Begin Autobar       --
------------------------------
local function stuffScan()
	if not InCombatLockdown() then 
		for _,t in pairs(bests) do for i in pairs(t) do t[i] = nil end end
		local mylevel = UnitLevel("player")
		Items = {}
		for bag=0,4 do
			for slot=1,GetContainerNumSlots(bag) do
				local link = GetContainerItemLink(bag, slot)
				local id = link and ids[link]
				local reqlvl = link and select(5, GetItemInfo(link)) or 0
				if id and allitems[id] and reqlvl <= mylevel then
					local _, stack = GetContainerItemInfo(bag,slot)
					local ready = false
					for set,setitems in pairs(stuff) do
						local thisbest, val = bests[set], setitems[id]
						if val and (not thisbest.val or (thisbest.val < val or thisbest.val == val and thisbest.stack > stack)) then
							thisbest.id, thisbest.val, thisbest.stack = id, val, stack
						end
					end
				end
			end
		end
		if bests.bandage.id then tinsert(Items,bests.bandage.id) end
		if bests.conjfood.id then tinsert(Items,bests.conjfood.id) end
		if bests.food.id then tinsert(Items,bests.food.id) end
		if bests.water.id then tinsert(Items,bests.water.id) end
		if bests.percfood.id then tinsert(Items,bests.percfood.id) end
		if bests.percwater.id then tinsert(Items,bests.percwater.id) end
		if bests.hstone.id then tinsert(Items,bests.hstone.id) end
		if bests.hppot.id then tinsert(Items,bests.hppot.id) end
		if bests.mstone.id then tinsert(Items,bests.mstone.id) end
		if bests.mppot.id then tinsert(Items,bests.mppot.id) end
		dirty = false
	end
end
------------------------------
--Create Movable Anchor     --
------------------------------
local anchor_move = false 
local icon_size = SVMod.Scale(38)*SuperSet.scaleops.abscale
local anchorW = (((icon_size+6)*5)+12)
local direction = "RIGHT"
local abanchor = CreateFrame("Frame","SVAutoAnchor",UIParent)
	abanchor:SetPoint("TOPLEFT", MapBorder, "BOTTOMLEFT", SVMod.Scale(6), SVMod.Scale(-24))
	abanchor:SetMovable(true)
	abanchor:SetClampedToScreen(true) 
	abanchor:SetWidth(anchorW)
	abanchor:SetHeight((icon_size+12)*2)
	abanchor:SetFrameStrata("BACKGROUND")
	abanchor:SetUserPlaced(true)

local anchorbg = CreateFrame("Frame","SVAutoAnchorBack",abanchor)
	anchorbg:SetFrameLevel(0)
	anchorbg:SetFrameStrata("BACKGROUND")
	anchorbg:SetAllPoints(abanchor)
	SVMod.MentaloBG(anchorbg)
	local mentaloframe = CreateFrame("Frame","SVAutoAnchorMentalo",abanchor)
	mentaloframe:SetSize(128,128)
	mentaloframe:SetPoint("CENTER",anchorbg,"TOPRIGHT")
    mentaloframe:SetAlpha(0)
    mentaloframe:Hide()
	local mentalo = mentaloframe:CreateTexture(nil,"OVERLAY")
	mentalo:SetAllPoints(mentaloframe)
	mentalo:SetTexture(SVMedia.mentalo_hand)
	local anchortxt = anchorbg:CreateFontString(nil,"OVERLAY")
	anchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	anchortxt:SetText("Autobuttons Anchor")
	anchortxt:SetPoint("TOP",anchorbg,0,-22)
	anchorbg:SetAlpha(0)
	abanchor:SetScript("OnEnter",function()
			if mentaloframe:IsShown() then
				anchorbg:SetBackdropColor(0.5,0.8,1,0.5)
				UIFrameFadeIn(mentaloframe, 0.3, 0, 1)
				SVMod.MentaloPEWPEW()
			end
		end)
	abanchor:SetScript("OnLeave",function()
			if mentaloframe:IsShown() then
				anchorbg:SetBackdropColor(0.5,0.8,1,0.15)
				UIFrameFadeOut(mentaloframe, 0.3, 1, 0)
				SVMod.MentaloIDLE()
			end
		end)
------------------------------
--Show/Hide Functions       --
------------------------------
local function VendingMachineHide(button)
	button:SetAlpha(0)
	if not InCombatLockdown() then
		button:EnableMouse(false)
	else
		button:RegisterEvent("PLAYER_REGEN_ENABLED")
		button:SetScript("OnEvent", function(self, event)
			if event == "PLAYER_REGEN_ENABLED" then
				button:EnableMouse(false)
				button:UnregisterEvent("PLAYER_REGEN_ENABLED")
			end
		end)
	end
end
local function VendingMachineHideAll()
	for i=1, TOTAL_AUTO_SLOTS do
		local button = _G["VillainVendingMachine"..i]
		button:SetAlpha(0)
		if not InCombatLockdown() then
			button:EnableMouse(false)
		else
			button:RegisterEvent("PLAYER_REGEN_ENABLED")
			button:SetScript("OnEvent", function(self, event)
				if event == "PLAYER_REGEN_ENABLED" then
					button:EnableMouse(false)
					button:UnregisterEvent("PLAYER_REGEN_ENABLED")
				end
			end)
		end
	end
end
local function VendingMachineShow(button,item)
	button:SetAlpha(1)
	if not InCombatLockdown() then
		button:EnableMouse(true)
		if item then
			button:SetAttribute("item", item)
		end
	else
		button:RegisterEvent("PLAYER_REGEN_ENABLED")
		button:SetScript("OnEvent", function(self, event)
			if event == "PLAYER_REGEN_ENABLED" then
				button:EnableMouse(true)
				if item then
					button:SetAttribute("item", item)
				end
				button:UnregisterEvent("PLAYER_REGEN_ENABLED")
			end
		end)
	end
end

--Create our Buttons
for i=1, TOTAL_AUTO_SLOTS do
	local vending = CreateFrame("Button", "VillainVendingMachine"..i, UIParent, "SecureActionButtonTemplate")
	vending:SetWidth(SVMod.Scale(32)*SuperSet.scaleops.abscale)
	vending:SetHeight(SVMod.Scale(32)*SuperSet.scaleops.abscale)
	if (i == 1) then
		vending:SetPoint("TOPLEFT", SVAutoAnchor, "TOPLEFT", SVMod.Scale(4), SVMod.Scale(-14))
	elseif (i == 6) then
		local FIRST_VMB = _G["VillainVendingMachine"..i-5]
		vending:SetPoint("TOP", FIRST_VMB, "BOTTOM", 0, SVMod.Scale(6))
	else
		local LAST_VMB = _G["VillainVendingMachine"..i-1]
		vending:SetPoint("LEFT", LAST_VMB, "RIGHT", SVMod.Scale(6), 0)
	end
	SVMod.AddonSkin(vending,nil,nil,2)
	SVMod.StyleButton(vending,false)
	vending:SetAttribute("type", "item")
	VendingMachineHide(vending)
	vending.t = vending:CreateTexture(nil,"OVERLAY",nil)
	vending.t:SetPoint("TOPLEFT", vending, "TOPLEFT", SVMod.Scale(2), SVMod.Scale(-2))
	vending.t:SetPoint("BOTTOMRIGHT", vending, "BOTTOMRIGHT", SVMod.Scale(-3), SVMod.Scale(2))
	vending.t:SetTexCoord(0.1, 0.9, 0.1, 0.9)
	vending.t:SetTexture[[Interface\Icons\INV_Misc_Food_153_Doughnut]]
	vending.c = vending:CreateFontString(nil,"OVERLAY",f)
	vending.c:SetFont(SVFonts.numbers,10,"THINOUTLINE")
	vending.c:SetTextColor(0.8, 0.8, 0.8, 1)
	vending.c:SetPoint("BOTTOMRIGHT", SVMod.Scale(4), SVMod.Scale(-2))
	vending.c:SetJustifyH("CENTER")	
	vending.Cooldown = CreateFrame("Cooldown",nil,vending)
	vending.Cooldown:SetPoint("TOPLEFT", vending, "TOPLEFT", SVMod.Scale(2), SVMod.Scale(-2))
	vending.Cooldown:SetPoint("BOTTOMRIGHT", vending, "BOTTOMRIGHT", SVMod.Scale(-2), SVMod.Scale(2))	
end

local Scanner = CreateFrame("Frame")
Scanner:RegisterEvent("PLAYER_LOGIN")
Scanner:RegisterEvent("BAG_UPDATE")
Scanner:RegisterEvent("UNIT_INVENTORY_CHANGED")
Scanner:SetScript("OnEvent", function()
	VendingMachineHideAll()
	--Scan bags for Item matchs
	stuffScan()
	local CURRENT_AUTO_SLOT = 1
	for b = 0, NUM_BAG_SLOTS do
		for s = 1, GetContainerNumSlots(b) do
			local itemID = GetContainerItemID(b, s)
			itemID = tonumber(itemID)
			for i, Items in pairs(Items) do
				local VMButton = _G["VillainVendingMachine"..i]
				if (itemID == Items) and VMButton then
					local itemName, _, _, _, _, _, _, _, _, _, _ = GetItemInfo(itemID)
					local count = GetItemCount(itemID)
					local itemIcon = GetItemIcon(itemID)

					--Set our texture to the item found in bags
					VMButton.t:SetTexture(itemIcon)

					--Get the count if there is one
					if count and count ~= 1 then
						VMButton.c:SetText(count)
					else
						VMButton.c:SetText("")
					end

					VMButton:SetScript("OnUpdate", function(self, elapsed)
						local cd_start, cd_finish, cd_enable = GetContainerItemCooldown(b, s)
						CooldownFrame_SetTimer(VMButton.Cooldown, cd_start, cd_finish, cd_enable)
					end)
					VendingMachineShow(VMButton,itemName)
					CURRENT_AUTO_SLOT = CURRENT_AUTO_SLOT + 1
				end
			end
		end
	end

	--Scan inventory for Equipment matches
	for w = 1, 19 do
		for e, EquipedItems in pairs(EquipedItems) do
			local VMEQButton = _G["VillainVendingMachine"..CURRENT_AUTO_SLOT]
			if GetInventoryItemID("player", w) == EquipedItems then
				local itemName, _, _, _, _, _, _, _, _, _, _ = GetItemInfo(EquipedItems)
				local itemIcon = GetInventoryItemTexture("player",w)
				--Set our texture to the item found in bags
				VMEQButton.t:SetTexture(itemIcon)
				VMEQButton.c:SetText("")

				VMEQButton:SetScript("OnUpdate", function(self, elapsed)
					local cd_start, cd_finish, cd_enable = GetInventoryItemCooldown("player",w)
					CooldownFrame_SetTimer(VMEQButton.Cooldown, cd_start, cd_finish, cd_enable)
				end)
				VendingMachineShow(VMEQButton,itemName)
			end
		end
	end
end)
local function MOVESVAUTO()
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if anchor_move == false then
		anchor_move = true
		SVAutoAnchorMentalo:Show()
		UIFrameFadeIn(SVAutoAnchorBack, 0.5, 0, 1)
		print(LEVEL_UP_FEATURE)
		SVAutoAnchor:SetFrameStrata("DIALOG")
		SVAutoAnchor:EnableMouse(true);
		SVAutoAnchor:RegisterForDrag("LeftButton"); 
		SVAutoAnchor:SetScript("OnDragStart", SVAutoAnchor.StartMoving); 
		SVAutoAnchor:SetScript("OnDragStop", SVAutoAnchor.StopMovingOrSizing);
	elseif anchor_move == true then
		SVAutoAnchor:SetFrameStrata("BACKGROUND")
		SVAutoAnchor:EnableMouse(false);
		anchor_move = false
		SVAutoAnchorMentalo:Hide()
		UIFrameFadeOut(SVAutoAnchorBack, 0.5, 1, 0)
		print(LOCKED)
	end
end

SLASH_MOVESVAUTO1 = "/svautobar"
SlashCmdList["MOVESVAUTO"] = MOVESVAUTO

local function RESETSVAUTO()
	SVAutoAnchor:ClearAllPoints()
	SVAutoAnchor:SetPoint("TOPLEFT", MapBorder, "BOTTOMLEFT", SVMod.Scale(6), SVMod.Scale(-24))
end

SLASH_RESETSVAUTO1 = "/rsvauto"
SlashCmdList["RESETSVAUTO"] = RESETSVAUTO