local function InstallMyChats()					
		FCF_ResetChatWindows()
		FCF_SetLocked(ChatFrame1, 1)
		FCF_DockFrame(ChatFrame2)
		FCF_SetLocked(ChatFrame2, 1)
		FCF_OpenNewWindow("Whispers")
		FCF_SetLocked(ChatFrame3, 1)
		FCF_DockFrame(ChatFrame3)
		
		if (Quokkas_Options.lootchat == true) then
			FCF_OpenNewWindow("Loot")
			FCF_UnDockFrame(ChatFrame4)
			FCF_SetLocked(ChatFrame4, 1)
			ChatFrame4:Show();
		else
			FCF_OpenNewWindow("Loot")
			FCF_SetLocked(ChatFrame4, 1)
			FCF_DockFrame(ChatFrame4)
		end

		for i = 1, NUM_CHAT_WINDOWS do
			local frame = _G[format("ChatFrame%s", i)]
			local chatFrameId = frame:GetID()
			local chatName = FCF_GetChatWindowInfo(chatFrameId)
			
			frame:SetSize(SVMod.Scale(278)*SuperSet.scaleops.chatscale, SVMod.Scale(128))
			
			-- this is the default width and height of Mung chats.
			SetChatWindowSavedDimensions(chatFrameId, SVMod.Scale(278)*SuperSet.scaleops.chatscale, SVMod.Scale(128))
			
			-- move general bottom left or Loot (if found) on right.
			if i == 1 then
				frame:ClearAllPoints()
				frame:SetPoint("TOPLEFT", SuperLeftChat, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(-8))
				frame:SetPoint("BOTTOMRIGHT", SuperLeftChat, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(8))
			elseif (i == 4) and (name == "Loot") and (Quokkas_Options.lootchat == true) then
				if not chat.isDocked then
					frame:ClearAllPoints()
					frame:SetPoint("TOPLEFT", SuperDock1, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(-8))
					frame:SetPoint("BOTTOMRIGHT", SuperDock1, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(8))
				end 
			end
					
			-- save new default position and dimension
			FCF_SavePositionAndDimensions(frame)
			
			-- set default Mung font size
			FCF_SetChatWindowFontSize(nil, frame, 12)
			
			-- rename windows general and combat log
			if i == 1 then FCF_SetWindowName(frame, "Main") end
			if i == 2 then FCF_SetWindowName(frame, "Log") end
		end
		
		ChatFrame_RemoveAllMessageGroups(ChatFrame1)
		ChatFrame_AddChannel(ChatFrame1, "Trade")
		ChatFrame_AddChannel(ChatFrame1, "General")
		ChatFrame_RemoveChannel(ChatFrame1, "LocalDefense")
		ChatFrame_RemoveChannel(ChatFrame1, "GuildRecruitment")
		ChatFrame_AddChannel(ChatFrame1, "LookingForGroup")
		ChatFrame_AddMessageGroup(ChatFrame1, "SAY")
		ChatFrame_AddMessageGroup(ChatFrame1, "EMOTE")
		ChatFrame_AddMessageGroup(ChatFrame1, "YELL")
		ChatFrame_AddMessageGroup(ChatFrame1, "GUILD")
		ChatFrame_AddMessageGroup(ChatFrame1, "OFFICER")
		ChatFrame_AddMessageGroup(ChatFrame1, "GUILD_ACHIEVEMENT")
		ChatFrame_AddMessageGroup(ChatFrame1, "WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_SAY")
		ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_EMOTE")
		ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_YELL")
		ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_BOSS_EMOTE")
		ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_BOSS_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame1, "PARTY")
		ChatFrame_AddMessageGroup(ChatFrame1, "PARTY_LEADER")
		ChatFrame_AddMessageGroup(ChatFrame1, "RAID")
		ChatFrame_AddMessageGroup(ChatFrame1, "RAID_LEADER")
		ChatFrame_AddMessageGroup(ChatFrame1, "RAID_WARNING")
		ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND")
		ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND_LEADER")
		ChatFrame_AddMessageGroup(ChatFrame1, "BG_HORDE")
		ChatFrame_AddMessageGroup(ChatFrame1, "BG_ALLIANCE")
		ChatFrame_AddMessageGroup(ChatFrame1, "BG_NEUTRAL")
		ChatFrame_AddMessageGroup(ChatFrame1, "SYSTEM")
		ChatFrame_AddMessageGroup(ChatFrame1, "ERRORS")
		ChatFrame_AddMessageGroup(ChatFrame1, "AFK")
		ChatFrame_AddMessageGroup(ChatFrame1, "DND")
		ChatFrame_AddMessageGroup(ChatFrame1, "IGNORED")
		ChatFrame_AddMessageGroup(ChatFrame1, "ACHIEVEMENT")
		ChatFrame_AddMessageGroup(ChatFrame1, "BN_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame1, "BN_CONVERSATION")
					
		-- Setup the spam chat frame
		ChatFrame_RemoveAllMessageGroups(ChatFrame3)
		ChatFrame_AddMessageGroup(ChatFrame3, "WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame3, "BN_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame3, "BN_CONVERSATION")

		-- Setup the loot tab
		ChatFrame_RemoveAllMessageGroups(ChatFrame4);
		ChatFrame_AddMessageGroup(ChatFrame4, "COMBAT_XP_GAIN")
		ChatFrame_AddMessageGroup(ChatFrame4, "GUILD_XP_GAIN")
		ChatFrame_AddMessageGroup(ChatFrame4, "COMBAT_HONOR_GAIN")
		ChatFrame_AddMessageGroup(ChatFrame4, "COMBAT_FACTION_CHANGE")
		ChatFrame_AddMessageGroup(ChatFrame4, "LOOT")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONEY")
		ChatFrame_AddMessageGroup(ChatFrame4, "SKILL")
				
		-- enable classcolor automatically on login and on each character without doing /configure each time.
		ToggleChatColorNamesByClassGroup(true, "SAY")
		ToggleChatColorNamesByClassGroup(true, "EMOTE")
		ToggleChatColorNamesByClassGroup(true, "YELL")
		ToggleChatColorNamesByClassGroup(true, "GUILD")
		ToggleChatColorNamesByClassGroup(true, "OFFICER")
		ToggleChatColorNamesByClassGroup(true, "GUILD_ACHIEVEMENT")
		ToggleChatColorNamesByClassGroup(true, "ACHIEVEMENT")
		ToggleChatColorNamesByClassGroup(true, "WHISPER")
		ToggleChatColorNamesByClassGroup(true, "PARTY")
		ToggleChatColorNamesByClassGroup(true, "PARTY_LEADER")
		ToggleChatColorNamesByClassGroup(true, "RAID")
		ToggleChatColorNamesByClassGroup(true, "RAID_LEADER")
		ToggleChatColorNamesByClassGroup(true, "RAID_WARNING")
		ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND")
		ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND_LEADER")	
		ToggleChatColorNamesByClassGroup(true, "CHANNEL1")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL2")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL3")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL4")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL5")
		
		if IsAddOnLoaded("DBM-Core") then
			SVMod.RunSlash("/dbmskin apply")
		else
			ReloadUI()
		end
end
SVMod.InstallMyChats = InstallMyChats

local function rldisui()
	ReloadUI()
end
local function resetbarz()
	SVMod.RunSlash("/rss")
	SVMod.RunSlash("/rpb")
	SVMod.RunSlash("/rmm")
	SVMod.RunSlash("/rabars")
	SVMod.RunSlash("/ranchors")
	SVMod.RunSlash("/rsvauto")
end
local function reset_some_barz()
	SVMod.RunSlash("/rss")
	SVMod.RunSlash("/rpb")
	SVMod.RunSlash("/rmm")
	SVMod.RunSlash("/ranchors")
	SVMod.RunSlash("/rsvauto")
end
local function ResetMyProfile()
	SVUISet = {}
	SVUIBar = {}
	SVUIStat = {}
	SVUIAuraBars = {}
	SVUIText = {}
	SuperFramePosition = {}
	MasterPlan = SVRoot.version
	SVMod.InstallMyChats()
end
local function InstallMyProfile()
	resetbarz()
	SuperFramePosition = {}
	MasterPlan = SVRoot.version
	SVMod.InstallMyChats()
end
local function UpdateMyProfile()
	reset_some_barz()
	MasterPlan = SVRoot.version
	rldisui()
end
------------------------------------------------------------------------
--	INSTALLER POPUPS
------------------------------------------------------------------------
StaticPopupDialogs["INSTALL_UI"] = {
	text = "I need to update Supervillain UI. This shouldn't hurt.... much.",
	button1 = ACCEPT,
	button2 = CANCEL,
    OnAccept = InstallMyProfile,
    timeout = 0,
    whileDead = 1,
}	
SLASH_INSTALLSVUI1 = "/gogosvui"
SlashCmdList["INSTALLSVUI"] = function() StaticPopup_Show("INSTALL_UI") end	

StaticPopupDialogs["RESET_UI"] = {
	text = "Would you like to reset ALL of your customization changes? WARNING: This cannot be undone.",
	button1 = ACCEPT,
	button2 = CANCEL,
    OnAccept = ResetMyProfile,
    timeout = 0,
    whileDead = 1,
}	
SLASH_RESETSVUI1 = "/resetsvui"
SlashCmdList["RESETSVUI"] = function() StaticPopup_Show("RESET_UI") end	

StaticPopupDialogs["UPDATE_UI"] = {
	text = "I see you have a newer version of SVUI installed! We need to update your settings for it to work.",
	button1 = ACCEPT,
	button2 = CANCEL,
    OnAccept = UpdateMyProfile,
    timeout = 0,
    whileDead = 1,
}	
SLASH_UPDATESVUI1 = "/updatesvui"
SlashCmdList["UPDATESVUI"] = function() StaticPopup_Show("UPDATE_UI") end
------------------------------------------------------------------------
--	CONFIG MENUS
------------------------------------------------------------------------
--  LAYOUT  --------
SlashCmdList.SVUFSET = function()
	local lost = "Unit Frame Layout."
	local frame = SVMod.make_settings(nil,nil,122,260,"FRAME LAYOUT OPTIONS",true,lost)
	local layouttable = {"Super","Simple","Minimal"}	
	local description = {"Unique frame styles\n focusing on unit\n portraits and very\n colorful.",
						 "Basic frames including\n portraits similar\n to most common\n layouts.",
						 "Very minimalistic\n frames that don't\n use portraits slim\n and functional."}
						 
	local laystate = frame:CreateFontString(nil,"OVERLAY")
	laystate:SetFont(SVFonts.super,24,"OUTLINE")
	laystate:SetPoint("CENTER",0,45)
	laystate:SetText(layouttable[SuperSet.uf_layout])
	laystate:SetJustifyH("LEFT")
	laystate:SetTextColor(1,1,0.2)
	laystate:SetShadowOffset(-4,-2.5)
	laystate:SetShadowColor(1,0.2,0.1)
	
	local namestate = frame:CreateFontString(nil,"OVERLAY")
	namestate:SetFont(SVFonts.font,16,"OUTLINE")
	namestate:SetPoint("CENTER",0,-20)
	namestate:SetText(description[SuperSet.uf_layout])
	namestate:SetJustifyH("CENTER")
	namestate:SetShadowOffset(1,-1)
	
	local abset = function (val)
		SuperSet.uf_layout = val
	end
	
	local swt = function(change,abc)
		local tem = (SuperSet.uf_layout) + change
		local abc = abc or tem
		if abc == 0 then abc = 3
		elseif abc == 4 then abc = 1
		end
		laystate:SetText(layouttable[abc])
		namestate:SetText(description[abc])
		abset(abc)
	end

	local crbutton = function(parent,t,change,x,y)
		local f = CreateFrame("Frame",nil,parent)
		f:SetSize(40,40)
		f:EnableMouse(true)
		local text = f:CreateFontString(nil,"OVERLAY")
		text:SetAllPoints()
		text:SetFont(SVFonts.font,34,"THICKOUTLINE")
		text:SetText(t)
		text:SetShadowOffset(-4,-2.5)
		text:SetShadowColor(1,0.2,0.1)
		f:SetPoint("CENTER",x,y)
		f:SetScript("OnEnter",function() text:SetTextColor(1,.3,.3) end)
		f:SetScript("OnLeave",function() text:SetTextColor(1,1,1) end)
		f:SetScript("OnMouseDown",function() swt(change) end)
	end
		
	local bleft = crbutton(frame,"<",-1,-90,45)
	local bright = crbutton(frame,">",1,90,45)
	frame:Show()
	SlashCmdList.SVUFSET = function() frame:Show() end
end
SLASH_SVUFSET1 = "/svlayout"
------------------------------------------------------------------------
--	COLOR THEME  ---------
SlashCmdList.SVCOLORZ = function()
	local colst = "Choose your theme."
	local frame = SVMod.make_settings(nil,nil,122,260,"COLOR THEMES",true,colst)
	local layouttable = {"Stan Lee","Neil Gaiman","Frank Miller"}	
	local description = {"Bright colors inspired\n by superhero comics.",
						 "Medium colors inspired\n by artistic comics.",
						 "Dark colors inspired\n by noir styled\n comic books."}
						 
	local laystate = frame:CreateFontString(nil,"OVERLAY")
	laystate:SetFont(SVFonts.super,24,"OUTLINE")
	laystate:SetPoint("CENTER",0,45)
	laystate:SetText(layouttable[SuperSet.colortheme])
	laystate:SetJustifyH("LEFT")
	laystate:SetTextColor(1,1,0.2)
	laystate:SetShadowOffset(-4,-2.5)
	laystate:SetShadowColor(1,0.2,0.1)
	
	local namestate = frame:CreateFontString(nil,"OVERLAY")
	namestate:SetFont(SVFonts.font,16,"OUTLINE")
	namestate:SetPoint("CENTER",0,-20)
	namestate:SetText(description[SuperSet.colortheme])
	namestate:SetJustifyH("CENTER")
	namestate:SetShadowOffset(1,-1)
	
	local abset = function (val)
		SuperSet.colortheme = val
	end
	
	local swt = function(change,abc)
		local tem = (SuperSet.colortheme) + change
		local abc = abc or tem
		if abc == 0 then abc = 3
		elseif abc == 4 then abc = 1
		end
		laystate:SetText(layouttable[abc])
		namestate:SetText(description[abc])
		abset(abc)
	end

	local crbutton = function(parent,t,change,x,y)
		local f = CreateFrame("Frame",nil,parent)
		f:SetSize(40,40)
		f:EnableMouse(true)
		local text = f:CreateFontString(nil,"OVERLAY")
		text:SetAllPoints()
		text:SetFont(SVFonts.font,34,"THICKOUTLINE")
		text:SetText(t)
		text:SetShadowOffset(-4,-2.5)
		text:SetShadowColor(1,0.2,0.1)
		f:SetPoint("CENTER",x,y)
		f:SetScript("OnEnter",function() text:SetTextColor(1,.3,.3) end)
		f:SetScript("OnLeave",function() text:SetTextColor(1,1,1) end)
		f:SetScript("OnMouseDown",function() swt(change) end)
	end
		
	local bleft = crbutton(frame,"<",-1,-90,45)
	local bright = crbutton(frame,">",1,90,45)
	frame:Show()
	SlashCmdList.SVCOLORZ = function() frame:Show() end
end
SLASH_SVCOLORZ1 = "/svcolors"
------------------------------------------------------------------------
--  AURABARS  --------
SlashCmdList.SVAURABAR = function()
	local bst = {
		["enabled"] = "Enable AuraBars",
	}
	
	local bstd = "Bar Styled Auras."
	local frame = SVMod.make_settings(bst,SuperSet.aurabars,122,260,"AURA BAR OPTIONS",true,bstd)
	local layouttable = {"1","2","3","4"}	
	local description = {"Both player and target\n auras in one frame\n right above playerframe.",
						 "Player and target auras\n separated into two frames\n above playerframe.",
						 "Player, target and proc\n auras separated into three\n frames above playerframe.",
						 "Player and proc auras are\n shown above playerframe\n and target auras\n are shown above targetframe."}
						 
	local laystate = frame:CreateFontString(nil,"OVERLAY")
	laystate:SetFont(SVFonts.super,24,"OUTLINE")
	laystate:SetPoint("CENTER",0,55)
	laystate:SetText(layouttable[SuperSet.abars_layout])
	laystate:SetJustifyH("LEFT")
	laystate:SetTextColor(1,1,0.2)
	laystate:SetShadowOffset(-4,-2.5)
	laystate:SetShadowColor(1,0.2,0.1)
	
	local namestate = frame:CreateFontString(nil,"OVERLAY")
	namestate:SetFont(SVFonts.font,16,"OUTLINE")
	namestate:SetPoint("CENTER",0,-10)
	namestate:SetText(description[SuperSet.abars_layout])
	namestate:SetJustifyH("CENTER")
	namestate:SetShadowOffset(1,-1)
	
	local abset = function (val)
		SuperSet.abars_layout = val
	end
	
	local swt = function(change,abc)
		local tem = (SuperSet.abars_layout) + change
		local abc = abc or tem
		if abc == 0 then abc = 4
		elseif abc == 5 then abc = 1
		end
		laystate:SetText(layouttable[abc])
		namestate:SetText(description[abc])
		abset(abc)
	end

	local crbutton = function(parent,t,change,x,y)
		local f = CreateFrame("Frame",nil,parent)
		f:SetSize(40,40)
		f:EnableMouse(true)
		local text = f:CreateFontString(nil,"OVERLAY")
		text:SetAllPoints()
		text:SetFont(SVFonts.font,34,"THICKOUTLINE")
		text:SetText(t)
		text:SetShadowOffset(-4,-2.5)
		text:SetShadowColor(1,0.2,0.1)
		f:SetPoint("CENTER",x,y)
		f:SetScript("OnEnter",function() text:SetTextColor(1,.3,.3) end)
		f:SetScript("OnLeave",function() text:SetTextColor(1,1,1) end)
		f:SetScript("OnMouseDown",function() swt(change) end)
	end
		
	local bleft = crbutton(frame,"<",-1,-90,55)
	local bright = crbutton(frame,">",1,90,55)
	frame:Show()
	SlashCmdList.SVAURABAR = function() frame:Show() end
end
SLASH_SVAURABAR1 = "/svaurabars"
------------------------------------------------------------------------
--  AURABAR SPELLS  --------
SlashCmdList.SVAURAZ = function()
	local sabt1 = {
	[1] = PLAYER..BUFFOPTIONS_LABEL,
	[2] = TARGET..BUFFOPTIONS_LABEL,
	[3] = TRINKET0SLOT,
	}
	local sabt2 = {
	[1] = "player",
	[2] = "target",
	[3] = "procs",
	}
	local sabd = "Add or remove aura bars."
	local frame = SVMod.make_selector(3,sabt1,sabt2,SVUIAuraBars,0,300,"SUPERVILLAIN AURAS MENU",true,sabd)
	frame:Show()
	SlashCmdList.SVAURAZ1 = function() frame:Show() end
end

SLASH_SVAURAZ1 = "/svauras"
------------------------------------------------------------------------
--	UI HELP
------------------------------------------------------------------------

-- Print Help Messages
local function UIHelp()
	print(" ")
	print("No one can help you...")
	print("...but since you asked.")
	print("type /resetsvui to reset SVUI settings")
	print("type /svmovemm to move your mainmenu bar")
	print("type /rmm to reset your mainmenu bar position to default")
	print("type /mpb to move your pet actionbar")
	print("type /rpb to reset your pet actionbar position to default")
	print("type /mss to move your shapeshift bar")
	print("type /rss to reset your shapeshift bar position to default")
	print("type /movesvuf to move unitframes")
	print("type /resetsvuf to reset moved frames")
	print("type /wf to move quest watch")
	print("type /wft to hide quest watch")
	print("type /rd to quickly disband a group")
	print("type /xCT for combat text help")
	print("type /gquit because it would be hilarious")
	print(" ")
end

SLASH_UIHELP1 = "/svuihelp"
SlashCmdList["UIHELP"] = UIHelp

------------------------------------------------------------------------
--	CHECK VERSION
------------------------------------------------------------------------
local SVUIOnLogon = CreateFrame("Frame")
SVUIOnLogon:RegisterEvent("PLAYER_ENTERING_WORLD")
SVUIOnLogon:SetScript("OnEvent", function(self, event)
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	if MasterPlan then
		if MasterPlan ~= SVRoot.version then
			StaticPopup_Show("UPDATE_UI")
			print("Supervillain UI too OLD!")
			print("Time to Update!")
		else
			print("Supervillain UI Loaded!")
			print("Type /svuihelp for a list of commands.")
		end
	else
		StaticPopup_Show("INSTALL_UI")
		print("Supervillain UI Not Loaded!")
		print("You Broke It!!!!")
	end
end)