﻿local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local dColor = SVColors["classy"][SVRoot.myclass]
local nc1,nc2,nc3 = dColor[1], dColor[2], dColor[3]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end

local bagskin = [[Interface\Icons\INV_Misc_Bag_07]]
SVMod.StatBox("SVStatBags",bagskin)
	
local name = SVStatBags.bar:CreateFontString (nil,"OVERLAY")
	name:SetFont(SVFonts.super,14,"OUTLINE")
	name:SetJustifyH("LEFT")
	name:SetPoint("LEFT",4,0)
	if (SuperSet.colortheme == 3) then
		name:SetTextColor(1,1,1)
	else
		name:SetTextColor(cr+0.3,cg+0.3,cb+0.3)
	end
	name:SetShadowOffset(2,-2)
	name:SetShadowColor(0,0,0,0.8)
	BagName=name

local Profit	= 0
local Spent		= 0
local OldMoney	= 0
local Tokenz = {}
local Tokename = {}
local free,total,used = 0, 0, 0	
local myPlayerRealm = GetCVar("realmName");
local startadding
local function Hex(color)
	return string.format('|cff%02x%02x%02x', color.r * 255, color.g * 255, color.b * 255)
end

local function GetColor()
	if not cColor then return end
	local r,g,b = cColor.r, cColor.g, cColor.b
	return r, g, b	
end

local function formatMoney(money)
	local gold = floor(math.abs(money) / 10000)
	local silver = mod(floor(math.abs(money) / 100), 100)
	local copper = mod(floor(math.abs(money)), 100)
	if gold ~= 0 then
		return format("%s"..SVLocal.goldabbrev.." %s"..SVLocal.silverabbrev.." %s"..SVLocal.copperabbrev, gold, silver, copper)
	elseif silver ~= 0 then
		return format("%s"..SVLocal.silverabbrev.." %s"..SVLocal.copperabbrev, silver, copper)
	else
		return format("%s"..SVLocal.copperabbrev, copper)
	end
end

local function FormatTooltipMoney(money)
	local gold, silver, copper = abs(money / 10000), abs(mod(money / 100, 100)), abs(mod(money, 100))
	local cash = ""
	cash = format("%.2d"..SVLocal.goldabbrev.." %.2d"..SVLocal.silverabbrev.." %.2d"..SVLocal.copperabbrev, gold, silver, copper)		
	return cash
end	

local function update()
	Tokenz[1] = "---"
	Tokename[1] = "---"
	for i = 1, MAX_WATCHED_TOKENS do
		local name, count, _, _, _ = GetBackpackCurrencyInfo(i)
		if name and count then
			Tokename[i] = name
			Tokenz[i] = count
		end
	end
end

local function OnEvent(self, event)
	free,total,used = 0, 0, 0
	for i = 0, NUM_BAG_SLOTS do
		free, total = free + GetContainerNumFreeSlots(i), total + GetContainerNumSlots(i)
	end
	local NewMoney,Change
	local myPlayerName = UnitName("player")
	if (MakeMoneyMoney == nil) then MakeMoneyMoney = {} end
	if (MakeMoneyMoney[myPlayerRealm]==nil) then MakeMoneyMoney[myPlayerRealm]={} end
	if (MakeMoneyMoney[myPlayerRealm][myPlayerName] == nil) then MakeMoneyMoney[myPlayerRealm][myPlayerName] = {} end
	if (event == "PLAYER_ENTERING_WORLD") or (event == "PLAYER_LOGIN") then
		if (MakeMoneyMoney[myPlayerRealm][myPlayerName]["money"] == nil) then 
			OldMoney = 0 
		else
			OldMoney = MakeMoneyMoney[myPlayerRealm][myPlayerName]["money"]
		end
		Profit = 0
		Spent = 0
		NewMoney = GetMoney()
		Change = 0
	end	
	self.bar:SetMinMaxValues(0,total)
	used = total - free
	BagName:SetText(free)
	self.bar:SetValue(used)
	NewMoney = GetMoney()
	Change = NewMoney-OldMoney -- Positive if we gain money
	if OldMoney>NewMoney then		-- Lost Money
		Spent = Spent - Change
	else							-- Gained Moeny
		Profit = Profit + Change
	end
	MakeMoneyMoney[myPlayerRealm][myPlayerName] = {["money"]=GetMoney(),["red"]=nc1,["green"]=nc2,["blue"]=nc3,}		
	OldMoney = NewMoney
	SVStatBags:UnregisterEvent("PLAYER_ENTERING_WORLD")
	update()
end
SVStatBags:RegisterEvent("PLAYER_ENTERING_WORLD")
SVStatBags:RegisterEvent("PLAYER_LOGIN")
SVStatBags:RegisterEvent("PLAYER_MONEY")
SVStatBags:RegisterEvent("SEND_MAIL_MONEY_CHANGED")
SVStatBags:RegisterEvent("SEND_MAIL_COD_CHANGED")
SVStatBags:RegisterEvent("PLAYER_TRADE_MONEY")
SVStatBags:RegisterEvent("TRADE_MONEY_CHANGED")
hooksecurefunc("BackpackTokenFrame_Update", update)
SVStatBags:SetScript("OnEvent", OnEvent)
SVStatBags:SetScript("OnMouseDown", function() OpenAllBags() end)
SVStatBags:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
	GameTooltip:ClearLines()
	GameTooltip:AddDoubleLine(SVLocal.datatext_bags,free.."/"..total,1,1,1,1,1,1)
	GameTooltip:AddDoubleLine(Tokename[1]..":",Tokenz[1],1,0.5,0,1,1,0.1)
	for i = 2, #Tokenz do
		GameTooltip:AddDoubleLine(Tokename[i]..":",Tokenz[i],1,0.5,0,1,1,0.1)
	end
	GameTooltip:AddLine' '
	GameTooltip:AddLine(SVLocal.datatext_session)
			GameTooltip:AddDoubleLine(SVLocal.datatext_earned, formatMoney(Profit), 1, 1, 1, 1, 1, 1)
			GameTooltip:AddDoubleLine(SVLocal.datatext_spent, formatMoney(Spent), 1, 1, 1, 1, 1, 1)
			if Profit < Spent then
				GameTooltip:AddDoubleLine(SVLocal.datatext_deficit, formatMoney(Profit-Spent), 1, 0, 0, 1, 1, 1)
			elseif (Profit-Spent)>0 then
				GameTooltip:AddDoubleLine(SVLocal.datatext_profit, formatMoney(Profit-Spent), 0, 1, 0, 1, 1, 1)
			end				
			GameTooltip:AddLine' '								
			local totalGold = 0	
			GameTooltip:AddLine(SVLocal.datatext_character)			
			local thisRealmList = MakeMoneyMoney[myPlayerRealm];
			for k,v in pairs(thisRealmList) do
				local name = k
				local moneyz,r,g,b
				if type(v) ~= "table" then 
					moneyz,r,g,b = 0,1,1,1
				else
					moneyz,r,g,b = v.money,v.red,v.green,v.blue
				end
				GameTooltip:AddDoubleLine(name, FormatTooltipMoney(moneyz), r, g, b, 1, 1, 1)
				totalGold=totalGold+moneyz;
			end 
			GameTooltip:AddLine' '
			GameTooltip:AddLine(SVLocal.datatext_server)
			GameTooltip:AddDoubleLine(SVLocal.datatext_totalgold, FormatTooltipMoney(totalGold), 0, 1, 0, 1, 1, 1)
			
	GameTooltip:Show()

end)
	
SVStatBags:SetScript("OnLeave", function(self)
	GameTooltip:Hide()
end)

-- reset gold data
local function RESETGOLD()
	local myPlayerRealm = GetCVar("realmName");
	local myPlayerName  = UnitName("player");
	
	MakeMoneyMoney = {}
	MakeMoneyMoney[myPlayerRealm]={}
	MakeMoneyMoney[myPlayerRealm][myPlayerName] = {}
	MakeMoneyMoney[myPlayerRealm][myPlayerName] = {["money"]=GetMoney(),["red"]=nc1,["green"]=nc2,["blue"]=nc3,};
end
SLASH_RESETGOLD1 = "/resetgold"
SlashCmdList["RESETGOLD"] = RESETGOLD
	
SVStatBags:Hide()	
SVStat.make("SVStatBags",BAGSLOT,1)