﻿
local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end
local bagskin = [[Interface\Icons\Spell_Holy_BorrowedTime]]
SVMod.StatBox("SVStatClock",bagskin)
	
local atime = SVStatClock.bar:CreateFontString (nil,"OVERLAY")
	atime:SetFont(SVFonts.numbers,14,"THINOUTLINE")
	atime:SetPoint("CENTER",0,2)
	atime:SetJustifyH("CENTER")
	atime:SetTextColor(0.3,1,0.5)
	atime:SetShadowOffset(-2,2)
	atime:SetShadowColor(0,0,0,0.5)
	ClockText=atime
	
local mess_f = CreateFrame("Frame",nil,UIParent)
	mess_f:SetScript("OnUpdate", FadingFrame_OnUpdate)
	mess_f:Hide()
	mess_f.fadeInTime = .2
	mess_f.holdTime = 1
	mess_f.fadeOutTime = .3
	mess_f:SetFrameStrata("TOOLTIP")
	mess_f:SetFrameLevel(30)
	
local text_f = mess_f:CreateFontString(nil,"OVERLAY")
	text_f:SetFont(SVFonts.font,12)
	text_f:SetShadowOffset(2,-2)
	text_f:SetPoint("TOPLEFT",clocks,"BOTTOMLEFT",.3,-8)
	text_f:SetJustifyH("LEFT")
	text_f:SetHeight(18)

local int = 1
local function Update(self, t)
--	if not svUISVStatClock:IsShown() then return end;
	local pendingCalendarInvites = CalendarGetNumPendingInvites()
	int = int - t
	if int < 0 then
		if SuperSet.load.localtime == true then
			Hr24 = tonumber(date("%H"))
			Hr = tonumber(date("%I"))
			Min = date("%M")
			if SuperSet.load.time24 == true then
				if pendingCalendarInvites > 0 then
				ClockText:SetText("|cffFF0000"..Hr24..":"..Min)
			else
				ClockText:SetText(Hr24..":"..Min)
			end
		else
			if Hr24>=12 then
				if pendingCalendarInvites > 0 then
					ClockText:SetText("|cffFF0000"..Hr..":"..Min.." |cffffffffpm|r")
				else
					ClockText:SetText(Hr..":"..Min.." |cffffffffpm|r")
				end
			else
				if pendingCalendarInvites > 0 then
					ClockText:SetText("|cffFF0000"..Hr..":"..Min.." |cffffffffam|r")
				else
					ClockText:SetText(Hr..":"..Min.." |cffffffffam|r")
				end
			end
		end
		local _,_,_,_,lefttime = GetWorldPVPAreaInfo(2)
		if lefttime == nil then
			lefttime = 9000
		end
		SVStatClock.bar:SetValue(lefttime)
	else
		local Hr, Min = GetGameTime()
		if Min<10 then Min = "0"..Min end
		if SuperSet.load.time24 == true then
			if pendingCalendarInvites > 0 then			
				ClockText:SetText("|cffFF0000"..Hr..":"..Min.." |cffffffff|r")
			else
				ClockText:SetText(Hr..":"..Min.." |cffffffff|r")
			end
		else
			if Hr>=12 then
				if Hr>12 then Hr = Hr-12 end
				if pendingCalendarInvites > 0 then
					ClockText:SetText("|cffFF0000"..Hr..":"..Min.." |cffffffffpm|r")
				else
					ClockText:SetText(Hr..":"..Min.." |cffffffffpm|r")
				end
			else
				if Hr == 0 then Hr = 12 end
				if pendingCalendarInvites > 0 then
					ClockText:SetText("|cffFF0000"..Hr..":"..Min.." |cffffffffam|r")
				else
					ClockText:SetText(Hr..":"..Min.." |cffffffffam|r")
				end
			end
		end
	end
	
	int = 1
	end
end

SVStatClock:SetScript("OnEnter", function(self)
	OnLoad = function(self) RequestRaidInfo() end,
	GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, SVMod.Scale(6));
	GameTooltip:ClearAllPoints()
	GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, SVMod.mult)
	GameTooltip:ClearLines()
	local pvp = GetNumWorldPVPAreas()
	for i=1, pvp do
		local timeleft = select(5, GetWorldPVPAreaInfo(i))
		local name = select(2, GetWorldPVPAreaInfo(i))
		local inprogress = select(3, GetWorldPVPAreaInfo(i))
		local inInstance, instanceType = IsInInstance()
		if not ( instanceType == "none" ) then
			timeleft = QUEUE_TIME_UNAVAILABLE
		elseif inprogress then
			timeleft = WINTERGRASP_IN_PROGRESS
		else
			local hour = tonumber(format("%01.f", floor(timeleft/3600)))
			local min = format(hour>0 and "%02.f" or "%01.f", floor(timeleft/60 - (hour*60)))
			local sec = format("%02.f", floor(timeleft - hour*3600 - min *60)) 
			timeleft = (hour>0 and hour..":" or "")..min..":"..sec
		end
		GameTooltip:AddDoubleLine(SVLocal.datatext_timeto.." "..name,timeleft)
	end
	GameTooltip:AddLine(" ")
	
	if SuperSet.load.localtime == true then
		local Hr, Min = GetGameTime()
		if Min<10 then Min = "0"..Min end
		if SuperSet.load.time24 == true then         
			GameTooltip:AddDoubleLine(SVLocal.datatext_servertime,Hr .. ":" .. Min);
		else             
			if Hr>=12 then
			Hr = Hr-12
			if Hr == 0 then Hr = 12 end
				GameTooltip:AddDoubleLine(SVLocal.datatext_servertime,Hr .. ":" .. Min.." PM");
			else
				if Hr == 0 then Hr = 12 end
				GameTooltip:AddDoubleLine(SVLocal.datatext_servertime,Hr .. ":" .. Min.." AM");
			end
		end
	else
		Hr24 = tonumber(date("%H"))
		Hr = tonumber(date("%I"))
		Min = date("%M")
		if SuperSet.load.time24 == true then
			GameTooltip:AddDoubleLine(SVLocal.datatext_localtime,Hr24 .. ":" .. Min);
		else
			if Hr24>=12 then
				GameTooltip:AddDoubleLine(SVLocal.datatext_localtime,Hr .. ":" .. Min.." PM");
			else
				GameTooltip:AddDoubleLine(SVLocal.datatext_localtime,Hr .. ":" .. Min.." AM");
			end
		end
	end  
	
	local oneraid
	for i = 1, GetNumSavedInstances() do
	local name,_,reset,difficulty,locked,extended,_,isRaid,maxPlayers = GetSavedInstanceInfo(i)
	if isRaid and (locked or extended) then
		local tr,tg,tb,diff
		if not oneraid then
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine(SVLocal.datatext_savedraid)
			oneraid = true
		end

		local function fmttime(sec,table)
		local table = table or {}
		local d,h,m,s = ChatFrame_TimeBreakDown(floor(sec))
		local string = gsub(gsub(format(" %dd %dh %dm "..((d==0 and h==0) and "%ds" or ""),d,h,m,s)," 0[dhms]"," "),"%s+"," ")
		local string = strtrim(gsub(string, "([dhms])", {d=table.days or "d",h=table.hours or "h",m=table.minutes or "m",s=table.seconds or "s"})," ")
		return strmatch(string,"^%s*$") and "0"..(table.seconds or L"s") or string
	end
	if extended then tr,tg,tb = 0.3,1,0.3 else tr,tg,tb = 1,1,1 end
	if difficulty == 3 or difficulty == 4 then diff = "H" else diff = "N" end
	GameTooltip:AddDoubleLine(name,fmttime(reset),1,1,1,tr,tg,tb)
	end
	end
	GameTooltip:Show()
end)

SVStatClock:SetScript("OnLeave", function() GameTooltip:Hide() end)
SVStatClock:RegisterEvent("CALENDAR_UPDATE_PENDING_INVITES")
SVStatClock:RegisterEvent("PLAYER_ENTERING_WORLD")
SVStatClock:SetScript("OnUpdate", Update)
SVStatClock:RegisterEvent("UPDATE_INSTANCE_INFO")
SVStatClock:SetScript("OnMouseDown", function(self, btn)
	if btn == 'RightButton'  then
		ToggleTimeManager()
	else
		ToggleCalendar()
	end
end)
Update(Stat, 10)
SVStatClock:Hide()
SVStat.make("SVStatClock",TIMEMANAGER_TITLE,2)