﻿local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end
local bagskin = [[Interface\Icons\Achievement_BG_killingblow_berserker]]
SVMod.StatBox("SVStatDPS",bagskin)

local dd = SVStatDPS.bar:CreateFontString (nil,"OVERLAY")
dd:SetFont(SVFonts.super,14,"OUTLINE")
dd:SetJustifyH("LEFT")
dd:SetPoint("LEFT",4,0)
if (SuperSet.colortheme == 3) then
	dd:SetTextColor(1,1,1)
else
	dd:SetTextColor(cr+0.3,cg+0.3,cb+0.3)
end
dd:SetShadowOffset(2,3)
dd:SetShadowColor(0,0,0,0.8)
dd:SetText("0")

--| Main Idea taked from A_Hero_Dies\\\\

local events = {
	SWING_DAMAGE = true,
	RANGE_DAMAGE = true,
	SPELL_DAMAGE = true,
	SPELL_PERIODIC_DAMAGE = true,
	DAMAGE_SHIELD = true,
	DAMAGE_SPLIT = true,
	SPELL_EXTRA_ATTACKS = true}

local player_id = UnitGUID("player")
local dmg_total, last_dmg_amount = 0, 0
local cmbt_time = 0

local pet_id = UnitGUID("pet")
local themax = 0

SVStatDPS:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)
SVStatDPS:RegisterEvent("PLAYER_LOGIN")

local function getDPS()
	local s
	if cmbt_time == 0 then
		s = 0
	else
		s = floor((dmg_total or 0) / (cmbt_time or 1))
	end
	if s > themax then
		themax = s
		SVStatDPS.bar:SetMinMaxValues(0,themax)
	end
	SVStatDPS.bar:SetValue((dmg_total or 0) / (cmbt_time or 1))
	return s
end

local counter = CreateFrame("Frame")

counter:SetScript("OnUpdate", function(self, elap)
	cmbt_time = cmbt_time + elap 
	dd:SetText(getDPS())
end)
counter:Hide()
     
function SVStatDPS:PLAYER_LOGIN()
	SVStatDPS:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	SVStatDPS:RegisterEvent("PLAYER_REGEN_ENABLED")
	SVStatDPS:RegisterEvent("PLAYER_REGEN_DISABLED")
	SVStatDPS:RegisterEvent("UNIT_PET")
	player_id = UnitGUID("player")
	SVStatDPS:UnregisterEvent("PLAYER_LOGIN")
end
     
function SVStatDPS:UNIT_PET(unit)
	if unit == "player" then
		pet_id = UnitGUID("pet")
	end
end
	
-- handler for the combat log. used http://www.wowwiki.com/API_COMBAT_LOG_EVENT for api
function SVStatDPS:COMBAT_LOG_EVENT_UNFILTERED(...)		   
	-- filter for events we only care about. i.e heals
	if not events[select(2, ...)] then return end

	-- only use events from the player
	local id = select(3, ...)
		   
	if id == player_id or id == pet_id then
		if select(2, ...) == "SWING_DAMAGE" then
			last_dmg_amount = select(9, ...)
		else
			last_dmg_amount = select(12, ...)
		end
			dmg_total = dmg_total + last_dmg_amount
	end       
end

function SVStatDPS:PLAYER_REGEN_ENABLED()
	counter:Hide()
end
	
function SVStatDPS:PLAYER_REGEN_DISABLED()
	if not (SVStatDPS:IsShown()) then return end
	counter:Show()
end
     
SVStatDPS:SetScript("OnMouseDown", function (self, button, down)
	cmbt_time = 0
	dmg_total = 0
	last_dmg_amount = 0
	themax = 0
	dd:SetText(getDPS())
end)
SVStatDPS:Hide()
SVStat.make("SVStatDPS",SVLocal.datatext_dps,3)