﻿local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end
SVLocal.Slots = {
	[1] = {1, "Head", 1000},
	[2] = {3, "Shoulder", 1000},
	[3] = {5, "Chest", 1000},
	[4] = {6, "Waist", 1000},
	[5] = {9, "Wrist", 1000},
	[6] = {10, "Hands", 1000},
	[7] = {7, "Legs", 1000},
	[8] = {8, "Feet", 1000},
	[9] = {16, "Main Hand", 1000},
	[10] = {17, "Off Hand", 1000},
	[11] = {18, "Ranged", 1000}
}

local bagskin = [[Interface\Icons\Trade_BlackSmithing]]
SVMod.StatBox("SVStatArmor",bagskin)
	
local name = SVStatArmor.bar:CreateFontString (nil,"OVERLAY")
	name:SetFont(SVFonts.super,14,"OUTLINE")
	name:SetPoint("LEFT",4,0)
	if (SuperSet.colortheme == 3) then
		name:SetTextColor(1,1,1)
	else
		name:SetTextColor(cr+0.3,cg+0.3,cb+0.3)
	end
	name:SetShadowOffset(2,3)
	name:SetShadowColor(0,0,0,0.8)
	name:SetJustifyH("LEFT")
DurName=name

local Slots = SVLocal.Slots

local Total,current,max = 0
local red,green

local function OnEvent(self)
--	if not svUISVStatArmor:IsShown() then return end;
	for i = 1, 11 do
		if GetInventoryItemLink("player", Slots[i][1]) ~= nil then
			current, max = GetInventoryItemDurability(Slots[i][1])
			if current then 
				Slots[i][3] = current/max
				Total = Total + 1
			end
		end
	end
	
	table.sort(Slots, function(a, b) return a[3] < b[3] end)
	
	if Total > 0 then
		local dura = floor(Slots[1][3]*100)
			local lol,r,g = (dura/100)
			if lol > .7 then
				r = 0; g = 1
			elseif lol > .3 then
				r = 1; g = 1
			else 
				r = 1; g = 0
			end
		self.bar:SetMinMaxValues(0,100)
		self.bar:SetValue(dura)
		DurName:SetText(dura.."|cffFFFFFF%")
		self:SetScript("OnEnter", function(self)	
			GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
			GameTooltip:ClearLines()
			GameTooltip:AddDoubleLine(SVLocal.datatext_armor,floor(Slots[1][3]*100).." %",1,1,1,r,g,0)
			GameTooltip:AddDoubleLine(" ")		
			for i = 1, 11 do
				if Slots[i][3] ~= 1000 then
					green = Slots[i][3]*2
					red = 1 - green
					GameTooltip:AddDoubleLine(Slots[i][2], floor(Slots[i][3]*100).."%",1 ,1 , 1, red + 1, green, 0)
				end
			end
			GameTooltip:Show()
		end)
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		Total = 0
	end
	
end

SVStatArmor:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
SVStatArmor:RegisterEvent("MERCHANT_SHOW")
SVStatArmor:RegisterEvent("PLAYER_ENTERING_WORLD")
SVStatArmor:SetScript("OnEvent", OnEvent)
SVStatArmor:SetScript("OnMouseDown", function() ToggleCharacter("PaperDollFrame") end)
	
SVStatArmor:Hide()
SVStat.make("SVStatArmor",SVLocal.datatext_armor,4)