local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end
local bagskin = [[Interface\Icons\Achievement_Reputation_01]]
SVMod.StatBox("SVStatFriends",bagskin)

local dd = SVStatFriends.bar:CreateFontString (nil,"OVERLAY")
dd:SetFont(SVFonts.super,14,"OUTLINE")
dd:SetJustifyH("LEFT")
dd:SetPoint("LEFT",4,0)
if (SuperSet.colortheme == 3) then
	dd:SetTextColor(1,1,1)
else
	dd:SetTextColor(cr+0.3,cg+0.3,cb+0.3)
end
dd:SetShadowOffset(2,3)
dd:SetShadowColor(0,0,0,0.8)
dd:SetText("0")
FriendText = dd

local correct = function(a,b)
	local max = a + b
	if max ~= 0 then
		SVStatFriends:SetValue(a/max)
	else
		SVStatFriends:SetValue(0)
	end
end

--| Main Idea taken from Tukui\\\\
local tthead = {r=0.4,g=0.78,b=1}
local ttsubh = {r=0.75,g=0.9,b=1}
local menuFrame = CreateFrame("Frame", "SVUIFriendRightClickMenu", UIParent, "UIDropDownMenuTemplate")
local menuList = {
	{ text = GAMEOPTIONS_MENU, isTitle = true,notCheckable=true},
	{ text = INVITE, hasArrow = true,notCheckable=true,
		menuList = {
			{ text = "Option 3", func = function() print("You've chosen option 3"); end }
		}
	},
	{ text = WHISPER, hasArrow = true,notCheckable=true,
		menuList = {
			{ text = "Option 4", func = function() print("You've chosen option 4"); end }
		}
	}
}

local function inviteClick(self, arg1, arg2, checked)
	menuFrame:Hide()
	InviteUnit(arg1)
end

local function whisperClick(self,arg1,arg2,checked)
	menuFrame:Hide() 
	SetItemRef( "player:"..arg1, ("|Hplayer:%1$s|h[%1$s]|h"):format(arg1), "LeftButton" )		 
end

local menuCountWhispers = 0
local menuCountInvites = 0	

local function Update(self, event)
--		if not svUISVStatFriends:IsShown() then return end;
		local online, total = 0, GetNumFriends()
		local BNonline, BNtotal = 0, BNGetNumFriends()
		for i = 0, total do if select(5, GetFriendInfo(i)) then online = online + 1 end end
		if BNtotal > 0 then
			for i = 1, BNtotal do if select(7, BNGetFriendInfo(i)) then BNonline = BNonline + 1 end end
		end
		local totalonline = online + BNonline
		FriendText:SetText(totalonline)
end

SVStatFriends:RegisterEvent("FRIENDLIST_SHOW")
SVStatFriends:RegisterEvent("FRIENDLIST_UPDATE")
SVStatFriends:RegisterEvent("MUTELIST_UPDATE")
SVStatFriends:RegisterEvent("WHO_LIST_UPDATE")
SVStatFriends:RegisterEvent("PLAYER_FLAGS_CHANGED")
SVStatFriends:RegisterEvent("BN_FRIEND_LIST_SIZE_CHANGED")
SVStatFriends:RegisterEvent("BN_FRIEND_INFO_CHANGED")
SVStatFriends:RegisterEvent("BN_FRIEND_INVITE_LIST_INITIALIZED")
SVStatFriends:RegisterEvent("BN_FRIEND_INVITE_ADDED")
SVStatFriends:RegisterEvent("BN_FRIEND_INVITE_REMOVED")
SVStatFriends:RegisterEvent("BN_SELF_ONLINE")
SVStatFriends:RegisterEvent("BN_BLOCK_LIST_UPDATED")
SVStatFriends:RegisterEvent("PLAYER_ENTERING_WORLD")
SVStatFriends:RegisterEvent("BN_CONNECTED")
SVStatFriends:RegisterEvent("BN_DISCONNECTED")
SVStatFriends:RegisterEvent("CHAT_MSG_SYSTEM")
SVStatFriends:SetScript("OnEnter", function(self)
	if not InCombatLockdown() then
		ShowFriends()
		menuCountWhispers = 0
		menuCountInvites = 0
		menuList[2].menuList = {}
		menuList[3].menuList = {}

		local online, total = 0, GetNumFriends()
		local name, level, class, zone, connected, status, note, classc, levelc, zone_r, zone_g, zone_b, grouped, isAFK, isDND
		for i = 0, total do if select(5, GetFriendInfo(i)) then online = online + 1 end end
		local BNonline, BNtotal = 0, BNGetNumFriends()
		local presenceID, givenName, surname, toonName, toonID, client, isOnline
		if BNtotal > 0 then
			for i = 1, BNtotal do if select(7, BNGetFriendInfo(i)) then BNonline = BNonline + 1 end end
		end
		local totalonline = online + BNonline
		local totalfriends = total + BNtotal
		if online > 0 or BNonline > 0 then
			GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, SVMod.Scale(6));
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, SVMod.mult)
			GameTooltip:ClearLines()
			GameTooltip:AddDoubleLine(SVLocal.datatext_friends, format(SVLocal.datatext_online .. "%s/%s",totalonline,totalfriends),tthead.r,tthead.g,tthead.b,tthead.r,tthead.g,tthead.b)
			if online > 0 then
				GameTooltip:AddLine' '
				GameTooltip:AddLine("World of Warcraft")
				for i = 1, total do
					name, level, class, zone, connected, status, note = GetFriendInfo(i)
					if not connected then break end
					if GetRealZoneText() == zone then zone_r, zone_g, zone_b = 0.3, 1.0, 0.3 else zone_r, zone_g, zone_b = 0.65, 0.65, 0.65 end
					for k,v in pairs(LOCALIZED_CLASS_NAMES_MALE) do if class == v then class = k end end
					if GetLocale() ~= "enUS" then -- feminine class localization (unsure if it's really needed)
						for k,v in pairs(LOCALIZED_CLASS_NAMES_FEMALE) do if class == v then class = k end end
					end
					classc, levelc = (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class], GetQuestDifficultyColor(level)
					if classc == nil then classc = GetQuestDifficultyColor(level) end
					if UnitInParty(name) or UnitInRaid(name) then grouped = "|cffaaaaaa*|r" else grouped = "" end
					GameTooltip:AddDoubleLine(format("|cff%02x%02x%02x%d|r %s%s%s",levelc.r*255,levelc.g*255,levelc.b*255,level,name,grouped," "..status),zone,classc.r,classc.g,classc.b,zone_r,zone_g,zone_b)
					
					menuCountInvites = menuCountInvites + 1
					menuCountWhispers = menuCountWhispers + 1

					menuList[2].menuList[menuCountInvites] = {text = format("|cff%02x%02x%02x%d|r |cff%02x%02x%02x%s|r",levelc.r*255,levelc.g*255,levelc.b*255,level,classc.r*255,classc.g*255,classc.b*255,name), arg1 = name,notCheckable=true, func = inviteClick}
					menuList[3].menuList[menuCountWhispers] = {text = format("|cff%02x%02x%02x%d|r |cff%02x%02x%02x%s|r",levelc.r*255,levelc.g*255,levelc.b*255,level,classc.r*255,classc.g*255,classc.b*255,name), arg1 = name,notCheckable=true, func = whisperClick}
				end
			end
			if BNonline > 0 then
				GameTooltip:AddLine' '
				GameTooltip:AddLine("Battle.net")
				for i = 1, BNtotal do
					presenceID, givenName, surname, toonName, toonID, client, isOnline, _, isAFK, isDND = BNGetFriendInfo(i)
					local realID = (BATTLENET_NAME_FORMAT):format(givenName, surname)
					if not isOnline then break end
					
					menuCountWhispers = menuCountWhispers + 1
					
					local playerRealm = GetRealmName()
					local playerFaction, localeFaction = UnitFactionGroup("player")
					if playerFaction == "Horde" then playerFaction = 0 else playerFaction = 1 end
					
					if(isAFK) then
						status = "[AFK]"
					else 
						if(isDND) then
							status = "[DND]"
						else
							status = ""
						end
					end
					if client == "WoW" then
						local hasFocus, toonName, client, realmName, faction, race, class, guild, zoneName, level = BNGetToonInfo(toonID)
						if level == "" then level = "0" end
						classc, levelc = (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class], GetQuestDifficultyColor(level)
						if classc == nil then classc = GetQuestDifficultyColor(level) end
						if UnitInParty(name) or UnitInRaid(name) then grouped = "|cffaaaaaa*|r" else grouped = "" end
						GameTooltip:AddDoubleLine(format("%s |cff%02x%02x%02x(%d|r |cff%02x%02x%02x%s|r%s) |cff%02x%02x%02x%s|r",client,levelc.r*255,levelc.g*255,levelc.b*255,level,classc.r*255,classc.g*255,classc.b*255,toonName,grouped, 255, 0, 0, status),givenName.." "..surname,238,238,238,238,238,238)
						if IsShiftKeyDown() then
							if GetRealZoneText() == zone then zone_r, zone_g, zone_b = 0.3, 1.0, 0.3 else zone_r, zone_g, zone_b = 0.65, 0.65, 0.65 end
							if GetRealmName() == realmName then realm_r, realm_g, realm_b = 0.3, 1.0, 0.3 else realm_r, realm_g, realm_b = 0.65, 0.65, 0.65 end
							GameTooltip:AddDoubleLine("  "..zoneName, realmName, zone_r, zone_g, zone_b, realm_r, realm_g, realm_b)
						end
						
						if playerRealm == realmName then
							if playerFaction == faction then
									if UnitInParty(toonName) or UnitInRaid(toonName) then
										grouped = "|cffaaaaaa*|r"
									else
										grouped = ""
										menuCountInvites = menuCountInvites + 1
										menuList[2].menuList[menuCountInvites] = {text = format("|cff%02x%02x%02x%d|r |cff%02x%02x%02x%s|r",levelc.r*255,levelc.g*255,levelc.b*255,level,classc.r*255,classc.g*255,classc.b*255,toonName), arg1 = toonName,notCheckable=true, func = inviteClick}
									end
							end
						end
						menuList[3].menuList[menuCountWhispers] = {text = realID, arg1 = realID,notCheckable=true, func = whisperClick}							
					else
						menuList[3].menuList[menuCountWhispers] = {text = realID, arg1 = realID,notCheckable=true, func = whisperClick}
						GameTooltip:AddDoubleLine("|cffeeeeee"..client.." ("..toonName..")|r", "|cffeeeeee"..givenName.." "..surname.."|r")
					end
				end
			end
			GameTooltip:Show()
		else 
			GameTooltip:Hide() 
		end
	end
end)
SVStatFriends:SetScript("OnLeave", function() GameTooltip:Hide() end)
SVStatFriends:SetScript("OnMouseDown", function(self, btn) 
	if btn == "LeftButton" then 
		ToggleFriendsFrame(1) 
	elseif btn == "RightButton" then 
		GameTooltip:Hide() 
		EasyMenu(menuList, menuFrame, "cursor", 0, 0, "MENU", 2) 
	end 
end)
SVStatFriends:SetScript("OnEvent", Update)
SVStatFriends:Hide()
SVStat.make("SVStatFriends",SVLocal.datatext_friends,5)