local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end
local bagskin = [[Interface\Icons\ACHIEVEMENT_BOSS_KILJAEDAN]]
SVMod.StatBox("SVStatLFG",bagskin)

local dd = SVStatLFG.bar:CreateFontString (nil,"OVERLAY")
dd:SetFont(SVFonts.super,14,"OUTLINE")
dd:SetPoint("LEFT",4,0)
if (SuperSet.colortheme == 3) then
	dd:SetTextColor(1,1,1)
else
	dd:SetTextColor(cr+0.3,cg+0.3,cb+0.3)
end
dd:SetShadowOffset(2,3)
dd:SetShadowColor(0,0,0,0.8)
dd:SetText(SVLocal.core_stat_lfgidle)
LFGText = dd
	
SVStatLFG:RegisterEvent("LFG_UPDATE")
SVStatLFG:RegisterEvent("UPDATE_LFG_LIST")
SVStatLFG:RegisterEvent("LFG_PROPOSAL_SHOW")
SVStatLFG:RegisterEvent("LFG_PROPOSAL_UPDATE")
SVStatLFG:RegisterEvent("PARTY_MEMBERS_CHANGED")
SVStatLFG:RegisterEvent("LFG_ROLE_CHECK_UPDATE")
SVStatLFG:RegisterEvent("PLAYER_ENTERING_WORLD")
SVStatLFG:RegisterEvent("LFG_COMPLETION_REWARD")
SVStatLFG:RegisterEvent("LFG_QUEUE_STATUS_UPDATE")
local format = string.format

local red, green = "ff0000", "0deb11"


SVStatLFG:SetScript("OnEvent", function(self, event)
--	if not svUILFG:IsShown() then return end;
	if event == "LFG_PROPOSAL_SHOW" then
		if SuperSet.load.declfg == true then
			local proposalExists, _, _, _, _, _, _, _, completedEncounters = GetLFGProposal()
	
			if proposalExists and completedEncounters > 0 then
				RaidNotice_AddMessage(RaidWarningFrame, format("|cff%s%s|r", red, SVLocal.core_stat_lfgdeclined), ChatTypeInfo["RAID_WARNING"])
				RejectProposal()
				LFDQueueFrameFindGroupButton:Click()
			end
		end
	end

	local hasData, _, tankNeeds, healerNeeds, dpsNeeds, _, _, _, _, _, _, myWait = GetLFGQueueStats()

	local mode, _ = GetLFGMode()

	if mode == "listed" then
		LFGText:SetText("LFM")
		return
	elseif mode == "queued" and not hasData then
		LFGText:SetText(LOOKING)
		return
	elseif not hasData then
		LFGText:SetText("LFG zzz")
		return
	end

	LFGText:SetText(
		format("%s%s%s%s%s %s",
			format("|cff%s%s|r", tankNeeds == 0 and green or red, "T"),
			format("|cff%s%s|r", healerNeeds == 0 and green or red, "H"),
			format("|cff%s%s|r", dpsNeeds == 3 and red or green, "D"),
			format("|cff%s%s|r", dpsNeeds >= 2 and red or green, "D"),
			format("|cff%s%s|r", dpsNeeds >= 1 and red or green, "D"),
			(myWait ~= -1 and SecondsToTime(myWait, false, false, 1) or "|cffCC3333Unknown|r")
		)
	)
end)

		
SVStatLFG:SetScript("OnMouseDown", function(self, button)
	local mode, _ = GetLFGMode()
	if button == "LeftButton" then
		if mode == "listed" then
			ToggleLFRParentFrame()
		else
			ToggleLFDParentFrame()
		end
	elseif(button=="MiddleButton") then
		TogglePVPFrame()
	elseif button == "RightButton" then
		if mode == "proposal" then
			if not LFDDungeonReadyPopup:IsShown() then
				StaticPopupSpecial_Show(LFDDungeonReadyPopup)
				return
			end
		end

		MiniMapLFGFrameDropDown.point = "TOP"
		MiniMapLFGFrameDropDown.relativePoint = "BOTTOM"
		ToggleDropDownMenu(1, nil, MiniMapLFGFrameDropDown, SVStatLFG, 0, 0)
	end
end)

SVStatLFG:SetScript("OnEnter", function()
	if not InCombatLockdown() then
		GameTooltip:SetOwner(SVStatLFG, "ANCHOR_TOP");
		GameTooltip:ClearAllPoints()
		GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, yoffset)
		GameTooltip:ClearLines()
		GameTooltip:AddLine(SVLocal.core_stat_lfginfo1)
		GameTooltip:AddLine(SVLocal.core_stat_lfginfo2)
		GameTooltip:AddLine(SVLocal.core_stat_lfginfo3)
		GameTooltip:Show()
	end
end)
SVStatLFG:SetScript("OnLeave", function() GameTooltip:Hide() end)
SVStatLFG:Hide()
SVStat.make("SVStatLFG","LFG",7)