﻿local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end

local bagskin = [[Interface\Icons\Achievement_BG_grab_cap_flagunderXseconds]]
SVMod.StatBox("SVStatPing",bagskin)
		
local name = SVStatPing.bar:CreateFontString (nil,"OVERLAY")
	name:SetFont(SVFonts.super,14,"OUTLINE")
	name:SetPoint("RIGHT",4,0)
	name:SetJustifyH("RIGHT")
	if (SuperSet.colortheme == 3) then
		name:SetTextColor(1,1,1)
	else
		name:SetTextColor(cr+0.3,cg+0.3,cb+0.3)
	end
	name:SetShadowOffset(2,3)
	name:SetShadowColor(0,0,0,0.8)
	name:SetText("0")
PingName=name

local fpsdata = SVStatPing.bar:CreateFontString (nil,"OVERLAY")
	fpsdata:SetFont(SVFonts.super,12,"THINOUTLINE")
	fpsdata:SetJustifyH("LEFT",-4,0)
	fpsdata:SetPoint("TOPLEFT",title,"TOPRIGHT",1,0)
	fpsdata:SetText("0")
FPSName=fpsdata

local colorme = string.format("%02x%02x%02x", 1*255, 1*255, 1*255)

local function formatMem(memory, color)
	if color then
		statColor = { "|cff"..colorme, "|r" }
	else
		statColor = { "", "" }
	end
	
	local mult = 10^1
	if memory > 999 then
		local mem = floor((memory/1024) * mult + 0.5) / mult
		if mem % 1 == 0 then
			return mem..string.format(".0 %smb%s", unpack(statColor))
		else
			return mem..string.format(" %smb%s", unpack(statColor))
		end
	else
		local mem = floor(memory * mult + 0.5) / mult
			if mem % 1 == 0 then
				return mem..string.format(".0 %skb%s", unpack(statColor))
			else
				return mem..string.format(" %skb%s", unpack(statColor))
			end
	end
end

local Total, Mem, MEMORY_TEXT, LATENCY_TEXT, Memory
local function RefreshMem(self)
	Memory = {}

	UpdateAddOnMemoryUsage()
	Total = 0
	for i = 1, GetNumAddOns() do
		Mem = GetAddOnMemoryUsage(i)
		Memory[i] = { select(2, GetAddOnInfo(i)), Mem, IsAddOnLoaded(i) }
		Total = Total + Mem
	end
	
	MEMORY_TEXT = formatMem(Total, true)
	table.sort(Memory, function(a, b)
		if a and b then
			return a[2] > b[2]
		end
	end)
end

local int, int2 = 10, 1
local function Update(self, t)
--	if not svUILatency:IsShown() then return end;
	int = int - t
	int2 = int2 - t
	if int < 0 then
		RefreshMem(self)
		int = 10
	end
	if int2 < 0 then
		FPSName:SetText(floor(GetFramerate()))
		int2 = 1
	end
	PingName:SetText(select(3, GetNetStats()))
end

SVStatPing:SetScript("OnMouseDown", function() collectgarbage("collect") Update(SVStatPing, 20) end)
SVStatPing:SetScript("OnUpdate", Update) 
SVStatPing:SetScript("OnEnter", function(self)
	if not InCombatLockdown() then
		local bandwidth = GetAvailableBandwidth()
		GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, SVMod.Scale(6));
		GameTooltip:ClearAllPoints()
		GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, SVMod.mult)
		GameTooltip:ClearLines()
		if bandwidth ~= 0 then
			GameTooltip:AddDoubleLine(SVLocal.datatext_bandwidth,format("%s "..SVLocal.datatext_ms,bandwidth),0.69, 0.31, 0.31,0.84, 0.75, 0.65)
			GameTooltip:AddDoubleLine(SVLocal.datatext_download,format("%s%%", floor(GetDownloadedPercentage()*100+0.5)),0.69, 0.31, 0.31, 0.84, 0.75, 0.65)
			GameTooltip:AddLine(" ")
		end
		GameTooltip:AddDoubleLine(SVLocal.datatext_totalmemusage,formatMem(Total), 0.69, 0.31, 0.31,0.84, 0.75, 0.65)
		GameTooltip:AddLine(" ")
		for i = 1, #Memory do
			if Memory[i][3] then 
				local red = Memory[i][2]/Total*2
				local green = 1 - red
				GameTooltip:AddDoubleLine(Memory[i][1], formatMem(Memory[i][2], false), 1, 1, 1, red, green+1, 0)						
			end
		end
		GameTooltip:Show()
	end
end)
SVStatPing:SetScript("OnLeave", function() GameTooltip:Hide() end)
Update(SVStatPing, 20)
SVStatPing:Hide()		
SVStat.make("SVStatPing",SVLocal.datatext_bandwidth,8)	