--------------------------------------------------------------------
-- BGScore (original feature by elv22, edited by Tukz)
--------------------------------------------------------------------
local bgframe = CreateFrame("Frame", "SVUIBattleGround", UIParent)
	bgframe:SetWidth(300) 
	bgframe:SetHeight(48) 
	bgframe:SetPoint("TOP", UIParent, "TOP", 0, -65)
	bgframe:SetFrameStrata("LOW")
	bgframe:SetFrameLevel(4)
local bgfbg = CreateFrame("Frame", nil,bgframe)
	bgfbg:SetAllPoints(bgframe)
	bgfbg:SetFrameLevel(1)
	SVMod.SuperSkin(bgfbg,2)
	bgfbg:SetBackdropColor(0.5,0.5,0.1,0.3)
	bgframe:EnableMouse(true)
	bgframe.hand = CreateFrame("Frame",nil,bgframe)
	bgframe.hand:SetSize(70,70)
	bgframe.hand:SetPoint("TOPRIGHT", bgframe, "BOTTOMLEFT", 40, 4)
	local bghtex = bgframe.hand:CreateTexture(nil,"OVERLAY")
	bghtex:SetAllPoints(bgframe.hand)
	bghtex:SetTexture(SVMedia.glove)
	bghtex:SetVertexColor(1,0,0.1,0.9)
	local handtext = bgframe.hand:CreateFontString(nil, "OVERLAY")
	handtext:SetFont(SVFonts.super,18,"THINOUTLINE")
	handtext:SetPoint("BOTTOMLEFT", bgframe, "TOPLEFT", 2, 2)
	handtext:SetText("Click to Drag")
	bgframe.hand:Hide()
local bg1bar = CreateFrame("StatusBar","SVUIBG1",SVUIBattleGround)
	bg1bar:SetWidth(288) 
	bg1bar:SetHeight(19) 
	bg1bar:SetPoint("TOP", bgframe, "TOP", 0, -6)
	bg1bar:SetFrameStrata("LOW")
	bg1bar:SetFrameLevel(3)
	bg1bar:SetStatusBarTexture(SVMedia.smoothbar)
	bg1bar:SetStatusBarColor(1,0.4,0)
	SVMod.SimpleSkin(bg1bar)
	bg1bar:EnableMouse(true)
	bg1bar:SetMinMaxValues(0,3600)
	bg1bar:SetValue(0)
local bg2bar = CreateFrame("StatusBar","SVUIBG2",SVUIBattleGround)
	bg2bar:SetWidth(288) 
	bg2bar:SetHeight(19) 
	bg2bar:SetPoint("BOTTOM", bgframe, "BOTTOM", 0, 6)
	bg2bar:SetFrameStrata("LOW")
	bg2bar:SetFrameLevel(3)
	bg2bar:SetStatusBarTexture(SVMedia.smoothbar)
	bg2bar:SetStatusBarColor(1,0.4,0)
	SVMod.SimpleSkin(bg2bar)
	bg2bar:EnableMouse(true)
	bg2bar:SetMinMaxValues(0,3600)
	bg2bar:SetValue(0)

bgframe:SetScript("OnEnter", function(self)
	if inInstance and (instanceType == "pvp") then
		local numScores = GetNumBattlefieldScores()
		for i=1, numScores do
			local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone, bgRating, ratingChange = GetBattlefieldScore(i)
			if ( name ) then
				if ( name == UnitName("player") ) then
					GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT",SVMod.Scale(298),SVMod.Scale(-4));
					GameTooltip:ClearLines()
					GameTooltip:AddLine(SVLocal.datatext_ttstatsfor.."[|cffCC0033"..name.."|r]")
					GameTooltip:AddLine' '
					GameTooltip:AddDoubleLine(SVLocal.datatext_ttkillingblows, killingBlows,1,1,1)
					GameTooltip:AddDoubleLine(SVLocal.datatext_tthonorkills, honorableKills,1,1,1)
					GameTooltip:AddDoubleLine(SVLocal.datatext_ttdeaths, deaths,1,1,1)
					GameTooltip:AddDoubleLine(SVLocal.datatext_tthonorgain, format('%d', honorGained),1,1,1)
					GameTooltip:AddDoubleLine(SVLocal.datatext_ttdmgdone, damageDone,1,1,1)
					GameTooltip:AddDoubleLine(SVLocal.datatext_tthealdone, healingDone,1,1,1)
					--Add extra statistics to watch based on what BG you are in.
					if GetRealZoneText() == SVLocal.bg_arathi then 
						GameTooltip:AddDoubleLine(SVLocal.datatext_basesassaulted,GetBattlefieldStatData(i, 1),1,1,1)
						GameTooltip:AddDoubleLine(SVLocal.datatext_basesdefended,GetBattlefieldStatData(i, 2),1,1,1)
					elseif GetRealZoneText() == SVLocal.bg_warsong then 
						GameTooltip:AddDoubleLine(SVLocal.datatext_flagscaptured,GetBattlefieldStatData(i, 1),1,1,1)
						GameTooltip:AddDoubleLine(SVLocal.datatext_flagsreturned,GetBattlefieldStatData(i, 2),1,1,1)
					elseif GetRealZoneText() == SVLocal.bg_eye then 
						GameTooltip:AddDoubleLine(SVLocal.datatext_flagscaptured,GetBattlefieldStatData(i, 1),1,1,1)
					elseif GetRealZoneText() == SVLocal.bg_alterac then
						GameTooltip:AddDoubleLine(SVLocal.datatext_graveyardsassaulted,GetBattlefieldStatData(i, 1),1,1,1)
						GameTooltip:AddDoubleLine(SVLocal.datatext_graveyardsdefended,GetBattlefieldStatData(i, 2),1,1,1)
						GameTooltip:AddDoubleLine(SVLocal.datatext_towersassaulted,GetBattlefieldStatData(i, 3),1,1,1)
						GameTooltip:AddDoubleLine(SVLocal.datatext_towersdefended,GetBattlefieldStatData(i, 4),1,1,1)
					elseif GetRealZoneText() == SVLocal.bg_strand then
						GameTooltip:AddDoubleLine(SVLocal.datatext_demolishersdestroyed,GetBattlefieldStatData(i, 1),1,1,1)
						GameTooltip:AddDoubleLine(SVLocal.datatext_gatesdestroyed,GetBattlefieldStatData(i, 2),1,1,1)
					elseif GetRealZoneText() == SVLocal.bg_isle then
						GameTooltip:AddDoubleLine(SVLocal.datatext_basesassaulted,GetBattlefieldStatData(i, 1),1,1,1)
						GameTooltip:AddDoubleLine(SVLocal.datatext_basesdefended,GetBattlefieldStatData(i, 2),1,1,1)
					end					
					GameTooltip:Show()
				end
			end
		end
	else
		local name = UnitName("player")
		GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT",SVMod.Scale(298),SVMod.Scale(-4));
		GameTooltip:ClearLines()
		GameTooltip:AddLine(SVLocal.datatext_ttstatsfor.."[|cffCC0033"..name.."|r]")
		GameTooltip:AddLine' '
		for index=1, MAX_BATTLEFIELD_QUEUES do
			local status, name = GetBattlefieldStatus(index)
			if (status == "confirm") or (status == "active") or (status == "queued") then
				GameTooltip:AddDoubleLine("|cffFFFF35"..name.."|r", "|cff35AAFF"..status.."|r")
			else
				GameTooltip:AddDoubleLine("|cffFFFF35--|r", "|cffFFFF35--|r")
			end  
		end
		GameTooltip:Show()
	end
	SVUIBattleGround.hand:Show()
end) 
bgframe:SetScript("OnLeave", function(self) 
	GameTooltip:Hide() 
	SVUIBattleGround.hand:Hide()
end)

local Stat = CreateFrame("Frame")
bgframe:EnableMouse(true)

local Text1  = SVUIBattleGround:CreateFontString(nil, "OVERLAY")
Text1:SetFont(SVFonts.super,12,"THINOUTLINE")
Text1:SetPoint("CENTER", SVUIBG2, 0, 0)
Text1:SetHeight(12)

local Text2  = SVUIBattleGround:CreateFontString(nil, "OVERLAY")
Text2:SetFont(SVFonts.super,12,"THINOUTLINE")
Text2:SetPoint("LEFT", SVUIBG1, 12, 1)
Text2:SetHeight(12)

local Text3  = SVUIBattleGround:CreateFontString(nil, "OVERLAY")
Text3:SetFont(SVFonts.super,12,"THINOUTLINE")
Text3:SetPoint("RIGHT", SVUIBG1, -12, 1)
Text3:SetHeight(12)

local Text4  = SVUIBattleGround:CreateFontString(nil, "OVERLAY")
Text4:SetFont(SVFonts.super_c,16,"OUTLINE")
Text4:SetPoint("CENTER", SVUIBG1, 0, 10)
Text4:SetShadowOffset(2,-2)

local Text5  = SVUIBattleGround:CreateFontString(nil, "OVERLAY")
Text5:SetFont(SVFonts.super_c,12,"THINOUTLINE")
Text5:SetPoint("CENTER", SVUIBG2, 0, 0)
Text5:SetHeight(12)

local int = 2
local function Update(self, t)
	int = int - t
	if int < 0 then
		if inInstance and (instanceType == "pvp") then
			SVUIBG1:SetValue(0)
			SVUIBG2:SetValue(0)
			local dmgtxt
			RequestBattlefieldScoreData()
			local numScores = GetNumBattlefieldScores()
			for i=1, numScores do
				local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone, bgRating, ratingChange = GetBattlefieldScore(i)
				if healingDone > damageDone then
					dmgtxt = ("|cffFFFF35"..SVLocal.datatext_healing.."|r"..healingDone)
				else
					dmgtxt = ("|cffFFFF35"..SVLocal.datatext_damage.."|r"..damageDone)
				end
				if ( name ) then
					if ( name == SVRoot.myname ) then
						Text2:SetText("|cffFFFF35"..SVLocal.datatext_honor.."|r"..format('%d', honorGained))
						Text1:SetText(dmgtxt)
						Text3:SetText("|cffFFFF35"..SVLocal.datatext_killingblows.."|r"..killingBlows)
					end   
				end
			end 
			int  = 2
		else
			local time1,max1 = ((GetBattlefieldTimeWaited(1)*0.001) or 0),((GetBattlefieldEstimatedWaitTime(1)*0.001) or 1)
			local time2,max2 = ((GetBattlefieldTimeWaited(2)*0.001) or 0),((GetBattlefieldEstimatedWaitTime(2)*0.001) or 1)
			SVUIBG1:SetMinMaxValues(0,max1)
			SVUIBG2:SetMinMaxValues(0,max2)
			SVUIBG1:SetValue(time1)
			SVUIBG2:SetValue(time2)
			if (max1 ~= nil) and (max1 > 0) then
				Text4:SetText("|cffFFFF35"..BATTLEFIELD_QUEUE_STATUS.."|r: "..SecondsToTime(time1, false, false, 1).."/"..SecondsToTime(max1, false, false, 1))
			end
			if (max2 ~= nil) and (max2 > 0)then
				Text5:SetText("|cffFFFF35"..BATTLEFIELD_QUEUE_STATUS.."|r: "..SecondsToTime(time2, false, false, 1).."/"..SecondsToTime(max2, false, false, 1))
			end
			int  = 2
		end
	end
end
--hide text when not in an bg
local function OnEvent(self, event)
	local inInstance, instanceType = IsInInstance()
	if inInstance and (instanceType == "pvp") then
		Text4:SetText("")
		Text5:SetText("")
		bgframe:Show();
	else
	   local status = GetBattlefieldStatus(1);
	   if (status == "confirm") or (status == "active") or (status == "queued") then
		   Text1:SetText("")
		   Text2:SetText("")
		   Text3:SetText("")
		   bgframe:Show();
	   else
	   	   bgframe:Hide();
	   end
	end
end

bgframe:RegisterEvent("PLAYER_ENTERING_WORLD")
bgframe:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND")
bgframe:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
bgframe:RegisterEvent("BATTLEFIELD_QUEUE_TIMEOUT")
bgframe:SetScript("OnEvent", OnEvent)
bgframe:SetScript("OnUpdate", Update)
bgframe:SetScript("OnShow", OnEvent)
Update(bgframe, 2)