﻿if (SuperStat.panels == nil) then SuperStat.panels = {} end
local stash_o_stats = {}
SVStat = {}
SVStat.count = 0
-- info panel
local infopanel = CreateFrame ("Frame","SVInfoPanel",UIParent)
infopanel:SetPoint("TOPLEFT",UIParent,"TOPLEFT",2,-2)
infopanel:SetWidth(34)
infopanel:SetHeight(34)
infopanel:SetFrameLevel(2)
infopanel.skin = infopanel:CreateTexture(nil,"OVERLAY")
infopanel.skin:SetPoint("TOPLEFT",4,-4)
infopanel.skin:SetPoint("BOTTOMRIGHT",-4,4)
infopanel.skin:SetTexture([[Interface\Icons\Achievement_Reputation_KirinTor]])
infopanel.skin:SetTexCoord(0.1, 0.9, 0.1, 0.9)
infopanel.overlay = CreateFrame ("Frame",nil,UIParent)
infopanel.overlay:SetAllPoints(infopanel)
infopanel.overlay:SetFrameLevel(5)
SVMod.SuperSkin(infopanel.overlay,2,nil,nil,nil,0)

local statmenu = SVMod.frame(UIParent)
statmenu:SetWidth(120)
statmenu:SetHeight(180)
statmenu:Hide()
statmenu:SetFrameStrata("HIGH")
statmenu:SetFrameLevel(2)
	
local close_button_frame = CreateFrame("Frame",nil,statmenu)
close_button_frame:SetWidth(110)
close_button_frame:SetHeight(16)
close_button_frame:EnableMouse(true)
close_button_frame:SetFrameLevel(3)
close_button_frame:SetFrameStrata("HIGH")
close_button_frame:SetPoint("BOTTOM",statmenu,"BOTTOM",0,6)	
local close_button = close_button_frame:CreateFontString(nil,"OVERLAY")
close_button:SetFont(SVFonts.font,12)
close_button:SetShadowOffset(1,-1)
close_button:SetPoint("CENTER")
close_button:SetJustifyH("CENTER")
close_button:SetJustifyV("MIDDLE")
close_button:SetText("CLOSE")

local toggle_enter = function(self)
	self.Light:SetAlpha(1)
end

local toggle_leave = function(self)
	self.Light:SetAlpha(0)
end

local function MouseDownHandler(frame, button)
  frame = SVInfoPanel
  if frame and (IsShiftKeyDown() or IsAltKeyDown()) and (button == "LeftButton") then
    frame:StartMoving()
    frame:SetUserPlaced(true)
  else
	statmenu:SetPoint("TOPLEFT",frame,4,-56)
	statmenu:Show()
  end
end

local function MouseUpHandler(frame, button)
  frame = SVInfoPanel
  if frame and button == "LeftButton" then
    frame:StopMovingOrSizing()
  end
end

local toggle_close = function()
	statmenu:Hide()
end

local recolor_enter = function(tt)
	tt:SetTextColor(.9,.7,.1)
end

local recolor_leave = function(tt)
	tt:SetTextColor(1,1,1)
end

close_button_frame:SetScript("OnMouseDown",toggle_close)
close_button_frame:SetScript("OnEnter",function() recolor_enter(close_button) end)
close_button_frame:SetScript("OnLeave",function() recolor_leave(close_button) end)

local mainbutton = CreateFrame("Frame",nil,SVInfoPanel)
mainbutton:SetAllPoints(SVInfoPanel)
mainbutton:EnableMouse(true)
mainbutton:SetFrameStrata("LOW")
mainbutton:SetFrameLevel(8)
mainbutton:SetAlpha(0)
local mbtex = mainbutton:CreateTexture(nil,"BORDER")
mbtex:SetTexture(0.8,0.8,0.8,0.5)
mbtex:SetAllPoints()

SVInfoPanel.Light = mainbutton

SVInfoPanel:EnableMouse(true)
SVInfoPanel:SetMovable(true)
SVInfoPanel:SetClampedToScreen(false)
SVInfoPanel:SetScript("OnEnter", toggle_enter)
SVInfoPanel:SetScript("OnLeave", toggle_leave)
SVInfoPanel:SetScript("OnMouseDown", MouseDownHandler)
SVInfoPanel:SetScript("OnMouseUp", MouseUpHandler)

local add_place = function(name,show)
	show:Show()
	local load_ok = true
	for i=1,SVStat.num_stats do
		if SuperStat.panels[i] == name then
			load_ok = false
		end
	end
	for j=1,SVStat.num_stats do
		if (SuperStat.panels[j] == nil) and (load_ok == true) then
			SuperStat.panels[j] = name
			load_ok = false
		end
	end
	local count = 1
	for k=1,SVStat.num_stats do
		if (SuperStat.panels[k] ~= nil) then
			local f = SuperStat.panels[k]
			local f_s = tostring(f)
			local swap = _G[f_s]
			swap:ClearAllPoints()
			swap:SetPoint("LEFT",SVInfoPanel,"RIGHT",(128*(count-1)),0)
			count = count+1
		end
	end
end

local remove_place = function(name,hide)
	hide:Hide()
	local swap_names = {}
	local count = 1
	for i=1,SVStat.num_stats do
		if (SuperStat.panels[i] ~= name) then
			swap_names[count] = SuperStat.panels[i]
			count = count+1
		end
	end
	SuperStat.panels = swap_names
	count = 1
	for j=1,SVStat.num_stats do
		if (SuperStat.panels[j]) then
			local f = SuperStat.panels[j]
			local f_s = tostring(f)
			local swap = _G[f_s]
			swap:ClearAllPoints()
			swap:SetPoint("LEFT",SVInfoPanel,"RIGHT",(128*(count-1)),0)
			count = count+1
		end
	end
end

local toggle_me = function(name)
	if not InCombatLockdown() then
		local panel = _G[name]
		if panel:IsShown() then
			remove_place(name,panel)
		else
			add_place(name,panel)
		end
	end
	statmenu:Hide()
end
local s_c = 0
SVStat.make = function(panel,statname,position)
	SVStat.num_stats = position
	local this_guy = tostring(panel)
	
	local frame = CreateFrame("Frame",nil,statmenu)
	frame:SetWidth(120)
	frame:SetHeight(16)
	frame:EnableMouse(true)
	frame:SetFrameLevel(3)
	frame:SetFrameStrata("HIGH")
	
	local place_name = frame:CreateFontString(nil,"OVERLAY")
	place_name:SetFont(SVFonts.font,12)
	place_name:SetShadowOffset(.3,-1)
	place_name:SetPoint("CENTER")
	place_name:SetText(statname)
	place_name:SetJustifyH("CENTER")
	place_name:SetJustifyV("MIDDLE")

	stash_o_stats[position] = frame
	stash_o_stats[position]:SetPoint("TOP",statmenu,"TOP",0,-(16*s_c))
	s_c = s_c + 1
	
	frame:SetScript("OnEnter",function() recolor_enter(place_name) end)
	frame:SetScript("OnLeave",function() recolor_leave(place_name) end)
	frame:SetScript("OnMouseDown",function() toggle_me(this_guy) end)
end

local on_load = function()
	local count = 0
	for i=1,SVStat.num_stats do
		if (SuperStat.panels[i]~=nil) then
			local f = SuperStat.panels[i]
			local f_s = tostring(f)
			local addme = _G[f_s]
			addme:Show()
			addme:ClearAllPoints()
			addme:SetPoint("LEFT",SVInfoPanel,"RIGHT",(128*count),0)
			count = count+1
		end
	end
	statmenu:SetHeight(SVStat.num_stats*16+61)
end
tinsert(SVRoot.PostApply,on_load)
