local wf = WatchFrame
local wfmove = false 
local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local r, g, b = 1,1,0
local ir,ig,ib = cColor[1],cColor[2],cColor[3]
local blank = SVMedia.blank
local glowTex = SVMedia.glow
local a_wide = (SVMod.Scale(SuperSet.chatops.chat_width)*SuperSet.scaleops.chatscale)-56
-----
------------------------------------------------------
local function CreateScrollFrame()
	local wf_parent = CreateFrame("Frame","SVUI_WatchFrame",UIParent)
	wf_parent:SetMovable(true)
	wf_parent:SetClampedToScreen(false)
	wf_parent:SetFrameLevel(0)
	if (Quokkas_Options.lootchat == true) then
		SVMod.chatskin(wf_parent,-6,false,true)
		wf_parent:ClearAllPoints()
		wf_parent:SetPoint("TOPLEFT", SuperDock2, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(42))
		wf_parent:SetPoint("BOTTOMRIGHT", SuperDock2, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(18))
	else
		wf_parent:SetPoint("TOPLEFT", MapBorder, "BOTTOMLEFT", SVMod.Scale(-8), SVMod.Scale(-140))
		wf_parent:SetWidth(236)
		wf_parent:SetHeight(237)
	end
	wf_parent:SetUserPlaced(true)
	------
	local wf_scrollgroup = CreateFrame("ScrollFrame", "SVUI_ScrollingWatchFrame", wf_parent)
	wf_scrollgroup:SetPoint("TOPLEFT",wf_parent,42,-12)
	wf_scrollgroup:SetPoint("BOTTOMRIGHT",wf_parent,-12,38)
	wf_scrollgroup:SetFrameLevel(4)
	------
	local wfcbg = CreateFrame("Frame","SVUI_ScrollingWatchFrameBG",wf_scrollgroup)
	wfcbg:SetPoint("TOPLEFT",wf_scrollgroup,-42,12)
	wfcbg:SetPoint("BOTTOMRIGHT",wf_scrollgroup,12,-13)
	wfcbg:SetFrameLevel(2)
	SVMod.SuperSkin(wfcbg,3)
	----------
	local wfhead_c_bg = CreateFrame("Frame","SVUI_WatchFrameTitle",wf_parent)
	wfhead_c_bg:SetPoint("BOTTOMLEFT",wf_parent,0,-4)
	wfhead_c_bg:SetPoint("BOTTOMRIGHT",wf_parent,0,-4)
	wfhead_c_bg:SetHeight(34)
	wfhead_c_bg:SetFrameLevel(2)
	SVMod.SuperSkin(wfhead_c_bg,3)
	----------
	local wf_sg_slider = CreateFrame("Slider", "SVUI_ScrollingWatchFrameSlider", wf_scrollgroup)
	wf_sg_slider:SetHeight(wf_scrollgroup:GetHeight()-12)
	wf_sg_slider:SetWidth(22)
	wf_sg_slider:SetPoint("TOPLEFT",wf_scrollgroup,-28,0)
	wf_sg_slider:SetPoint("BOTTOMLEFT",wf_scrollgroup,-28,0)
	wf_sg_slider:SetBackdrop({
		bgFile = SVMedia.blank, 
		edgeFile = SVMedia.glow, 
		edgeSize = 4, insets = {left = 3, right = 3, top = 3, bottom = 3}})
	wf_sg_slider:SetBackdropColor(ir,ig,ib,0.3)
	wf_sg_slider:SetBackdropBorderColor(ir,ig,ib,0.8)
	wf_sg_slider:SetFrameLevel(6)
	SVMod.SimpleSkin(wf_sg_slider,1)
	---------
	wf_sg_slider:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
	wf_sg_slider:SetOrientation("VERTICAL")
	wf_sg_slider:SetValueStep(15)
	wf_sg_slider:SetMinMaxValues(1,600)
	wf_sg_slider:SetValue(1)
	-----
	wf:ClearAllPoints()
	wf:SetClampedToScreen(false)
	wf:SetParent(wf_scrollgroup)
	wf:SetWidth( wf_scrollgroup:GetWidth()-40)
	wf:SetHeight(600)
	wf:SetPoint( "TOPLEFT", 40, 0 )
	wf:SetFrameLevel((wf_scrollgroup:GetFrameLevel()) + 12)
	SVWatch.ResetWatchFrame(SVUI_ScrollingWatchFrame);
	------
	wf_scrollgroup:SetScrollChild(wf)
	wf_sg_slider:SetScript("OnValueChanged", function(self,value) wf_scrollgroup:SetVerticalScroll(value) end)
	local wfceb = WatchFrameCollapseExpandButton
	wfceb:SetParent(wf_parent)
	wfceb:ClearAllPoints()
	wfceb:SetPoint("RIGHT",wfhead_c_bg,"RIGHT",-12,0)
	local wfhead = WatchFrameHeader;
	local wftitle = WatchFrameTitle;
	if (wfhead) then
		wfhead:SetParent(wf_parent)
		wfhead:ClearAllPoints();
		wfhead:SetFrameLevel(2);
		wfhead:SetPoint("LEFT",wfhead_c_bg,"LEFT",14,0);
		wfhead:SetPoint("RIGHT",wfceb,"LEFT",-5,0);		
	else
		wftitle:SetParent(wf_parent)
		wftitle:ClearAllPoints();
		wftitle:SetPoint("LEFT",wfhead_c_bg,"LEFT",14,0);
		wftitle:SetPoint("RIGHT",wfceb,"LEFT",-5,0);
	end
	------
	wf_sg_slider:ClearAllPoints()
	wf_sg_slider:SetPoint("TOPLEFT",wf_scrollgroup,-28,0)
	wf_sg_slider:SetPoint("BOTTOMLEFT",wf_scrollgroup,-28,0)
	--------------------------------------------------
	local w = WatchFrameLines;
	w:ClearAllPoints();
	w:SetAllPoints();
end

hooksecurefunc("WatchFrame_Update",function(self)
	self = WatchFrame;
	local filterOK, numQuests, numAchievements, numTimers = SVWatch.CheckFilters(self);
	SVWatch.UpdateWatchFrame(WatchFrame);
	local autoHide,isShown = SVWatch.CheckAutoHide(SVUI_ScrollingWatchFrame);
end);

WatchFrame.OnUpdate = function()
	SVWatch.UpdateWatchFrame(WatchFrame);
	WatchFrame_Update(WatchFrame);
end

WatchFrame.OnShow = function() 
	SVWatch.RestoreWatchFrame();
	local autoHide,isShown = SVWatch.CheckAutoHide(SVUI_ScrollingWatchFrame);			
	WatchFrame.OnUpdate(f);
end

local function onEvent(self,event,arg1,arg2,arg3)
	if event == "CVAR_UPDATE" then
		if ( arg1 == "WATCH_FRAME_WIDTH_TEXT" ) then
			if ( SVUI_WatchFrame ) then
				WatchFrame.OnUpdate();
			end
		end		
	elseif event == "PLAYER_ENTERING_WORLD" then	
		if ( not SVUI_WatchFrame ) then
			CreateScrollFrame();
			WatchFrame.OnShow();
		end
		SVWF_EventFrame:UnregisterEvent( "PLAYER_ENTERING_WORLD" );
	end	
end

local function WATCHFRAMELOCK()
	if (SuperSet.current_dock == 2) then
		if SVUI_ScrollingWatchFrame:IsShown() then
			SVUI_ScrollingWatchFrame:Hide()
			if (Quokkas_Options.lootchat == true) then
				SuperDock2:SetAlpha(0)
				SVUI_WatchFrame.bg:SetGradientAlpha("VERTICAL",0,0,0,0,0,0,0,0)
			end
		else
			SVUI_ScrollingWatchFrame:Show()
			if (Quokkas_Options.lootchat == true) then
				SuperDock2:SetAlpha(1)
				SVUI_WatchFrame.bg:SetGradientAlpha("VERTICAL",0.12,0.12,0.12,0.9,0,0,0,0)
			end
		end
	end
end

SLASH_WATCHFRAMELOCK1 = "/wf"
SlashCmdList["WATCHFRAMELOCK"] = WATCHFRAMELOCK
WatchFrameCollapseExpandButton:HookScript("OnClick", function() WATCHFRAMELOCK() end)
------------------------------------------------------------------------
--	Chat Animations and Miscellaneous features by AlleyKat
------------------------------------------------------------------------
if (Quokkas_Options.lootchat == true) then
	local a_low = SuperSet.chatops.chat_height*0.6
	local a_high = SVMod.Scale(SuperSet.chatops.chat_height)*SuperSet.scaleops.chatscale
	function SVWFSTRETCH()
		SVUI_WatchFrame:ClearAllPoints()
		SVUI_WatchFrame:SetPoint("TOPLEFT", SuperDock2, "TOPLEFT", SVMod.Scale(8), SVMod.Scale(42))
		SVUI_WatchFrame:SetPoint("BOTTOMRIGHT", SuperDock2, "BOTTOMRIGHT", SVMod.Scale(-8), SVMod.Scale(18))
		SuperDock2:SetAlpha(1)
		SVUI_ScrollingWatchFrameSlider:ClearAllPoints()
		SVUI_ScrollingWatchFrameSlider:SetPoint("TOPLEFT",SVUI_ScrollingWatchFrame,-28,0)
		SVUI_ScrollingWatchFrameSlider:SetPoint("BOTTOMLEFT",SVUI_ScrollingWatchFrame,-28,0)
	end
	local chatcur = {a_low,a_high}
	local n = {
		[1] = chatcur[1],
		[2] = chatcur[2],
	}
	local speed = 240
	local move_UP = function (self,t,target,N)
		n[N] = n[N] + t * speed
		if n[N] < a_high then
			target:SetHeight(n[N])
		else
			self:Hide()
			n[N] = a_high
			target:SetHeight(a_high)
		end
	end
	local move_DOWN = function (self,t,target,N)
		n[N] = n[N] - t * speed
		if n[N] > a_low then
			target:SetHeight(n[N])
		else
			self:Hide()
			n[N] = a_low
			target:SetHeight(a_low)
		end

	end
	local wf_up = CreateFrame("Frame") 
	local wf_down = CreateFrame("Frame")
	wf_up:Hide()
	wf_down:Hide()
	wf_up:SetScript("OnUpdate",function(self,t) move_UP(self,t,SuperDock2,1,2) end)
	wf_down:SetScript("OnUpdate",function(self,t) move_DOWN(self,t,SuperDock2,1,2) end)
	SuperDockToggle2:SetScript("OnMouseDown",function() 
		if chatcur[1] == a_low then
			chatcur[1] = a_high
			wf_up:Show()
			wf_down:Hide()
		else 
			chatcur[1] = a_low
			wf_up:Hide()
			wf_down:Show()
		end
		SVWFSTRETCH()
	end)
	tinsert(SVRoot.PostApply,SVWFSTRETCH)
end
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
wfEventFrame = CreateFrame( "Frame", "SVWF_EventFrame", UIParent );
wfEventFrame:SetScript( "OnEvent", onEvent );
wfEventFrame:RegisterEvent( "PLAYER_ENTERING_WORLD" );
wfEventFrame:RegisterEvent( "CVAR_UPDATE" );
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------