if SuperSet.unitops.grid == true then return end
if SuperSet.unitops.old_style_party ~= true then return end
if SuperSet.unitops.allparty == false then return end

local colors = SVColors.oUF_colors
local fsize = SuperSet.font_sizes.partyname

local updatePower = function(bar, unit, min, max)
	
	if UnitIsDead(unit) or UnitIsGhost(unit) or not(UnitIsConnected(unit)) then
	bar:SetValue(0)	
	else
	bar:SetValue(min)
		
	local ptype = select(2, UnitPowerType(unit))
	
		if(colors.power[ptype]) then
		
			local r, g, b = unpack(colors.power[ptype])
				
			if bar.value then
			bar.value:SetTextColor(r, g, b)
			end
			
		end
	
	end
	
end

local function CreateParty(self, unit)
	local high_level = CreateFrame("Frame",nil,self)
	high_level:SetFrameLevel(12)
	self.data = high_level
	
	self.menu = SVUnit.SpawnMenu
	self:RegisterForClicks('AnyDown')
	self:SetAttribute('*type2', 'menu')
	self:SetFrameLevel(0)
	self:SetFrameStrata("LOW")
	
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)
	
	self:SetBackdrop( {
		bgFile = SVMedia.blank,
		edgeFile = SVMedia.glow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }}) 
	self:SetBackdropBorderColor(unpack(SVMedia.bordershadow))
	self:SetBackdropColor(unpack(SVMedia.backdropcolor))
	
	local i_bg = SVUnit.frame(self,"LOW",3)
	i_bg:SetPoint ("TOPLEFT",self,"BOTTOMLEFT",-1,5)
	i_bg:SetPoint ("TOPRIGHT",self,"BOTTOMRIGHT",1,5)
	i_bg:SetHeight(18*SuperSet.scaleops.ufscale)
	self.infobg = i_bg
	
	local port = CreateFrame("Frame", nil, self)
	port:SetPoint("TOPLEFT",self,"TOPLEFT",2,-2)
	port:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",-2,2)
	port:SetBackdrop{bgFile = SVMedia.bar, tile = false}
	port:SetBackdropColor(0.1,0,0)
	port:SetFrameLevel(1)
	SVMod.SimpleSkin(port)
	
	local mask = CreateFrame("Frame",nil,port)
	mask:SetFrameLevel(3)
	mask:SetPoint("TOPLEFT")
	mask:SetPoint("TOPRIGHT")
	mask:SetHeight(25*SuperSet.scaleops.ufscale)
	
	local tex = mask:CreateTexture(nil,"Border")
	tex:SetAllPoints()
	tex:SetTexture(1,1,1,1)
	tex:SetGradientAlpha("VERTICAL",0,0,0,0,0,0,0,.666)
	tex:SetBlendMode("BLEND")
	
	local health = CreateFrame("StatusBar", nil, self)
	health:SetStatusBarTexture(SVMedia.smoothbar)
	health:SetAllPoints(port)
	health:SetFrameLevel(3)
	SVMod.SimpleSkin(health)				
	health.Smooth = true
	health.frequentUpdates = true
	
	health.deadornot = health:CreateFontString (nil,"OVERLAY")
	health.deadornot:SetFont(SVFonts.font,fsize)
	health.deadornot:SetShadowOffset(1,-1)
	health.deadornot:SetJustifyH("CENTER")
	health.deadornot:SetPoint("CENTER",0,1.3)
	
	self.Health = health
	self.Health.port = port
	self.Health.colorClass = true
	self.Health.colorReaction = true	
	self.Auras = CreateFrame("Frame", nil, self)
	
		self.Auras.initialAnchor = "TOPLEFT"
		self.Auras["growth-x"] = "RIGHT"
		self.Auras["growth-y"] = "DOWN"
		self.Auras.numDebuffs = 4
		self.Auras.spacing = 4
		self.Auras.size = 25*SuperSet.scaleops.ufscale
		self.Auras.numBuffs = 4
		self.Auras:SetHeight(self.Auras.size*2+4)
		self.Auras:SetWidth((28*4+12)*SuperSet.scaleops.ufscale)
		self.Auras:SetPoint("TOPLEFT",self,"TOPRIGHT",5,-2)
		self.Auras.cc_font_size = 13
		self.Auras.onlyShowPlayer = true
		self.Auras.PostCreateIcon = SVUnit.auraIcon
		self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
	
	local hvalue = self.Health:CreateFontString(nil, "OVERLAY")
	hvalue:SetFont(SVFonts.super,fsize,"OUTLINE")
	hvalue:SetAllPoints(self)
	hvalue:SetAlpha(0)
	self.Health.value = hvalue
		
	local cc = CreateFrame("StatusBar", nil, self.infobg)
	cc:SetFrameLevel(8)
	
	cc:SetAllPoints(self.infobg)
	cc:SetStatusBarTexture(SVMedia.blank)
	cc:SetStatusBarColor(0.8,1,0.1)
	SVMod.SimpleSkin(cc)
		cc.Spark = cc:CreateTexture(nil, "OVERLAY")
		cc.Spark:SetWidth(9)
		cc.Spark:SetBlendMode("ADD")
		cc.Spark:SetAlpha(1)
		
	local iconbg = CreateFrame("Frame", nil, cc)
		iconbg:SetPoint("BOTTOMRIGHT",cc,"BOTTOMLEFT")
		iconbg:SetWidth(35*SuperSet.scaleops.ufscale)
		iconbg:SetHeight(35*SuperSet.scaleops.ufscale)
		iconbg:SetBackdrop{
				bgFile = SVMedia.blank, tile = true, tileSize = 16,
				edgeFile = SVMedia.glow, edgeSize = 4,
				insets = {left = 3, right = 3, top = 3, bottom = 3},}
		iconbg:SetBackdropColor(unpack(SVMedia.backdropcolor))
		iconbg:SetBackdropBorderColor(unpack(SVMedia.bordershadow))
		SVUnit.mkButton(iconbg,nil,true)
		iconbg:SetFrameLevel(10)
		iconbg:SetFrameStrata(self.Health:GetFrameStrata())
		iconbg:SetAlpha(.9)
	
		cc.Icon = iconbg:CreateTexture(nil, "BORDER")
		cc.Icon:SetTexCoord(.1,.9,.1,.9)
		cc.Icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
		cc.Icon:SetPoint("TOPLEFT",4,-4)
		cc.Icon:SetPoint("BOTTOMRIGHT",-4,4)
	
	self.Castbar = cc
	
	local lead = self.data:CreateFontString(nil,"OVERLAY")
	lead:SetFont(SVFonts.cooldown,fsize,"THINOUTLINE")
	lead:SetShadowOffset(1,-1.5)
	lead:SetPoint("BOTTOMLEFT",self.Portrait,"BOTTOMLEFT",2,3)
	lead:SetText("L")
	
	local power = CreateFrame("StatusBar", nil, self)
	power:SetPoint("TOPLEFT",self.infobg,3,-3)
	power:SetPoint("BOTTOMRIGHT",self.infobg,-3,3)
	power:SetFrameLevel(6)
	power:SetStatusBarTexture(SVMedia.colorbar)
	SVMod.SimpleSkin(power)
	power.frequentUpdates = true
	power.Smooth = true
	power.colorSmooth = true
	self.Power = power
	
	local info = self.Health:CreateFontString(nil, "OVERLAY")
	info:SetFont(SVFonts.super,fsize,"THINOUTLINE")
	info:SetShadowOffset(-2,-1)
	info:SetShadowColor(0,0,0,0.4)
	info:SetPoint("TOPLEFT",2,-2)
	info:SetPoint("TOPRIGHT",-2,-2)
	info:SetJustifyH("LEFT")
	self:Tag(info, '[raidcolor][nameparty]')
	
	local p_glow = SVUnit.frame(self.infobg,nil,0)
	p_glow:SetPoint("TOPRIGHT")
	p_glow:SetPoint("BOTTOMLEFT")
	p_glow:SetAlpha(0)
	self.Power.glow = p_glow
	
	SVUnit.RaidIcons(self,"RIGHT")
	self.RaidIcon:SetAlpha(0.7)
	
	local lfd = self.data:CreateTexture(nil, "OVERLAY")
    lfd:SetHeight(24*SuperSet.scaleops.ufscale)
    lfd:SetWidth(24*SuperSet.scaleops.ufscale)
	lfd:SetPoint("TOPRIGHT",self,"TOPLEFT")
	
	self.LFDRole = lfd
	
	table.insert(self.__elements, SVUnit.LegionThreat)
	self:RegisterEvent('PLAYER_TARGET_CHANGED', SVUnit.LegionThreat)
	self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', SVUnit.LegionThreat)
	self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', SVUnit.LegionThreat)
	
	self.SpellRange = {
				["insideAlpha"] = 1,
				["outsideAlpha"] = .666,}
	
	local picon = self.Health:CreateTexture(nil, 'OVERLAY')
	picon:SetPoint('CENTER', self.Health)
	picon:SetSize(55, 55)
	picon:SetTexture(SVMedia.svlogo)
	picon.Override = SVMod.Phasing
	self.PhaseIcon = picon
	
	local dbh = self.data:CreateTexture(nil,"OVERLAY")
	dbh:SetAllPoints(self.Health)
	dbh:SetTexture(SVMedia.unitaf)
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0)
	self.DebuffHighlight = dbh
	self.DebuffHighlightFilter = true
	self.DebuffHighlightAlpha = 0.5
	
	self.Health.PostUpdate = SVUnit.PostHealth
	self.Power.PostUpdate = updatePower
	SVUnit.IncomingHeals(self,unit)
	self:SetSize(124*SuperSet.scaleops.ufscale,50*SuperSet.scaleops.ufscale)
	return self
	
end

oUF:RegisterStyle('VillainParty', CreateParty)
oUF:Factory(function(self)
	oUF:SetActiveStyle('VillainParty')
	local raid = oUF:SpawnHeader("oUF_VillainParty", nil ,"custom [@raid6,exists] hide;show",
	'oUF-initialConfigFunction', [[
		local header = self:GetParent()
		self:SetWidth(header:GetAttribute('initial-width'))
		self:SetHeight(header:GetAttribute('initial-height'))
	]],
	'initial-width', SVMod.Scale(124*SuperSet.scaleops.gridscale),
	'initial-height', SVMod.Scale(50*SuperSet.scaleops.gridscale),
	"showParty", true, "showPlayer", SuperSet.unitops.playerparty, "showRaid", true, "groupFilter", "1,2,3,4,5,6,7,8", 
	"groupingOrder", "1,2,3,4,5,6,7,8", "groupBy", "GROUP", "yOffset", -SuperSet.unitops.party_space)

	raid:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 46, -125)
end)