if not SuperSet.unitops.grid == true then return end
if SuperSet.unitops.allparty == false then return end

local font2 = SVFonts.font
local font1 = SVFonts.super_c
local fsize = SuperSet.font_sizes.raidname
local highlight = false	
local invert = SVColors["invert"]

local function Shared(self, unit)
	self.colors = SVColors.oUF_colors
	self:RegisterForClicks("AnyUp")
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)
	self.menu = SVUnit.SpawnMenu
	self:SetBackdrop( {
		bgFile = SVMedia.blank,
		edgeFile = SVMedia.glow,
		edgeSize = 4, insets = { left = 2, right = 2, top = 2, bottom = 2 }}) 
	self:SetBackdropBorderColor(0,0,0,0)
	self:SetBackdropColor(0,0,0,0)
	self:SetFrameStrata("LOW")
	self:SetFrameLevel(0)
	
	local glowme = CreateFrame("Frame",nil,self)
	glowme:SetPoint("TOPLEFT",self,3,-3)
	glowme:SetPoint("BOTTOMRIGHT",self,-3,3)
	glowme:SetFrameLevel(2)
	SVMod.SimpleSkin(glowme)
	self.glow = glowme
	
	local health = CreateFrame('StatusBar', nil, self)
    health:SetPoint("TOPLEFT",self,5,-5)
    health:SetPoint("BOTTOMRIGHT",self,-5,5)
	health:SetStatusBarTexture(SVMedia.bar)
	health.frequentUpdates = true
	health.colorDisconnected = true
	health.colorClass = true
	health.colorReaction = true
	health:SetOrientation("VERTICAL")
	self.Health = health

	health.bg = self.Health:CreateTexture(nil, 'BORDER')
	health.bg:SetAllPoints(self.Health)
	health.bg:SetTexture(SVMedia.blank)
	health.bg:SetVertexColor(1, 1, 1)
	health.bg.multiplier = (0.2)
	
	self.Health.bg = health.bg
	
	local track = CreateFrame("Frame",nil,self)
	track:SetAllPoints(self.Health)
	track:SetFrameLevel(2)
	self.track = track
	
	local hvalue = self.track:CreateFontString(nil, "OVERLAY")
	hvalue:SetFont(SVFonts.super,14,"THINOUTLINE")
	hvalue:SetPoint("TOPLEFT", self, "TOPLEFT", SVMod.Scale(2),SVMod.Scale(-2))
	hvalue:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", SVMod.Scale(-2),SVMod.Scale(2))
	hvalue:SetAlpha(0)
	self.Health.value = hvalue
	
	self.grad = self.glow:CreateTexture(nil,"BORDER")
	self.grad:SetTexture(1,1,1)
	self.grad:SetGradientAlpha("VERTICAL",0,1,1,0.6,0,1,1,0.2)
	self.grad:SetAllPoints(self.Health)
	self.grad:Hide()
		
	local name = self.track:CreateFontString(nil, 'OVERLAY')
	name:SetFont(SVFonts.font,fsize,"THINOUTLINE")
	name:SetShadowOffset(3,0)
	name:SetShadowColor(0,0,0)
	name:SetPoint("TOPLEFT", self, "TOPLEFT", SVMod.Scale(5),SVMod.Scale(-12))
	name:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", SVMod.Scale(-5),SVMod.Scale(2))
	name:SetJustifyH("CENTER")
	self:Tag(name, '[raidcolor][nameraid]')
	self.Name = name

	RaidIcon = self.Health:CreateTexture(nil, 'OVERLAY')
		RaidIcon:SetHeight(SVMod.Scale(20*SuperSet.scaleops.gridscale))
		RaidIcon:SetWidth(SVMod.Scale(20*SuperSet.scaleops.gridscale))
		RaidIcon:SetPoint("TOP", self, "TOP", 0, -5)
		RaidIcon:SetTexture(SVMedia.raidicons) -- thx hankthetank for texture
		RaidIcon:SetAlpha(0.8)
		self.RaidIcon = RaidIcon
	
	table.insert(self.__elements, SVUnit.LegionThreat)
	self:RegisterEvent('PLAYER_TARGET_CHANGED', SVUnit.LegionThreat)
	self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', SVUnit.LegionThreat)
	self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', SVUnit.LegionThreat)
	
	local ReadyCheck = self.Health:CreateTexture(nil, "OVERLAY")
	ReadyCheck:SetHeight(SVMod.Scale(12*SuperSet.scaleops.gridscale))
	ReadyCheck:SetWidth(SVMod.Scale(12*SuperSet.scaleops.gridscale))
	ReadyCheck:SetPoint('CENTER')
	self.ReadyCheck = ReadyCheck
	
	local dbh = self.track:CreateTexture(nil,"OVERLAY")
	dbh:SetAllPoints(self.track)
	dbh:SetTexture(SVMedia.bar)
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0)
	self.DebuffHighlight = dbh
	self.DebuffHighlightFilter = true
	self.DebuffHighlightAlpha = 0.5
	health.Smooth = true
	local range = {insideAlpha = 1, outsideAlpha = 0.4}
	self.Range = range
	
	if SuperSet.unitops.raidwatch == true then
		-- AuraWatch (corner icon)
		SVMod.createAuraWatch(self,unit)
		
		-- Raid Debuffs (big middle icon)
		local RaidDebuffs = CreateFrame('Frame', nil, self)
		RaidDebuffs:SetSize(24,24)
		RaidDebuffs:SetPoint("CENTER",self.Health)
		RaidDebuffs:SetFrameStrata(self.Health:GetFrameStrata())
		RaidDebuffs:SetFrameLevel(self.Health:GetFrameLevel() + 2)
		
		RaidDebuffs.icon = RaidDebuffs:CreateTexture(nil, 'OVERLAY')
		RaidDebuffs.icon:SetTexCoord(.1,.9,.1,.9)
		RaidDebuffs.icon:SetVertexColor(1,1,1,0.3)
		RaidDebuffs.icon:SetPoint("TOPLEFT", SVMod.Scale(2), SVMod.Scale(-2))
		RaidDebuffs.icon:SetPoint("BOTTOMRIGHT", SVMod.Scale(-2), SVMod.Scale(2))
		
		RaidDebuffs.count = RaidDebuffs:CreateFontString(nil, 'OVERLAY')
		RaidDebuffs.count:SetFont(SVFonts.super_c, 18, "THINOUTLINE")
		RaidDebuffs.count:SetPoint('BOTTOMRIGHT', RaidDebuffs, 'BOTTOMRIGHT', 2, 2)
		RaidDebuffs.count:SetTextColor(1, .9, 0)
		
		self.RaidDebuffs = RaidDebuffs
    end
    self.Health.Name = self.Name
    self.Health.RaidDebuffs = self.RaidDebuffs
	self.Health.PostUpdate = SVUnit.PostHealthRaid
	
	self:SetScript('OnEnter', function(self) UnitFrame_OnEnter(self) 
		if highlight == false then 
			self.grad:Show()
			highlight = true 
		end
	end)
	
	self:SetScript('OnLeave', function(self)
		UnitFrame_OnLeave(self) 
		if highlight == true then 
			self.grad:Hide() 
			highlight = false
		end
	end)
	
	self:RegisterEvent("PARTY_MEMBERS_CHANGED", SVMod.updateAllElements)
	self:RegisterEvent("RAID_ROSTER_UPDATE", SVMod.updateAllElements)
	
	return self
end

oUF:RegisterStyle('VillainGrid', Shared)
oUF:Factory(function(self)
	oUF:SetActiveStyle("VillainGrid")
	local raid = self:SpawnHeader("oUF_VillainGrid", nil, "raid,party", 
		'oUF-initialConfigFunction', [[
			local header = self:GetParent()
			self:SetWidth(header:GetAttribute('initial-width'))
			self:SetHeight(header:GetAttribute('initial-height'))
		]],
		'initial-width', SVMod.Scale(75*SuperSet.scaleops.gridscale),
		'initial-height', SVMod.Scale(70*SuperSet.scaleops.gridscale),
		"showParty", true,
		'showPlayer', SuperSet.unitops.playerparty,
		'showRaid', true,
		'xoffset', -2,
		'yOffset', 2,
		'point', "LEFT",
		'groupFilter', '1,2,3,4,5,6,7,8',
		'groupingOrder', '1,2,3,4,5,6,7,8',
		'groupBy', 'GROUP',
		'maxColumns', 8,
		'unitsPerColumn', 5,
		'columnSpacing', 5,
		'columnAnchorPoint', "TOP")
	raid:SetPoint('LEFT', UIParent, 'LEFT', 25, 0)
end)