﻿if SuperSet.unitops.grid == true then return end
if SuperSet.unitops.old_style_party == true then return end
if SuperSet.unitops.allparty == false then return end

local colors = SVColors.oUF_colors
local fsize = SuperSet.font_sizes.partyname

local updateHealth = function(bar, unit, current, maxhp)  
	local anim = bar.second.anim:IsPlaying()
	if (UnitIsDead(unit)) or (UnitIsGhost(unit)) or not(UnitIsConnected(unit)) then	
		bar:SetStatusBarColor(0,0,0,0)
		bar.second:SetStatusBarColor(0.2, 0.2, 0.2, 0.68)
		bar.second:SetMinMaxValues(0,maxhp)
		bar.second:SetValue(maxhp)
		bar.second:SetAlpha(1)
		if anim then
			bar.second.anim:Stop()
			bar:SetFrameLevel(6)
			bar.second:SetFrameLevel(5)
		end
	else		
		bar:SetValue(maxhp-current)
		bar.second:SetMinMaxValues(0,maxhp)
		bar.second:SetValue(maxhp-current)
		bar.deadornot:SetText()
		if (current/maxhp) <= .25 then
			if not anim then
				bar.second.anim:Play()
				bar:SetFrameLevel(5)
				bar.second:SetFrameLevel(6)	
			end
			bar.second:SetStatusBarColor(1, 0, 0, .95)
			bar:SetStatusBarColor(0.09, 0, 0, 0.7)
		else
			if anim then
				bar.second.anim:Stop()
				bar:SetFrameLevel(6)
				bar.second:SetFrameLevel(5)	
			end
			bar.second:SetAlpha(1)
			bar:SetStatusBarColor(1, 0, 0, 0.666)
			bar.second:SetStatusBarColor(0.8, 0, 0, 0.6)
		end
	end
end

local updatePower = function(bar, unit, min, max)
	if UnitIsDead(unit) or UnitIsGhost(unit) or not(UnitIsConnected(unit)) then
	bar:SetValue(0)	
	else
	bar:SetValue(min)
	local ptype = select(2, UnitPowerType(unit))
		if(colors.power[ptype]) then
			local r, g, b = unpack(colors.power[ptype])
			if bar.value then
			bar.value:SetTextColor(r, g, b)
			end
		end
	end
end

local function CreateParty(self, unit)
	local high_level = CreateFrame("Frame",nil,self)
	high_level:SetFrameLevel(12)
	self.data = high_level
	self.menu = SVUnit.SpawnMenu
	self:RegisterForClicks('AnyDown')
	self:SetAttribute('*type2', 'menu')
	self:SetFrameLevel(0)
	self:SetFrameStrata("LOW")
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)
	
	self:SetBackdrop( {
		bgFile = SVMedia.blank,
		edgeFile = SVMedia.glow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }}) 
	self:SetBackdropBorderColor(unpack(SVMedia.bordershadow))
	self:SetBackdropColor(unpack(SVMedia.backdropcolor))
	
	local i_bg = SVUnit.frame(self,"LOW",3)
	i_bg:SetPoint ("TOPLEFT",self,"BOTTOMLEFT",-1,5)
	i_bg:SetPoint ("TOPRIGHT",self,"BOTTOMRIGHT",1,5)
	i_bg:SetHeight(18*SuperSet.scaleops.ufscale)
	self.infobg = i_bg
	
	local port = CreateFrame("PlayerModel", nil, self)
	port:SetAlpha(1)
	port:SetPoint("TOPLEFT",self,"TOPLEFT",2,-2)
	port:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",-2,2)
	port:SetBackdrop{bgFile = SVMedia.smallbg, tile = false}
	port:SetFrameLevel(2)

	SVUnit.mkButton(port,-1,true,true)
	port:SetAlpha(1)
	port.bg = CreateFrame("Frame",nil,port)
	port.bg:SetPoint("TOPLEFT", port, "TOPLEFT")
	port.bg:SetPoint("BOTTOMRIGHT", port, "BOTTOMRIGHT")
	port.bg:SetBackdrop{bgFile = SVUnit.partybg, tile = false}
	port.bg:SetFrameLevel(0)
	
	local mask = CreateFrame("Frame",nil,port)
	mask:SetFrameLevel(3)
	mask:SetPoint("TOPLEFT")
	mask:SetPoint("TOPRIGHT")
	mask:SetHeight(25*SuperSet.scaleops.ufscale)
	
	local tex = mask:CreateTexture(nil,"Border")
	tex:SetAllPoints()
	tex:SetTexture(1,1,1,1)
	tex:SetGradientAlpha("VERTICAL",0,0,0,0,0,0,0,.666)
	tex:SetBlendMode("BLEND")
	
	local health = CreateFrame("StatusBar", nil, self)
	health:SetStatusBarTexture(SVMedia.bar)
	health:SetAllPoints(self)
	health:SetFrameLevel(3)
	SVMod.SimpleSkin(health,3)				
	health.Smooth = true
	health.frequentUpdates = true
	
	health.deadornot = health:CreateFontString (nil,"OVERLAY")
	health.deadornot:SetFont(SVFonts.font,fsize)
	health.deadornot:SetShadowOffset(1,-1)
	health.deadornot:SetJustifyH("CENTER")
	health.deadornot:SetPoint("CENTER",0,1.3)
	
	health.second = CreateFrame("StatusBar",nil,health)
	health.second:SetFrameLevel(health:GetFrameLevel()-1)
	health.second:SetAllPoints(health)
	health.second:SetStatusBarTexture(SVMedia.bar)
	health.second:SetStatusBarColor(0,0,0,0)
	health.second:SetFrameLevel(3)
	SVUnit.Animated(health.second,.3,1,2)
	health.port = port
	
	self.Health = health
	
	local track = CreateFrame("Frame",nil,self)
	track:SetAllPoints(self.Health)
	track:SetFrameLevel(6)
	self.track = track
	
	self.Auras = CreateFrame("Frame", nil, self)
	
		self.Auras.initialAnchor = "TOPLEFT"
		self.Auras["growth-x"] = "RIGHT"
		self.Auras["growth-y"] = "DOWN"
		self.Auras.numDebuffs = 6
		self.Auras.spacing = 4
		self.Auras.size = 25*SuperSet.scaleops.ufscale
		self.Auras.numBuffs = 0
		self.Auras:SetHeight(self.Auras.size*2+4)
		self.Auras:SetWidth((28*3+8)*SuperSet.scaleops.ufscale)
		self.Auras:SetPoint("TOPLEFT",self,"TOPRIGHT",5,-2)
		self.Auras.cc_font_size = 13
		self.Auras.PostCreateIcon = SVUnit.auraIcon
		self.Auras.PostUpdateIcon = SVUnit.auraUpdateIcon
		
	local cc = CreateFrame("StatusBar", nil, self.infobg)
	cc:SetFrameLevel(8)
	
	local invise = cc:CreateTexture(nil,"OVERLAY")
	invise:SetTexture(0,0,0,0)
	
	cc:SetPoint("TOPLEFT",self.infobg,4,-4)
	cc:SetPoint("BOTTOMRIGHT",self.infobg,-4,4)
	cc:SetStatusBarTexture(invise)
	
		cc.Spark = cc:CreateTexture(nil, "OVERLAY")
		cc.Spark:SetWidth(9)
		cc.Spark:SetBlendMode("ADD")
		cc.Spark:SetAlpha(1)
		
	local iconbg = CreateFrame("Frame", nil, cc)
		iconbg:SetPoint("TOPRIGHT",self,"TOPLEFT",-2,-2)
		iconbg:SetWidth(24*SuperSet.scaleops.ufscale)
		iconbg:SetHeight(24*SuperSet.scaleops.ufscale)
		iconbg:SetBackdrop{
				bgFile = SVMedia.blank, tile = true, tileSize = 16,
				edgeFile = SVMedia.glow, edgeSize = 4,
				insets = {left = 3, right = 3, top = 3, bottom = 3},}
		iconbg:SetBackdropColor(unpack(SVMedia.backdropcolor))
		iconbg:SetBackdropBorderColor(unpack(SVMedia.bordershadow))
		SVUnit.mkButton(iconbg,nil,true)
		iconbg:SetFrameLevel(10)
		iconbg:SetFrameStrata(self.Health:GetFrameStrata())
		iconbg:SetAlpha(.9)
	
		cc.Icon = iconbg:CreateTexture(nil, "BORDER")
		cc.Icon:SetTexCoord(.1,.9,.1,.9)
		cc.Icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
		cc.Icon:SetPoint("TOPLEFT",4,-4)
		cc.Icon:SetPoint("BOTTOMRIGHT",-4,4)
	
	self.Castbar = cc
	
	local lead = self.Health:CreateFontString(nil,"OVERLAY")
	lead:SetFont(SVFonts.super_c,fsize,"THINOUTLINE")
	lead:SetShadowOffset(1,-1.5)
	lead:SetPoint("BOTTOMLEFT",self.Health,"BOTTOMLEFT",2,3)
	lead:SetText("L")
	self.Leader = lead
	
	local power = CreateFrame("StatusBar", nil, self)
	power:SetPoint("TOPLEFT",self.infobg,3,-3)
	power:SetPoint("BOTTOMRIGHT",self.infobg,-3,3)
	power:SetFrameLevel(6)
	power:SetStatusBarTexture(SVMedia.colorbar)
	SVMod.SimpleSkin(power)
	power.frequentUpdates = true
	power.Smooth = true
	power.colorSmooth = true
	self.Power = power
	
	local info = self.Health:CreateFontString(nil, "OVERLAY")
	info:SetFont(SVFonts.font,fsize,"THINOUTLINE")
	info:SetShadowOffset(-2,-1)
	info:SetShadowColor(0,0,0,0.4)
	info:SetPoint("TOPLEFT")
	info:SetPoint("TOPRIGHT")
	info:SetJustifyH("LEFT")
	self:Tag(info, '[raidcolor][name]')
	
	SVUnit.RaidIcons(self,"RIGHT")
	self.RaidIcon:SetAlpha(0.7)
	
	local lfd = self.data:CreateTexture(nil, "OVERLAY")
    lfd:SetHeight(24*SuperSet.scaleops.ufscale)
    lfd:SetWidth(24*SuperSet.scaleops.ufscale)
	lfd:SetPoint("TOPRIGHT",self,"TOPLEFT")
	self.LFDRole = lfd
	
	table.insert(self.__elements, SVUnit.LegionThreat)
	self:RegisterEvent('PLAYER_TARGET_CHANGED', SVUnit.LegionThreat)
	self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', SVUnit.LegionThreat)
	self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', SVUnit.LegionThreat)
	
	self.SpellRange = {
				["insideAlpha"] = 1,
				["outsideAlpha"] = .666,}
	
	local picon = self.Health:CreateTexture(nil, 'OVERLAY')
	picon:SetPoint('CENTER', self.Health)
	picon:SetSize(55, 55)
	picon:SetTexture(SVMedia.svlogo)
	picon.Override = SVMod.Phasing
	self.PhaseIcon = picon
	
	local dbh = self.data:CreateTexture(nil,"OVERLAY")
	dbh:SetAllPoints(self.Health)
	dbh:SetTexture(SVMedia.unitaf)
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0)
	self.DebuffHighlight = dbh
	self.DebuffHighlightFilter = true
	self.DebuffHighlightAlpha = 0.5
	
	self.Portrait = port
	SVUnit.PortraitUnavailable(self.Portrait)
	self.Portrait.PostUpdate = SVUnit.LegionPictures
	self.Health.PostUpdate = updateHealth
	self.Power.PostUpdate = updatePower
	SVUnit.IncomingHeals(self,unit)
	self:SetSize(120*SuperSet.scaleops.ufscale,55*SuperSet.scaleops.ufscale)
	return self
	
end

oUF:RegisterStyle('VillainParty', CreateParty)
oUF:Factory(function(self)
	oUF:SetActiveStyle('VillainParty')
	local raid = oUF:SpawnHeader("oUF_VillainParty", nil ,"custom [@raid6,exists] hide;show",
	'oUF-initialConfigFunction', [[
		local header = self:GetParent()
		self:SetWidth(header:GetAttribute('initial-width'))
		self:SetHeight(header:GetAttribute('initial-height'))
	]],
	'initial-width', SVMod.Scale(120*SuperSet.scaleops.gridscale),
	'initial-height', SVMod.Scale(55*SuperSet.scaleops.gridscale),
	"showParty", true, "showPlayer", SuperSet.unitops.playerparty, "showRaid", true, "groupFilter", "1,2,3,4,5,6,7,8", 
	"groupingOrder", "1,2,3,4,5,6,7,8", "groupBy", "GROUP", "yOffset", -SuperSet.unitops.party_space)

	raid:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 46, -125)
end)