﻿if not SVPally then return end;
if not SAIAurora then return; end
if not(IsAddOnLoaded("PallyPower")) then return end

local _G = _G
local _, frame, tex
local font = SVFonts.font

local one = SAIAurora.Scale(1)
local two = SAIAurora.Scale(2)
local three = SAIAurora.Scale(3)
local four = SAIAurora.Scale(4)
local thirty = SAIAurora.Scale(30)
local sixty = SAIAurora.Scale(60)

PallyPower.defaults.profile.cBuffNeedAll     = {r = 0.6, g = 0.2, b = 0.2, t = 1}
PallyPower.defaults.profile.cBuffNeedSome    = {r = 0.15, g = 0.15, b = 0.15, t = 1}
PallyPower.defaults.profile.cBuffNeedSpecial = {r = 0, g = 6/16, b = 9/16, t = 1}
PallyPower.defaults.profile.cBuffGood        = SAIAurora.backdropcolor

PallyPower.options.display.settings.cBuffNeedAll     = {r = 0.6, g = 0.2, b = 0.2, t = 1}
PallyPower.options.display.settings.cBuffNeedSome    = {r = 0.15, g = 0.15, b = 0.15, t = 1}
PallyPower.options.display.settings.cBuffNeedSpecial = {r = 0, g = 6/16, b = 9/16, t = 1}
PallyPower.options.display.settings.cBuffGood        = SAIAurora.backdropcolor

PallyPower.options.display.settings.buffscale = one
PallyPower.options.display.settings.configscale = one
--PallyPower.options.display.gapping = four

local _applyskin = PallyPower.ApplySkin
function PallyPower:ApplySkin(skinname)

	local needSkinning = {PallyPowerAuto, PallyPowerRF, PallyPowerAura}

	for i = 1, #PallyPowerDB.profileKeys do
		table.insert(needSkinning, PallyPower.classButtons[i])
		for j = 1, #PallyPowerDB.profileKeys do
			table.insert(needSkinning, PallyPower.playerButtons[i][j])
		end
	end
		
	for _,frame in pairs(needSkinning) do
		frame:SetBackdrop({
			bgFile = SAIAurora.blank,
			insets = { left = two, right = two, top = two, bottom = two }
		})
		if not frame.bg then
			frame.bg = CreateFrame('Frame', nil, frame)
			frame.bg:SetAllPoints(frame)
			frame.bg:SetFrameLevel(frame:GetFrameLevel()-1)
			SAIAurora.DeluxeSkin(frame.bg)
		end
		
		local fname = frame:GetName()
		--print(fname)
		for _, fontstring in pairs({"Time", "Time2", "Text", "Player1", "Player2", "Rng", "Dead", "Name"}) do
			local fs = _G[fname..fontstring]
			if fs then
				local _, size = fs:GetFont()
				fs:SetFont(font, size, 'THINOUTLINE')
				fs:SetShadowColor(0,0,0,0)
				if not fname:find("PowerC%d+P%d+$") then
					if fontstring == "Text" then
						fs:ClearAllPoints()
						fs:SetJustifyH("LEFT")
						fs:SetWidth(999)
						fs:SetPoint("LEFT",fname:find("Auto$") and (thirty + two) or (sixty + two), 0)
					elseif fontstring == "Time" or fontstring == "Time2" then
						fs:ClearAllPoints()
						fs:SetWidth(999)
						fs:SetJustifyH("RIGHT")
						fs:SetPoint(fontstring == "Time" and "BOTTOMRIGHT" or "TOPRIGHT", frame, "RIGHT", 0, 0)
					end
				end
			end
		end
		for _, tex in pairs({"Icon", "ClassIcon", "BuffIcon", "IconSeal"}) do
			if _G[fname..tex] and not _G[fname..'New'..tex] then
				local oldicon = _G[fname..tex]
				oldicon:SetAlpha(0)
				
				oldicon:ClearAllPoints()
				-- Swap seal and RF icon
				if fname == "PallyPowerRF" then
					if tex == "IconSeal" then
						oldicon:SetPoint('LEFT', four, 0)
					else
						oldicon:SetPoint('LEFT', thirty + four, 0)
					end
				-- Aura icon / Auto icon
				elseif fname:find("(Au[rt][ao])$") then
					oldicon:SetPoint('LEFT', four, 0)
				-- Player frames
				elseif fname:find("PowerC%d+P%d+$") then
					oldicon:SetPoint('TOPLEFT', four, -four)
				-- CLass frames
				elseif fname:find("PowerC%d+$") then
					if tex == "ClassIcon" then
						oldicon:SetPoint('LEFT', four, 0)
					else
						oldicon:SetPoint('LEFT', thirty + four, 0)
					end
				else
					--oldicon:SetPoint('TOPLEFT', four, -four)
				end
				
				local panel = CreateFrame("Frame", fname..'New'..tex, frame)
				panel:SetAllPoints(oldicon)
				panel:SetFrameLevel(4)
				SAIAurora.DeluxeSkin(panel)
				
				local icon = panel:CreateTexture()
				panel.icon = panel
				icon:SetPoint("TOPLEFT", panel, two, -two)
				icon:SetPoint("BOTTOMRIGHT", panel, -two, two)
				icon:SetTexCoord(.12, .88, .12, .88)
				icon:SetTexture(oldicon:GetTexture())
				--hacky tacky, yay!
				oldicon.SetTexture = function(tex,texstring)
					icon:SetTexture(texstring)
					--hide the border/bg if icon:SetTexture() is sued to hide the icon
					if not texstring then
						panel:SetAlpha(0)
					else
						panel:SetAlpha(1)
					end
				end
				oldicon.SetVertexColor = function(self, ...)
					--[[if r + b + g == 3 then
						icon:SetDesaturated(false)
					else
						icon:SetDesaturated(true)
					end]]
					icon:SetVertexColor(...)
				end
			end
		end			
	end
end

local _updatelayout = PallyPower.UpdateLayout
function PallyPower:UpdateLayout()
--	self.opt.display.gapping = four
	self.options.buffscale = one
	self.options.configscale = one
	
	_updatelayout(self)
	
	-- Update button layout for aura, rf and auto
	for _, button in pairs({PallyPowerAuto, PallyPowerRF, PallyPowerAura}) do
		local a, p, b, x, y = button:GetPoint()
		
		-- ridiculous, why is this a string and not an int
		local align = tonumber(self.opt.display.alignClassButtons)
		
		y = align < 4 and (y - four) or (y + four)
	
		button:SetPoint(a,p,b,x,y)
	end
end
PallyPower:ApplySkin()
PallyPower:UpdateLayout()