--[[

  /$$$$$$                                          /$$    /$$ /$$ /$$ /$$           /$$          
 /$$__  $$                                        | $$   | $$|__/| $$| $$          |__/          
| $$  \__/ /$$   /$$  /$$$$$$   /$$$$$$   /$$$$$$ | $$   | $$ /$$| $$| $$  /$$$$$$  /$$ /$$$$$$$ 
|  $$$$$$ | $$  | $$ /$$__  $$ /$$__  $$ /$$__  $$|  $$ / $$/| $$| $$| $$ |____  $$| $$| $$__  $$
 \____  $$| $$  | $$| $$  \ $$| $$$$$$$$| $$  \__/ \  $$ $$/ | $$| $$| $$  /$$$$$$$| $$| $$  \ $$
 /$$  \ $$| $$  | $$| $$  | $$| $$_____/| $$        \  $$$/  | $$| $$| $$ /$$__  $$| $$| $$  | $$
|  $$$$$$/|  $$$$$$/| $$$$$$$/|  $$$$$$$| $$         \  $/   | $$| $$| $$|  $$$$$$$| $$| $$  | $$
 \______/  \______/ | $$____/  \_______/|__/          \_/    |__/|__/|__/ \_______/|__/|__/  |__/
                    | $$                                                                         
                    | $$                                                                         
                    |__/                                                                         

  /$$$$$$  /$$$$$$        /$$$$$$                                                  
 /$$__  $$|_  $$_/       /$$__  $$                                                 
| $$  \ $$  | $$        | $$  \ $$ /$$   /$$  /$$$$$$   /$$$$$$   /$$$$$$  /$$$$$$ 
| $$$$$$$$  | $$ /$$$$$$| $$$$$$$$| $$  | $$ /$$__  $$ /$$__  $$ /$$__  $$|____  $$
| $$__  $$  | $$|______/| $$__  $$| $$  | $$| $$  \__/| $$  \ $$| $$  \__/ /$$$$$$$
| $$  | $$  | $$        | $$  | $$| $$  | $$| $$      | $$  | $$| $$      /$$__  $$
| $$  | $$ /$$$$$$      | $$  | $$|  $$$$$$/| $$      |  $$$$$$/| $$     |  $$$$$$$
|__/  |__/|______/      |__/  |__/ \______/ |__/       \______/ |__/      \_______/
                                                                                   
                                                           
Aurora created by: Haleth, AI-Art by: Quokka.  Re-engineered for SVUI by: Munglunch.
]]--

local classcolors = {
	["HUNTER"] = { r = 0.58, g = 0.86, b = 0.49 },
	["WARLOCK"] = { r = 0.6, g = 0.47, b = 0.85 },
	["PALADIN"] = { r = 1, g = 0.22, b = 0.52 },
	["PRIEST"] = { r = 0.8, g = 0.87, b = .9 },
	["MAGE"] = { r = 0, g = 0.76, b = 1 },
	["ROGUE"] = { r = 1, g = 0.91, b = 0.2 },
	["DRUID"] = { r = 1, g = 0.49, b = 0.04 },
	["SHAMAN"] = { r = 0, g = 0.6, b = 0.6 };
	["WARRIOR"] = { r = 0.78, g = 0.61, b = 0.43 },
	["DEATHKNIGHT"] = { r = 0.77, g = 0.12 , b = 0.23 },
}
local Skin = CreateFrame("Frame", nil, UIParent)
if CUSTOM_CLASS_COLORS then 
	c = CUSTOM_CLASS_COLORS[SAIAurora.myclass]
else
	c = classcolors[SAIAurora.myclass]
end
local maxbags = 32 -- change if you have a bag with more than 32 slots

Skin:RegisterEvent("ADDON_LOADED")
Skin:SetScript("OnEvent", function(self, event, addon)	
	if addon == "Supervillain_AI_Aurora" then
		
		-- [[ Headers ]]
		local header = {"GameMenuFrame", "InterfaceOptionsFrame", "AudioOptionsFrame", "VideoOptionsFrame", "ChatConfigFrame", "ColorPickerFrame"}
		for i = 1, getn(header) do
		local title = _G[header[i].."Header"]
			if title then
				title:SetTexture("")
				title:ClearAllPoints()
				if title == _G["GameMenuFrameHeader"] then
					title:SetPoint("TOP", GameMenuFrame, 0, 7)
				else
					title:SetPoint("TOP", header[i], 0, 0)
				end
			end
		end

		-- [[ Simple backdrops ]] --
		local skins = {"AutoCompleteBox", "DropDownList1Backdrop", "DropDownList2Backdrop", "DropDownList1MenuBackdrop", "DropDownList2MenuBackdrop", "LFDSearchStatus", "FriendsTooltip", "GhostFrame", "GhostFrameContentsFrame", "DropDownList1MenuBackdrop", "DropDownList2MenuBackdrop", "DropDownList1Backdrop", "DropDownList2Backdrop", "ChatConfigCategoryFrame", "ChatConfigBackgroundFrame", "ChatConfigChatSettingsLeft", "ChatConfigChatSettingsClassColorLegend", "ChatConfigChannelSettingsLeft", "ChatConfigChannelSettingsClassColorLegend", "FriendsFriendsList"}

		for i = 1, getn(skins) do
			SAIAurora.MenuSkin(_G[skins[i]])
		end

		local shadowskins = {"StaticPopup1", "StaticPopup2", "GameMenuFrame", "InterfaceOptionsFrame", "VideoOptionsFrame", "AudioOptionsFrame", "LFDDungeonReadyStatus", "ChatConfigFrame", "AutoCompleteBox", "SpellBookFrame", "CharacterFrame", "PVPFrame", "GearManagerDialog", "WorldStateScoreFrame", "GearManagerDialogPopup", "StackSplitFrame", "AddFriendFrame", "FriendsFriendsFrame", "ColorPickerFrame", "ReadyCheckFrame", "PetStableFrame", "LFDDungeonReadyDialog", "ReputationDetailFrame", "LFDRoleCheckPopup"}

		for i = 1, getn(shadowskins) do
			SAIAurora.MenuSkin(_G[shadowskins[i]],0.9,3,true)
		end

		local simplebds = {"SecondaryProfession1", "SecondaryProfession2", "SecondaryProfession3", "SecondaryProfession4"}
		for i = 1, getn(simplebds) do
			local prime_pro = _G[simplebds[i]]
			if prime_pro then 
				prime_pro.tex = CreateFrame("Frame",nil,prime_pro)
				prime_pro.tex:SetPoint("TOPLEFT",-6,6)
				prime_pro.tex:SetPoint("BOTTOMRIGHT",6,-6)
				prime_pro.tex:SetFrameLevel(prime_pro:GetFrameLevel()-2)
				prime_pro.tex:SetBackdrop( {
					bgFile = SAIAurora.bar,
					edgeFile = SAIAurora.glow,
					edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
				prime_pro.tex:SetBackdropColor(c.r,c.g,c.b,0.1)
				prime_pro.tex:SetBackdropBorderColor(c.r,c.g,c.b,0.5)
			end
		end
		
		for i=1,2 do
			local prime_pro = _G["PrimaryProfession"..i]
			prime_pro.tex = CreateFrame("Frame",nil,prime_pro)
			prime_pro.tex:SetPoint("TOPLEFT",-6,2)
			prime_pro.tex:SetPoint("BOTTOMRIGHT",6,-10)
			prime_pro.tex:SetFrameLevel(prime_pro:GetFrameLevel()-2)
			prime_pro.tex:SetBackdrop( {
				bgFile = SAIAurora.bar,
				edgeFile = SAIAurora.glow,
				edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
			prime_pro.tex:SetBackdropColor(c.r,c.g,c.b,0.1)
			prime_pro.tex:SetBackdropBorderColor(c.r,c.g,c.b,0.5)
		end
		
		_G["FriendsFrameCloseButton"]:SetFrameLevel(8)
		
		for i=1,2 do
			for j=1,10 do
				if _G["DropDownList"..i.."Button"..j] then
					SAIAurora.MenuSkin(_G["DropDownList"..i.."Button"..j],0,0)
				end
			end
		end
		
		local betterbds = {"ChatConfigCategoryFrame", "ChatConfigBackgroundFrame", "ChatConfigChatSettingsLeft", "ChatConfigChatSettingsClassColorLegend", "ChatConfigChannelSettingsLeft", "ChatConfigChannelSettingsClassColorLegend"}
		for i = 1, getn(betterbds) do
			local betterbd = _G[betterbds[i]]
			if betterbd then SAIAurora.MenuSkin(betterbd) end
		end
		
		for i = 1, 5 do
			local a1, p, a2, x, y = _G["SpellBookSkillLineTab"..i]:GetPoint()
			local bg = CreateFrame("Frame", nil, _G["SpellBookSkillLineTab"..i])
			bg:SetPoint("TOPLEFT", -1, 1)
			bg:SetPoint("BOTTOMRIGHT", 1, -1)
			bg:SetFrameLevel(_G["SpellBookSkillLineTab"..i]:GetFrameLevel()-1)
			_G["SpellBookSkillLineTab"..i]:SetPoint(a1, p, a2, x + 11, y)
			SAIAurora.SlotSkin(bg)
			select(3, _G["SpellBookSkillLineTab"..i]:GetRegions()):SetTexCoord(0.1, 0.9, 0.1, 0.9)
			select(4, _G["SpellBookSkillLineTab"..i]:GetRegions()):SetTexCoord(0.1, 0.9, 0.1, 0.9)
		end

		-- [[ Backdrop frames ]]
		SAIAurora.BG_o_Matic(_G["BNToastFrame"])
		SAIAurora.MenuSkin(_G["TicketStatusFrameButton"],0.2,1,true)
		SAIAurora.BG_o_Matic(_G["FriendsFrame"],10,-30,-34,76)
		SAIAurora.BG_o_Matic(_G["QuestLogFrame"],4,-9,-2,6)
		SAIAurora.BG_o_Matic(_G["QuestFrame"],4,-15,-26,64)
		SAIAurora.BG_o_Matic(_G["QuestLogDetailFrame"],4,-9,-2,6)
		SAIAurora.BG_o_Matic(_G["GossipFrame"],4,-15,-26,64)
		SAIAurora.BG_o_Matic(_G["LFDParentFrame"],10,-10,0,0)
		SAIAurora.BG_o_Matic(_G["LFRParentFrame"],10,-10,0,4)
		SAIAurora.BG_o_Matic(_G["MerchantFrame"],10,-10,-34,61)
		SAIAurora.BG_o_Matic(_G["MailFrame"],10,-12,-34,73)
		SAIAurora.BG_o_Matic(_G["OpenMailFrame"],10,-12,-34,73)
		SAIAurora.BG_o_Matic(_G["DressUpFrame"],10,-12,-34,73)
		SAIAurora.ComicSkin(_G["DressUpModel"])
		SAIAurora.BG_o_Matic(_G["TaxiFrame"],3,-23,-5,3)
		SAIAurora.BG_o_Matic(_G["QuestNPCModel"],3,-23,-5,3)
		SAIAurora.ComicSkin(_G["QuestNPCModel"])
		SAIAurora.BG_o_Matic(_G["TradeFrame"],10,-12,-30,52)
		SAIAurora.BG_o_Matic(_G["ItemTextFrame"],16,-8,-28,62)
		SAIAurora.BG_o_Matic(_G["TabardFrame"],16,-8,-28,76)

		if SAIAurora.myclass == "HUNTER" or SAIAurora.myclass == "MAGE" or SAIAurora.myclass == "DEATHKNIGHT" or SAIAurora.myclass == "WARLOCK" then
			if SAIAurora.myclass == "HUNTER" then
				for i = 1, 10 do
					local bd = CreateFrame("Frame", nil, _G["PetStableStabledPet"..i])
					bd:SetPoint("TOPLEFT", -1, 1)
					bd:SetPoint("BOTTOMRIGHT", 1, -1)
					SAIAurora.MenuSkin(bd)
					bd:SetBackdropColor(0, 0, 0, 0)
					_G["PetStableStabledPet"..i]:SetNormalTexture("")
					_G["PetStableStabledPet"..i]:GetRegions():SetTexCoord(0.1, 0.9, 0.1, 0.9)
				end
			end
			SAIAurora.MenuSkin(_G["PetPaperDollFrame"])
			local PetToon = _G["PetModelFrame"]
			SAIAurora.ComicSkin(PetToon)
			PetToon.tex:ClearAllPoints()
			PetToon.tex:SetPoint("TOPLEFT", 4, -4)
			PetToon.tex:SetPoint("BOTTOMRIGHT", -4, 40)
			PetModelFrameShadowOverlay:Hide()
			PetPaperDollFrameExpBar:GetRegions():Hide()
			select(2, PetPaperDollFrameExpBar:GetRegions()):Hide()
			SAIAurora.SlotSkin(_G["PetPaperDollFrameExpBar"])
		end

		-- [[ Hide regions ]]

		select(3, CharacterFrame:GetRegions()):Hide()
		for i = 1, 5 do
			select(i, _G["CharacterModelFrame"]:GetRegions()):Hide()
			local ToonModel = _G["CharacterModelFrame"]
			SAIAurora.ComicSkin(ToonModel)
			ToonModel.tex:ClearAllPoints()
			ToonModel.tex:SetPoint("TOPLEFT", 1, 4)
			ToonModel.tex:SetPoint("BOTTOMRIGHT", -1, 20)
		end
		
		local CompanionModel = _G["SpellBookCompanionModelFrame"]
		SAIAurora.ComicSkin(CompanionModel)
		CompanionModel.tex:ClearAllPoints()
		CompanionModel.tex:SetPoint("TOPLEFT", -8, 8)
		CompanionModel.tex:SetPoint("BOTTOMRIGHT", 8, 2)
		
		for i = 1, 3 do
			select(i, QuestLogFrame:GetRegions()):Hide()
		end
		QuestLogDetailFrame:GetRegions():Hide()
		QuestFrame:GetRegions():Hide()
		GossipFrame:GetRegions():Hide()
		for i = 1, 6 do
			for j = 1, 3 do
				select(i, _G["FriendsTabHeaderTab"..j]:GetRegions()):Hide()
				select(i, _G["FriendsTabHeaderTab"..j]:GetRegions()).Show = SAIAurora.dummy
			end
		end
		for i=1,3 do
			_G["FriendsTabHeaderTab"..i]:SetFrameLevel(8)
		end
		select(6, FriendsFrame:GetRegions()):Hide()
		select(3, SpellBookFrame:GetRegions()):Hide()
		SpellBookCompanionModelFrameShadowOverlay:Hide()
		select(3, PVPFrame:GetRegions()):Hide()
		LFRParentFrame:GetRegions():Hide()
		for i = 1, 5 do
			select(i, MailFrame:GetRegions()):Hide()
		end
		OpenMailFrame:GetRegions():Hide()
		select(12, OpenMailFrame:GetRegions()):Hide()
		select(13, OpenMailFrame:GetRegions()):Hide()
		for i = 4, 7 do
			select(i, SendMailFrame:GetRegions()):Hide()
		end
		MerchantFrame:GetRegions():Hide()
		DressUpFrame:GetRegions():Hide()
		select(2, DressUpFrame:GetRegions()):Hide()
		for i = 8, 11 do
			select(i, DressUpFrame:GetRegions()):Hide()
		end
		select(6, TaxiFrame:GetRegions()):Hide()
		TradeFrame:GetRegions():Hide()
		select(2, TradeFrame:GetRegions()):Hide()
		for i = 1, 4 do
			select(i, GearManagerDialogPopup:GetRegions()):Hide()
		end
		StackSplitFrame:GetRegions():Hide()
		ItemTextFrame:GetRegions():Hide()
		select(3, ItemTextScrollFrame:GetRegions()):Hide()
		select(3, PetStableFrame:GetRegions()):Hide()
		select(4, ReputationDetailFrame:GetRegions()):Hide()
		select(5, ReputationDetailFrame:GetRegions()):Hide()
		select(2, QuestNPCModel:GetRegions()):Hide()
		TabardFrame:GetRegions():Hide()
		BNToastFrameCloseButton:SetAlpha(0)
		PetStableModelShadow:Hide()
		LFDParentFramePortrait:Hide()

		local slots = {
			"Head", "Neck", "Shoulder", "Shirt", "Chest", "Waist", "Legs", "Feet", "Wrist",
			"Hands", "Finger0", "Finger1", "Trinket0", "Trinket1", "Back", "MainHand",
			"SecondaryHand", "Ranged", "Tabard",
		}

		for i = 1, getn(slots) do
			_G["Character"..slots[i].."Slot"]:SetNormalTexture("")
			_G["Character"..slots[i].."Slot"]:GetRegions():SetTexCoord(0.1, 0.9, 0.1, 0.9)
			local bd = CreateFrame("Frame", nil, _G["Character"..slots[i].."Slot"])
			bd:SetPoint("TOPLEFT")
			bd:SetPoint("BOTTOMRIGHT")
			SAIAurora.SlotSkin(bd)
			bd:SetBackdropColor(0, 0, 0, 0)
		end
		
		-- [[  Gear Manager Button and Slots  ]]--
		 -- _G["GearManagerToggleButton"]:SetNormalTexture(SAIAurora.smallicon)
		 -- _G["GearManagerToggleButton"]:SetPushedTexture(SAIAurora.smallicon)
		 -- _G["GearManagerToggleButton"]:GetRegions():SetTexCoord(0.1, 0.9, 0.1, 0.9)
		 -- local embd = CreateFrame("Frame", nil, _G["GearManagerToggleButton"])
		 -- embd:SetPoint("TOPLEFT")
		 -- embd:SetPoint("BOTTOMRIGHT")
		 -- SAIAurora.SlotSkin(embd)
		 -- embd:SetBackdropColor(0, 0, 0, 0)

		-- for i = 1, 10 do
			-- _G["GearSetButton"..i]:SetNormalTexture("")
			-- _G["GearSetButton"..i.."Icon"]:SetTexCoord(0.1, 0.9, 0.1, 0.9)
			-- local gsbd = CreateFrame("Frame", nil, _G["GearSetButton"..i])
		 	-- gsbd:SetPoint("TOPLEFT")
		 	-- gsbd:SetPoint("BOTTOMRIGHT")
		 	-- SAIAurora.SlotSkin(gsbd)
		 	-- gsbd:SetBackdropColor(0, 0, 0, 0)
		-- end
		------------------------------------------
		-- _G["PlayerTitleFrameLeft"]:SetTexture("")
		-- _G["PlayerTitleFrameMiddle"]:SetTexture("")
		-- _G["PlayerTitleFrameRight"]:SetTexture("")
		------------------------------------------
		local all_pro = {
		"PrimaryProfession1SpellButtonTop","PrimaryProfession1SpellButtonBottom",
		"PrimaryProfession2SpellButtonTop","PrimaryProfession2SpellButtonBottom",
		"SecondaryProfession1SpellButtonRight","SecondaryProfession1SpellButtonLeft",
		"SecondaryProfession2SpellButtonRight","SecondaryProfession3SpellButtonRight",
		"SecondaryProfession4SpellButtonRight","SecondaryProfession3SpellButtonLeft",
		}
		
		for i = 1, getn(all_pro) do
			 _G[all_pro[i]]:GetRegions():SetTexCoord(0.1, 0.9, 0.1, 0.9)
			 local probd = CreateFrame("Frame", nil, _G[all_pro[i]])
			 probd:SetPoint("TOPLEFT")
			 probd:SetPoint("BOTTOMRIGHT")
			 SAIAurora.SlotSkin(probd)
			 probd:SetBackdropColor(0, 0, 0, 0)
		end
		
		local pets_n_shit = {}
		for i=1,12 do
			 _G["SpellBookCompanionButton"..i]:GetRegions():SetTexCoord(0.1, 0.9, 0.1, 0.9)
			 _G["SpellBookCompanionButton"..i.."IconTexture"]:SetTexCoord(0.1, 0.9, 0.1, 0.9)
			 local mntbd = CreateFrame("Frame", nil, _G["SpellBookCompanionButton"..i])
			 mntbd:SetPoint("TOPLEFT")
			 mntbd:SetPoint("BOTTOMRIGHT")
			 SAIAurora.SlotSkin(mntbd)
			 mntbd:SetBackdropColor(0, 0, 0, 0)
		end
		
		--SAIAurora.MenuSkin(_G["PlayerSpecTab1"])
		--SAIAurora.MenuSkin(_G["PlayerSpecTab2"])
		-----------------------------------------------------------------------
		_G["ReadyCheckFrame"]:HookScript("OnShow", function(self) if UnitIsUnit("player", self.initiator) then self:Hide() end end)

		
		-- [[ Text colour functions ]]

		NORMAL_QUEST_DISPLAY = "|cffffffff%s|r"
		TRIVIAL_QUEST_DISPLAY = "|cffffffff%s (low level)|r"

		local newquestcolor = function(template, parentFrame, acceptButton, material)
			QuestInfoTitleHeader:SetTextColor(1, 1, 1);
			QuestInfoDescriptionHeader:SetTextColor(1, 1, 1);
			QuestInfoObjectivesHeader:SetTextColor(1, 1, 1);
			QuestInfoRewardsHeader:SetTextColor(1, 1, 1);
			-- other text
			QuestInfoDescriptionText:SetTextColor(1, 1, 1);
			QuestInfoObjectivesText:SetTextColor(1, 1, 1);
			QuestInfoGroupSize:SetTextColor(1, 1, 1);
			QuestInfoRewardText:SetTextColor(1, 1, 1);
			-- reward frame text
			QuestInfoItemChooseText:SetTextColor(1, 1, 1);
			QuestInfoItemReceiveText:SetTextColor(1, 1, 1);
			QuestInfoSpellLearnText:SetTextColor(1, 1, 1);		
			QuestInfoXPFrameReceiveText:SetTextColor(1, 1, 1);

			local numObjectives = GetNumQuestLeaderBoards();
			local objective;
			local text, type, finished;
			local numVisibleObjectives = 0;
			for i = 1, numObjectives do
				text, type, finished = GetQuestLogLeaderBoard(i);
				if (type ~= "spell") then
					numVisibleObjectives = numVisibleObjectives+1;
					objective = _G["QuestInfoObjective"..numVisibleObjectives];
					objective:SetTextColor(1, 1, 1);
				end
			end
		end

		local newgossipcolor = function()
			GossipGreetingText:SetTextColor(1, 1, 1)
		end
		function QuestFrame_SetTitleTextColor(fontString)
			fontString:SetTextColor(1, 1, 1)
		end

		function QuestFrame_SetTextColor(fontString)
			fontString:SetTextColor(1, 1, 1);
		end

		function GossipFrameOptionsUpdate(...)
			local titleButton;
			local titleIndex = 1;
			local titleButtonIcon;
			for i=1, select("#", ...), 2 do
				if ( GossipFrame.buttonIndex > NUMGOSSIPBUTTONS ) then
					message("This NPC has too many quests and/or gossip options.");
				end
				titleButton = _G["GossipTitleButton" .. GossipFrame.buttonIndex];
				titleButton:SetFormattedText("|cffffffff%s|r", select(i, ...));
				GossipResize(titleButton);
				titleButton:SetID(titleIndex);
				titleButton.type="Gossip";
				titleButtonIcon = _G[titleButton:GetName() .. "GossipIcon"];
				titleButtonIcon:SetTexture("Interface\\GossipFrame\\" .. select(i+1, ...) .. "GossipIcon");
				titleButtonIcon:SetVertexColor(1, 1, 1, 1);
				GossipFrame.buttonIndex = GossipFrame.buttonIndex + 1;
				titleIndex = titleIndex + 1;
				titleButton:Show();
			end
		end

		local newspellbookcolor = function(self)
			local slot, slotType = SpellBook_GetSpellBookSlot(self);
			local name = self:GetName();
			-- local spellString = _G[name.."SpellName"];
			local subSpellString = _G[name.."SubSpellName"]

			-- spellString:SetTextColor(1, 1, 1)
			subSpellString:SetTextColor(1, 1, 1)
			if slotType == "FUTURESPELL" then
				local level = GetSpellAvailableLevel(slot, SpellBookFrame.bookType)
				if (level and level > UnitLevel("player")) then
					self.RequiredLevelString:SetTextColor(.7, .7, .7)
					self.SpellName:SetTextColor(.7, .7, .7)
					subSpellString:SetTextColor(.7, .7, .7)
				end
			end
		end

		local newprofcolor = function(frame, index)
			if index then
				local rank = GetProfessionInfo(index)
				-- frame.rank:SetTextColor(1, 1, 1)
				frame.professionName:SetTextColor(1, 1, 1)
			else
				frame.missingText:SetTextColor(1, 1, 1)
				frame.missingHeader:SetTextColor(1, 1, 1)
			end
		end

		local newprofbuttoncolor = function(self)
			self.spellString:SetTextColor(1, 1, 1);	
			self.subSpellString:SetTextColor(1, 1, 1)
		end	
	
		ItemTextFrame:HookScript("OnEvent", function(self, event, ...)
			if event == "ITEM_TEXT_BEGIN" then
				ItemTextTitleText:SetText(ItemTextGetItem())
				ItemTextScrollFrame:Hide()
				ItemTextCurrentPage:Hide()
				ItemTextStatusBar:Hide()
				ItemTextPrevPageButton:Hide()
				ItemTextNextPageButton:Hide()
				ItemTextPageText:SetTextColor(1, 1, 1)
				return
			end
		end)

		function PaperDollFrame_SetLevel()
			local primaryTalentTree = GetPrimaryTalentTree()
			local classDisplayName, class = UnitClass("player")
			local classColor = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[SAIAurora.myclass] or classcolors[SAIAurora.myclass]
			local classColorString = format("ff%.2x%.2x%.2x", classColor.r * 255, classColor.g * 255, classColor.b * 255)
			local specName

			if (primaryTalentTree) then
				_, specName = GetTalentTabInfo(primaryTalentTree);
			end

			if (specName and specName ~= "") then
				CharacterLevelText:SetFormattedText(PLAYER_LEVEL, UnitLevel("player"), classColorString, specName, classDisplayName);
			else
				CharacterLevelText:SetFormattedText(PLAYER_LEVEL_NO_SPEC, UnitLevel("player"), classColorString, classDisplayName);
			end
		end

		hooksecurefunc("QuestInfo_Display", newquestcolor)
		hooksecurefunc("GossipFrameUpdate", newgossipcolor)
		hooksecurefunc("SpellButton_UpdateButton", newspellbookcolor)
		hooksecurefunc("FormatProfession", newprofcolor)
		hooksecurefunc("UpdateProfessionButton", newprofbuttoncolor)

		-- [[ Change positions ]]

		ChatConfigFrameDefaultButton:SetWidth(125)
		ChatConfigFrameDefaultButton:ClearAllPoints()
		ChatConfigFrameDefaultButton:SetPoint("TOP", ChatConfigCategoryFrame, "BOTTOM", 0, -4)
		ChatConfigFrameOkayButton:ClearAllPoints()
		ChatConfigFrameOkayButton:SetPoint("TOPRIGHT", ChatConfigBackgroundFrame, "BOTTOMRIGHT", 0, -4)

		_G["VideoOptionsFrameCancel"]:ClearAllPoints()
		_G["VideoOptionsFrameCancel"]:SetPoint("RIGHT",_G["VideoOptionsFrameApply"],"LEFT",-4,0)		 
		_G["VideoOptionsFrameOkay"]:ClearAllPoints()
		_G["VideoOptionsFrameOkay"]:SetPoint("RIGHT",_G["VideoOptionsFrameCancel"],"LEFT",-4,0)	
		_G["AudioOptionsFrameOkay"]:ClearAllPoints()
		_G["AudioOptionsFrameOkay"]:SetPoint("RIGHT",_G["AudioOptionsFrameCancel"],"LEFT",-4,0)		 	 
		_G["InterfaceOptionsFrameOkay"]:ClearAllPoints()
		_G["InterfaceOptionsFrameOkay"]:SetPoint("RIGHT",_G["InterfaceOptionsFrameCancel"],"LEFT", -4,0)

		-- GearManagerDialog:ClearAllPoints()
		-- GearManagerDialog:SetPoint("TOPLEFT", PaperDollFrame, "TOPRIGHT", 10, 0)

		QuestLogFrameShowMapButton:Hide()
		QuestLogFrameShowMapButton.Show = SAIAurora.dummy

		local questlogcontrolpanel = function()
			local parent
			if QuestLogFrame:IsShown() then
				parent = QuestLogFrame
				QuestLogControlPanel:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", 9, 6)
			elseif QuestLogDetailFrame:IsShown() then
				parent = QuestLogDetailFrame
				QuestLogControlPanel:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", 9, 0)
			end
		end

		hooksecurefunc("QuestLogControlPanel_UpdatePosition", questlogcontrolpanel)

		QuestLogFramePushQuestButton:ClearAllPoints()
		QuestLogFramePushQuestButton:SetPoint("LEFT", QuestLogFrameAbandonButton, "RIGHT", 1, 0)
		QuestLogFramePushQuestButton:SetWidth(100)
		QuestLogFrameTrackButton:ClearAllPoints()
		QuestLogFrameTrackButton:SetPoint("LEFT", QuestLogFramePushQuestButton, "RIGHT", 1, 0)

		FriendsFrameStatusDropDown:ClearAllPoints()
		FriendsFrameStatusDropDown:SetPoint("TOPLEFT", FriendsFrame, "TOPLEFT", 10, -40)
		FriendsFrameCloseButton:ClearAllPoints()
		FriendsFrameCloseButton:SetPoint("LEFT", FriendsFrameBroadcastInput, "RIGHT", 20, 0)

		RaidFrameConvertToRaidButton:ClearAllPoints()
		RaidFrameConvertToRaidButton:SetPoint("TOPLEFT", FriendsFrame, "TOPLEFT", 30, -44)
		RaidFrameRaidInfoButton:ClearAllPoints()
		RaidFrameRaidInfoButton:SetPoint("TOPRIGHT", FriendsFrame, "TOPRIGHT", -70, -44)

		TaxiFrameCloseButton:ClearAllPoints()
		TaxiFrameCloseButton:SetPoint("TOPRIGHT", TaxiRouteMap, "TOPRIGHT")

		local a1, p, a2, x, y = ReputationDetailFrame:GetPoint()
		ReputationDetailFrame:SetPoint(a1, p, a2, x + 10, y)

		-- [[ Tabs ]]

		for i = 1, 5 do
			SAIAurora.CreateTab(_G["SpellBookFrameTabButton"..i])
		end

		for i = 1, 4 do
			SAIAurora.CreateTab(_G["FriendsFrameTab"..i])
			_G["FriendsFrameTab"..i]:ClearAllPoints()
			if i == 1 then
				_G["FriendsFrameTab"..i]:SetPoint("TOPLEFT",_G["FriendsFrame"],"BOTTOMLEFT",6,65)
			else
				_G["FriendsFrameTab"..i]:SetPoint("LEFT",_G["FriendsFrameTab"..(i-1)],"RIGHT",2,0)
			end
			if _G["CharacterFrameTab"..i] then
				SAIAurora.CreateTab(_G["CharacterFrameTab"..i])
				_G["CharacterFrameTab"..i]:ClearAllPoints()
				if i == 1 then
				_G["CharacterFrameTab"..i]:SetPoint("TOPLEFT",_G["PaperDollFrame"],"BOTTOMLEFT",6,-10)
				else
					_G["CharacterFrameTab"..i]:SetPoint("LEFT",_G["CharacterFrameTab"..(i-1)],"RIGHT",2,0)
				end
			end
		end

		for i = 1, 3 do
			SAIAurora.CreateTab(_G["PVPFrameTab"..i])
			SAIAurora.CreateTab(_G["WorldStateScoreFrameTab"..i])
		end

		for i = 1, 2 do
			SAIAurora.CreateTab(_G["LFRParentFrameTab"..i])
			SAIAurora.CreateTab(_G["MerchantFrameTab"..i])
			SAIAurora.CreateTab(_G["MailFrameTab"..i])
		end

		-- [[ Buttons ]]

		for i = 1, 2 do
			for j = 1, 2 do
				SAIAurora.Reskin(_G["StaticPopup"..i.."Button"..j])
			end
		end

		local buttons = {"VideoOptionsFrameOkay", "VideoOptionsFrameCancel", "VideoOptionsFrameDefaults", "VideoOptionsFrameApply", "AudioOptionsFrameOkay", "AudioOptionsFrameCancel", "AudioOptionsFrameDefaults", "InterfaceOptionsFrameDefaults", "InterfaceOptionsFrameOkay", "InterfaceOptionsFrameCancel", "ChatConfigFrameOkayButton", "ChatConfigFrameDefaultButton", "DressUpFrameCancelButton", "DressUpFrameResetButton", "WhoFrameWhoButton", "WhoFrameAddFriendButton", "WhoFrameGroupInviteButton", "GearManagerDialogDeleteSet", "GearManagerDialogEquipSet", "GearManagerDialogSaveSet", "SendMailMailButton", "SendMailCancelButton", "OpenMailReplyButton", "OpenMailDeleteButton", "OpenMailCancelButton", "OpenMailReportSpamButton", "aMailButton", "QuestLogFrameAbandonButton", "QuestLogFramePushQuestButton", "QuestLogFrameTrackButton", "QuestLogFrameCancelButton", "QuestFrameAcceptButton", "QuestFrameDeclineButton", "QuestFrameCompleteQuestButton", "QuestFrameCompleteButton", "QuestFrameGoodbyeButton", "GossipFrameGreetingGoodbyeButton", "QuestFrameGreetingGoodbyeButton", "ChannelFrameNewButton", "RaidFrameRaidInfoButton", "RaidFrameConvertToRaidButton", "TradeFrameTradeButton", "TradeFrameCancelButton", "GearManagerDialogPopupOkay", "GearManagerDialogPopupCancel", "StackSplitOkayButton", "StackSplitCancelButton", "TabardFrameAcceptButton", "TabardFrameCancelButton"}
		for i = 1, getn(buttons) do
		local reskinbutton = _G[buttons[i]]
			if reskinbutton then
				SAIAurora.Reskin(reskinbutton)
			end
		end

		local alphabuttons = {"GameMenuButtonOptions", "GameMenuButtonSoundOptions", "GameMenuButtonUIOptions", "GameMenuButtonKeybindings", "GameMenuButtonMacros", "GameMenuButtonAddOns", "GameMenuButtonLogout", "GameMenuButtonQuit", "GameMenuButtonContinue", "GameMenuButtonMacOptions", "FriendsFrameAddFriendButton", "FriendsFrameSendMessageButton", "LFDQueueFrameFindGroupButton", "LFDQueueFrameCancelButton", "LFRQueueFrameFindGroupButton", "LFRQueueFrameAcceptCommentButton", "PVPFrameLeftButton", "PVPHonorFrameWarGameButton", "PVPFrameRightButton", "RaidFrameNotInRaidRaidBrowserButton", "WorldStateScoreFrameLeaveButton", "SpellBookCompanionSummonButton", "AddFriendEntryFrameAcceptButton", "AddFriendEntryFrameCancelButton", "FriendsFriendsSendRequestButton", "FriendsFriendsCloseButton", "ColorPickerOkayButton", "ColorPickerCancelButton", "FriendsFrameIgnorePlayerButton", "FriendsFrameUnsquelchButton", "LFDDungeonReadyDialogEnterDungeonButton", "LFDDungeonReadyDialogLeaveQueueButton", "LFRBrowseFrameSendMessageButton", "LFRBrowseFrameInviteButton", "LFRBrowseFrameRefreshButton", "LFDRoleCheckPopupAcceptButton", "LFDRoleCheckPopupDeclineButton", "GuildInviteFrameJoinButton", "GuildInviteFrameDeclineButton", "FriendsFramePendingButton1AcceptButton", "FriendsFramePendingButton1DeclineButton"}
		for i = 1, getn(alphabuttons) do
		local button = _G[alphabuttons[i]]
			if button then
				SAIAurora.Reskin(button)
				_G[alphabuttons[i].."Left"]:SetAlpha(0)
				_G[alphabuttons[i].."Middle"]:SetAlpha(0)
				_G[alphabuttons[i].."Right"]:SetAlpha(0)
			end
		end

	-- [[ Load on Demand Addons ]]

	elseif addon == "Blizzard_ArchaeologyUI" then
		SAIAurora.MenuSkin(ArchaeologyFrame)
		SAIAurora.Reskin(ArchaeologyFrameArtifactPageSolveFrameSolveButton)
		_G["ArchaeologyFrameArtifactPageSolveFrameSolveButton".."Left"]:SetAlpha(0)
		_G["ArchaeologyFrameArtifactPageSolveFrameSolveButton".."Middle"]:SetAlpha(0)
		_G["ArchaeologyFrameArtifactPageSolveFrameSolveButton".."Right"]:SetAlpha(0)
		select(3, ArchaeologyFrame:GetRegions()):Hide()
		ArchaeologyFrameSummaryPage:GetRegions():SetTextColor(1, 1, 1)
		ArchaeologyFrameArtifactPage:GetRegions():SetTextColor(1, 1, 1)
		ArchaeologyFrameArtifactPageHistoryScrollChild:GetRegions():SetTextColor(1, 1, 1)
		ArchaeologyFrameCompletedPage:GetRegions():SetTextColor(1, 1, 1)
		select(5, ArchaeologyFrameCompletedPage:GetRegions()):SetTextColor(1, 1, 1)
		ArchaeologyFrameHelpPage:GetRegions():SetTextColor(1, 1, 1)
		select(5, ArchaeologyFrameHelpPage:GetRegions()):SetTextColor(1, 1, 1)
		ArchaeologyFrameHelpPageHelpScrollHelpText:SetTextColor(1, 1, 1)
		select(2, ArchaeologyFrameCompletedPage:GetRegions()):SetTextColor(1, 1, 1)
		select(11, ArchaeologyFrameCompletedPage:GetRegions()):SetTextColor(1, 1, 1)
		for i = 1, 10 do
			_G["ArchaeologyFrameSummaryPageRace"..i]:GetRegions():SetTextColor(1, 1, 1)
		end
		for i = 1, ARCHAEOLOGY_MAX_COMPLETED_SHOWN do
			local bu = _G["ArchaeologyFrameCompletedPageArtifact"..i]
			bu:GetRegions():Hide()
			select(2, bu:GetRegions()):Hide()
			select(3, bu:GetRegions()):SetTexCoord(0.1, 0.9, 0.1, 0.9)
			select(4, bu:GetRegions()):SetTextColor(1, 1, 1)
			select(5, bu:GetRegions()):SetTextColor(1, 1, 1)
			local bg = CreateFrame("Frame", nil, bu)
			bg:SetPoint("TOPLEFT", -1, 1)
			bg:SetPoint("BOTTOMRIGHT", 1, -1)
			bg:SetFrameLevel(bu:GetFrameLevel()-1)
			SAIAurora.MenuSkin(bg, .25)
			local vline = CreateFrame("Frame", nil, bu)
			vline:SetPoint("LEFT", 44, 0)
			vline:SetSize(1, 44)
			SAIAurora.MenuSkin(vline)
		end
	elseif addon == "Blizzard_AuctionUI" then
		local AuctionBD = _G["AuctionFrame"]
		SAIAurora.MenuSkin(AuctionBD)
		AuctionBD.tex:ClearAllPoints()
		AuctionBD.tex:SetPoint("TOPLEFT", 2, -2)
		AuctionBD.tex:SetPoint("BOTTOMRIGHT", 6, 8)
		SAIAurora.MenuSkin(_G["AuctionProgressFrame"])
		_G["AuctionDressUpFrame"]:ClearAllPoints()
		_G["AuctionDressUpFrame"]:SetPoint("LEFT", AuctionFrame, "RIGHT", 16, 6)
		SAIAurora.MenuSkin(_G["AuctionDressUpFrame"],0,0)
		SAIAurora.ComicSkin(_G["AuctionDressUpModel"],2,8,8,22)
		SAIAurora.BG_o_Matic(_G["AuctionProgressBar"])

		AuctionFrame:GetRegions():Hide()
		for i = 1, 4 do
			select(i, AuctionProgressFrame:GetRegions()):Hide()
		end
		select(2, AuctionProgressBar:GetRegions()):Hide()
		for i = 1, 4 do
			select(i, AuctionDressUpFrame:GetRegions()):Hide()
		end
		for i = 1, 3 do
			SAIAurora.CreateTab(_G["AuctionFrameTab"..i])
		end
		local abuttons = {"BrowseBidButton", "BrowseBuyoutButton", "BrowseCloseButton", "BrowseSearchButton", "BrowseResetButton", "BidBidButton", "BidBuyoutButton", "BidCloseButton", "AuctionsCloseButton", "AuctionDressUpFrameResetButton"}
		for i = 1, getn(abuttons) do
			local reskinbutton = _G[abuttons[i]]
			if reskinbutton then
				SAIAurora.Reskin(reskinbutton)
			end
		end
		local apbuttons = {"AuctionsCancelAuctionButton", "AuctionsCreateAuctionButton", "AuctionsNumStacksMaxButton", "AuctionsStackSizeMaxButton"}
		for i = 1, getn(apbuttons) do
			local reskinbutton = _G[apbuttons[i]]
			if reskinbutton then
				SAIAurora.Reskin(reskinbutton)
				_G[apbuttons[i].."Left"]:SetAlpha(0)
				_G[apbuttons[i].."Middle"]:SetAlpha(0)
				_G[apbuttons[i].."Right"]:SetAlpha(0)
			end
		end
		BrowseBuyoutButton:ClearAllPoints()
		BrowseBuyoutButton:SetPoint("RIGHT", BrowseCloseButton, "LEFT", -1, 0)
		BrowseBidButton:ClearAllPoints()
		BrowseBidButton:SetPoint("RIGHT", BrowseBuyoutButton, "LEFT", -1, 0)
		BidBuyoutButton:ClearAllPoints()
		BidBuyoutButton:SetPoint("RIGHT", BidCloseButton, "LEFT", -1, 0)
		BidBidButton:ClearAllPoints()
		BidBidButton:SetPoint("RIGHT", BidBuyoutButton, "LEFT", -1, 0)
		AuctionsCancelAuctionButton:ClearAllPoints()
		AuctionsCancelAuctionButton:SetPoint("RIGHT", AuctionsCloseButton, "LEFT", -1, 0)
	elseif addon == "Blizzard_AchievementUI" then
		SAIAurora.MenuSkin(AchievementFrame)
		for i = 1, 13 do
			select(i, AchievementFrame:GetRegions()):Hide()
		end
		AchievementFrameSummary:GetRegions():Hide()
		for i = 1, 4 do
			select(i, AchievementFrameHeader:GetRegions()):Hide()
		end
		AchievementFrameHeader:ClearAllPoints()
		AchievementFrameHeader:SetPoint("TOP", AchievementFrame, "TOP", 0, 40)
		AchievementFrameFilterDropDown:ClearAllPoints()
		AchievementFrameFilterDropDown:SetPoint("RIGHT", AchievementFrameHeader, "RIGHT", -120, -1)
		for i = 1, 3 do
			if _G["AchievementFrameTab"..i] then
				for j = 1, 6 do
					select(j, _G["AchievementFrameTab"..i]:GetRegions()):Hide()
					select(j, _G["AchievementFrameTab"..i]:GetRegions()).Show = SAIAurora.dummy
				end
				local sd = CreateFrame("Frame", nil, _G["AchievementFrameTab"..i])
				sd:SetPoint("TOPLEFT", 6, -4)
				sd:SetPoint("BOTTOMRIGHT", -6, -2)
				sd:SetFrameStrata("LOW")
				sd:SetBackdrop({
					bgFile = SAIAurora.blank,
					edgeFile = SAIAurora.glow,
					edgeSize = 5,
					insets = { left = 5, right = 5, top = 5, bottom = 5 },
				})
				sd:SetBackdropColor(0, 0, 0, .5)
				sd:SetBackdropBorderColor(0, 0, 0)
			end
		end
	elseif addon == "Blizzard_BindingUI" then
		SAIAurora.BG_o_Matic(_G["KeyBindingFrame"],2,0,-38,10)
		KeyBindingFrameHeader:SetTexture("")
	elseif addon == "Blizzard_Calendar" then
		for i = 1, 15 do
			if i ~= 10 and i ~= 11 and i ~= 12 and i ~= 13 and i ~= 14 then select(i, CalendarViewEventFrame:GetRegions()):Hide() end
		end
		for i = 1, 9 do
			select(i, CalendarViewHolidayFrame:GetRegions()):Hide()
			select(i, CalendarViewRaidFrame:GetRegions()):Hide()
		end
		for i = 1, 3 do
			select(i, CalendarViewEventTitleFrame:GetRegions()):Hide()
			select(i, CalendarViewHolidayTitleFrame:GetRegions()):Hide()
			select(i, CalendarViewRaidTitleFrame:GetRegions()):Hide()
		end
		CalendarViewEventInviteListSection:GetRegions():Hide()
		CalendarViewEventInviteList:GetRegions():Hide()
		CalendarViewEventDescriptionContainer:GetRegions():Hide()
		select(5, CalendarViewEventCloseButton:GetRegions()):Hide()
		select(5, CalendarViewHolidayCloseButton:GetRegions()):Hide()
		select(5, CalendarViewRaidCloseButton:GetRegions()):Hide()
		local CalBD = CreateFrame("Frame", nil, CalendarFrame)
		CalBD:SetPoint("TOPLEFT", 11, 0)
		CalBD:SetPoint("BOTTOMRIGHT", -9, 3)
		CalBD:SetFrameStrata("MEDIUM")
		SAIAurora.MenuSkin(CalBD)
		SAIAurora.MenuSkin(CalendarViewEventFrame)
		SAIAurora.MenuSkin(CalendarViewHolidayFrame)
		SAIAurora.MenuSkin(CalendarViewRaidFrame)
		SAIAurora.MenuSkin(CalendarViewEventInviteList, .25)
		SAIAurora.MenuSkin(CalendarViewEventDescriptionContainer, .25)
		-- No, I don't have a better way to do this
		for i = 1, 6 do
			local vline = CreateFrame("Frame", nil, _G["CalendarDayButton"..i])
			vline:SetHeight(546)
			vline:SetWidth(1)
			vline:SetPoint("TOP", _G["CalendarDayButton"..i], "TOPRIGHT")
			SAIAurora.MenuSkin(vline)
		end
		for i = 1, 36, 7 do
			local hline = CreateFrame("Frame", nil, _G["CalendarDayButton"..i])
			hline:SetWidth(637)
			hline:SetHeight(1)
			hline:SetPoint("LEFT", _G["CalendarDayButton"..i], "TOPLEFT")
			SAIAurora.MenuSkin(hline)
		end
		local cbuttons = { "CalendarViewEventAcceptButton", "CalendarViewEventTentativeButton", "CalendarViewEventDeclineButton", "CalendarViewEventRemoveButton" }
		for i = 1, getn(cbuttons) do
		local cbutton = _G[cbuttons[i]]
			if cbutton then
				SAIAurora.Reskin(cbutton)
				_G[cbuttons[i].."Left"]:SetAlpha(0)
				_G[cbuttons[i].."Middle"]:SetAlpha(0)
				_G[cbuttons[i].."Right"]:SetAlpha(0)
			end
		end
		CalendarCloseButton:ClearAllPoints()
		CalendarCloseButton:SetPoint("TOPRIGHT", CalBD, "TOPRIGHT")
	elseif addon == "Blizzard_GlyphUI" then
		GlyphFrame:GetRegions():Hide()
		for i=1, 9 do
			if _G["GlyphFrameScrollFrameButton"..i] then
				SAIAurora.MenuSkin(_G["GlyphFrameScrollFrameButton"..i],0,0)
			end
		end
	elseif addon == "Blizzard_GuildBankUI" then
		SAIAurora.MenuSkin(GuildBankFrame)
		for i = 1, 4 do
			SAIAurora.CreateTab(_G["GuildBankFrameTab"..i])
		end
		SAIAurora.Reskin(GuildBankFrameWithdrawButton)
		SAIAurora.Reskin(GuildBankFrameDepositButton)
	elseif addon == "Blizzard_GuildUI" then
		SAIAurora.MenuSkin(GuildFrame)
		SAIAurora.MenuSkin(GuildMemberDetailFrame)
		_G["GuildMemberDetailFrame"]:SetFrameLevel(4)
		SAIAurora.MenuSkin(GuildMemberNoteBackground, .25)
		SAIAurora.MenuSkin(GuildMemberOfficerNoteBackground, .25)
		SAIAurora.MenuSkin(GuildLogFrame)
		SAIAurora.MenuSkin(GuildLogContainer, .25)
		SAIAurora.MenuSkin(GuildNewsFiltersFrame)
		SAIAurora.MenuSkin(GuildTextEditFrame)
		_G["GuildTextEditFrame"]:SetFrameLevel(12)
		SAIAurora.MenuSkin(GuildTextEditContainer)
		_G["GuildTextEditContainer"]:SetFrameLevel(12)
		for i = 1, 5 do
			SAIAurora.CreateTab(_G["GuildFrameTab"..i])
		end
		select(18, GuildFrame:GetRegions()):Hide()
		select(21, GuildFrame:GetRegions()):Hide()
		select(22, GuildFrame:GetRegions()):Hide()
		select(5, GuildInfoFrame:GetRegions()):Hide()
		select(11, GuildMemberDetailFrame:GetRegions()):Hide()
		select(12, GuildMemberDetailFrame:GetRegions()):Hide()
		for i = 1, 9 do
			select(i, GuildLogFrame:GetRegions()):Hide()
			select(i, GuildNewsFiltersFrame:GetRegions()):Hide()
			select(i, GuildTextEditFrame:GetRegions()):Hide()
		end
		select(2, GuildNewPerksFrame:GetRegions()):Hide()
		select(3, GuildNewPerksFrame:GetRegions()):Hide()
		GuildAllPerksFrame:GetRegions():Hide()
		GuildNewsFrame:GetRegions():Hide()
		GuildRewardsFrame:GetRegions():Hide()
		GuildNewsFiltersFrame:ClearAllPoints()
		GuildNewsFiltersFrame:SetPoint("TOPLEFT", GuildFrame, "TOPRIGHT", 10, -10)
		GuildMemberDetailFrame:ClearAllPoints()
		GuildMemberDetailFrame:SetPoint("TOPLEFT", GuildFrame, "TOPRIGHT", 10, -10)
		GuildLevelFrame:SetAlpha(0)
		SAIAurora.Reskin(GuildMemberGroupInviteButton)
		SAIAurora.Reskin(GuildMemberRemoveButton)
		local closebutton = select(4, GuildTextEditFrame:GetChildren())
		SAIAurora.Reskin(closebutton)
		_G[closebutton:GetName().."Left"]:SetAlpha(0)
		_G[closebutton:GetName().."Middle"]:SetAlpha(0)
		_G[closebutton:GetName().."Right"]:SetAlpha(0)
		local logbutton = select(3, GuildLogFrame:GetChildren())
		SAIAurora.Reskin(logbutton)
		_G[logbutton:GetName().."Left"]:SetAlpha(0)
		_G[logbutton:GetName().."Middle"]:SetAlpha(0)
		_G[logbutton:GetName().."Right"]:SetAlpha(0)
		local gbuttons = {"GuildAddMemberButton", "GuildViewLogButton", "GuildControlButton", "GuildTextEditFrameAcceptButton"}
		for i = 1, getn(gbuttons) do
		local gbutton = _G[gbuttons[i]]
			if gbutton then
				SAIAurora.Reskin(gbutton)
				_G[gbuttons[i].."Left"]:SetAlpha(0)
				_G[gbuttons[i].."Middle"]:SetAlpha(0)
				_G[gbuttons[i].."Right"]:SetAlpha(0)
			end
		end
	elseif addon == "Blizzard_InspectUI" then
		SAIAurora.MenuSkin(InspectFrame)

		local slots = {
			"Head", "Neck", "Shoulder", "Shirt", "Chest", "Waist", "Legs", "Feet", "Wrist",
			"Hands", "Finger0", "Finger1", "Trinket0", "Trinket1", "Back", "MainHand",
			"SecondaryHand", "Ranged", "Tabard",
		}

		for i = 1, getn(slots) do
			local bd = CreateFrame("Frame", nil, _G["Inspect"..slots[i].."Slot"])
			bd:SetPoint("TOPLEFT", -1, 1)
			bd:SetPoint("BOTTOMRIGHT", 1, -1)
			SAIAurora.MenuSkin(bd)
			bd:SetBackdropColor(0, 0, 0, 0)
			_G["Inspect"..slots[i].."Slot"]:SetNormalTexture("")
			_G["Inspect"..slots[i].."Slot"]:GetRegions():SetTexCoord(0.1, 0.9, 0.1, 0.9)
		end

		for i = 1, 4 do
			SAIAurora.CreateTab(_G["InspectFrameTab"..i])
		end
		select(3, InspectFrame:GetRegions()):Hide()
		InspectGuildFrame:GetRegions():Hide()
		for i = 1, 5 do
			select(i, InspectModelFrame:GetRegions()):Hide()
		end
		for i = 1, 4 do
			select(i, InspectTalentFrame:GetRegions()):Hide()
		end
		for i = 1, 3 do
			for j = 1, 6 do
				select(j, _G["InspectTalentFrameTab"..i]:GetRegions()):Hide()
				select(j, _G["InspectTalentFrameTab"..i]:GetRegions()).Show = SAIAurora.dummy
			end
		end
	elseif addon == "Blizzard_ItemSocketingUI" then
		SAIAurora.BG_o_Matic(_G["ItemSocketingFrame"],12,-8,-2,24)
		ItemSocketingFrame:GetRegions():Hide()
		SAIAurora.Reskin(ItemSocketingSocketButton)
		_G["ItemSocketingSocketButton".."Left"]:SetAlpha(0)
		_G["ItemSocketingSocketButton".."Middle"]:SetAlpha(0)
		_G["ItemSocketingSocketButton".."Right"]:SetAlpha(0)
		ItemSocketingSocketButton:ClearAllPoints()
		ItemSocketingSocketButton:SetPoint("BOTTOMRIGHT", ItemSocketingFrame, "BOTTOMRIGHT", -10, 28)
	elseif addon == "Blizzard_MacroUI" then
		SAIAurora.BG_o_Matic(_G["MacroFrame"],12,-10,-33,68)
		SAIAurora.MenuSkin(MacroFrameTextBackground, .25)
		SAIAurora.MenuSkin(MacroPopupFrame)
		for i = 1, 6 do
			select(i, MacroFrameTab1:GetRegions()):Hide()
			select(i, MacroFrameTab2:GetRegions()):Hide()
			select(i, MacroFrameTab1:GetRegions()).Show = SAIAurora.dummy
			select(i, MacroFrameTab2:GetRegions()).Show = SAIAurora.dummy
		end
		for i = 1, 8 do
			if i ~= 6 then select(i, MacroFrame:GetRegions()):Hide() end
		end
		for i = 1, 5 do
			select(i, MacroPopupFrame:GetRegions()):Hide()
		end
		SAIAurora.Reskin(MacroDeleteButton)
		SAIAurora.Reskin(MacroNewButton)
		SAIAurora.Reskin(MacroExitButton)
		SAIAurora.Reskin(MacroEditButton)
		SAIAurora.Reskin(MacroPopupOkayButton)
		SAIAurora.Reskin(MacroPopupCancelButton)
		MacroPopupFrame:ClearAllPoints()
		MacroPopupFrame:SetPoint("LEFT", MacroFrame, "RIGHT", -14, 16)
	elseif addon == "Blizzard_RaidUI" then
					local shown = false
			CompactRaidFrameManagerToggleButton:HookScript("OnEnter",function() 
				if shown == false then
					UIFrameFadeIn(CompactRaidFrameManager,.5,0,1) 
				end
			end)

			CompactRaidFrameManagerToggleButton:HookScript("OnLeave",function() 
				if shown == false then
					UIFrameFadeOut(CompactRaidFrameManager,.5,1,0) 
				end
			end)

			CompactRaidFrameManagerToggleButton:HookScript("OnClick",function(self,button)
			if button ~= "LeftButton" then return end
				if shown == false then 
					shown = true
				else 
					shown = false
				end
			end)
			CompactRaidFrameManager:SetAlpha(0)
		if not xrfsd then return end
		for i = 1, 5 do
			if i ~= 3 and i ~= 2 then select(i, CompactRaidFrameManagerDisplayFrame:GetRegions()):Hide() end
		end
		for i = 1, 8 do
			select(i, CompactRaidFrameManager:GetRegions()):Hide()
		end
		SAIAurora.MenuSkin(CompactRaidFrameManagerDisplayFrame)
		SAIAurora.Reskin(CompactRaidFrameManagerToggleButton)
		SAIAurora.Reskin(RaidFrameRaidBrowserButton)
		local rbuttons = {"CompactRaidFrameManagerDisplayFrameFilterRoleTank", "CompactRaidFrameManagerDisplayFrameFilterRoleHealer", "CompactRaidFrameManagerDisplayFrameFilterRoleDamager", "CompactRaidFrameManagerDisplayFrameFilterGroup1", "CompactRaidFrameManagerDisplayFrameFilterGroup2", "CompactRaidFrameManagerDisplayFrameFilterGroup3", "CompactRaidFrameManagerDisplayFrameFilterGroup4", "CompactRaidFrameManagerDisplayFrameFilterGroup5", "CompactRaidFrameManagerDisplayFrameFilterGroup6", "CompactRaidFrameManagerDisplayFrameFilterGroup7", "CompactRaidFrameManagerDisplayFrameFilterGroup8", "CompactRaidFrameManagerDisplayFrameLockedModeToggle", "CompactRaidFrameManagerDisplayFrameHiddenModeToggle", "CompactRaidFrameManagerDisplayFrameLeaderOptionsInitiateRolePoll", "CompactRaidFrameManagerDisplayFrameLeaderOptionsInitiateReadyCheck", "CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton"}
		for i = 1, getn(rbuttons) do
			local rbutton = _G[rbuttons[i]]
			if rbutton then
				SAIAurora.Reskin(rbutton)
				_G[rbuttons[i].."Left"]:SetAlpha(0)
				_G[rbuttons[i].."Middle"]:SetAlpha(0)
				_G[rbuttons[i].."Right"]:SetAlpha(0)
			end
		end
		CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton:SetText("Mark") -- because the texture is hidden, don't want an empty button
		CompactRaidFrameManagerDisplayFrameOptionsButton:Hide()
		local a1, p, a2, x, y = CompactRaidFrameManagerToggleButton:GetPoint()
		CompactRaidFrameManagerToggleButton:SetPoint(a1, p, a2, x + 5, y)
	elseif addon == "Blizzard_ReforgingUI" then
		SAIAurora.MenuSkin(ReforgingFrame)
		select(3, ReforgingFrame:GetRegions()):Hide()
		SAIAurora.Reskin(ReforgingFrameRestoreButton)
		SAIAurora.Reskin(ReforgingFrameReforgeButton)
		_G["ReforgingFrameRestoreButton".."Left"]:SetAlpha(0)
		_G["ReforgingFrameRestoreButton".."Middle"]:SetAlpha(0)
		_G["ReforgingFrameRestoreButton".."Right"]:SetAlpha(0)
		_G["ReforgingFrameReforgeButton".."Left"]:SetAlpha(0)
		_G["ReforgingFrameReforgeButton".."Middle"]:SetAlpha(0)
		_G["ReforgingFrameReforgeButton".."Right"]:SetAlpha(0)
	elseif addon == "Blizzard_TalentUI" then
		SAIAurora.MenuSkin(PlayerTalentFrame)
		local talentbuttons = { "PlayerTalentFrameToggleSummariesButton", "PlayerTalentFrameLearnButton", "PlayerTalentFrameResetButton" }
		for i = 1, getn(talentbuttons) do
		local reskinbutton = _G[talentbuttons[i]]
			if reskinbutton then
				SAIAurora.Reskin(reskinbutton)
				_G[talentbuttons[i].."Left"]:SetAlpha(0)
				_G[talentbuttons[i].."Middle"]:SetAlpha(0)
				_G[talentbuttons[i].."Right"]:SetAlpha(0)
			end
		end	
		select(3, PlayerTalentFrame:GetRegions()):Hide()
		for i = 1, 3 do
			if _G["PlayerTalentFrameTab"..i] then
				SAIAurora.CreateTab(_G["PlayerTalentFrameTab"..i])
				_G["PlayerTalentFrameTab"..i]:ClearAllPoints()
				_G["PlayerTalentFrameTab"..i]:SetPoint("TOPLEFT",PlayerTalentFrame,"BOTTOMLEFT",40*i,-30)
			end
		end
	elseif addon == "Blizzard_TradeSkillUI" then
		SAIAurora.MenuSkin(TradeSkillFrame)
		select(3, TradeSkillFrame:GetRegions()):Hide()
		select(3, TradeSkillFrame:GetRegions()).Show = SAIAurora.dummy
		select(21, TradeSkillFrame:GetRegions()):Hide()
		select(22, TradeSkillFrame:GetRegions()):Hide()
		local tradeskillbuttons = {"TradeSkillCreateButton", "TradeSkillCreateAllButton", "TradeSkillCancelButton"}
		for i = 1, getn(tradeskillbuttons) do
		local button = _G[tradeskillbuttons[i]]
			if button then
				SAIAurora.Reskin(button)
				_G[tradeskillbuttons[i].."Left"]:SetAlpha(0)
				_G[tradeskillbuttons[i].."Middle"]:SetAlpha(0)
				_G[tradeskillbuttons[i].."Right"]:SetAlpha(0)
			end
		end
	elseif addon == "Blizzard_TrainerUI" then
		SAIAurora.MenuSkin(ClassTrainerFrame)
		select(3, ClassTrainerFrame:GetRegions()):Hide()
		select(19, ClassTrainerFrame:GetRegions()):Hide()
		SAIAurora.Reskin(ClassTrainerTrainButton)
		_G["ClassTrainerTrainButton".."Left"]:SetAlpha(0)
		_G["ClassTrainerTrainButton".."Middle"]:SetAlpha(0)
		_G["ClassTrainerTrainButton".."Right"]:SetAlpha(0)
	elseif addon == "BugSack" then
		SAIAurora.MenuSkin(_G["BugSackFrame"])
	end

	-- [[ Mac Options ]]

	if IsMacClient() then
		-- Skin main frame and reposition the header
		SAIAurora.MenuSkin(MacOptionsFrame)
		MacOptionsFrameHeader:SetTexture("")
		MacOptionsFrameHeader:ClearAllPoints()
		MacOptionsFrameHeader:SetPoint("TOP", MacOptionsFrame, 0, 0)
 
		--Skin internal frames
		SAIAurora.MenuSkin(MacOptionsFrameMovieRecording, .25)
		SAIAurora.MenuSkin(MacOptionsITunesRemote, .25)
 
		--Skin buttons
		SAIAurora.Reskin(_G["MacOptionsFrameCancel"])
		SAIAurora.Reskin(_G["MacOptionsFrameOkay"])
		SAIAurora.Reskin(_G["MacOptionsFrameDefaults"])

		local stupidbuttons = {"MacOptionsButtonKeybindings", "MacOptionsButtonCompress"}
		for i = 1, getn(stupidbuttons) do
		local button = _G[stupidbuttons[i]]
			if button then
				SAIAurora.Reskin(button)
				_G[stupidbuttons[i].."Left"]:SetAlpha(0)
				_G[stupidbuttons[i].."Middle"]:SetAlpha(0)
				_G[stupidbuttons[i].."Right"]:SetAlpha(0)
			end
		end
 
		--Reposition and resize buttons
		_G["MacOptionsButtonCompress"]:SetWidth(136)
 
		_G["MacOptionsFrameCancel"]:SetWidth(96)
		_G["MacOptionsFrameCancel"]:SetHeight(22)
		_G["MacOptionsFrameCancel"]:ClearAllPoints()
		_G["MacOptionsFrameCancel"]:SetPoint("LEFT", _G["MacOptionsButtonKeybindings"], "RIGHT", 107, 0)
 
		_G["MacOptionsFrameOkay"]:SetWidth(96)
		_G["MacOptionsFrameOkay"]:SetHeight(22)
		_G["MacOptionsFrameOkay"]:ClearAllPoints()
		_G["MacOptionsFrameOkay"]:SetPoint("LEFT", _G["MacOptionsButtonKeybindings"], "RIGHT", 5, 0)
 
		_G["MacOptionsButtonKeybindings"]:SetWidth(96)
		_G["MacOptionsButtonKeybindings"]:SetHeight(22)
		_G["MacOptionsButtonKeybindings"]:ClearAllPoints()
		_G["MacOptionsButtonKeybindings"]:SetPoint("LEFT", _G["MacOptionsFrameDefaults"], "RIGHT", 5, 0)
 
		_G["MacOptionsFrameDefaults"]:SetWidth(96)
		_G["MacOptionsFrameDefaults"]:SetHeight(22)
 
	end
end)